.586

.model flat, stdcall

option casemap:none

include z.inc

.code


;____________________________________________________________________________



Call_Function_By_Address proc USES EDI EBX ECX EDX 
	LOCAL pBase:pVOID
	LOCAL pre_initialized_base:DWORD
	LOCAL counter:DWORD
	LOCAL current_time:DWORD
	LOCAL future:DWORD
	LOCAL testor:DWORD
	call Get_Base
	.if (EAX == STATUS_NO_SUCH_FILE)
		jmp give_them_error_msg
	.endif	
	mov pBase, EAX
	mov pre_initialized_base, EAX						; save
	.if (pBase != 0)
		invoke ExFreePoolWithTag, pointer_to_module_list, 'KAOR'
	.endif
	invoke RtlImageNtHeader, pre_initialized_base
	mov pBase, EAX
	invoke Write_PIMAGE_NT_HEADER_To_File, pBase, pre_initialized_base
	.if (EAX == STATUS_DATA_ERROR)
		jmp give_them_error_msg
	.endif
	invoke Write_Table_Of_Functions_To_File, pre_initialized_base,  EAX, iedNumberOfFunctions	; EAX = inh_OptionalHeader_DataDirectory_VirtualAddress from Write_PIMAGE_NT_HEADER_To_File
; call _atoi64 function of NTDLL.DLL if it is there . . . . .
	.if(ntdll_function_address != 0)
		mov EAX, offset number_string					; string
		push EAX
		call DWORD PTR [ntdll_function_address]			; call ntdll.dll's _atoi64
		.if (EAX == 0)							; error
			invoke Convert_Number_To_ASCII, EAX
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset atoi64_error_msg
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset number_string
			push EAX
			call DbgPrint
			pop ECX
		.else									; success
			invoke Convert_Number_To_ASCII, EAX
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset atoi64_success_msg
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset number_string
			push EAX
			call DbgPrint
			pop ECX
		.endif
		mov EAX, offset crap_string
		push EAX
		call DWORD PTR [ntdll_function_address]			; call ntdll.dll's _atoi64
		.if (EAX == 0)							; error
			invoke Convert_Number_To_ASCII, EAX
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset atoi64_error_msg
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset crap_string
			push EAX
			call DbgPrint
			pop ECX
		.else									; success
			invoke Convert_Number_To_ASCII, EAX
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset atoi64_success_msg
			push EAX
			call DbgPrint
			pop ECX
			mov EAX, offset crap_string
			push EAX
			call DbgPrint
			pop ECX
		.endif
	.endif
	jmp give_them_success
give_them_error_msg:
	mov counter, 0
	.repeat
		mov EBX, counter
		mov AL, err_module_not_found[EBX]				; BYTE array
		mov BYTE PTR [ESI + EBX], AL
		add counter, 1
	.until (counter == 256)
	ret
give_them_success:
	mov counter, 0
	.repeat
		mov EBX, counter
		mov AX, success_msg[EBX]					; WORD array
		mov BYTE PTR [ESI + EBX], AL
		mov BYTE PTR [ESI + EBX + 1], AH
		add counter, 2
	.until (counter == 256)
	ret
Call_Function_By_Address endp


;________________________________________________________________________________________



Clean_String proc		USES EDI EBX ECX EDX	buffer_address:DWORD
	LOCAL counter:DWORD
	mov EDI, buffer_address
	mov EBX, 0
	mov EDX, 0
last_slash:										; start reading from last slash
	mov AL, BYTE PTR [EDI]
	inc EDI
	inc EBX
	.if(AL == 92)								; '\' = 92
		mov EDX, EBX
	.endif
	.if EDX > 50								; but don't go too far
		jmp enough_slash
	.endif
	or AL, AL
	jnz last_slash
enough_slash:
	mov EDI, buffer_address
	mov EBX, 0
	mov ESI, offset local_string_buffer
copy_clean_string_loop:								; get string length
	mov AL, BYTE PTR [EDI + EDX]						; EDX is last slash 
	.if ((AL < 97 || AL > 122) && (AL < 65 || AL > 90) && AL != 46 && (AL < 48 || AL > 57))
		mov AL, 32
	.endif
	.if (EBX > 60)
		mov AL, 0
		jmp long_enough
	.endif
	mov BYTE PTR [ESI], AL							; put string into local string_buffer
	inc EDI
	inc ESI
	inc EBX
	or AL, AL
	jnz copy_clean_string_loop
long_enough:
	dec EBX
	mov counter, EBX								; string length
	mov EBX, 0
	.repeat
		mov AL, local_string_buffer[EBX]
		mov AH, local_string_buffer[EBX + 1]
		mov BYTE PTR [ESI + EBX], AL
		mov BYTE PTR [ESI +EBX + 1], AH
		add EBX, 2
	.until (EBX == counter)
	mov EAX, counter
	ret
Clean_String endp


;________________________________________________________________________________________



Compare_Strings proc	USES ESI EDI EBX ECX EDX	string_one:DWORD, string_two:DWORD
	LOCAL my_test:DWORD
	mov ESI, string_one
	mov EDI, string_two
	mov EBX, 0
	mov my_test, 0
start_compare:
	mov AL, BYTE PTR [ESI]
	mov AH, BYTE PTR [EDI]
	inc ESI
	inc EDI
	inc EBX
	.if(AL == AH)
		.if(AL == 0 && AH == 0)
			mov my_test, 1
			jmp over_compare
		.endif
		jmp start_compare
	.endif
over_compare:
	.if (EBX > 0 && my_test == 1)
		invoke Write_Data_To_File, ADDR this_is_what_you_want, sizeof this_is_what_you_want, ADDR file_name, 0
		mov EAX, 0
	.else
		mov EAX, 13
	.endif
	ret
Compare_Strings endp


;________________________________________________________________________________________



Convert_Number_To_ASCII PROC uses ebx ecx edx esi edi		number_to_display:DWORD
	LOCAL counter:DWORD
	mov counter, 0
	mov EBX, number_to_display					; number to display
get_and_convert_loop:
	mov EAX, EBX
	xor EDX, EDX
	mov ECX, 10
	div ECX
	mov EBX, EAX
	add EDX, 48
	inc counter
	push EDX
	.if EBX != 0
		jmp get_and_convert_loop
	.endif
	mov ESI, offset bytes_to_write
	mov ECX, counter
reverse_loop:
	pop EDX
	mov BYTE PTR [ESI], DL
	dec ECX
	inc ESI
	.if ECX > 0
		jmp reverse_loop
	.endif
	mov counter, 0
zero_ascii_loop:
	mov BYTE PTR [ESI], 0
	inc ESI
	inc counter
	.if counter < 10
		jmp zero_ascii_loop
	.endif
	mov EAX, offset bytes_to_write
	ret
Convert_Number_To_ASCII ENDP


;________________________________________________________________________________________



Day_Of_Week PROC uses EBX ECX EDX ESI EDI				month:DWORD, day:DWORD, year:DWORD
	LOCAL value:DWORD
	mov ECX, month							; C Algorithm by Tomohiko Sakamoto
	mov EAX, 0
	cmp ECX, 3
	setl AL
	sub year, EAX
	mov EAX, year
	mov value, EAX
	mov ECX, 4
	mov EDX, 0
	div ECX
	add value, EAX
	mov EAX, year
	mov ECX, 100
	mov EDX, 0
	div ECX
	sub value, EAX
	mov EAX, year
	mov ECX, 400
	mov EDX, 0
	div ECX
	add value, EAX
	mov ESI, offset time_array					; time_array
	mov ECX, month
	dec ECX
	cmp CL, 0
	je dont_bother_zero_1
month_loop:
	inc ESI
	dec ECX
	cmp CL, 0
	jne month_loop
dont_bother_zero_1:
	mov EAX, 0
	mov AL, BYTE PTR [ESI]
	add value, EAX
	mov EAX, day
	add value, EAX
	mov EAX, value
	mov ECX, 7
	mov EDX, 0
	div ECX
	mov ECX, EDX
	mov EDI, offset day_array					; day_array
	cmp CL, 0
	je dont_bother_zero_2
day_loop:
	add EDI, 10
	dec ECX
	cmp CL, 0
	jne day_loop
dont_bother_zero_2:
	mov ESI, offset day_work_buffer
	xor ECX, ECX
null_day_loop:								; make null string it
	mov AL, BYTE PTR [EDI]
	.if AL == 32
		mov AL, 0
	.endif
	mov BYTE PTR [ESI], AL
	inc EDI
	inc ESI
	inc ECX
	cmp AL, 0
	jne null_day_loop
	mov EAX, offset day_work_buffer
	ret
Day_Of_Week ENDP


;_________________________________________________________________________________________



Get_Base proc	USES ESI EDI EBX ECX EDX
	LOCAL counter:DWORD
	LOCAL sub_counter:DWORD
	LOCAL dIndex:DWORD
	LOCAL dBase:DWORD
	LOCAL maximum_number_of_modules:DWORD
	mov dIndex, -1
	invoke Write_Data_To_File, ADDR module_table_title, sizeof module_table_title, ADDR file_name, 1
	ASSUME EAX:PMODULE_LIST
	call Get_Pointer_To_Module_List
	mov pointer_to_module_list, EAX					; save pointer
	mov ECX, [EAX].count_Modules
	mov maximum_number_of_modules, ECX
	mov counter, 0
look_at_module_loop:
	mov EAX, pointer_to_module_list					; restore pointer
	push ESI
	push EDI
	mov EBX, counter
	lea ESI, buffy
	lea EDI, DWORD PTR [EAX].actual_Modules.byte_array_ImageName
	movzx EDX, [EAX].actual_Modules.word_NameOffset
	add EDI, EDX								; first offset
	imul EAX, counter, sizeof(_SYSTEM_MODULE_INFORMATION)		; 284 bytes
	add EDI, EAX
copy_string_loop:									; copy string from structure to buffy
	mov AL, BYTE PTR [EDI] 
	mov BYTE PTR [ESI], AL 
	inc EDI
	inc ESI 
	or AL, AL
	jnz copy_string_loop
	pop EDI
	pop ESI
	push ESI									; clean string
	push EDI
	push EBX
	invoke Clean_String, ADDR buffy
	mov sub_counter, EAX
	mov EBX, 0
sub_clean_loop:
	mov AL, BYTE PTR [ESI + EBX]
	mov buffy[EBX], AL
	inc EBX
	.if EBX < sub_counter
		jmp sub_clean_loop
	.endif
	pop EBX
	pop EDI
	pop ESI
	push ESI									; compare string
	push EDI
	push EBX
	mov EBX, 0
	lea ESI, buffy
	lea EDI, ntdll_string							; string to compare to
sub_compare_loop:
	mov AL, BYTE PTR [EDI]
	mov AH, BYTE PTR [ESI]
	.if AH >= 65 && AH <= 90						; make lower case if necessary
		add AH, 32
	.endif
	inc EDI
	inc ESI
	inc EBX
	.if(AL == AH)
		jmp sub_compare_loop
	.endif
	.if (EBX == sizeof ntdll_string)
		invoke Write_Data_To_File, ADDR this_is_what_you_want, sizeof this_is_what_you_want, ADDR file_name, 0
		mov EAX, counter
		mov dIndex, EAX
	.endif
	pop EBX
	pop EDI
	pop ESI
	.if(buffy[0] != 0)							; write module to file
		invoke Write_Data_To_File, ADDR buffy, 25, ADDR file_name, 0
	.else
		invoke Write_Data_To_File, ADDR nothing_there, sizeof nothing_there, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, counter			; ascii number offset in EAX
		invoke Write_Data_To_File, EAX, 20, ADDR file_name, 0
	.endif
	invoke Write_Data_To_File, ADDR new_line, sizeof new_line, ADDR file_name, 0
	inc counter
	mov ECX, maximum_number_of_modules
	.if counter < ECX	
		jmp look_at_module_loop
	.endif
	.if (dIndex == -1)
		mov EAX, STATUS_NO_SUCH_FILE
		ret
	.endif
	.if (dIndex != -1)
		mov EAX, pointer_to_module_list				; restore pointer
		push EDI								; get your module
		lea EDI, DWORD PTR [EAX].actual_Modules.Base
		mov EAX, dIndex
		mov ECX, 284
		mul ECX
		add EDI, EAX
		mov EBX, DWORD PTR [EDI]
		pop EDI
		mov dBase, EBX
	.endif
	mov EAX, dBase
	mov function_address_base, EAX
	ret
Get_Base endp


;________________________________________________________________________________________



Get_Pointer_To_Module_List proc	USES ESI EDI EBX ECX EDX	; RETURNS POINTER TO MODULE LIST
	LOCAL my_status:DWORD
	LOCAL data_size:DWORD
	LOCAL bytes_returned:DWORD
	mov my_status, STATUS_INVALID_PARAMETER
	mov data_size, 4096
start_of_module_loop:
	.if data_size < 1
		mov data_size, 1
	.endif
	invoke ExAllocatePoolWithTag, PagedPool, data_size, 'KAOR'
	mov pointer_to_module_list, EAX
	.if pointer_to_module_list == 0
		mov my_status, STATUS_NO_MEMORY
		jmp no_memory
	.endif
	invoke ZwQuerySystemInformation, SystemModuleInfo, pointer_to_module_list, data_size, ADDR bytes_returned
	mov my_status, EAX
	.if my_status == 0
		jmp successful
	.endif
		.if my_status != STATUS_SUCCESS
			.if bytes_returned != 0	; or pointer_to_module_list != 0
				invoke ExFreePoolWithTag, pointer_to_module_list, 'KAOR'
				mov pointer_to_module_list, 0
				mov bytes_returned, 0
					.if my_status != STATUS_INFO_LENGTH_MISMATCH
						jmp mrs_match
					.endif
			.endif
		.endif
no_memory:
mrs_match:
		mov EAX, data_size
		shl EAX, 1
		mov data_size, EAX
		.if pointer_to_module_list == 0 && data_size != 1
			jmp start_of_module_loop
		.endif
successful:
	mov EAX, pointer_to_module_list
	ret
Get_Pointer_To_Module_List endp


;________________________________________________________________________________________



Read_Hard_Disk_Sector proc	USES EDI EBX ECX EDX	b1:BYTE, b2:BYTE, b3:BYTE, b4:BYTE
	LOCAL counter:DWORD
	LOCAL sector_buffer[512]:BYTE
	mov DX, 1F2h								; sector count port 
	mov AL, 1									; read only one sector
	out DX, AL
	mov DX, 1F3h								; sector number port
	mov AL, b1									; sector #					
	out DX, AL 
	mov DX, 1F4h								; cylinder low port
	mov AL, b2									; cylinder low part			
	out DX, AL 
	mov DX, 1F5h								; cylinder high port
	mov AL, b3									; cylinder high part			
	out DX, AL
	mov DX, 1F6h								; drive and head port
	mov AL, b4									; drive/head
	; BIT	10100000b = 0A0h = 160 = MASTER HEAD 0
	; OR	00010000b = 0B0h = 176 = SLAVE HEAD 0
	; OR  00000000b to 00001111b or 0 to 15 heads
	out DX, AL
	mov DX, 1F7h								; command port
	mov AL, 20h									; read with retry
	out DX, AL 
still_going:									; Is read done? 
	in AL, DX
	test AL, 8									; This means the sector buffer requires servicing.
	jz still_going								; Don't continue until the sector buffer is ready.
	mov counter, 0 
	.repeat									; GET SECTOR BUFFER FROM DATA PORT 1F0h
		mov DX, 1F0h
		in AX, DX
		mov EBX, counter
		mov sector_buffer[EBX], AL
		mov sector_buffer[EBX + 1], AH
		mov BYTE PTR [ESI + EBX], AL
		mov BYTE PTR [ESI + EBX + 1], AH
		add counter, 2
	.until (counter == 512)
	invoke Write_Data_To_File, ADDR sector_buffer, 512, ADDR file_name, 1	; buffer written to file c:\roak.txt
	mov EAX, 17
	ret
Read_Hard_Disk_Sector endp


;________________________________________________________________________________________



Read_Memory proc		USES EDI EBX ECX EDX
	LOCAL counter:DWORD
	LOCAL memory_length:DWORD
	LOCAL ZwOpenSection_handle:DWORD
	LOCAL memory_O_A_S:OBJECT_ATTRIBUTES_STRUCT
	mov out_memory_virtual_address, 0
	invoke RtlInitUnicodeString, ADDR MySNDeviceNameUnicode, ADDR MySNDeviceName
	mov EAX, 24									; FILL O_A_S STRUCTURE
	mov memory_O_A_S.oasLength, EAX					; size of O_A_S
	mov EAX, 0
	mov memory_O_A_S.RootDirectory, EAX					; handle
	mov EAX, offset MySNDeviceNameUnicode				; never DWORD PTR
	mov memory_O_A_S.ObjectName, EAX					; unicode string structure
	mov EAX, OBJ_CASE_INSENSITIVE 
	mov memory_O_A_S.Attributes, EAX
	mov EAX, 0
	mov memory_O_A_S.SecurityDescriptor, EAX
	mov memory_O_A_S.SecurityQualityOfService, EAX
	invoke ZwOpenSection, ADDR ZwOpenSection_handle, 4, ADDR memory_O_A_S
	mov memory_length, 1							; for one page
	invoke ZwMapViewOfSection, ZwOpenSection_handle, -1, ADDR out_memory_virtual_address, 0, 1, ADDR memory_offset, ADDR memory_length, 1, 0, 2
	invoke Write_Data_To_File, out_memory_virtual_address, 4096, ADDR file_name, 1
	add out_memory_virtual_address, 0C71h				; start of byte serial number from offset
	mov EAX, [out_memory_virtual_address]
	ASSUME EDX:PTR _My_Serial_Number_Structure
	mov EDX, EAX
	mov counter, 0
	.repeat
		mov EBX, counter
		mov AX, [EDX].character[EBX]					; 37 characters
			.if EBX > 37
				mov AX, '~~'
			.endif
		mov BYTE PTR [ESI + EBX], AL
		mov BYTE PTR [ESI + EBX + 1], AH
		add counter, 2
	.until (counter == 256)
	ASSUME EDX:NOTHING
	invoke ZwClose, ZwOpenSection_handle
	mov EAX, 13
	ret
Read_Memory endp


;________________________________________________________________________________________



Roaknogs_Structured_Exception_Handler	PROC	USES EBX ECX EDX EDI	test_raise:DWORD, test_13:DWORD
	LOCAL seh_test:DWORD
	push ESI
	ASSUME FS:NOTHING
	push offset roaknogs_seh
	push FS:[0]
	mov [roaks_seh], ESP
	mov [roaks_seh + 4], EBP
	mov [roaks_seh + 8], offset my_except_list
	mov FS:[0], ESP
	.if(test_raise == 1)						; use parameter 1 to get exception
;		invoke ExRaiseAccessViolation				; raise exception
		mov EAX, 0
		mov ECX, DWORD PTR [EAX]
	.endif
	mov EAX, 1000
my_except_list:								; uninstall the handler
	ASSUME FS:NOTHING
	pop FS:[0]
	add ESP, 4
	.if(test_13 == 13)						; dealt with exceiption so lets look at parameter 2
		mov EAX, offset msg_test_13_parameter_2
		push EAX
		call DbgPrint
		mov EAX, 5000
		pop ECX
	.endif
	pop ESI
	mov EBX, 0
	push EAX
my_seh_msg_loop:								; send loader message from driver
	mov AL, msg_get_buger[EBX]
	mov [ESI + EBX], AL
	inc EBX
	.if (EBX < 512)
		jmp my_seh_msg_loop
	.endif
	pop EAX
	ret
roaknogs_seh:								; my exception handler
	mov EAX, offset msg_in_except
	push EAX
	call DbgPrint
	pop ECX
	mov EAX, 3000
	mov ESP, [roaks_seh]
	mov EBP, [roaks_seh + 4]
	jmp [roaks_seh + 8]
	ret
Roaknogs_Structured_Exception_Handler ENDP


;________________________________________________________________________________________



Roak_Unload proc		DriverObject:PDRIVER_OBJECT
	push EDI
	mov EAX, offset SymbolicLinkNameUnicode
	push EDI 
	push EAX 
	invoke RtlInitUnicodeString, EAX, ADDR zDosDeviceName
	pop EDI
	invoke IoDeleteSymbolicLink, ADDR SymbolicLinkNameUnicode
	mov EAX, DriverObject 
	invoke IoDeleteDevice, DWORD PTR [EAX + 4]			; DRIVER_OBJECT._PDEVICE_OBJECT
	ret
Roak_Unload endp


;_________________________________________________________________________________________



Space_Function_Name PROC	uses EBX ECX EDX ESI EDI		function_name:DWORD
	LOCAL counter:DWORD
	mov ESI, function_name
	mov EDI, offset function_buffer_name
	mov counter, 0
function_length_loop:
	mov AL, BYTE PTR [ESI]
	.if (AL == 0)
space_loop:
		mov AL, 32
	.endif
	mov BYTE PTR [EDI], AL
	inc ESI
	inc EDI
	inc counter
	.if (counter < 50)
		.if(AL == 32)
			jmp space_loop
		.endif
		jmp function_length_loop
	.endif
	mov EAX, offset function_buffer_name
	ret
Space_Function_Name ENDP


;________________________________________________________________________________________



Speaker_Off proc
	in AL, 61h
	mov AL, 61h
	and AL, 0FCh
	out 61h, AL
	ret
Speaker_Off endp


;_________________________________________________________________________________________



Speaker_On PROC  frequency_low:DWORD, frequency_high:DWORD
	in AL, 61h
	or AL, 3 
	out 61h, AL
	mov AL, 0B6h
	out 43h, AL
	mov EAX, frequency_low							; 2 for middle C
	out 42h, AL
	mov EAX, frequency_high							; 5
	out 42h, AL
	ret
Speaker_On ENDP


;_________________________________________________________________________________________



Time_Date_Stamp_Converteor PROC USES EBX ECX EDX ESI EDI	tds:DWORD
	LOCAL counter:DWORD
	LOCAL number_of_leap_days:DWORD
	LOCAL year:DWORD
	LOCAL month:DWORD
	LOCAL day:DWORD
	LOCAL hour:DWORD
	LOCAL minute:DWORD
	LOCAL second:DWORD
	mov EAX, tds								; work on years first
	mov ECX, 86400								; seconds per day
	mov EDX, 0
	div ECX
	mov ECX, 365								; days per year
	mov EDX, 0
	div ECX
	add EAX, 1970
	mov year, EAX
	mov EBX, 0									; number of leap days
	mov number_of_leap_days, 0
search_leap_array:
	mov EAX, leap_year_array[EBX]
	.if (year > EAX && year != EAX)
		inc number_of_leap_days
	.endif
	inc EBX
	.if EBX < 25
		jmp search_leap_array
	.endif
	.if number_of_leap_days > 0
		inc number_of_leap_days
	.endif									; end number of leap days
	mov EAX, year								; seconds left into EBX
	sub EAX, 1970
	mov ECX, 365
	mul ECX
	add EAX, number_of_leap_days
	mov ECX, 86400
	mul ECX
	mov EBX, tds
	sub EBX, EAX								; end seconds left
	mov EAX, EBX								; work on month & day
	mov ECX, 86400
	mov EDX, 0
	div ECX
	mov day, EAX
	mov ECX, 86400								; seconds left
	mul ECX
	sub EBX, EAX								; end seconds left
	mov month, 1
	mov counter, 0
	mov ESI, offset month_array
	.while (counter < 12)
		mov EAX, [ESI]
		.if (day > EAX)
			inc month
			sub day, EAX
		.endif
		add ESI, 4
		inc counter
	.endw
	add day, 1
	mov EAX, EBX								; hour
	mov ECX, 3600
	mov EDX, 0
	div ECX
	mov hour, EAX								; end hour
	mov ECX, 3600								; seconds left
	mul ECX
	sub EBX, EAX								; end seconds left
	mov EAX, EBX								; minute
	mov ECX, 60
	mov EDX, 0
	div ECX
	mov minute, EAX								; end minute
	mov ECX, 60									; seconds left
	mul ECX
	sub EBX, EAX
	mov second, EBX								; end seconds left
	mov EDI, offset time_date						; fill time_date buffer
	invoke Convert_Number_To_ASCII, month
	mov ESI, EAX
	mov AL, BYTE PTR [ESI + 1]
	.if AL == 0
		mov AL, 48								; zero '0'
		mov [EDI + 0], AL
		mov AL, BYTE PTR [ESI]
		mov [EDI + 1], AL
	.else
		mov AL, BYTE PTR [ESI]
		mov [EDI + 0], AL
		mov AL, BYTE PTR [ESI + 1]
		mov [EDI + 1], AL
	.endif
	mov AL, 47									; slash '/'
	mov [EDI + 2], AL
	invoke Convert_Number_To_ASCII, day
	mov ESI, EAX
	mov AL, BYTE PTR [ESI + 1]
	.if AL == 0
		mov AL, 48								; zero '0'
		mov [EDI + 3], AL
		mov AL, BYTE PTR [ESI]
		mov [EDI + 4], AL
	.else
		mov AL, BYTE PTR [ESI]
		mov [EDI + 3], AL
		mov AL, BYTE PTR [ESI + 1]
		mov [EDI + 4], AL
	.endif
	mov AL, 47									; slash '/'
	mov [EDI + 5], AL
	invoke Convert_Number_To_ASCII, year
	mov ESI, EAX
	mov AL, BYTE PTR [ESI]
	mov [EDI + 6], AL
	mov AL, BYTE PTR [ESI + 1]
	mov [EDI + 7], AL
	mov AL, BYTE PTR [ESI + 2]
	mov [EDI + 8], AL
	mov AL, BYTE PTR [ESI + 3]
	mov [EDI + 9], AL
	mov AL, 32									; space ' '
	mov [EDI + 10], AL
	invoke Convert_Number_To_ASCII, hour
	mov ESI, EAX
	mov AL, BYTE PTR [ESI + 1]
	.if AL == 0
		mov AL, 48								; zero '0'
		mov [EDI + 11], AL
		mov AL, BYTE PTR [ESI]
		mov [EDI + 12], AL
	.else
		mov AL, BYTE PTR [ESI]
		mov [EDI + 11], AL
		mov AL, BYTE PTR [ESI + 1]
		mov [EDI + 12], AL
	.endif
	mov AL, 58									; colon ':'
	mov [EDI + 13], AL
	invoke Convert_Number_To_ASCII, minute
	mov ESI, EAX
	mov AL, BYTE PTR [ESI + 1]
	.if AL == 0
		mov AL, 48								; zero '0'
		mov [EDI + 14], AL
		mov AL, BYTE PTR [ESI]
		mov [EDI + 15], AL
	.else
		mov AL, BYTE PTR [ESI]
		mov [EDI + 14], AL
		mov AL, BYTE PTR [ESI + 1]
		mov [EDI + 15], AL
	.endif
	mov AL, 58									; colon ':'
	mov [EDI + 16], AL
	invoke Convert_Number_To_ASCII, second
	mov ESI, EAX
	mov AL, BYTE PTR [ESI + 1]
	.if AL == 0
		mov AL, 48								; zero '0'
		mov [EDI + 17], AL
		mov AL, BYTE PTR [ESI]
		mov [EDI + 18], AL
	.else
		mov AL, BYTE PTR [ESI]
		mov [EDI + 17], AL
		mov AL, BYTE PTR [ESI + 1]
		mov [EDI + 18], AL
	.endif
	invoke Day_Of_Week, month, day, year				; add actual day
	mov ESI, EAX
	add EDI, 19
	mov AL, 32
	mov BYTE PTR [EDI], AL
	inc EDI
	mov BYTE PTR [EDI], AL
add_day_to_date_loop:
	mov AL, BYTE PTR [ESI]
	mov BYTE PTR [EDI], AL
	inc EDI
	inc ESI
	cmp AL, 0
	jne add_day_to_date_loop
	mov EBX, 0
zero_day_date_loop:
	mov BYTE PTR [EDI], AL
	inc EDI
	inc BL
	cmp BL, 5
	jne zero_day_date_loop
	mov EAX, offset time_date
	ret
Time_Date_Stamp_Converteor ENDP


;________________________________________________________________________________________



Write_Data_To_File proc		address_of_data_to_write:DWORD, data_size:DWORD, address_of_file_name:DWORD, read_write_test:DWORD
	invoke RtlInitUnicodeString, ADDR FileNameUnicode, address_of_file_name
	mov EAX, 24
	mov file_O_A_S.oasLength, EAX						; size of O_A_S
	mov EAX, 0
	mov file_O_A_S.RootDirectory, EAX					; handle
	mov EAX, offset FileNameUnicode
	mov file_O_A_S.ObjectName, EAX					; unicode string structure
	mov EAX, OBJ_CASE_INSENSITIVE	
	mov file_O_A_S.Attributes, EAX
	mov EAX, 0
	mov file_O_A_S.SecurityDescriptor, EAX
	mov file_O_A_S.SecurityQualityOfService, EAX
	.if read_write_test == 0						; open existing
		invoke ZwCreateFile, ADDR hFile, FILE_APPEND_DATA, ADDR file_O_A_S, ADDR iostatus, 0, 0, FILE_APPEND_DATA or FILE_WRITE_TO_END_OF_FILE, FILE_OPEN_IF, FILE_SYNCHRONOUS_IO_NONALERT, 0, 0
	.endif
	.if read_write_test == 1						; create new
		invoke ZwCreateFile, ADDR hFile, GENERIC_WRITE, ADDR file_O_A_S, ADDR iostatus, 0, FILE_ATTRIBUTE_NORMAL, 0, FILE_OVERWRITE_IF, FILE_SYNCHRONOUS_IO_NONALERT, 0, 0
	.endif
	invoke ZwWriteFile, hFile, 0, 0, 0, ADDR iostatus, address_of_data_to_write, data_size, 0, 0
	invoke ZwClose, hFile
	ret
Write_Data_To_File endp


;_________________________________________________________________________________________



Write_PIMAGE_EXPORT_DIRECTORY_To_File proc	pre_initialized_base:DWORD, inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD
	LOCAL iedCharacteristics:DWORD
	LOCAL iedTimeDateStamp:DWORD
	LOCAL iedMajorVersion:DWORD
	LOCAL iedMinorVersion:DWORD
	LOCAL iedBase:DWORD
	LOCAL iedNumberOfNames:DWORD
	LOCAL iedAddressOfFunctions:DWORD
	LOCAL iedAddressOfNames:DWORD
	LOCAL iedAddressOfNameOrdinals:DWORD
	mov EAX, pre_initialized_base						; PTR_ADD
	add EAX, inh_OptionalHeader_DataDirectory_VirtualAddress
	ASSUME EAX:PIMAGE_EXPORT_DIRECTORY					; PIMAGE_EXPORT_DIRECTORY
	mov EBX, [EAX].Characteristics
	mov iedCharacteristics, EBX
	mov EBX, [EAX].TimeDateStamp
	mov iedTimeDateStamp, EBX
	movzx EBX, [EAX].MajorVersion						; WORD VALUE OF MAJOR VERSION
	mov iedMajorVersion, EBX
	movzx EBX, [EAX].MinorVersion						; WORD VALUE OF MINOR VERSION
	mov iedMinorVersion, EBX
	mov EBX, [EAX].iedName							; NAME OF DLL
	add EBX, pre_initialized_base
	mov iedName, EBX
	mov EBX, [EAX].Base
	mov iedBase, EBX
	mov EBX, [EAX].NumberOfFunctions					; NUMBER OF FUNCTIONS
	mov iedNumberOfFunctions, EBX
	mov EBX, [EAX].NumberOfNames
	mov iedNumberOfNames, EBX
	mov EBX, [EAX].AddressOfFunctions
	mov iedAddressOfFunctions, EBX
	mov EBX, [EAX].AddressOfNames
	mov iedAddressOfNames, EBX
	mov EBX, [EAX].AddressOfNameOrdinals
	mov iedAddressOfNameOrdinals, EBX
	ASSUME EAX:NOTHING
	invoke Write_Data_To_File, ADDR ied_string_0, sizeof ied_string_0, ADDR file_name, 0
	invoke Write_Data_To_File, iedName, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_1, sizeof ied_string_1, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedCharacteristics
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_2, sizeof ied_string_2, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedTimeDateStamp
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_3, sizeof ied_string_3, ADDR file_name, 0
	invoke Time_Date_Stamp_Converteor, iedTimeDateStamp
	invoke Write_Data_To_File, EAX, 30, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_4, sizeof ied_string_4, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedMajorVersion
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_5, sizeof ied_string_5, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedMinorVersion
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_6, sizeof ied_string_6, ADDR file_name, 0
	invoke Write_Data_To_File,iedName, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_7, sizeof ied_string_7, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedBase
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_8, sizeof ied_string_8, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedNumberOfFunctions
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_9, sizeof ied_string_9, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedNumberOfNames
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_10, sizeof ied_string_10, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedAddressOfFunctions
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_11, sizeof ied_string_11, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedAddressOfNames
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_12, sizeof ied_string_12, ADDR file_name, 0
	invoke Convert_Number_To_ASCII, iedAddressOfNameOrdinals
	invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR ied_string_13, sizeof ied_string_13, ADDR file_name, 0
	mov EAX, iedAddressOfFunctions
	ret
Write_PIMAGE_EXPORT_DIRECTORY_To_File endp


;________________________________________________________________________________________



Write_PIMAGE_NT_HEADER_To_File proc		pBase:DWORD, pre_initialized_base:DWORD
	LOCAL inh_Signature:DWORD
	LOCAL inh_FileHeader_Machine:DWORD
	LOCAL inh_FileHeader_NumberOfSections:DWORD
	LOCAL inh_FileHeader_TimeDateStamp:DWORD
	LOCAL inh_FileHeader_PointerToSymbolTable:DWORD
	LOCAL inh_FileHeader_NumberOfSymbols:DWORD
	LOCAL inh_FileHeader_SizeOfOptionHeader:DWORD
	LOCAL inh_FileHeader_Characteristics:DWORD
	LOCAL inh_OptionalHeader_Magic:DWORD
	LOCAL inh_OptionalHeader_MajorLinkerVersion
	LOCAL inh_OptionalHeader_MinorLinkerVersion
	LOCAL inh_OptionalHeader_SizeOfCode:DWORD
	LOCAL inh_OptionalHeader_SizeOfInitializedData:DWORD
	LOCAL inh_OptionalHeader_SizeOfUninitializedData:DWORD
	LOCAL inh_OptionalHeader_AddressOfEntryPoint:DWORD
	LOCAL inh_OptionalHeader_BaseOfCode:DWORD
	LOCAL inh_OptionalHeader_BaseOfData:DWORD
	LOCAL inh_OptionalHeader_ImageBase:DWORD
	LOCAL inh_OptionalHeader_SectionalAlignment:DWORD
	LOCAL inh_OptionalHeader_FileAlignment:DWORD
	LOCAL inh_OptionalHeader_MajorOperatingSystemVersion:DWORD
	LOCAL inh_OptionalHeader_MinorOperatingSystemVersion:DWORD
	LOCAL inh_OptionalHeader_MajorImageVersion:DWORD
	LOCAL inh_OptionalHeader_MinorImageVersion:DWORD
	LOCAL inh_OptionalHeader_MajorSubsystemVersion:DWORD
	LOCAL inh_OptionalHeader_MinorSubsystemVersion:DWORD
	LOCAL inh_OptionalHeader_Win32VersionValue:DWORD
	LOCAL inh_OptionalHeader_SizeOfImage:DWORD
	LOCAL inh_OptionalHeader_SizeOfHeaders:DWORD
	LOCAL inh_OptionalHeader_CheckSum:DWORD
	LOCAL inh_OptionalHeader_Subsystem:DWORD
	LOCAL inh_OptionalHeader_DllCharacteristics:DWORD
	LOCAL inh_OptionalHeader_SizeOfStackReserve:DWORD
	LOCAL inh_OptionalHeader_SizeOfStackCommit:DWORD
	LOCAL inh_OptionalHeader_SizeOfHeapReserve:DWORD
	LOCAL inh_OptionalHeader_SizeOfHeapCommit:DWORD
	LOCAL inh_OptionalHeader_LoaderFlags:DWORD
	LOCAL inh_OptionalHeader_NumberOfRvaAndSizes:DWORD
	LOCAL inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD
	LOCAL inh_OptionalHeader_DataDirectory_Size:DWORD
	.if (pBase != 0)
	mov EDX, pBase
	ASSUME EDX:PIMAGE_NT_HEADER
		.if ([EDX].OptionalHeader.DataDirectory.VirtualAddress && ([EDX].OptionalHeader.DataDirectory.iddSize >= 40))	; sizeof _IMAGE_EXPORT_DIRECTORY = 40
			mov EBX, [EDX].Signature
			mov inh_Signature, EBX
			movzx EBX, [EDX].FileHeader.Machine					; WORD
			mov inh_FileHeader_Machine, EBX
			movzx EBX, [EDX].FileHeader.NumberOfSections			; WORD
			mov inh_FileHeader_NumberOfSections, EBX
			mov EBX, [EDX].FileHeader.TimeDateStamp
			mov inh_FileHeader_TimeDateStamp, EBX
			mov EBX, [EDX].FileHeader.PointerToSymbolTable
			mov inh_FileHeader_PointerToSymbolTable, EBX
			mov EBX, [EDX].FileHeader.NumberOfSymbols
			mov inh_FileHeader_NumberOfSymbols, EBX
			movzx EBX, [EDX].FileHeader.SizeOfOptionHeader			; WORD
			mov inh_FileHeader_SizeOfOptionHeader, EBX
			movzx EBX, [EDX].FileHeader.Characteristics			; WORD
			mov inh_FileHeader_Characteristics, EBX
			movzx EBX, [EDX].OptionalHeader.Magic				; WORD
			mov inh_OptionalHeader_Magic, EBX
			movzx EBX, [EDX].OptionalHeader.MajorLinkerVersion		; BYTE
			mov inh_OptionalHeader_MajorLinkerVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorLinkerVersion		; BYTE
			mov inh_OptionalHeader_MinorLinkerVersion, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfCode
			mov inh_OptionalHeader_SizeOfCode, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfInitializedData
			mov inh_OptionalHeader_SizeOfInitializedData, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfUninitializedData
			mov inh_OptionalHeader_SizeOfUninitializedData, EBX
			mov EBX, [EDX].OptionalHeader.AddressOfEntryPoint
			mov inh_OptionalHeader_AddressOfEntryPoint, EBX
			mov EBX, [EDX].OptionalHeader.BaseOfCode
			mov inh_OptionalHeader_BaseOfCode, EBX
			mov EBX, [EDX].OptionalHeader.BaseOfData
			mov inh_OptionalHeader_BaseOfData, EBX
			mov EBX, [EDX].OptionalHeader.ImageBase
			mov inh_OptionalHeader_ImageBase, EBX
			mov EBX, [EDX].OptionalHeader.SectionalAlignment
			mov inh_OptionalHeader_SectionalAlignment, EBX
			mov EBX, [EDX].OptionalHeader.FileAlignment
			mov inh_OptionalHeader_FileAlignment, EBX
			movzx EBX, [EDX].OptionalHeader.MajorOperatingSystemVersion	; WORD
			mov inh_OptionalHeader_MajorOperatingSystemVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorOperatingSystemVersion	; WORD
			mov inh_OptionalHeader_MinorOperatingSystemVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MajorImageVersion		; WORD
			mov inh_OptionalHeader_MajorImageVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorImageVersion		; WORD
			mov inh_OptionalHeader_MinorImageVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MajorSubsystemVersion		; WORD
			mov inh_OptionalHeader_MajorSubsystemVersion, EBX
			movzx EBX, [EDX].OptionalHeader.MinorSubsystemVersion		; WORD
			mov inh_OptionalHeader_MinorSubsystemVersion, EBX
			mov EBX, [EDX].OptionalHeader.Win32VersionValue
			mov inh_OptionalHeader_Win32VersionValue, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfImage
			mov inh_OptionalHeader_SizeOfImage, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfHeaders
			mov inh_OptionalHeader_SizeOfHeaders, EBX
			mov EBX, [EDX].OptionalHeader.CheckSum
			mov inh_OptionalHeader_CheckSum, EBX
			movzx EBX, [EDX].OptionalHeader.Subsystem				; WORD
			mov inh_OptionalHeader_Subsystem, EBX
			movzx EBX, [EDX].OptionalHeader.DllCharacteristics		; WORD
			mov inh_OptionalHeader_DllCharacteristics, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfStackReserve
			mov inh_OptionalHeader_SizeOfStackReserve, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfStackCommit
			mov inh_OptionalHeader_SizeOfStackCommit, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfHeapReserve
			mov inh_OptionalHeader_SizeOfHeapReserve, EBX
			mov EBX, [EDX].OptionalHeader.SizeOfHeapCommit
			mov inh_OptionalHeader_SizeOfHeapCommit, EBX
			mov EBX, [EDX].OptionalHeader.LoaderFlags
			mov inh_OptionalHeader_LoaderFlags, EBX
			mov EBX, [EDX].OptionalHeader.NumberOfRvaAndSizes
			mov inh_OptionalHeader_NumberOfRvaAndSizes, EBX
			mov EBX, [EDX].OptionalHeader.DataDirectory.VirtualAddress	; NEEDED FOR OTHER PROCEDURES
			mov inh_OptionalHeader_DataDirectory_VirtualAddress, EBX
			mov EBX, [EDX].OptionalHeader.DataDirectory.iddSize
			mov inh_OptionalHeader_DataDirectory_Size, EBX
		.else
			mov EAX, STATUS_DATA_ERROR
			ret
		.endif
		invoke Write_PIMAGE_EXPORT_DIRECTORY_To_File, pre_initialized_base, inh_OptionalHeader_DataDirectory_VirtualAddress	; to get iedName
		ASSUME EDX:NOTHING
		invoke Write_Data_To_File, ADDR inh_string_1, sizeof inh_string_1, ADDR file_name, 0
		invoke Write_Data_To_File, iedName, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_2, sizeof inh_string_2, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_Signature
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_3, sizeof inh_string_3, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_Machine
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_4, sizeof inh_string_4, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_NumberOfSections
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_5, sizeof inh_string_5, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_TimeDateStamp
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_6, sizeof inh_string_6, ADDR file_name, 0
		invoke Time_Date_Stamp_Converteor, inh_FileHeader_TimeDateStamp
		invoke Write_Data_To_File, EAX, 30, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_7, sizeof inh_string_7, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_PointerToSymbolTable
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_8, sizeof inh_string_8, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_NumberOfSymbols
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_9, sizeof inh_string_9, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_SizeOfOptionHeader
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_10, sizeof inh_string_10, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_FileHeader_Characteristics
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_11, sizeof inh_string_11, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_Magic
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_12, sizeof inh_string_12, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MajorLinkerVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_13, sizeof inh_string_13, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MinorLinkerVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_14, sizeof inh_string_14, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfCode
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_15, sizeof inh_string_15, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfInitializedData
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_16, sizeof inh_string_16, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfUninitializedData
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_17, sizeof inh_string_17, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_AddressOfEntryPoint
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_18, sizeof inh_string_18, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_BaseOfCode
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_19, sizeof inh_string_19, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_BaseOfData
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_20, sizeof inh_string_20, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_ImageBase
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_21, sizeof inh_string_21, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SectionalAlignment
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_22, sizeof inh_string_22, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_FileAlignment
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_23, sizeof inh_string_23, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MajorOperatingSystemVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_24, sizeof inh_string_24, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MinorOperatingSystemVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_25, sizeof inh_string_25, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MajorImageVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_26, sizeof inh_string_26, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MinorImageVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_27, sizeof inh_string_27, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MajorSubsystemVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_28, sizeof inh_string_28, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_MinorSubsystemVersion
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_29, sizeof inh_string_29, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_Win32VersionValue
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_30, sizeof inh_string_30, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfImage 
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_31, sizeof inh_string_31, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfHeaders
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_32, sizeof inh_string_32, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_CheckSum
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_33, sizeof inh_string_33, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_Subsystem
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_34, sizeof inh_string_34, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_DllCharacteristics
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_35, sizeof inh_string_35, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfStackReserve
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_36, sizeof inh_string_36, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfStackCommit
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_37, sizeof inh_string_37, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfHeapReserve
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_38, sizeof inh_string_38, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_SizeOfHeapCommit
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_39, sizeof inh_string_39, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_LoaderFlags
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_40, sizeof inh_string_40, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_NumberOfRvaAndSizes
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_41, sizeof inh_string_41, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_DataDirectory_VirtualAddress
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_42, sizeof inh_string_42, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, inh_OptionalHeader_DataDirectory_Size
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR inh_string_43, sizeof inh_string_43, ADDR file_name, 0
	.endif
	mov EAX, inh_OptionalHeader_DataDirectory_VirtualAddress
	ret
Write_PIMAGE_NT_HEADER_To_File endp


;________________________________________________________________________________________



Write_Table_Of_Functions_To_File proc USES ESI EDI EBX ECX EDX	pre_initialized_base:DWORD, inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD, NumberOfFunctions:DWORD
	LOCAL counter:DWORD
	LOCAL ordinal:DWORD
	LOCAL local_data:DWORD
	invoke Write_Data_To_File, ADDR function_table_name_1, sizeof function_table_name_1, ADDR file_name, 0
	invoke Write_Data_To_File, iedName, 10, ADDR file_name, 0
	invoke Write_Data_To_File, ADDR function_table_name_2, sizeof function_table_name_2, ADDR file_name, 0
	ASSUME EDX:PIMAGE_EXPORT_DIRECTORY
	mov EDX, pre_initialized_base
	add EDX, inh_OptionalHeader_DataDirectory_VirtualAddress
	mov ESI, [EDX].AddressOfNames
	add ESI, pre_initialized_base
	mov EAX, [EDX].AddressOfNameOrdinals
	add EAX, pre_initialized_base
	mov EBX, EAX
	mov EAX, [EDX].AddressOfFunctions
	add EAX, pre_initialized_base
	mov EDI, EAX
	mov counter, 0
	.repeat
		mov EAX, DWORD PTR [ESI]					; name array
		add EAX, pre_initialized_base
		mov RVA_NAME, EAX	
		mov EDX, [EBX]
		movzx EDX, DX							; word ordinals
		mov ECX, EDX
		add ECX, 1								; counter
		shl EDX, 2								; * 4 bytes along pointer
		add EDX, EDI
		push EBX								; GET FUNCTION ADDRESSES
		push ECX
		push EDX
		mov EBX, ECX							; counter for ordinal
		mov ordinal, EBX							; ordinal
		mov EAX, DWORD PTR [EDX]					; pointer to data
		mov local_data, EAX						; data
		mov EAX, function_address_base				; get function address by adding module address
		add EAX, DWORD PTR [EDX]					; with base address from Get_Base procedure
		mov address_plus_base, EAX
		invoke Compare_Strings, ADDR ntdll__atoi64_function, RVA_NAME	; returns 0 in EAX if equal else 13
		.if (EAX == 0)
			mov EAX, address_plus_base
			mov ntdll_function_address, EAX
		.endif
		pop EDX
		pop ECX
		pop EBX
; print function name, tab, ordinal number, tab, data address, tab, function address, new line
		invoke Space_Function_Name, RVA_NAME
		invoke Write_Data_To_File, EAX, 50, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR tab_string, sizeof tab_string, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, ordinal
		invoke Write_Data_To_File, EAX, 5, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR tab_string, sizeof tab_string, ADDR file_name, 0
		invoke Convert_Number_To_ASCII, local_data
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR tab_string, sizeof tab_string, ADDR file_name, 0
; print function address
		invoke Convert_Number_To_ASCII, address_plus_base
		invoke Write_Data_To_File, EAX, 10, ADDR file_name, 0
		invoke Write_Data_To_File, ADDR new_line, 2, ADDR file_name, 0
		add ESI, 4
		add EBX, 2
		inc counter
		mov ECX, iedNumberOfFunctions
	.until (counter == ECX)
	ASSUME EDX:NOTHING
	ret
Write_Table_Of_Functions_To_File endp


;________________________________________________________________________________________



END




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;













;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
















;;;;;;;;;;;;;;;;;;;;;;;;;




















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

















;;;;;;;;;;;;;;;;;;;;;;;;;;









;;;;;;;;;;;;;;;;
