.586 

.model flat, stdcall

option casemap:none

include z.inc

.code

start:



	invoke GetModuleHandle, 0
	mov hInstance, EAX
	invoke GetCommandLine
	invoke WinMain, hInstance, 0, EAX, SW_SHOWDEFAULT 
	invoke ExitProcess, EAX


;_________________________________________________________________________



WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD  
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL Wwd:DWORD
	LOCAL Wht:DWORD
	LOCAL Wtx:DWORD
	LOCAL Wty:DWORD
	mov wc.cbSize, sizeof WNDCLASSEX 
	mov wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW 
	mov wc.lpfnWndProc, offset WndProc 
	mov wc.cbClsExtra, 0
	mov wc.cbWndExtra, 0
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, 16					; background color
	mov wc.lpszMenuName, 0
	mov wc.lpszClassName, offset szClassName 
	invoke LoadIcon, hInst, 500					; icon ID for U.S. flag
	mov wc.hIcon, EAX
	invoke LoadCursor, NULL, IDC_ARROW 
	mov wc.hCursor, EAX
	mov wc.hIconSm, 0
	invoke RegisterClassEx, ADDR wc 
	mov Wwd, 500 							; width
	mov Wht, 400 							; height
	mov Wtx, 50 							; right starting position
	mov Wty, 20								; down starting position 
	invoke CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR szClassName, ADDR szDisplayName, WS_OVERLAPPEDWINDOW, Wtx, Wty, Wwd, Wht, 0, 0, hInst, 0
	mov hWnd, EAX
	invoke LoadMenu, hInst, 600					; menu ID 
	invoke SetMenu, hWnd, EAX
	invoke ShowWindow, hWnd, SW_SHOWNORMAL 
	invoke UpdateWindow, hWnd
StartLoop:
	invoke GetMessage, ADDR msg, 0, 0, 0 
	cmp EAX, 0 
	je ExitLoop
	invoke TranslateMessage, ADDR msg 
	invoke DispatchMessage, ADDR msg 
	jmp StartLoop
ExitLoop:
	mov EAX, msg.wParam
	ret
WinMain endp


;_________________________________________________________________________



WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
	.if uMsg == WM_COMMAND
		.if wParam == 3000					; exit
			call Shut_Down_Roak
			invoke CloseHandle, hDriver
			invoke SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, 0
		.elseif wParam == 3100					; play roak wave
			invoke PlaySound, ADDR wave_path, 0, SND_ASYNC 
			invoke SetFocus, hWin
		.elseif wParam == 3200					; speaker on
			.if(hDriver != INVALID_HANDLE_VALUE && hDriver != 0)
				invoke Choose_Roak_Function, 1
				invoke Display_Return, hWin, 1
			.else
				invoke Interchange_With_Roak, hWin, 1
			.endif
			mov EAX, dStruct.Status
			invoke dwtoa, EAX, ADDR STATUS_RETURN
			invoke SendMessage, hEdit6, WM_SETTEXT, 32, ADDR STATUS_RETURN
			invoke SetFocus, hWin
		.elseif wParam == 3300					; speaker off
			.if(hDriver != INVALID_HANDLE_VALUE && hDriver != 0)
				invoke Choose_Roak_Function, 0
				invoke Display_Return, hWin, 0
			.else
				invoke Interchange_With_Roak, hWin, 0
			.endif
			mov EAX, dStruct.Status
			invoke dwtoa, EAX, ADDR STATUS_RETURN
			invoke SendMessage, hEdit6, WM_SETTEXT, 32, ADDR STATUS_RETURN
			invoke SetFocus, hWin
		.elseif wParam == 3400 					; read disk sector
			invoke SendMessage, hEdit3, WM_GETTEXT, 32, ADDR cylinder	
			invoke atodw, ADDR cylinder
			mov dStruct.c2, AL				; low cylinder
			mov dStruct.c3, AH				; high cylinder
			invoke SendMessage, hEdit4, WM_GETTEXT, 32, ADDR sector
			invoke atodw, ADDR sector
			.if AL == 0
				mov AL, 1
			.endif
			mov dStruct.c1, AL
			invoke SendMessage, hEdit5, WM_GETTEXT, 32, ADDR track
			or EAX, 0A0h					; master disk
			invoke atodw, ADDR track
			mov dStruct.c4, AL				; head
			.if(hDriver != INVALID_HANDLE_VALUE && hDriver != 0)
				invoke Choose_Roak_Function, 2
				invoke Display_Return, hWin, 2
			.else
				invoke Interchange_With_Roak, hWin, 2
			.endif
			mov EAX, dStruct.Status
			invoke dwtoa, EAX, ADDR STATUS_RETURN
			invoke SendMessage, hEdit6, WM_SETTEXT, 32, ADDR STATUS_RETURN
			invoke SetFocus, hWin
		.elseif wParam == 3500					; read serial number
			.if(hDriver != INVALID_HANDLE_VALUE && hDriver != 0)
				invoke Choose_Roak_Function, 3
				invoke Display_Return, hWin, 3
			.else
				invoke Interchange_With_Roak, hWin, 3
			.endif
			mov EAX, dStruct.Status
			invoke dwtoa, EAX, ADDR STATUS_RETURN
			invoke SendMessage, hEdit6, WM_SETTEXT, 32, ADDR STATUS_RETURN
			invoke SetFocus, hWin
		.elseif wParam == 3600					; call function by address
			.if(hDriver != INVALID_HANDLE_VALUE && hDriver != 0)
				mov EAX, my_os_test
				mov dStruct.osv, EAX
				invoke Choose_Roak_Function, 5
				invoke Display_Return, hWin, 5
			.else
				invoke Interchange_With_Roak, hWin, 5
			.endif
			mov EAX, dStruct.Status
			invoke dwtoa, EAX, ADDR STATUS_RETURN
			invoke SendMessage, hEdit6, WM_SETTEXT, 32, ADDR STATUS_RETURN
			invoke SetFocus, hWin
		.elseif wParam == 3700					; structured exception handling
			invoke SendMessage, hEdit1, WM_GETTEXT, 32, ADDR SEH_NUM_1	
			invoke atodw, ADDR SEH_NUM_1
			mov dStruct.c1, AL
			invoke SendMessage, hEdit2, WM_GETTEXT, 32, ADDR SEH_NUM_2	
			invoke atodw, ADDR SEH_NUM_2
			mov dStruct.c2, AL
			.if(hDriver != INVALID_HANDLE_VALUE && hDriver != 0)
				invoke Choose_Roak_Function, 4
				invoke Display_Return, hWin, 4
			.else
				invoke Interchange_With_Roak, hWin, 4
			.endif
			mov EAX, dStruct.Status
			invoke dwtoa, EAX, ADDR STATUS_RETURN
			invoke SendMessage, hEdit6, WM_SETTEXT, 32, ADDR STATUS_RETURN
			invoke SetFocus, hWin
		.elseif wParam == 3800					; about message box
			invoke MessageBox, hWin, ADDR about_mb_msg, ADDR szDisplayName , 0
			invoke SetFocus, hWin
		.elseif wParam == 3900					; what message box
			invoke MessageBox, hWin, ADDR what_mb_msg, ADDR what_mb_title , 0  
			invoke SetFocus, hWin
		.elseif wParam == 4000					; sys flow chart
			invoke MessageBox, hWin, ADDR flow_mb_msg, ADDR flow_mb_title , 0  
			invoke SetFocus, hWin
		.elseif wParam == 4100					; bibliography
			invoke MessageBox, hWin, ADDR biblio_mb_msg, ADDR biblio_mb_title , 0  
			invoke SetFocus, hWin
		.elseif wParam == 4200					; clock
			inc clock_test
			invoke SetTimer, hWin, 1, 1, 0
			.if (clock_test > 1)
				mov clock_test, 0
				invoke TextOut, EBX, 25, 0, ADDR no_clock_buf, 89
				invoke InvalidateRect, hWin, 0, 1
				invoke KillTimer, hWin, 1
			.endif
			invoke SetFocus, hWin
		.elseif wParam == 4300					; exe flow chart
			invoke MessageBox, hWin, ADDR exe_flow_mb_msg, ADDR exe_flow_mb_title , 0  
			invoke SetFocus, hWin
		.elseif wParam == 4400					; why
			invoke MessageBox, hWin, ADDR why_mb_msg, ADDR why_mb_title , 0  
			invoke SetFocus, hWin
		.endif
		ret
	.elseif uMsg == WM_CREATE
		invoke Creation_Procedure, hWin
		ret
	.elseif uMsg == WM_KEYDOWN
;		invoke KillTimer, hWin, 1
		ret
	.elseif uMsg == WM_TIMER
		invoke GetDC, hWin
		mov EBX, EAX
		call Time_Procedure
		.if (clock_test == 1)
			invoke TextOut, EBX, 25, 0, EAX, 65
		.endif
		ret
	.elseif uMsg == WM_CLOSE
		invoke PostQuitMessage, 0
		ret
	.endif
	invoke DefWindowProc, hWin, uMsg, wParam, lParam 	; set and display default window
	ret
WndProc endp


;_________________________________________________________________________



Choose_Roak_Function proc	control_value:DWORD
	.IF control_value == 0
		invoke DeviceIoControl, hDriver, IOCTL_SPEAKER_OFF, ADDR dStruct, sizeof dStruct, ADDR dStruct, sizeof dStruct, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 1
		invoke DeviceIoControl, hDriver, IOCTL_SPEAKER_ON, ADDR dStruct, sizeof dStruct, ADDR dStruct, sizeof dStruct, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 2
		invoke DeviceIoControl, hDriver, IOCTL_READ_HARD_DISK_SECTOR, ADDR dStruct, sizeof dStruct, ADDR dStruct, sizeof dStruct, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 3
		invoke DeviceIoControl, hDriver, IOCTL_READ_MEMORY, ADDR dStruct, sizeof dStruct, ADDR dStruct, sizeof dStruct, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 4
		invoke DeviceIoControl, hDriver, IOCTL_SEH, ADDR dStruct, sizeof dStruct, ADDR dStruct, sizeof dStruct, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 5
		invoke DeviceIoControl, hDriver, IOCTL_FUNCTION_ADDRESS, ADDR dStruct, sizeof dStruct, ADDR dStruct, sizeof dStruct, ADDR dwBytesReturned, 0
	.ENDIF
	ret									; IF deviceIoControl RETURN IN EAX != 0 WE HAVE SUCCESS
Choose_Roak_Function endp


;_________________________________________________________________________



Create_Edit_Box proc		ebszMsg:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, hParent:DWORD, ID:DWORD
	LOCAL hndle:DWORD
	invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR edit_class, ebszMsg, WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL, a, b, wd, ht, hParent, ID, hInstance, 0
	mov hndle, EAX
	ret
Create_Edit_Box endp


;_________________________________________________________________________



Create_Push_Button proc		lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
	invoke CreateWindowEx, 0, ADDR button_class, lpText, WS_CHILD or WS_VISIBLE, a, b, wd, ht, hParent, ID, hInstance, 0
	ret
Create_Push_Button endp


;_________________________________________________________________________



Creation_Procedure PROC		hWin:DWORD
;	invoke SetTimer, hWin, 1, 1, 0
	invoke Show_String, ADDR lbl1, hWin, 50, 030, 210, 17, 0
	invoke Show_String, ADDR lbl2, hWin, 50, 075, 180, 17, 0
	invoke Show_String, ADDR lbl3, hWin, 50, 120, 140, 17, 0
	invoke Show_String, ADDR lbl4, hWin, 50, 165, 110, 17, 0
	invoke Show_String, ADDR lbl5, hWin, 50, 210, 080, 17, 0
	invoke Show_String, ADDR lbl6, hWin, 50, 255, 050, 17, 0
	invoke Create_Edit_Box, 0, 50, 050, 235, 23, hWin, 17000
	mov hEdit1, EAX
	invoke Create_Edit_Box, 0, 50, 095, 205, 23, hWin, 18000
	mov hEdit2, EAX
	invoke Create_Edit_Box, 0, 50, 140, 170, 23, hWin, 19000
	mov hEdit3, EAX
	invoke Create_Edit_Box, 0, 50, 185, 130, 23, hWin, 19000
	mov hEdit4, EAX
	invoke Create_Edit_Box, 0, 50, 230, 090, 23, hWin, 20000
	mov hEdit5, EAX
	invoke Create_Edit_Box, 0, 50, 275, 050, 23, hWin, 20000
	mov hEdit6, EAX
	invoke dwtoa, 1, ADDR STATUS_RETURN
	invoke SendMessage, hEdit1, WM_SETTEXT, 32, ADDR STATUS_RETURN
	invoke dwtoa, 13, ADDR STATUS_RETURN
	invoke SendMessage, hEdit2, WM_SETTEXT, 32, ADDR STATUS_RETURN
	invoke dwtoa, 0, ADDR STATUS_RETURN
	invoke SendMessage, hEdit3, WM_SETTEXT, 32, ADDR STATUS_RETURN
	invoke dwtoa, 1, ADDR STATUS_RETURN
	invoke SendMessage, hEdit4, WM_SETTEXT, 32, ADDR STATUS_RETURN
	invoke dwtoa, 0, ADDR STATUS_RETURN
	invoke SendMessage, hEdit5, WM_SETTEXT, 32, ADDR STATUS_RETURN
	invoke SetWindowLong, hEdit1, GWL_WNDPROC, Filter_Input
	mov last_input, EAX
	invoke SetWindowLong, hEdit2, GWL_WNDPROC, Filter_Input
	mov last_input, EAX
	invoke SetWindowLong, hEdit3, GWL_WNDPROC, Filter_Input
	mov last_input, EAX
	invoke SetWindowLong, hEdit4, GWL_WNDPROC, Filter_Input
	mov last_input, EAX
	invoke SetWindowLong, hEdit5, GWL_WNDPROC, Filter_Input
	mov last_input, EAX
	invoke Create_Push_Button, ADDR exit_rnsexe_button,	hWin, 330, 030, 100, 23, 3000
	invoke Create_Push_Button, ADDR play_roakn_button,	hWin, 300, 070, 130, 23, 3100
	invoke Create_Push_Button, ADDR speaker_on_button,	hWin, 270, 110, 160, 23, 3200
	invoke Create_Push_Button, ADDR speaker_off_button,	hWin, 240, 150, 190, 23, 3300
	invoke Create_Push_Button, ADDR read_drive_button,	hWin, 210, 190, 220, 23, 3400
	invoke Create_Push_Button, ADDR read_serial_button,	hWin, 180, 230, 250, 23, 3500
	invoke Create_Push_Button, ADDR function_ad_button,	hWin, 150, 270, 280, 23, 3600
	invoke Create_Push_Button, ADDR sexception_button,	hWin, 120, 310, 310, 23, 3700
	ret
Creation_Procedure ENDP


;_________________________________________________________________________



Display_Return PROC uses ESI EDI EBX ECX EDX	hWin:DWORD, control_value:DWORD
	mov ESI, offset dStruct.b
	.if (control_value == 4)
		invoke MessageBox, 0, ESI, ADDR return_mb_title, 0
		ret
	.endif
	mov ECX, 0
	mov EDI, offset return_mb_msg
return_mb_msg_loop:
	mov AL, [ESI]
	.if AL == 0
		mov AL, 32
	.endif
	mov [EDI], AL
	inc ESI
	inc EDI
	inc ECX
	cmp ECX, 512
	jl return_mb_msg_loop
	.if (control_value != 4 && control_value != 2)
		mov AL, 0
		mov [EDI - 256], AL
	.endif
	invoke MessageBox, 0, ADDR return_mb_msg, ADDR return_mb_title, 0
	ret
Display_Return ENDP


;_________________________________________________________________________



Filter_Input proc			hCtl:DWORD, uMsg:DWORD, wParam :DWORD, lParam :DWORD	
	.if uMsg == WM_CHAR							; filter input
		.if wParam == 8 || (wParam >= 48 && wParam <= 57)	; accept backspace and numbers from '0' to '9'
			jmp accept_input
		.endif
		invoke MessageBox, hWnd, ADDR bad_input_mb_msg, ADDR bad_input_mb_title , 0 
		mov EAX, 0
		ret
	.endif
accept_input:
	invoke CallWindowProc, last_input, hCtl, uMsg, wParam, lParam
	ret
Filter_Input endp


;_________________________________________________________________________



Get_Os_Version proc
	LOCAL osvex:OSVERSIONINFO
	mov EAX, sizeof OSVERSIONINFO
	mov osvex.dwOSVersionInfoSize, EAX
	invoke GetVersionEx, ADDR osvex
	invoke wsprintf, ADDR version_buffer, ADDR version_msg, osvex.dwOSVersionInfoSize, osvex.dwMajorVersion, osvex.dwMinorVersion, osvex.dwBuildNumber, osvex.dwPlatformId
			invoke lstrcatA, ADDR version_mb_msg, ADDR version_buffer
	.if (osvex.dwMajorVersion == 4 && osvex.dwMinorVersion == 90); ME
			invoke lstrcatA, ADDR version_mb_msg, ADDR ME_msg
		mov my_os_test, 2001
	.endif
	.if (osvex.dwMajorVersion == 4 && osvex.dwMinorVersion == 10); 98SE
			invoke lstrcatA, ADDR version_mb_msg, ADDR W98SE_msg
		mov my_os_test, 98
	.endif
	.if (osvex.dwMajorVersion == 4 && osvex.dwMinorVersion < 10 && osvex.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS); 95
			invoke lstrcatA, ADDR version_mb_msg, ADDR W95_msg
		mov my_os_test, 95
	.endif 
	.if (osvex.dwPlatformId == VER_PLATFORM_WIN32_NT)
		.if(osvex.szCSDVersion[4] != 0)
			invoke wsprintf, ADDR version_buffer, ADDR additional_msg, ADDR osvex.szCSDVersion
			invoke lstrcatA, ADDR version_mb_msg, ADDR version_buffer
		.endif
		.if(osvex.dwMajorVersion == 5 && osvex.dwMinorVersion == 0)
			invoke lstrcatA, ADDR version_mb_msg, ADDR W2K_msg
			mov my_os_test, 50
		.endif
		.if(osvex.dwMajorVersion == 5 && osvex.dwMinorVersion == 1)
			invoke lstrcatA, ADDR version_mb_msg, ADDR WXP_msg
			mov my_os_test, 51
		.endif
		.if(osvex.dwMajorVersion == 3 && osvex.dwMinorVersion == 51 && osvex.dwPlatformId == VER_PLATFORM_WIN32_NT)
			invoke lstrcatA, ADDR version_mb_msg, ADDR NT351_msg
			mov my_os_test, 351
		.endif
		.if(osvex.dwMajorVersion == 4 && osvex.dwMinorVersion == 0 && osvex.dwPlatformId == VER_PLATFORM_WIN32_NT)
			invoke lstrcatA, ADDR version_mb_msg, ADDR NT4_msg
			mov my_os_test, 40
		.endif
	.endif
;	invoke MessageBox, 0, ADDR version_mb_msg, ADDR version_mb_title, 0
;	invoke RtlZeroMemory, ADDR version_mb_msg, 1000
	.if (osvex.dwPlatformId != VER_PLATFORM_WIN32_NT)
		invoke MessageBox, 0, ADDR not_you_mb_msg, ADDR not_you_mb_title, 0
	.endif
	mov EAX, my_os_test
	mov dStruct.osv, EAX
	ret
Get_Os_Version endp


;_________________________________________________________________________



Initialize_Roak_Sys proc
	LOCAL bool_test:DWORD
	invoke GetModuleFileName, hInstance, ADDR file_path, 512
	mov size_of_file_path, EAX
	mov EBX, size_of_file_path
slash_again:
	.if (file_path[EBX] == '\')
		jmp break_slash
	.endif
	dec EBX
	jmp slash_again
break_slash:
	mov dword ptr file_path[EBX+1], 'KAOR'
	mov dword ptr file_path[EBX+5], 'SYS.'
	mov dword ptr file_path[EBX+9], 0
	invoke OpenSCManager, 0, 0, 983103					; 983103 = SC_MANAGER_ALL_ACCESS
	mov manager_handle, EAX
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke ControlService, service_handle, 1,  ADDR ServiceStatus; 1 = SERVICE_CONTROL_STOP
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke DeleteService, service_handle				; SEND REMOVE COMMAND TO SERVICE MANAGER 
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE
	invoke CreateService, manager_handle, ADDR sys_name, ADDR sys_name, 983551, 1, 3, 1, ADDR file_path, 0, 0, 0, 0, 0	; 983551 = SERVICE_ALL_ACCESS, 1 = SERVICE_KERNEL_DRIVER, 3 = SERVICE_DEMAND_START, 1 = SERVICE_ERROR_NORMAL
	mov service_handle, EAX
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke StartService, service_handle, 0, 0				; SEND START DRIVER COMMAND
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE
.if (hDriver == INVALID_HANDLE_VALUE || hDriver == 0)
	invoke CreateFile, ADDR create_roak, GENERIC_READ or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	mov hDriver, EAX  
.endif
	.if(hDriver != INVALID_HANDLE_VALUE)
		mov bool_test, 1
	.else
		invoke CloseHandle, hDriver
		mov bool_test, 0
	.endif
	invoke CloseServiceHandle, manager_handle	
	invoke CloseServiceHandle, service_handle
	mov EAX, bool_test
	ret
Initialize_Roak_Sys endp


;_________________________________________________________________________



Interchange_With_Roak PROC		hWin:DWORD, function_number:DWORD 
	mov test_counter, 0
	call Get_Os_Version
	mov EAX, my_os_test
	mov dStruct.osv, EAX
do_it_again:
	call Initialize_Roak_Sys					; INITIALIZE DRIVER
	.if(EAX == 0)							; ERROR!
		invoke GetLastError
		inc test_counter
;		invoke wsprintf, ADDR interchange_buffer, ADDR interchange_msg, EAX, function_number
;		invoke MessageBox, hWin, ADDR interchange_buffer, ADDR interchange_error_mb_title, 0
		.if(test_counter > 100)
			jmp to_exit
		.endif
		jmp do_it_again
	.endif
	invoke Choose_Roak_Function, function_number		; CHOOSE DRIVER FUNCTION
	invoke Display_Return, hWin, function_number		; DISPLAY OUTPUT FROM STRUCTURE
to_exit:
	call Shut_Down_Roak
	ret
Interchange_With_Roak ENDP


;_________________________________________________________________________



Show_String proc		lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
	LOCAL hndle:DWORD
	invoke CreateWindowEx, WS_EX_LEFT, ADDR static_class, lpText, WS_CHILD or WS_VISIBLE or SS_LEFT, a, b, wd, ht, hParent, ID, hInstance, 0
	ret
Show_String endp



;_________________________________________________________________________



Shut_Down_Roak proc
	invoke OpenSCManager, 0, 0, 983103					; 983103 = SC_MANAGER_ALL_ACCESS
	mov manager_handle, EAX							; GET SERVICE CONTROL HANDLE
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke ControlService, service_handle, 1, ADDR ServiceStatus; 1 = SERVICE_CONTROL_STOP
	invoke CloseServiceHandle, service_handle
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX 
	invoke DeleteService, service_handle				; SEND REMOVE COMMAND
	invoke CloseServiceHandle, service_handle
	invoke CloseServiceHandle, manager_handle
	mov EAX, 1
	ret
Shut_Down_Roak endp 


;_________________________________________________________________________



Time_Procedure proc	USES EBX ECX EDX ESI EDI	
	invoke GetLocalTime, ADDR system_time
	mov EAX, 0
	mov AX, system_time.wYear
	mov stYear, EAX
	mov EAX, 0
	mov AX, system_time.wMonth
	mov stMonth, EAX
	mov EAX, 0								; day of week string
	mov AX, system_time.wDayOfWeek
	mov stDayOfWeek, EAX
	mov ECX, EAX
	mov EDI, offset day_array					; day_array
	cmp CL, 0
	je dont_bother_zero_2
day_loop:
	add EDI, 10
	dec ECX
	cmp CL, 0
	jne day_loop
dont_bother_zero_2:
	mov ESI, offset day_string
	xor ECX, ECX
null_day_loop:								; make null string it
	mov AL, BYTE PTR [EDI]
	.if AL == 32
		mov AL, 0
	.endif
	mov BYTE PTR [ESI], AL
	inc EDI
	inc ESI
	inc ECX
	cmp AL, 0
	jne null_day_loop
	mov EAX, 0								; day of month
	mov AX, system_time.wDay
	mov stDay, EAX
	mov EAX, 0
	mov AX, system_time.wHour
	mov stHour, EAX
	.if stHour >= 12
		invoke lstrcpyA, ADDR APM, ADDR szPM
		sub stHour, 12
		.if stHour == 0
			mov stHour, 12
		.endif
	.else
		.if stHour == 0
			mov stHour, 12
		.endif
		invoke lstrcpyA, ADDR APM, ADDR szAM
	.endif
	mov EAX, 0
	mov AX, system_time.wMinute
	mov stMinute, EAX
	mov EAX, 0
	mov AX, system_time.wSecond
	mov stSecond, EAX
	mov EAX, 0
	mov AX, system_time.wMilliseconds
	mov stMillisecond, EAX
	invoke wsprintf, ADDR time_date_string_buffer, ADDR szDate_Time, stMonth, stDay, stYear, ADDR day_string, stHour, stMinute, stSecond, stMillisecond, ADDR APM
	mov EAX, offset time_date_string_buffer
	ret
Time_Procedure endp


;_________________________________________________________________________



end start
