


;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<MACROS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



CTL_CODE MACRO DeviceType,Function,Method,Access
EXITM %(((DeviceType) SHL 16) OR ((Access) SHL 14) OR ((Function) SHL 2) OR (Method))
ENDM



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<EQUS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



TRUE								EQU 1
FALSE								EQU 0
NULL								EQU 0
KernelMode							EQU 0
UserMode							EQU 1
IoReadAccess						EQU 0
IoWriteAccess						EQU 1
IoModifyAccess						EQU 2
NonPagedPool						EQU 0
PagedPool							EQU 1
NonPagedPoolMustSucceed					EQU 2
DontUseThisType						EQU 3
NonPagedPoolCacheAligned				EQU 4
PagedPoolCacheAligned					EQU 5
NonPagedPoolCacheAlignedMustS				EQU 6
MaxPoolType							EQU 7
MUTEX_LEVEL_VDM_IO					EQU 1h
MUTEX_LEVEL_EX_PROFILE					EQU 40h
MUTEX_LEVEL_RDR_FILESYS_DATABASE			EQU 10100000h
MUTEX_LEVEL_RDR_FILESYS_SECURITY			EQU 10100001h
MUTEX_LEVEL_FILESYSTEM_RAW_VCB			EQU 11000006h
MUTEX_LEVEL_STREAMS_SUBSYS				EQU 11001001h
MUTEX_LEVEL_PS_LDT					EQU 1F000000h
MDL_MAPPED_TO_SYSTEM_VA					EQU 1h
MDL_PAGES_LOCKED						EQU 2h
MDL_SOURCE_IS_NONPAGED_POOL				EQU 4h
MDL_ALLOCATED_FIXED_SIZE				EQU 8h
MDL_PARTIAL							EQU 10h
MDL_PARTIAL_HAS_BEEN_MAPPED				EQU 20h
MDL_IO_PAGE_READ						EQU 40h
MDL_WRITE_OPERATION					EQU 80h
MDL_PARENT_MAPPED_SYSTEM_VA				EQU 100h
MDL_LOCK_HELD						EQU 200h
MDL_PHYSICAL_VIEW						EQU 400h
MDL_IO_SPACE						EQU 800h
MDL_NETWORK_HEADER					EQU 1000h
MDL_MAPPING_CAN_FAIL					EQU 2000h
MDL_ALLOCATED_MUST_SUCCEED				EQU 4000h
MDL_MAPPING_FLAGS						EQU MDL_MAPPED_TO_SYSTEM_VA or MDL_PAGES_LOCKED MDL_SOURCE_IS_NONPAGED_POOL or MDL_PARTIAL_HAS_BEEN_MAPPED or MDL_PARENT_MAPPED_SYSTEM_VA or MDL_LOCK_HELD or MDL_SYSTEM_VA or MDL_IO_SPACE
DELETE							EQU 10000h
READ_CONTROL						EQU 20000h
WRITE_DAC							EQU 40000h
WRITE_OWNER							EQU 80000h
SYNCHRONIZE							EQU 100000h
STANDARD_RIGHTS_REQUIRED				EQU 0F0000h
STANDARD_RIGHTS_READ					EQU READ_CONTROL
STANDARD_RIGHTS_WRITE					EQU READ_CONTROL
STANDARD_RIGHTS_EXECUTE					EQU READ_CONTROL
STANDARD_RIGHTS_ALL					EQU 1F0000h
SPECIFIC_RIGHTS_ALL					EQU 0FFFFh
ACCESS_SYSTEM_SECURITY					EQU 1000000h
MAXIMUM_ALLOWED						EQU 2000000h
GENERIC_EXECUTE						EQU 20000000h
GENERIC_ALL							EQU 10000000h
ACL_REVISION						EQU 2h
ACL_REVISION_DS						EQU 4h
ACL_REVISION1						EQU 1h
MIN_ACL_REVISION						EQU ACL_REVISION2
ACL_REVISION2						EQU 2h
ACL_REVISION3						EQU 3h
ACL_REVISION4						EQU 4h
MAX_ACL_REVISION						EQU ACL_REVISION4
PRIVILEGE_SET_ALL_NECESSARY				EQU 1h
SECURITY_DESCRIPTOR_REVISION				EQU 1h
SECURITY_DESCRIPTOR_REVISION1				EQU 1h
SE_PRIVILEGE_ENABLED_BY_DEFAULT			EQU 1h
SE_PRIVILEGE_ENABLED					EQU 2h
SE_PRIVILEGE_USED_FOR_ACCESS				EQU 80000000h
SE_MIN_WELL_KNOWN_PRIVILEGE				EQU 2h
SE_CREATE_TOKEN_PRIVILEGE				EQU 2h
SE_ASSIGNPRIMARYTOKEN_PRIVILEGE			EQU 3h
SE_LOCK_MEMORY_PRIVILEGE				EQU 4h
SE_INCREASE_QUOTA_PRIVILEGE				EQU 5h
SE_UNSOLICITED_INPUT_PRIVILEGE			EQU 6h
SE_MACHINE_ACCOUNT_PRIVILEGE				EQU 6h
SE_TCB_PRIVILEGE						EQU 7h
SE_SECURITY_PRIVILEGE					EQU 8h
SE_TAKE_OWNERSHIP_PRIVILEGE				EQU 9h
SE_LOAD_DRIVER_PRIVILEGE				EQU 10
SE_SYSTEM_PROFILE_PRIVILEGE				EQU 11
SE_SYSTEMTIME_PRIVILEGE					EQU 12
SE_PROF_SINGLE_PROCESS_PRIVILEGE			EQU 13
SE_INC_BASE_PRIORITY_PRIVILEGE			EQU 14
SE_CREATE_PAGEFILE_PRIVILEGE				EQU 15
SE_CREATE_PERMANENT_PRIVILEGE				EQU 16
SE_BACKUP_PRIVILEGE					EQU 17
SE_RESTORE_PRIVILEGE					EQU 18
SE_SHUTDOWN_PRIVILEGE					EQU 19
SE_DEBUG_PRIVILEGE					EQU 20
SE_AUDIT_PRIVILEGE					EQU 21
SE_SYSTEM_ENVIRONMENT_PRIVILEGE			EQU 22
SE_CHANGE_NOTIFY_PRIVILEGE				EQU 23
SE_REMOTE_SHUTDOWN_PRIVILEGE				EQU 24
SE_UNDOCK_PRIVILEGE					EQU 25
SE_SYNC_AGENT_PRIVILEGE					EQU 26
SE_ENABLE_DELEGATION_PRIVILEGE			EQU 27
SE_MAX_WELL_KNOWN_PRIVILEGE				EQU SE_ENABLE_DELEGATION_PRIVILEGE
SECURITY_DYNAMIC_TRACKING				EQU 1
SECURITY_STATIC_TRACKING				EQU 0
OWNER_SECURITY_INFORMATION				EQU 1h
GROUP_SECURITY_INFORMATION				EQU 2h
DACL_SECURITY_INFORMATION				EQU 4h
SACL_SECURITY_INFORMATION				EQU 8h
PROTECTED_DACL_SECURITY_INFORMATION			EQU 80000000h
PROTECTED_SACL_SECURITY_INFORMATION			EQU 40000000h
UNPROTECTED_DACL_SECURITY_INFORMATION		EQU 20000000h
UNPROTECTED_SACL_SECURITY_INFORMATION		EQU 10000000h
LOW_PRIORITY						EQU 0
LOW_REALTIME_PRIORITY					EQU 16
HIGH_PRIORITY						EQU 31
MAXIMUM_PRIORITY						EQU 32
MAXIMUM_WAIT_OBJECTS					EQU 64
MAXIMUM_SUSPEND_COUNT					EQU MAXCHAR
SystemBasicInfo						EQU 0
SystemProcessorInfo					EQU 1
SystemPerformanceInfo					EQU 2
SystemTimeInfo						EQU 3
SystemPathInfo						EQU 4
SystemProcessThreadInfo					EQU 5
SystemServiceDescriptorTableInfo			EQU 6
SystemIoConfigInfo					EQU 7
SystemProcessorTimeInfo					EQU 8
SystemNtGlobalFlagInfo					EQU 9
SystemNotImplemented1					EQU 10
SystemModuleInfo						EQU 11
SystemResourceLockInfo					EQU 12
SystemNotImplemented2					EQU 13
SystemNotImplemented3					EQU 14
SystemNotImplemented4					EQU 15
SystemHandleInfo						EQU 16
SystemObjectInformation					EQU 17
SystemPageFileInformation				EQU 18
SystemInstructionEmulationInfo			EQU 19
SystemNotUsed1						EQU 20
SystemCacheInfo						EQU 21
SystemPoolTagInfo						EQU 22
SystemProcessorScheduleInfo				EQU 23
SystemDpcInfo						EQU 24
SystemNotImplemented5					EQU 25
SystemLoadSystemImage					EQU 26
SystemUnloadSystemImage					EQU 27
SystemTimerInfo						EQU 28
SystemNotImplemented6					EQU 29
SystemNotImplemented7					EQU 30
SystemNotImplemented8					EQU 31
SystemCrashDumpSectionInfo				EQU 32
SystemProcessorFaultCountInfo				EQU 33
SystemCrashDumpStateInfo				EQU 34
SystemDebuggerInfo					EQU 35
SystemThreadSwitchCounters				EQU 36
SystemQuotaInfo						EQU 37
SystemLoadDriverInfo					EQU 38
SystemPrioritySeparation				EQU 39
SystemNotImplemented9					EQU 40
SystemNotImplemented10					EQU 41
SystemNotUsed6						EQU 42
SystemNotUsed7						EQU 43
SystemTimeZoneIno						EQU 44
SystemLookasideInfo					EQU 45
CmResourceTypeNull					EQU 0
CmResourceTypePort					EQU 1
CmResourceTypeInterrupt					EQU 2
CmResourceTypeMemory					EQU 3
CmResourceTypeDma						EQU 4
CmResourceTypeDeviceSpecific				EQU 5
CmResourceTypeBusNumber					EQU 6
CmResourceTypeMaximum					EQU 7
CmResourceTypeAssignedResource			EQU 8
CmResourceTypeSubAllocateFrom				EQU 9
CmResourceTypeNonArbitrated				EQU 128
CmResourceTypeConfigData				EQU 128
CmResourceTypeDevicePrivate				EQU 129
CmResourceTypePcCardConfig				EQU 130
CmResourceTypeMfCardConfig				EQU 131
CM_RESOURCE_COMMON_COMPUTE_LENGTH_FROM_DEPENDENTS EQU 8000h
CM_RESOURCE_COMMON_NOT_REASSIGNED			EQU 4000h
CM_RESOURCE_COMMON_SUBSTRACTIVE			EQU 2000h
CM_RESOURCE_INTERRUPT_LEVEL_SENSITIVE		EQU 0h
CM_RESOURCE_INTERRUPT_LATCHED				EQU 1h
CM_RESOURCE_MEMORY_READ_WRITE				EQU 0h
CM_RESOURCE_MEMORY_READ_ONLY				EQU 1h
CM_RESOURCE_MEMORY_WRITE_ONLY				EQU 2h
CM_RESOURCE_MEMORY_PREFETCHABLE			EQU 4h
CM_RESOURCE_MEMORY_COMBINEDWRITE			EQU 8h
CM_RESOURCE_MEMORY_24					EQU 10h
CM_RESOURCE_MEMORY_CACHEABLE				EQU 20h
CM_RESOURCE_PORT_MEMORY					EQU 0h
CM_RESOURCE_PORT_IO					EQU 1h
CM_RESOURCE_PORT_FORWARD_FIRST_256_OF_EACH_1024	EQU 2h
CM_RESOURCE_PORT_10_BIT_DECODE			EQU 4h
CM_RESOURCE_PORT_12_BIT_DECODE			EQU 8h
CM_RESOURCE_PORT_16_BIT_DECODE			EQU 10h
CM_RESOURCE_PORT_POSITIVE_DECODE			EQU 20h
CM_RESOURCE_PORT_PASSIVE_DECODE			EQU 40h
CM_RESOURCE_PORT_WINDOW_DECODE			EQU 80h
CM_RESOURCE_DMA_8						EQU 0h
CM_RESOURCE_DMA_16					EQU 1h
CM_RESOURCE_DMA_32					EQU 2h
CM_RESOURCE_DMA_8_AND_16				EQU 4h
CM_RESOURCE_DMA_BUS_MASTER				EQU 8h
CM_RESOURCE_DMA_TYPE_A					EQU 10h
CM_RESOURCE_DMA_TYPE_B					EQU 20h
CM_RESOURCE_DMA_TYPE_F					EQU 40h
CM_RESOURCE_BUSNUMBER_SUBALLOCATE_FIRST_VALUE	EQU 1h
CM_RESOURCE_SUBALLOCATEFROM_FIXED_TRANSLATION	EQU 1h
CM_RESOURCE_SUBALLOCATEFROM_WIRED_TRANSLATION	EQU 2h
SECTION_QUERY						EQU 1
SECTION_MAP_WRITE						EQU 2
SECTION_MAP_READ						EQU 4
SECTION_MAP_EXECUTE					EQU 8
SECTION_EXTEND_SIZE					EQU 10h
SECTION_ALL_ACCESS					EQU STANDARD_RIGHTS_REQUIRED or SECTION_QUERY or SECTION_MAP_WRITE or SECTION_MAP_READ or SECTION_MAP_EXECUTE or SECTION_EXTEND_SIZE
SEGMENT_ALL_ACCESS					EQU SECTION_ALL_ACCESS
MEM_LARGE_PAGES						EQU 20000000h
PROCESS_DUP_HANDLE					EQU 40h
PROCESS_ALL_ACCESS					EQU STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 0FFFh
MAXIMUM_PROCESSORS 					EQU 32
THREAD_TERMINATE						EQU 1
THREAD_SET_INFORMATION					EQU 20h
THREAD_ALL_ACCESS						EQU STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 3FFh
DEVICE_DESCRIPTION_VERSION				EQU 0
DEVICE_DESCRIPTION_VERSION1				EQU 1
DO_BUFFERED_IO						EQU 4h
DO_EXCLUSIVE						EQU 8h
DO_DIRECT_IO						EQU 10h
DO_MAP_IO_BUFFER						EQU 20h
DO_DEVICE_INITIALIZING					EQU 80h
DO_SHUTDOWN_REGISTERED					EQU 800h
DO_BUS_ENUMERATED_DEVICE				EQU 1000h
DO_POWER_PAGABLE						EQU 2000h
DO_POWER_INRUSH						EQU 4000h
SECTION_MAP_READ						EQU 4h
UP_KUSER_SHARED_DATA					EQU 7FFE0000h
MAX_PATH							EQU 260
FB_FASTSYSCALL						EQU 1000h
THREAD_INFO_OFFSET					EQU 24h
THREAD_INFO_SIZE						EQU 40h
NT4_PROCESS_INFO_SIZE					EQU 88h
NT5_PROCESS_INFO_SIZE					EQU 0B8h
ABOVE2GB							EQU 8000000h
ADJUST_CURRENT_PROCESS					EQU 0h
ADJUST_CURRENT_THREAD					EQU 1h
PAGE_NOACCESS						EQU 1h
PAGE_READONLY						EQU 2h
PAGE_READWRITE						EQU 4h
PAGE_WRITECOPY						EQU 8h
PAGE_EXECUTE						EQU 10h
PAGE_EXECUTE_READ						EQU 20h
PAGE_EXECUTE_READWRITE					EQU 40h
PAGE_EXECUTE_WRITECOPY					EQU 80h
PAGE_GUARD							EQU 100h
PAGE_NOCACHE						EQU 200h
PAGE_WRITECOMBINE						EQU 400h
MEM_COMMIT							EQU 1000h  
MEM_RESERVE							EQU 2000h
MEM_DECOMMIT						EQU 4000h
MEM_RELEASE							EQU 8000h
MEM_FREE							EQU 10000h
MEM_PRIVATE							EQU 20000h
MEM_MAPPED							EQU 40000h
MEM_RESET							EQU 80000h
MEM_TOP_DOWN						EQU 100000h
MEM_4MB_PAGES						EQU 80000000
SEC_FILE							EQU 800000
SEC_IMAGE							EQU 1000000
SEC_VLM							EQU 2000000
SEC_RESERVE							EQU 4000000
SEC_COMMIT							EQU 8000000
SEC_NOCACHE							EQU 10000000
MEM_IMAGE							EQU SEC_IMAGE
TS_INITIALIZED						EQU 0h
TS_READY							EQU 1h
TS_RUNNING							EQU 2h
TS_STANDBY							EQU 3h
TS_TERMINATED						EQU 4h
TS_WAITING							EQU 5h
TS_TRANSITION						EQU 6h
TS_MAX							EQU 7h
WR_EXECUTIVE						EQU 0
WR_FREEPAGE							EQU 1
WR_PAGEIN							EQU 2
WR_POOLALLOC						EQU 3
WR_DELAYEXEC						EQU 4
WR_SUSPENDED						EQU 5
WR_USERREQUEST						EQU 6
WR_EXECUTIVE_						EQU 7
WR_FREEPAGE_						EQU 8
WR_PAGEIN_							EQU 9
WR_POOLALLOC_						EQU 10
WR_DELAYEXEC_						EQU 11
WR_SUSPENDED_						EQU 12
WR_USERREQUEST_						EQU 13
WR_EVENTPAIRHIGH						EQU 14
WR_EVENTPAIRLOW						EQU 15
WR_LPCRECEIVE						EQU 16
WR_LPCREPLY							EQU 17
WR_VIRTMEMORY						EQU 18
WR_PAGEOUT							EQU 19
WR_SPARE1							EQU 20
WR_SPARE2							EQU 21
WR_SPARE3							EQU 22
WR_SPARE4							EQU 23
WR_SPARE5							EQU 24
WR_SPARE6							EQU 25
WR_SPARE7							EQU 26
WR_MAX							EQU 27
OBJ_INHERIT							EQU 2h
OBJ_PERMANENT						EQU 10h
OBJ_EXCLUSIVE						EQU 20h
OBJ_CASE_INSENSITIVE					EQU 40h
OBJ_KERNEL_HANDLE						EQU 200h
OBJ_VALID_ATTRIBUTES					EQU 3F2h 
OBJ_OPENIF							EQU 80h
OBJ_OPENLINK						EQU 100h
GENERIC_READ						EQU 80000000h
FILE_SHARE_READ						EQU 1h
FILE_OPEN							EQU 1h
FILE_SYNCHRONOUS_IO_NONALERT				EQU 20h
GENERIC_WRITE						EQU 40000000h
SYNCHRONIZE							EQU 100000h
FILE_APPEND_DATA						EQU 4h
FILE_ATTRIBUTE_NORMAL					EQU 80h
FILE_OVERWRITE_IF						EQU 5h
FILE_SYNCHRONOUS_IO_NONALERT				EQU 20h
INHERITED_ADDRESS_SPACE					EQU 1h
READ_IMAGEFILE_EXEC_OPTIONS				EQU 100h
BEING_DEBUGGED						EQU 10000h
LDRP_STATIC_LINK						EQU 2h
LDRP_IMAGE_DLL						EQU 4h
LDRP_LOAD_IN_PROGRESS					EQU 1000h
LDRP_UNLOAD_IN_PROGRESS					EQU 2000h
LDRP_ENTRY_PROCESSED					EQU 4000h
LDRP_ENTRY_INSERTED					EQU 8000h
LDRP_CURRENT_LOAD						EQU 10000h
LDRP_FAILED_BUILTIN_LOAD				EQU 20000h
LDRP_DONT_CALL_FOR_THREADS				EQU 40000h
LDRP_PROCESS_ATTACH_CALLED				EQU 80000h
LDRP_DEBUG_SYMBOLS_LOADED				EQU 100000h
LDRP_IMAGE_NOT_AT_BASE					EQU 200000h
LDRP_WX86_IGNORE_MACHINETYPE				EQU 400000h
GF_SOE							EQU 1h
GF_SLS							EQU 2h
GF_DIC							EQU 4h
GF_SHG							EQU 8h
GF_HTC							EQU 10h
GF_HFC							EQU 20h
GF_HPC							EQU 40h
GF_HVC							EQU 80h
GF_PTC							EQU 100h
GF_PFC							EQU 200h
GF_PTG							EQU 400h
GF_HTG							EQU 800h
GF_UST							EQU 1000h
GF_KST							EQU 2000h
GF_OTL							EQU 4000h
GF_HTD							EQU 8000h
GF_IDP							EQU 10000h
GF_D32							EQU 20000h
GF_KSL							EQU 40000h
GF_DPS							EQU 80000h
GF_HAT							EQU 100000h
GF_DHC							EQU 200000h
GF_ECE							EQU 400000h
GF_EEL							EQU 800000h
GF_EOT							EQU 1000000h
GF_HPA 							EQU 2000000h
GF_DWL 							EQU 4000000h
GF_DDP							EQU 8000000h
GF_ECC							EQU 10000000h
GF_DPD							EQU 80000000h
FLG_STOP_ON_EXCEPTION					EQU GF_SOE
FLG_SHOW_LDR_SNAPS					EQU GF_SLS
FLG_DEBUG_INITIAL_COMMAND				EQU GF_DIC
FLG_STOP_ON_HUNG_GUI					EQU GF_SHG
FLG_HEAP_ENABLE_TAIL_CHECK				EQU GF_HTC
FLG_HEAP_ENABLE_FREE_CHECK				EQU GF_HFC
FLG_HEAP_VALIDATE_PARAMETERS				EQU GF_HPC
FLG_HEAP_VALIDATE_ALL					EQU GF_HVC
FLG_POOL_ENABLE_TAIL_CHECK				EQU GF_PTC
FLG_POOL_ENABLE_FREE_CHECK				EQU GF_PFC
FLG_POOL_ENABLE_TAGGING					EQU GF_PTG
FLG_USER_STACK_TRACE_DB					EQU GF_UST
FLG_KERNEL_STACK_TRACE_DB				EQU GF_KST
FLG_MAINTAIN_OBJECT_TYPELIST 				EQU GF_OTL
FLG_WIN95_MODE						EQU GF_HTD
FLG_IGNORE_DEBUG_PRIV 					EQU GF_IDP
FLG_ENABLE_CSRDEBUG 					EQU GF_D32
FLG_ENABLE_KDEBUG_SYMBOL_LOAD				EQU GF_KSL
FLG_DISABLE_PAGE_KERNEL_STACKS			EQU GF_DPS
FLG_VALID_BITS						EQU 0FF7FFh
OB_TYPE_TYPE						EQU 1h
OB_TYPE_DIRECTORY						EQU 2h
OB_TYPE_SYMBOLIC_LINK					EQU 3h
OB_TYPE_TOKEN						EQU 4h
OB_TYPE_PROCESS						EQU 5h
OB_TYPE_THREAD						EQU 6h
OB_TYPE_EVENT						EQU 7h
OB_TYPE_EVENT_PAIR					EQU 8h
OB_TYPE_MUTANT						EQU 9h
OB_TYPE_SEMAPHORE						EQU 10h
OB_TYPE_TIMER						EQU 11h
OB_TYPE_PROFILE						EQU 12h
OB_TYPE_WINDOW_STATION					EQU 13h
OB_TYPE_DESKTOP						EQU 14h
OB_TYPE_SECTION						EQU 15h
OB_TYPE_KEY							EQU 16h
OB_TYPE_PORT						EQU 17h
OB_TYPE_ADAPTER						EQU 18h
OB_TYPE_CONTROLLER					EQU 19h
OB_TYPE_DEVICE						EQU 20h
OB_TYPE_DRIVER						EQU 21h
OB_TYPE_IO_COMPLETION					EQU 22h
OB_TYPE_FILE						EQU 23h
RTL_QUERY_REGISTRY_SUBKEY				EQU 1
RTL_QUERY_REGISTRY_TOPKEY				EQU 2
RTL_QUERY_REGISTRY_REQUIRED				EQU 4
RTL_QUERY_REGISTRY_NOVALUE				EQU 8
RTL_QUERY_REGISTRY_NOEXPAND				EQU 10h
RTL_QUERY_REGISTRY_DIRECT				EQU 20h
RTL_QUERY_REGISTRY_DELETE				EQU 40h
RTL_REGISTRY_ABSOLUTE					EQU 0
RTL_REGISTRY_SERVICES					EQU 1
RTL_REGISTRY_CONTROL					EQU 2
RTL_REGISTRY_WINDOWS_NT					EQU 3
RTL_REGISTRY_DEVICEMAP					EQU 4
RTL_REGISTRY_USER						EQU 5
RTL_REGISTRY_MAXIMUM					EQU 6
RTL_REGISTRY_HANDLE					EQU 40000000h
RTL_REGISTRY_OPTIONAL					EQU 80000000h
FILE_DEVICE_BEEP						EQU 1
FILE_DEVICE_CD_ROM					EQU 2
FILE_DEVICE_CD_ROM_FILE_SYSTEM			EQU 3
FILE_DEVICE_CONTROLLER					EQU 4
FILE_DEVICE_DATALINK					EQU 5
FILE_DEVICE_DFS						EQU 6
FILE_DEVICE_DISK						EQU 7
FILE_DEVICE_DISK_FILE_SYSTEM				EQU 8
FILE_DEVICE_FILE_SYSTEM					EQU 9
FILE_DEVICE_INPORT_PORT					EQU 0Ah
FILE_DEVICE_KEYBOARD					EQU 0Bh
FILE_DEVICE_MAILSLOT					EQU 0Ch
FILE_DEVICE_MIDI_IN					EQU 0Dh
FILE_DEVICE_MIDI_OUT					EQU 0Eh
FILE_DEVICE_MOUSE						EQU 0Fh
FILE_DEVICE_MULTI_UNC_PROVIDER			EQU 10h
FILE_DEVICE_NAMED_PIPE					EQU 11h
FILE_DEVICE_NETWORK					EQU 12h
FILE_DEVICE_NETWORK_BROWSER				EQU 13h
FILE_DEVICE_NETWORK_FILE_SYSTEM			EQU 14h
FILE_DEVICE_NULL						EQU 15h
FILE_DEVICE_PARALLEL_PORT				EQU 16h
FILE_DEVICE_PHYSICAL_NETCARD				EQU 17h
FILE_DEVICE_PRINTER					EQU 18h
FILE_DEVICE_SCANNER					EQU 19h
FILE_DEVICE_SERIAL_MOUSE_PORT				EQU 1Ah
FILE_DEVICE_SERIAL_PORT					EQU 1Bh
FILE_DEVICE_SCREEN					EQU 1Ch
FILE_DEVICE_SOUND						EQU 1Dh
FILE_DEVICE_STREAMS					EQU 1Eh
FILE_DEVICE_TAPE						EQU 1Fh
FILE_DEVICE_TAPE_FILE_SYSTEM				EQU 20h
FILE_DEVICE_TRANSPORT					EQU 21h
FILE_DEVICE_UNKNOWN					EQU 22h
FILE_DEVICE_VIDEO						EQU 23h
FILE_DEVICE_VIRTUAL_DISK				EQU 24h
FILE_DEVICE_WAVE_IN					EQU 25h
FILE_DEVICE_WAVE_OUT					EQU 26h
FILE_DEVICE_8042_PORT					EQU 27h
FILE_DEVICE_NETWORK_REDIRECTOR			EQU 28h
FILE_DEVICE_BATTERY					EQU 29h
FILE_DEVICE_BUS_EXTENDER				EQU 2Ah
FILE_DEVICE_MODEM						EQU 2Bh
FILE_DEVICE_VDM						EQU 2Ch
FILE_DEVICE_MASS_STORAGE				EQU 2Dh
FILE_DEVICE_SMB						EQU 2Eh
FILE_DEVICE_KS						EQU 2Fh
FILE_DEVICE_CHANGER					EQU 30h
FILE_DEVICE_SMARTCARD					EQU 31h
FILE_DEVICE_ACPI						EQU 32h
FILE_DEVICE_DVD						EQU 33h
FILE_DEVICE_FULLSCREEN_VIDEO				EQU 34h
FILE_DEVICE_DFS_FILE_SYSTEM				EQU 35h
FILE_DEVICE_DFS_VOLUME					EQU 36h
FILE_DEVICE_SERENUM					EQU 37h
FILE_DEVICE_TERMSRV					EQU 38h
FILE_DEVICE_KSEC						EQU 39h
METHOD_BUFFERED						EQU 0
METHOD_IN_DIRECT						EQU 1
METHOD_OUT_DIRECT						EQU 2
METHOD_NEITHER						EQU 3
FILE_ANY_ACCESS						EQU 0
FILE_SPECIAL_ACCESS					EQU FILE_ANY_ACCESS
FILE_READ_ACCESS						EQU 1
FILE_WRITE_ACCESS						EQU 2
FILE_READ_DATA						EQU 1
FILE_LIST_DIRECTORY					EQU 1
FILE_WRITE_DATA						EQU 2
FILE_ADD_FILE						EQU 2
FILE_APPEND_DATA						EQU 4
FILE_ADD_SUBDIRECTORY					EQU 4
FILE_CREATE_PIPE_INSTANCE				EQU 4
FILE_READ_EA						EQU 8
FILE_WRITE_EA						EQU 10h
FILE_EXECUTE						EQU 20h
FILE_TRAVERSE						EQU 20h
FILE_DELETE_CHILD						EQU 40h
FILE_READ_ATTRIBUTES					EQU 80h
FILE_WRITE_ATTRIBUTES					EQU 100h
FILE_ALL_ACCESS						EQU STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 1FFh
FILE_GENERIC_READ						EQU STANDARD_RIGHTS_READ or FILE_READ_DATA or FILE_READ_ATTRIBUTES or FILE_READ_EA or SYNCHRONIZE
FILE_GENERIC_WRITE					EQU STANDARD_RIGHTS_WRITE or FILE_WRITE_DATA or FILE_WRITE_ATTRIBUTES or FILE_WRITE_EA or FILE_APPEND_DATA or SYNCHRONIZE
FILE_GENERIC_EXECUTE					EQU STANDARD_RIGHTS_EXECUTE or FILE_READ_ATTRIBUTES or FILE_EXECUTE or SYNCHRONIZE
FILE_SHARE_READ						EQU 1
FILE_SHARE_WRITE						EQU 2
FILE_SHARE_DELETE						EQU 4
FILE_SHARE_VALID_FLAGS					EQU 7
FILE_ATTRIBUTE_READONLY					EQU 1
FILE_ATTRIBUTE_HIDDEN					EQU 2
FILE_ATTRIBUTE_SYSTEM					EQU 4
FILE_ATTRIBUTE_DIRECTORY				EQU 10h
FILE_ATTRIBUTE_ARCHIVE					EQU 20h
FILE_ATTRIBUTE_DEVICE					EQU 40h
FILE_ATTRIBUTE_NORMAL					EQU 80h
FILE_ATTRIBUTE_TEMPORARY				EQU 100h
FILE_ATTRIBUTE_SPARSE_FILE				EQU 200h
FILE_ATTRIBUTE_REPARSE_POINT				EQU 400h
FILE_ATTRIBUTE_COMPRESSED				EQU 800h
FILE_ATTRIBUTE_OFFLINE					EQU 1000h
FILE_ATTRIBUTE_NOT_CONTENT_INDEXED			EQU 2000h
FILE_ATTRIBUTE_ENCRYPTED				EQU 4000h
FILE_ATTRIBUTE_CONTENT_INDEXED			EQU FILE_ATTRIBUTE_NOT_CONTENT_INDEXED
FILE_ATTRIBUTE_VALID_FLAGS				EQU 7FB7h
FILE_ATTRIBUTE_VALID_SET_FLAGS			EQU 31A7h
FILE_SUPERSEDE						EQU 0
FILE_OPEN							EQU 1
FILE_CREATE							EQU 2
FILE_OPEN_IF						EQU 3
FILE_OVERWRITE						EQU 4
FILE_OVERWRITE_IF						EQU 5
FILE_MAXIMUM_DISPOSITION				EQU 5
FILE_DIRECTORY_FILE					EQU 1
FILE_WRITE_THROUGH					EQU 2
FILE_SEQUENTIAL_ONLY					EQU 4
FILE_NO_INTERMEDIATE_BUFFERING			EQU 8
FILE_SYNCHRONOUS_IO_ALERT				EQU 10h
FILE_SYNCHRONOUS_IO_NONALERT				EQU 20h
FILE_NON_DIRECTORY_FILE					EQU 40h
FILE_CREATE_TREE_CONNECTION				EQU 80h
FILE_COMPLETE_IF_OPLOCKED				EQU 100h
FILE_NO_EA_KNOWLEDGE					EQU 200h
FILE_OPEN_FOR_RECOVERY					EQU 400h
FILE_RANDOM_ACCESS					EQU 800h
FILE_DELETE_ON_CLOSE					EQU 1000h
FILE_OPEN_BY_FILE_ID					EQU 2000h
FILE_OPEN_FOR_BACKUP_INTENT				EQU 4000h
FILE_NO_COMPRESSION					EQU 8000h
FILE_RESERVE_OPFILTER					EQU 100000h
FILE_OPEN_REPARSE_POINT					EQU 200000h
FILE_OPEN_NO_RECALL					EQU 400000h
FILE_OPEN_FOR_FREE_SPACE_QUERY			EQU 800000h
FILE_COPY_STRUCTURED_STORAGE				EQU 41h
FILE_STRUCTURED_STORAGE					EQU 441h
FILE_VALID_OPTION_FLAGS					EQU 0FFFFFFh
FILE_VALID_PIPE_OPTION_FLAGS				EQU 32h
FILE_VALID_MAILSLOT_OPTION_FLAGS			EQU 32h
FILE_VALID_SET_FLAGS					EQU 36h
FILE_SUPERSEDED						EQU 0
FILE_OPENED							EQU 1
FILE_CREATED						EQU 2
FILE_OVERWRITTEN						EQU 3
FILE_EXISTS							EQU 4
FILE_DOES_NOT_EXIST					EQU 5
FILE_WRITE_TO_END_OF_FILE				EQU 0FFFFFFFFh
FILE_USE_FILE_POINTER_POSITION			EQU 0FFFFFFFEh
FILE_BYTE_ALIGNMENT					EQU 0
FILE_WORD_ALIGNMENT					EQU 1h
FILE_LONG_ALIGNMENT					EQU 3h
FILE_QUAD_ALIGNMENT					EQU 7h
FILE_OCTA_ALIGNMENT					EQU 0Fh
FILE_32_BYTE_ALIGNMENT					EQU 1Fh
FILE_64_BYTE_ALIGNMENT					EQU 3Fh
FILE_128_BYTE_ALIGNMENT					EQU 7Fh
FILE_256_BYTE_ALIGNMENT					EQU 0FFh
FILE_512_BYTE_ALIGNMENT					EQU 1FFh
MAXIMUM_FILENAME_LENGTH					EQU 256
FILE_REMOVABLE_MEDIA					EQU 1h
FILE_READ_ONLY_DEVICE					EQU 2h
FILE_FLOPPY_DISKETTE					EQU 4h
FILE_WRITE_ONCE_MEDIA					EQU 8h
FILE_REMOTE_DEVICE					EQU 10h
FILE_DEVICE_IS_MOUNTED					EQU 20h
FILE_VIRTUAL_VOLUME					EQU 40h
FILE_AUTOGENERATED_DEVICE_NAME			EQU 80h
FILE_DEVICE_SECURE_OPEN					EQU 100h
FILE_CHARACTERISTICS_PROPAGATED			EQU FILE_REMOVABLE_MEDIA or FILE_READ_ONLY_DEVICE or FILE_FLOPPY_DISKETTE or FILE_WRITE_ONCE_MEDIA or FILE_DEVICE_SECURE_OPEN
DBG_STATUS_CONTROL_C					EQU 1
DBG_STATUS_SYSRQ						EQU 2
DBG_STATUS_BUGCHECK_FIRST				EQU 3
DBG_STATUS_BUGCHECK_SECOND				EQU 4
DBG_STATUS_FATAL						EQU 5
DBG_STATUS_DEBUG_CONTROL				EQU 6
RtlCopyBytes						EQU RtlCopyMemory
RtlZeroBytes						EQU RtlZeroMemory
RtlFillBytes						EQU RtlFillMemory
VER_EQUAL							EQU 1
VER_GREATER							EQU 2
VER_GREATER_EQUAL						EQU 3
VER_LESS							EQU 4
VER_LESS_EQUAL						EQU 5
VER_AND							EQU 6
VER_OR							EQU 7
VER_CONDITION_MASK					EQU 7
VER_NUM_BITS_PER_CONDITION_MASK			EQU 3
VER_MINORVERSION						EQU 1
VER_MAJORVERSION						EQU 2
VER_BUILDNUMBER						EQU 4
VER_PLATFORMID						EQU 8
VER_SERVICEPACKMINOR					EQU 10h
VER_SERVICEPACKMAJOR					EQU 20h
VER_SUITENAME						EQU 40h
VER_PRODUCT_TYPE						EQU 80h
VER_NT_WORKSTATION					EQU 1
VER_NT_DOMAIN_CONTROLLER				EQU 2
VER_NT_SERVER						EQU 3
VER_PLATFORM_WIN32s					EQU 0
VER_PLATFORM_WIN32_WINDOWS				EQU 1
VER_PLATFORM_WIN32_NT					EQU 2
RTL_RANGE_SHARED						EQU 1
RTL_RANGE_CONFLICT					EQU 2
RTL_RANGE_LIST_ADD_IF_CONFLICT			EQU 1
RTL_RANGE_LIST_ADD_SHARED				EQU 2
RTL_RANGE_LIST_SHARED_OK				EQU 1
RTL_RANGE_LIST_NULL_CONFLICT_OK			EQU 2
OWNER_SECURITY_INFORMATION				EQU 1
GROUP_SECURITY_INFORMATION				EQU 2
DACL_SECURITY_INFORMATION				EQU 4
SACL_SECURITY_INFORMATION				EQU 8
PROTECTED_DACL_SECURITY_INFORMATION			EQU 80000000h
PROTECTED_SACL_SECURITY_INFORMATION			EQU 40000000h
UNPROTECTED_DACL_SECURITY_INFORMATION		EQU 20000000h
UNPROTECTED_SACL_SECURITY_INFORMATION		EQU 10000000h
PROCESS_TERMINATE						EQU 1
PROCESS_CREATE_THREAD					EQU 2
PROCESS_SET_SESSIONID					EQU 4
PROCESS_VM_OPERATION					EQU 8
PROCESS_VM_READ						EQU 10h
PROCESS_VM_WRITE						EQU 20h
PROCESS_DUP_HANDLE					EQU 40h
PROCESS_CREATE_PROCESS					EQU 80h
PROCESS_SET_QUOTA						EQU 100h
PROCESS_SET_INFORMATION					EQU 200h
PROCESS_QUERY_INFORMATION				EQU 400h
PROCESS_ALL_ACCESS					EQU STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 0FFFh
MAXIMUM_PROCESSORS					EQU 32
THREAD_TERMINATE						EQU 1
THREAD_SUSPEND_RESUME					EQU 2
THREAD_GET_CONTEXT					EQU 8
THREAD_SET_CONTEXT					EQU 10h
THREAD_SET_INFORMATION					EQU 20h
THREAD_QUERY_INFORMATION				EQU 40h
THREAD_SET_THREAD_TOKEN					EQU 80h
THREAD_IMPERSONATE					EQU 100h
THREAD_DIRECT_IMPERSONATION				EQU 200h
IMAGE_SUBSYSTEM_UNKNOWN					EQU 0
IMAGE_SUBSYSTEM_NATIVE					EQU 1
IMAGE_SUBSYSTEM_WINDOWS_GUI				EQU 2
IMAGE_SUBSYSTEM_WINDOWS_CUI				EQU 3
IMAGE_SUBSYSTEM_OS2_CUI					EQU 5
IMAGE_SUBSYSTEM_POSIX_CUI				EQU 7
IMAGE_SUBSYSTEM_NATIVE_WINDOWS			EQU 8
IMAGE_SUBSYSTEM_WINDOWS_CE_GUI			EQU 9
IMAGE_LIBRARY_PROCESS_INIT				EQU 1
IMAGE_LIBRARY_PROCESS_TERM				EQU 2
IMAGE_LIBRARY_THREAD_INIT				EQU 4
IMAGE_LIBRARY_THREAD_TERM				EQU 8
IMAGE_DLLCHARACTERISTICS_WDM_DRIVER			EQU 2000h
IMAGE_DIRECTORY_ENTRY_EXPORT				EQU 0
IMAGE_DIRECTORY_ENTRY_IMPORT				EQU 1
IMAGE_DIRECTORY_ENTRY_RESOURCE			EQU 2
IMAGE_DIRECTORY_ENTRY_EXCEPTION			EQU 3
IMAGE_DIRECTORY_ENTRY_SECURITY			EQU 4
IMAGE_DIRECTORY_ENTRY_BASERELOC			EQU 5
IMAGE_DIRECTORY_ENTRY_DEBUG				EQU 6
IMAGE_DIRECTORY_ENTRY_COPYRIGHT			EQU 7
IMAGE_DIRECTORY_ENTRY_ARCHITECTURE			EQU 7
IMAGE_DIRECTORY_ENTRY_GLOBALPTR			EQU 8
IMAGE_DIRECTORY_ENTRY_TLS				EQU 9
IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG			EQU 10
IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT			EQU 11
IMAGE_DIRECTORY_ENTRY_IAT				EQU 12
IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT			EQU 13
IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR		EQU 14
IMAGE_NUMBEROF_DIRECTORY_ENTRIES			EQU 16
IMAGE_DOS_SIGNATURE					EQU 5A4Dh
IMAGE_OS2_SIGNATURE					EQU 454Eh
IMAGE_OS2_SIGNATURE_LE					EQU 454Ch
IMAGE_VXD_SIGNATURE					EQU 454Ch 
IMAGE_NT_SIGNATURE					EQU 4550h
IMAGE_FILE_MACHINE_I386 				EQU 14Ch
IMAGE_SIZEOF_SHORT_NAME					EQU 8
EVENT_INCREMENT						EQU 1
IO_NO_INCREMENT						EQU 0
IO_CD_ROM_INCREMENT					EQU 1
IO_DISK_INCREMENT						EQU 1
IO_KEYBOARD_INCREMENT					EQU 6
IO_MAILSLOT_INCREMENT					EQU 2
IO_MOUSE_INCREMENT					EQU 6
IO_NAMED_PIPE_INCREMENT					EQU 2
IO_NETWORK_INCREMENT					EQU 2
IO_PARALLEL_INCREMENT					EQU 1
IO_SERIAL_INCREMENT					EQU 2
IO_SOUND_INCREMENT					EQU 8
IO_VIDEO_INCREMENT					EQU 1
SEMAPHORE_INCREMENT					EQU 1
IO_TYPE_ADAPTER						EQU 1
IO_TYPE_CONTROLLER					EQU 2
IO_TYPE_DEVICE						EQU 3
IO_TYPE_DRIVER						EQU 4
IO_TYPE_FILE						EQU 5
IO_TYPE_IRP							EQU 6
IO_TYPE_MASTER_ADAPTER					EQU 7
IO_TYPE_OPEN_PACKET					EQU 8
IO_TYPE_TIMER						EQU 9
IO_TYPE_VPB							EQU 0Ah
IO_TYPE_ERROR_LOG						EQU 0Bh
IO_TYPE_ERROR_MESSAGE					EQU 0Ch
IO_TYPE_DEVICE_OBJECT_EXTENSION			EQU 0Dh
IRP_MJ_CREATE						EQU 0
IRP_MJ_CREATE_NAMED_PIPE				EQU 1
IRP_MJ_CLOSE						EQU 2
IRP_MJ_READ							EQU 3
IRP_MJ_WRITE						EQU 4
IRP_MJ_QUERY_INFORMATION				EQU 5
IRP_MJ_SET_INFORMATION					EQU 6
IRP_MJ_QUERY_EA						EQU 7
IRP_MJ_SET_EA						EQU 8
IRP_MJ_FLUSH_BUFFERS					EQU 9
IRP_MJ_QUERY_VOLUME_INFORMATION			EQU 0Ah
IRP_MJ_SET_VOLUME_INFORMATION				EQU 0Bh
IRP_MJ_DIRECTORY_CONTROL				EQU 0Ch
IRP_MJ_FILE_SYSTEM_CONTROL				EQU 0Dh
IRP_MJ_DEVICE_CONTROL					EQU 0Eh
IRP_MJ_INTERNAL_DEVICE_CONTROL			EQU 0Fh
IRP_MJ_SHUTDOWN						EQU 10h
IRP_MJ_LOCK_CONTROL					EQU 11h
IRP_MJ_CLEANUP						EQU 12h
IRP_MJ_CREATE_MAILSLOT					EQU 13h
IRP_MJ_QUERY_SECURITY					EQU 14h
IRP_MJ_SET_SECURITY					EQU 15h
IRP_MJ_POWER						EQU 16h
IRP_MJ_SYSTEM_CONTROL					EQU 17h
IRP_MJ_DEVICE_CHANGE					EQU 18h
IRP_MJ_QUERY_QUOTA					EQU 19h
IRP_MJ_SET_QUOTA						EQU 1Ah
IRP_MJ_PNP							EQU 1Bh
IRP_MJ_PNP_POWER						EQU IRP_MJ_PNP      
IRP_MJ_MAXIMUM_FUNCTION					EQU 1Bh
IRP_MJ_SCSI							EQU IRP_MJ_INTERNAL_DEVICE_CONTROL
IRP_MN_QUERY_DIRECTORY					EQU 1
IRP_MN_NOTIFY_CHANGE_DIRECTORY			EQU 2
IRP_MN_USER_FS_REQUEST					EQU 0
IRP_MN_MOUNT_VOLUME					EQU 1
IRP_MN_VERIFY_VOLUME					EQU 2
IRP_MN_LOAD_FILE_SYSTEM					EQU 3
IRP_MN_TRACK_LINK						EQU 4
IRP_MN_KERNEL_CALL					EQU 4
IRP_MN_LOCK							EQU 1
IRP_MN_UNLOCK_SINGLE					EQU 2
IRP_MN_UNLOCK_ALL						EQU 3
IRP_MN_UNLOCK_ALL_BY_KEY				EQU 4
IRP_MN_NORMAL						EQU 0
IRP_MN_DPC							EQU 1
IRP_MN_MDL							EQU 2
IRP_MN_COMPLETE						EQU 4
IRP_MN_COMPRESSED						EQU 8
IRP_MN_MDL_DPC						EQU IRP_MN_MDL or IRP_MN_DPC
IRP_MN_COMPLETE_MDL					EQU IRP_MN_COMPLETE or IRP_MN_MDL
IRP_MN_COMPLETE_MDL_DPC					EQU IRP_MN_COMPLETE_MDL or IRP_MN_DPC
IRP_MN_SCSI_CLASS						EQU 1
IRP_MN_START_DEVICE					EQU 0
IRP_MN_QUERY_REMOVE_DEVICE				EQU 1
IRP_MN_REMOVE_DEVICE					EQU 2
IRP_MN_CANCEL_REMOVE_DEVICE				EQU 3
IRP_MN_STOP_DEVICE					EQU 4
IRP_MN_QUERY_STOP_DEVICE				EQU 5
IRP_MN_CANCEL_STOP_DEVICE				EQU 6
IRP_MN_QUERY_DEVICE_RELATIONS				EQU 7
IRP_MN_QUERY_INTERFACE					EQU 8
IRP_MN_QUERY_CAPABILITIES				EQU 9
IRP_MN_QUERY_RESOURCES					EQU 0Ah
IRP_MN_QUERY_RESOURCE_REQUIREMENTS			EQU 0Bh
IRP_MN_QUERY_DEVICE_TEXT				EQU 0Ch
IRP_MN_FILTER_RESOURCE_REQUIREMENTS			EQU 0Dh
IRP_MN_READ_CONFIG					EQU 0Fh
IRP_MN_WRITE_CONFIG					EQU 10h
IRP_MN_EJECT						EQU 11h
IRP_MN_SET_LOCK						EQU 12h
IRP_MN_QUERY_ID						EQU 13h
IRP_MN_QUERY_PNP_DEVICE_STATE				EQU 14h
IRP_MN_QUERY_BUS_INFORMATION				EQU 15h
IRP_MN_DEVICE_USAGE_NOTIFICATION			EQU 16h
IRP_MN_SURPRISE_REMOVAL					EQU 17h
IRP_MN_QUERY_LEGACY_BUS_INFORMATION			EQU 18h
IRP_MN_WAIT_WAKE						EQU 0
IRP_MN_POWER_SEQUENCE					EQU 1
IRP_MN_SET_POWER						EQU 2
IRP_MN_QUERY_POWER					EQU 3
IRP_MN_QUERY_ALL_DATA					EQU 0
IRP_MN_QUERY_SINGLE_INSTANCE				EQU 1
IRP_MN_CHANGE_SINGLE_INSTANCE				EQU 2
IRP_MN_CHANGE_SINGLE_ITEM				EQU 3
IRP_MN_ENABLE_EVENTS					EQU 4
IRP_MN_DISABLE_EVENTS					EQU 5
IRP_MN_ENABLE_COLLECTION				EQU 6
IRP_MN_DISABLE_COLLECTION				EQU 7
IRP_MN_REGINFO						EQU 8
IRP_MN_EXECUTE_METHOD					EQU 9
IO_FORCE_ACCESS_CHECK					EQU 1
IO_OPEN_PAGING_FILE					EQU 2
IO_OPEN_TARGET_DIRECTORY				EQU 4
IO_NO_PARAMETER_CHECKING				EQU 100h
IO_REPARSE							EQU 0
IO_REMOUNT							EQU 1



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<STATUS CODES>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



STATUS_SUCCESS						EQU 0h
FACILITY_USB_ERROR_CODE					EQU 10h
FACILITY_RPC_STUBS					EQU 3h
FACILITY_RPC_RUNTIME					EQU 2h
FACILITY_IO_ERROR_CODE					EQU 4h
FACILITY_HID_ERROR_CODE					EQU 11h
FACILITY_FIREWIRE_ERROR_CODE				EQU 12h
FACILITY_CLUSTER_ERROR_CODE				EQU 13h
STATUS_SEVERITY_WARNING					EQU 2h
STATUS_SEVERITY_SUCCESS					EQU 0h
STATUS_SEVERITY_INFORMATIONAL				EQU 1h
STATUS_SEVERITY_ERROR					EQU 3h
STATUS_WAIT_0						EQU 0h
STATUS_WAIT_1						EQU 1h
STATUS_WAIT_2						EQU 2h
STATUS_WAIT_3						EQU 3h
STATUS_WAIT_63						EQU 03Fh
STATUS_ABANDONED						EQU 80h
STATUS_ABANDONED_WAIT_0					EQU 80h
STATUS_ABANDONED_WAIT_63				EQU 0BFh
STATUS_USER_APC						EQU 0C0h
STATUS_KERNEL_APC						EQU 100h
STATUS_ALERTED						EQU 101h
STATUS_TIMEOUT						EQU 102h
STATUS_PENDING						EQU 103h
STATUS_REPARSE						EQU 104h
STATUS_MORE_ENTRIES					EQU 105h
STATUS_NOT_ALL_ASSIGNED					EQU 106h
STATUS_SOME_NOT_MAPPED					EQU 107h
STATUS_OPLOCK_BREAK_IN_PROGRESS			EQU 108h
STATUS_VOLUME_MOUNTED					EQU 109h
STATUS_RXACT_COMMITTED					EQU 10Ah
STATUS_NOTIFY_CLEANUP					EQU 10Bh
STATUS_NOTIFY_ENUM_DIR					EQU 10Ch
STATUS_NO_QUOTAS_FOR_ACCOUNT				EQU 10Dh
STATUS_PRIMARY_TRANSPORT_CONNECT_FAILED		EQU 10Eh
STATUS_PAGE_FAULT_TRANSITION				EQU 110h
STATUS_PAGE_FAULT_DEMAND_ZERO				EQU 111h
STATUS_PAGE_FAULT_COPY_ON_WRITE			EQU 112h
STATUS_PAGE_FAULT_GUARD_PAGE				EQU 113h
STATUS_PAGE_FAULT_PAGING_FILE				EQU 114h
STATUS_CACHE_PAGE_LOCKED				EQU 115h
STATUS_CRASH_DUMP						EQU 116h
STATUS_BUFFER_ALL_ZEROS					EQU 117h
STATUS_REPARSE_OBJECT					EQU 118h
STATUS_RESOURCE_REQUIREMENTS_CHANGED		EQU 119h
STATUS_OBJECT_NAME_EXISTS				EQU 40000000h
STATUS_THREAD_WAS_SUSPENDED				EQU 40000001h
STATUS_WORKING_SET_LIMIT_RANGE			EQU 40000002h
STATUS_IMAGE_NOT_AT_BASE				EQU 40000003h
STATUS_RXACT_STATE_CREATED				EQU 40000004h
STATUS_SEGMENT_NOTIFICATION				EQU 40000005h 
STATUS_LOCAL_USER_SESSION_KEY				EQU 40000006h
STATUS_BAD_CURRENT_DIRECTORY				EQU 40000007h
STATUS_SERIAL_MORE_WRITES				EQU 40000008h
STATUS_REGISTRY_RECOVERED				EQU 40000009h
STATUS_FT_READ_RECOVERY_FROM_BACKUP			EQU 4000000Ah
STATUS_FT_WRITE_RECOVERY				EQU 4000000Bh
STATUS_SERIAL_COUNTER_TIMEOUT				EQU 4000000Ch
STATUS_NULL_LM_PASSWORD					EQU 4000000Dh
STATUS_IMAGE_MACHINE_TYPE_MISMATCH			EQU 4000000Eh
STATUS_RECEIVE_PARTIAL					EQU 4000000Fh
STATUS_RECEIVE_EXPEDITED				EQU 40000010h
STATUS_RECEIVE_PARTIAL_EXPEDITED			EQU 40000011h
STATUS_EVENT_DONE						EQU 40000012h
STATUS_EVENT_PENDING					EQU 40000013h
STATUS_CHECKING_FILE_SYSTEM				EQU 40000014h
STATUS_FATAL_APP_EXIT					EQU 40000015h
STATUS_PREDEFINED_HANDLE				EQU 40000016h
STATUS_WAS_UNLOCKED					EQU 40000017h
STATUS_SERVICE_NOTIFICATION				EQU 40000018h
STATUS_WAS_LOCKED						EQU 40000019h
STATUS_LOG_HARD_ERROR					EQU 4000001Ah
STATUS_ALREADY_WIN32					EQU 4000001Bh
STATUS_WX86_UNSIMULATE					EQU 4000001Ch
STATUS_WX86_CONTINUE					EQU 4000001Dh
STATUS_WX86_SINGLE_STEP					EQU 4000001Eh
STATUS_WX86_BREAKPOINT					EQU 4000001Fh
STATUS_WX86_EXCEPTION_CONTINUE			EQU 40000020h
STATUS_WX86_EXCEPTION_LASTCHANCE			EQU 40000021h
STATUS_WX86_EXCEPTION_CHAIN				EQU 40000022h
STATUS_IMAGE_MACHINE_TYPE_MISMATCH_EXE		EQU 40000023h
STATUS_NO_YIELD_PERFORMED				EQU 40000024h
STATUS_TIMER_RESUME_IGNORED				EQU 40000025h
STATUS_ARBITRATION_UNHANDLED				EQU 40000026h
STATUS_GUARD_PAGE_VIOLATION				EQU 80000001h
STATUS_DATATYPE_MISALIGNMENT				EQU 80000002h
STATUS_BREAKPOINT						EQU 80000003h 
STATUS_SINGLE_STEP					EQU 80000004h 
STATUS_BUFFER_OVERFLOW					EQU 80000005h
STATUS_NO_MORE_FILES					EQU 80000006h
STATUS_WAKE_SYSTEM_DEBUGGER				EQU 80000007h
STATUS_HANDLES_CLOSED					EQU 8000000Ah
STATUS_NO_INHERITANCE					EQU 8000000Bh
STATUS_GUID_SUBSTITUTION_MADE				EQU 8000000Ch
STATUS_PARTIAL_COPY					EQU 8000000Dh
STATUS_DEVICE_PAPER_EMPTY				EQU 8000000Eh
STATUS_DEVICE_POWERED_OFF				EQU 8000000Fh
STATUS_DEVICE_OFF_LINE					EQU 80000010h
STATUS_DEVICE_BUSY					EQU 80000011h
STATUS_NO_MORE_EAS					EQU 80000012h
STATUS_INVALID_EA_NAME					EQU 80000013h
STATUS_EA_LIST_INCONSISTENT				EQU 80000014h
STATUS_INVALID_EA_FLAG					EQU 80000015h
STATUS_VERIFY_REQUIRED					EQU 80000016h
STATUS_EXTRANEOUS_INFORMATION				EQU 80000017h
STATUS_RXACT_COMMIT_NECESSARY				EQU 80000018h
STATUS_NO_MORE_ENTRIES					EQU 8000001Ah
STATUS_FILEMARK_DETECTED				EQU 8000001Bh
STATUS_MEDIA_CHANGED					EQU 8000001Ch
STATUS_BUS_RESET						EQU 8000001Dh
STATUS_END_OF_MEDIA					EQU 8000001Eh
STATUS_BEGINNING_OF_MEDIA				EQU 8000001Fh
STATUS_MEDIA_CHEECK					EQU 80000020h
STATUS_SETMARK_DETECTED					EQU 80000021h
STATUS_NO_DATA_DETECTED					EQU 80000022h
STATUS_REDIRECTOR_HAS_OPEN_HANDLES			EQU 80000023h
STATUS_SERVER_HAS_OPEN_HANDLES			EQU 80000024h
STATUS_ALREADY_DISCONNECTED				EQU 80000025h
STATUS_LONGJUMP						EQU 80000026h
STATUS_UNSUCCESSFUL					EQU 0C0000001h
STATUS_NOT_IMPLEMENTED					EQU 0C0000002h
STATUS_INVALID_INFO_CLASS				EQU 0C0000003h 
STATUS_INFO_LENGTH_MISMATCH				EQU 0C0000004h
STATUS_ACCESS_VIOLATION					EQU 0C0000005h
STATUS_IN_PAGE_ERROR					EQU 0C0000006h
STATUS_PAGEFILE_QUOTA					EQU 0C0000007h
STATUS_INVALID_HANDLE					EQU 0C0000008h 
STATUS_BAD_INITIAL_STACK				EQU 0C0000009h
STATUS_BAD_INITIAL_PC					EQU 0C000000Ah
STATUS_INVALID_CID					EQU 0C000000Bh
STATUS_TIMER_NOT_CANCELED				EQU 0C000000Ch
STATUS_INVALID_PARAMETER				EQU 0C000000Dh
STATUS_NO_SUCH_DEVICE					EQU 0C000000Eh
STATUS_NO_SUCH_FILE					EQU 0C000000Fh
STATUS_INVALID_DEVICE_REQUEST				EQU 0C0000010h
STATUS_END_OF_FILE					EQU 0C0000011h
STATUS_WRONG_VOLUME					EQU 0C0000012h
STATUS_NO_MEDIA_IN_DEVICE				EQU 0C0000013h
STATUS_UNRECOGNIZED_MEDIA				EQU 0C0000014h
STATUS_NONEXISTENT_SECTOR				EQU 0C0000015h
STATUS_MORE_PROCESSING_REQUIRED			EQU 0C0000016h
STATUS_NO_MEMORY						EQU 0C0000017h 
STATUS_CONFLICTING_ADDRESSES				EQU 0C0000018h
STATUS_NOT_MAPPED_VIEW					EQU 0C0000019h
STATUS_UNABLE_TO_FREE_VM				EQU 0C000001Ah
STATUS_UNABLE_TO_DELETE_SECTION			EQU 0C000001Bh
STATUS_INVALID_SYSTEM_SERVICE				EQU 0C000001Ch
STATUS_ILLEGAL_INSTRUCTION				EQU 0C000001Dh
STATUS_INVALID_LOCK_SEQUENCE				EQU 0C000001Eh
STATUS_INVALID_VIEW_SIZE				EQU 0C000001Fh
STATUS_INVALID_FILE_FOR_SECTION			EQU 0C0000020h
STATUS_ALREADY_COMMITTED				EQU 0C0000021h
STATUS_ACCESS_DENIED					EQU 0C0000022h
STATUS_BUFFER_TOO_SMALL					EQU 0C0000023h
STATUS_OBJECT_TYPE_MISMATCH				EQU 0C0000024h
STATUS_NONCONTINUABLE_EXCEPTION			EQU 0C0000025h
STATUS_INVALID_DISPOSITION				EQU 0C0000026h 
STATUS_UNWIND						EQU 0C0000027h
STATUS_BAD_STACK						EQU 0C0000028h
STATUS_INVALID_UNWIND_TARGET				EQU 0C0000029h
STATUS_NOT_LOCKED						EQU 0C000002Ah
STATUS_PARITY_ERROR					EQU 0C000002Bh
STATUS_UNABLE_TO_DECOMMIT_VM				EQU 0C000002Ch
STATUS_NOT_COMMITTED					EQU 0C000002Dh
STATUS_INVALID_PORT_ATTRIBUTES			EQU 0C000002Eh
STATUS_PORT_MESSAGE_TOO_LONG				EQU 0C000002Fh
STATUS_INVALID_PARAMETER_MIX				EQU 0C0000030h
STATUS_INVALID_QUOTA_LOWER				EQU 0C0000031h
STATUS_DISK_CORRUPT_ERROR				EQU 0C0000032h
STATUS_OBJECT_NAME_INVALID				EQU 0C0000033h
STATUS_OBJECT_NAME_NOT_FOUND				EQU 0C0000034h
STATUS_OBJECT_NAME_COLLISION				EQU 0C0000035h
STATUS_PORT_DISCONNECTED				EQU 0C0000037h
STATUS_DEVICE_ALREADY_ATTACHED			EQU 0C0000038h
STATUS_OBJECT_PATH_INVALID				EQU 0C0000039h
STATUS_OBJECT_PATH_NOT_FOUND				EQU 0C000003Ah
STATUS_OBJECT_PATH_SYNTAX_BAD				EQU 0C000003Bh
STATUS_DATA_LATE_ERROR					EQU 0C000003Dh
STATUS_DATA_ERROR						EQU 0C000003Eh
STATUS_CRC_ERROR						EQU 0C000003Fh
STATUS_SECTION_TOO_BIG					EQU 0C0000040h
STATUS_PORT_CONNECTION_REFUSED			EQU 0C0000041h
STATUS_INVALID_PORT_HANDLE				EQU 0C0000042h
STATUS_SHARING_VIOLATION				EQU 0C0000043h
STATUS_QUOTA_EXCEEDED					EQU 0C0000044h
STATUS_INVALID_PAGE_PROTECTION			EQU 0C0000045h
STATUS_MUTANT_NOT_OWNED					EQU 0C0000046h
STATUS_SEMAPHORE_LIMIT_EXCEEDED			EQU 0C0000047h
STATUS_PORT_ALREADY_SET					EQU 0C0000048h
STATUS_SECTION_NOT_IMAGE				EQU 0C0000049h
STATUS_SUSPEND_COUNT_EXCEEDED				EQU 0C000004Ah
STATUS_THREAD_IS_TERMINATING				EQU 0C000004Bh
STATUS_THREAD_IS_TERMINATING				EQU 0C000004Bh
STATUS_INCOMPATIBLE_FILE_MAP				EQU 0C000004Dh
STATUS_SECTION_PROTECTION				EQU 0C000004Eh
STATUS_EAS_NOT_SUPPORTED				EQU 0C000004Fh
STATUS_EA_TOO_LARGE					EQU 0C0000050h
STATUS_NONEXISTENT_EA_ENTRY				EQU 0C0000051h
STATUS_NO_EAS_ON_FILE					EQU 0C0000052h
STATUS_EA_CORRUPT_ERROR					EQU 0C0000053h
STATUS_FILE_LOCK_CONFLICT				EQU 0C0000054h
STATUS_LOCK_NOT_GRANTED					EQU 0C0000055h
STATUS_DELETE_PENDING					EQU 0C0000056h
STATUS_CTL_FILE_NOT_SUPPORTED				EQU 0C0000057h
STATUS_UNKNOWN_REVISION					EQU 0C0000058h
STATUS_REVISION_MISMATCH				EQU 0C0000059h
STATUS_INVALID_OWNER					EQU 0C000005Ah
STATUS_INVALID_PRIMARY_GROUP				EQU 0C000005Bh
STATUS_NO_IMPERSONATION_TOKEN				EQU 0C000005Ch
STATUS_CANT_DISABLE_MANDATORY				EQU 0C000005Dh
STATUS_NO_LOGON_SERVERS					EQU 0C000005Eh
STATUS_NO_SUCH_LOGON_SESSION				EQU 0C000005Fh
STATUS_NO_SUCH_PRIVILEGE				EQU 0C0000060h
STATUS_PRIVILEGE_NOT_HELD				EQU 0C0000061h
STATUS_INVALID_ACCOUNT_NAME				EQU 0C0000062h
STATUS_USER_EXISTS					EQU 0C0000063h
STATUS_NO_SUCH_USER					EQU 0C0000064h 
STATUS_GROUP_EXISTS					EQU 0C0000065h
STATUS_NO_SUCH_GROUP					EQU 0C0000066h
STATUS_MEMBER_IN_GROUP					EQU 0C0000067h
STATUS_MEMBER_NOT_IN_GROUP				EQU 0C0000068h
STATUS_LAST_ADMIN						EQU 0C0000069h
STATUS_WRONG_PASSWORD					EQU 0C000006Ah 
STATUS_ILL_FORMED_PASSWORD				EQU 0C000006Bh
STATUS_PASSWORD_RESTRICTION				EQU 0C000006Ch
STATUS_LOGON_FAILURE					EQU 0C000006Dh 
STATUS_ACCOUNT_RESTRICTION				EQU 0C000006Eh 
STATUS_INVALID_LOGON_HOURS				EQU 0C000006Fh
STATUS_INVALID_WORKSTATION				EQU 0C0000070h 
STATUS_PASSWORD_EXPIRED					EQU 0C0000071h 
STATUS_ACCOUNT_DISABLED					EQU 0C0000072h
STATUS_NONE_MAPPED					EQU 0C0000073h
STATUS_TOO_MANY_LUIDS_REQUESTED			EQU 0C0000074h
STATUS_LUIDS_EXHAUSTED					EQU 0C0000075h
STATUS_INVALID_SUB_AUTHORITY				EQU 0C0000076h
STATUS_INVALID_ACL					EQU 0C0000077h
STATUS_INVALID_SID					EQU 0C0000078h
STATUS_INVALID_SECURITY_DESCR				EQU 0C0000079h
STATUS_PROCEDURE_NOT_FOUND				EQU 0C000007Ah
STATUS_INVALID_IMAGE_FORMAT				EQU 0C000007Bh
STATUS_NO_TOKEN						EQU 0C000007Ch
STATUS_BAD_INHERITANCE_ACL				EQU 0C000007Dh
STATUS_RANGE_NOT_LOCKED					EQU 0C000007Eh
STATUS_DISK_FULL						EQU 0C000007Fh
STATUS_SERVER_DISABLED					EQU 0C0000080h
STATUS_SERVER_NOT_DISABLED				EQU 0C0000081h
STATUS_TOO_MANY_GUIDS_REQUESTED			EQU 0C0000082h
STATUS_GUIDS_EXHAUSTED					EQU 0C0000083h
STATUS_INVALID_ID_AUTHORITY				EQU 0C0000084h
STATUS_AGENTS_EXHAUSTED					EQU 0C0000085h
STATUS_INVALID_VOLUME_LABEL				EQU 0C0000086h
STATUS_SECTION_NOT_EXTENDED				EQU 0C0000087h
STATUS_NOT_MAPPED_DATA					EQU 0C0000088h
STATUS_RESOURCE_DATA_NOT_FOUND			EQU 0C0000089h
STATUS_RESOURCE_TYPE_NOT_FOUND			EQU 0C000008Ah
STATUS_RESOURCE_NAME_NOT_FOUND			EQU 0C000008Bh
STATUS_ARRAY_BOUNDS_EXCEEDED				EQU 0C000008Ch
STATUS_FLOAT_DENORMAL_OPERAND				EQU 0C000008Dh
STATUS_FLOAT_DIVIDE_BY_ZERO				EQU 0C000008Eh
STATUS_FLOAT_INEXACT_RESULT				EQU 0C000008Fh 
STATUS_FLOAT_INVALID_OPERATION			EQU 0C0000090h
STATUS_FLOAT_OVERFLOW					EQU 0C0000091h
STATUS_FLOAT_STACK_CHECK				EQU 0C0000092h
STATUS_FLOAT_UNDERFLOW					EQU 0C0000093h
STATUS_INTEGER_DIVIDE_BY_ZERO				EQU 0C0000094h
STATUS_INTEGER_OVERFLOW					EQU 0C0000095h 
STATUS_PRIVILEGED_INSTRUCTION				EQU 0C0000096h
STATUS_TOO_MANY_PAGING_FILES				EQU 0C0000097h
STATUS_FILE_INVALID					EQU 0C0000098h
STATUS_ALLOTTED_SPACE_EXCEEDED			EQU 0C0000099h
STATUS_INSUFFICIENT_RESOURCES				EQU 0C000009Ah
STATUS_DFS_EXIT_PATH_FOUND				EQU 0C000009Bh
STATUS_DEVICE_DATA_ERROR				EQU 0C000009Ch
STATUS_DEVICE_NOT_CONNECTED				EQU 0C000009Dh
STATUS_DEVICE_POWER_FAILURE				EQU 0C000009Eh
STATUS_FREE_VM_NOT_AT_BASE				EQU 0C000009Fh
STATUS_MEMORY_NOT_ALLOCATED				EQU 0C00000A0h
STATUS_WORKING_SET_QUOTA				EQU 0C00000A1h
STATUS_MEDIA_WRITE_PROTECTED				EQU 0C00000A2h
STATUS_DEVICE_NOT_READY					EQU 0C00000A3h
STATUS_INVALID_GROUP_ATTRIBUTES			EQU 0C00000A4h
STATUS_BAD_IMPERSONATION_LEVEL			EQU 0C00000A5h
STATUS_CANT_OPEN_ANONYMOUS				EQU 0C00000A6h
STATUS_BAD_VALIDATION_CLASS				EQU 0C00000A7h
STATUS_BAD_TOKEN_TYPE					EQU 0C00000A8h
STATUS_BAD_MASTER_BOOT_RECORD				EQU 0C00000A9h
STATUS_INSTRUCTION_MISALIGNMENT			EQU 0C00000AAh
STATUS_INSTANCE_NOT_AVAILABLE				EQU 0C00000ABh
STATUS_PIPE_NOT_AVAILABLE				EQU 0C00000ACh
STATUS_INVALID_PIPE_STATE				EQU 0C00000ADh
STATUS_PIPE_BUSY						EQU 0C00000AEh
STATUS_ILLEGAL_FUNCTION					EQU 0C00000AFh
STATUS_PIPE_DISCONNECTED				EQU 0C00000B0h
STATUS_PIPE_CLOSING					EQU 0C00000B1h
STATUS_PIPE_CONNECTED					EQU 0C00000B2h
STATUS_PIPE_LISTENING					EQU 0C00000B3h
STATUS_INVALID_READ_MODE				EQU 0C00000B4h
STATUS_IO_TIMEOUT						EQU 0C00000B5h
STATUS_FILE_FORCED_CLOSED				EQU 0C00000B6h
STATUS_PROFILING_NOT_STARTED				EQU 0C00000B7h
STATUS_PROFILING_NOT_STOPPED				EQU 0C00000B8h
STATUS_COULD_NOT_INTERPRET				EQU 0C00000B9h
STATUS_FILE_IS_A_DIRECTORY				EQU 0C00000BAh
STATUS_NOT_SUPPORTED					EQU 0C00000BBh
STATUS_REMOTE_NOT_LISTENING				EQU 0C00000BCh
STATUS_DUPLICATE_NAME					EQU 0C00000BDh
STATUS_BAD_NETWORK_PATH					EQU 0C00000BEh
STATUS_NETWORK_BUSY					EQU 0C00000BFh
STATUS_DEVICE_DOES_NOT_EXIST				EQU 0C00000C0h
STATUS_TOO_MANY_COMMANDS				EQU 0C00000C1h
STATUS_ADAPTER_HARDWARE_ERROR				EQU 0C00000C2h
STATUS_INVALID_NETWORK_RESPONSE			EQU 0C00000C3h
STATUS_UNEXPECTED_NETWORK_ERROR			EQU 0C00000C4h
STATUS_BAD_REMOTE_ADAPTER				EQU 0C00000C5h
STATUS_PRINT_QUEUE_FULL					EQU 0C00000C6h
STATUS_NO_SPOOL_SPACE					EQU 0C00000C7h
STATUS_PRINT_CANCELLED					EQU 0C00000C8h
STATUS_NETWORK_NAME_DELETED				EQU 0C00000C9h
STATUS_NETWORK_ACCESS_DENIED				EQU 0C00000CAh
STATUS_BAD_DEVICE_TYPE					EQU 0C00000CBh
STATUS_BAD_NETWORK_NAME					EQU 0C00000CCh
STATUS_TOO_MANY_NAMES					EQU 0C00000CDh
STATUS_TOO_MANY_SESSIONS				EQU 0C00000CEh
STATUS_SHARING_PAUSED					EQU 0C00000CFh
STATUS_REQUEST_NOT_ACCEPTED				EQU 0C00000D0h
STATUS_REDIRECTOR_PAUSED				EQU 0C00000D1h
STATUS_NET_WRITE_FAULT					EQU 0C00000D2h
STATUS_PROFILING_AT_LIMIT				EQU 0C00000D3h
STATUS_NOT_SAME_DEVICE					EQU 0C00000D4h
STATUS_FILE_RENAMED					EQU 0C00000D5h
STATUS_VIRTUAL_CIRCUIT_CLOSED				EQU 0C00000D6h
STATUS_NO_SECURITY_ON_OBJECT				EQU 0C00000D7h
STATUS_CANT_WAIT						EQU 0C00000D8h
STATUS_PIPE_EMPTY						EQU 0C00000D9h
STATUS_CANT_ACCESS_DOMAIN_INFO			EQU 0C00000DAh
STATUS_CANT_TERMINATE_SELF				EQU 0C00000DBh
STATUS_INVALID_SERVER_STATE				EQU 0C00000DCh
STATUS_INVALID_DOMAIN_STATE				EQU 0C00000DDh
STATUS_INVALID_DOMAIN_ROLE				EQU 0C00000DEh
STATUS_NO_SUCH_DOMAIN					EQU 0C00000DFh
STATUS_DOMAIN_EXISTS					EQU 0C00000E0h
STATUS_DOMAIN_LIMIT_EXCEEDED				EQU 0C00000E1h
STATUS_OPLOCK_NOT_GRANTED				EQU 0C00000E2h
STATUS_INVALID_OPLOCK_PROTOCOL			EQU 0C00000E3h
STATUS_INTERNAL_DB_CORRUPTION				EQU 0C00000E4h
STATUS_INTERNAL_ERROR					EQU 0C00000E5h
STATUS_GENERIC_NOT_MAPPED				EQU 0C00000E6h
STATUS_BAD_DESCRIPTOR_FORMAT				EQU 0C00000E7h
STATUS_INVALID_USER_BUFFER				EQU 0C00000E8h
STATUS_UNEXPECTED_IO_ERROR				EQU 0C00000E9h
STATUS_UNEXPECTED_MM_CREATE_ERR			EQU 0C00000EAh
STATUS_UNEXPECTED_MM_MAP_ERROR			EQU 0C00000EBh
STATUS_UNEXPECTED_MM_EXTEND_ERR			EQU 0C00000ECh
STATUS_NOT_LOGON_PROCESS				EQU 0C00000EDh
STATUS_LOGON_SESSION_EXISTS				EQU 0C00000EEh
STATUS_INVALID_PARAMETER_1				EQU 0C00000EFh
STATUS_INVALID_PARAMETER_2				EQU 0C00000F0h
STATUS_INVALID_PARAMETER_3				EQU 0C00000F1h
STATUS_INVALID_PARAMETER_4				EQU 0C00000F2h
STATUS_INVALID_PARAMETER_5				EQU 0C00000F3h
STATUS_INVALID_PARAMETER_6				EQU 0C00000F4h
STATUS_INVALID_PARAMETER_7				EQU 0C00000F5h
STATUS_INVALID_PARAMETER_8				EQU 0C00000F6h
STATUS_INVALID_PARAMETER_9				EQU 0C00000F7h
STATUS_INVALID_PARAMETER_10				EQU 0C00000F8h
STATUS_INVALID_PARAMETER_11				EQU 0C00000F9h
STATUS_INVALID_PARAMETER_12				EQU 0C00000FAh
STATUS_REDIRECTOR_NOT_STARTED				EQU 0C00000FBh
STATUS_REDIRECTOR_STARTED				EQU 0C00000FCh
STATUS_STACK_OVERFLOW					EQU 0C00000FDh
STATUS_NO_SUCH_PACKAGE					EQU 0C00000FEh
STATUS_BAD_FUNCTION_TABLE				EQU 0C00000FFh
STATUS_VARIABLE_NOT_FOUND				EQU 0C0000100h
STATUS_DIRECTORY_NOT_EMPTY				EQU 0C0000101h
STATUS_FILE_CORRUPT_ERROR				EQU 0C0000102h
STATUS_NOT_A_DIRECTORY					EQU 0C0000103h
STATUS_BAD_LOGON_SESSION_STATE			EQU 0C0000104h
STATUS_LOGON_SESSION_COLLISION			EQU 0C0000105h
STATUS_NAME_TOO_LONG					EQU 0C0000106h
STATUS_FILES_OPEN						EQU 0C0000107h
STATUS_CONNECTION_IN_USE				EQU 0C0000108h
STATUS_MESSAGE_NOT_FOUND				EQU 0C0000109h
STATUS_PROCESS_IS_TERMINATING				EQU 0C000010Ah
STATUS_INVALID_LOGON_TYPE				EQU 0C000010Bh
STATUS_NO_GUID_TRANSLATION				EQU 0C000010Ch
STATUS_CANNOT_IMPERSONATE				EQU 0C000010Dh
STATUS_IMAGE_ALREADY_LOADED				EQU 0C000010Eh
STATUS_ABIOS_NOT_PRESENT				EQU 0C000010Fh
STATUS_ABIOS_LID_NOT_EXIST				EQU 0C0000110h
STATUS_ABIOS_LID_ALREADY_OWNED			EQU 0C0000111h
STATUS_ABIOS_NOT_LID_OWNER				EQU 0C0000112h
STATUS_ABIOS_INVALID_COMMAND				EQU 0C0000113h
STATUS_ABIOS_INVALID_LID				EQU 0C0000114h
STATUS_ABIOS_SELECTOR_NOT_AVAILABLE			EQU 0C0000115h
STATUS_ABIOS_INVALID_SELECTOR				EQU 0C0000116h
STATUS_NO_LDT						EQU 0C0000117h
STATUS_INVALID_LDT_SIZE					EQU 0C0000118h
STATUS_INVALID_LDT_OFFSET				EQU 0C0000119h
STATUS_INVALID_LDT_DESCRIPTOR				EQU 0C000011Ah
STATUS_INVALID_IMAGE_NE_FORMAT			EQU 0C000011Bh
STATUS_RXACT_INVALID_STATE				EQU 0C000011Ch
STATUS_RXACT_COMMIT_FAILURE				EQU 0C000011Dh
STATUS_MAPPED_FILE_SIZE_ZERO				EQU 0C000011Eh
STATUS_TOO_MANY_OPENED_FILES				EQU 0C000011Fh
STATUS_CANCELLED						EQU 0C0000120h
STATUS_CANNOT_DELETE					EQU 0C0000121h
STATUS_INVALID_COMPUTER_NAME				EQU 0C0000122h
STATUS_FILE_DELETED					EQU 0C0000123h
STATUS_SPECIAL_ACCOUNT					EQU 0C0000124h
STATUS_SPECIAL_GROUP					EQU 0C0000125h
STATUS_SPECIAL_USER					EQU 0C0000126h
STATUS_MEMBERS_PRIMARY_GROUP				EQU 0C0000127h
STATUS_FILE_CLOSED					EQU 0C0000128h
STATUS_TOO_MANY_THREADS					EQU 0C0000129h
STATUS_THREAD_NOT_IN_PROCESS				EQU 0C000012Ah
STATUS_TOKEN_ALREADY_IN_USE				EQU 0C000012Bh
STATUS_PAGEFILE_QUOTA_EXCEEDED			EQU 0C000012Ch
STATUS_COMMITMENT_LIMIT					EQU 0C000012Dh
STATUS_INVALID_IMAGE_LE_FORMAT			EQU 0C000012Eh
STATUS_INVALID_IMAGE_NOT_MZ				EQU 0C000012Fh
STATUS_INVALID_IMAGE_PROTECT				EQU 0C0000130h
STATUS_INVALID_IMAGE_WIN_16				EQU 0C0000131h
STATUS_LOGON_SERVER_CONFLICT				EQU 0C0000132h
STATUS_TIME_DIFFERENCE_AT_DC				EQU 0C0000133h
STATUS_SYNCHRONIZATION_REQUIRED			EQU 0C0000134h
STATUS_DLL_NOT_FOUND					EQU 0C0000135h
STATUS_OPEN_FAILED					EQU 0C0000136h
STATUS_IO_PRIVILEGE_FAILED				EQU 0C0000137h
STATUS_ORDINAL_NOT_FOUND				EQU 0C0000138h
STATUS_ENTRYPOINT_NOT_FOUND				EQU 0C0000139h
STATUS_CONTROL_C_EXIT					EQU 0C000013Ah  
STATUS_LOCAL_DISCONNECT					EQU 0C000013Bh
STATUS_REMOTE_DISCONNECT				EQU 0C000013Ch
STATUS_REMOTE_RESOURCES					EQU 0C000013Dh
STATUS_LINK_FAILED					EQU 0C000013Eh
STATUS_LINK_TIMEOUT					EQU 0C000013Fh
STATUS_INVALID_CONNECTION				EQU 0C0000140h
STATUS_INVALID_ADDRESS					EQU 0C0000141h
STATUS_DLL_INIT_FAILED					EQU 0C0000142h
STATUS_MISSING_SYSTEMFILE				EQU 0C0000143h
STATUS_UNHANDLED_EXCEPTION				EQU 0C0000144h
STATUS_APP_INIT_FAILURE					EQU 0C0000145h
STATUS_PAGEFILE_CREATE_FAILED				EQU 0C0000146h
STATUS_NO_PAGEFILE					EQU 0C0000147h
STATUS_INVALID_LEVEL					EQU 0C0000148h
STATUS_WRONG_PASSWORD_CORE				EQU 0C0000149h
STATUS_ILLEGAL_FLOAT_CONTEXT				EQU 0C000014Ah
STATUS_PIPE_BROKEN					EQU 0C000014Bh
STATUS_REGISTRY_CORRUPT					EQU 0C000014Ch
STATUS_REGISTRY_IO_FAILED				EQU 0C000014Dh
STATUS_NO_EVENT_PAIR					EQU 0C000014Eh
STATUS_UNRECOGNIZED_VOLUME				EQU 0C000014Fh
STATUS_SERIAL_NO_DEVICE_INITED			EQU 0C0000150h
STATUS_NO_SUCH_ALIAS					EQU 0C0000151h
STATUS_MEMBER_NOT_IN_ALIAS				EQU 0C0000152h
STATUS_MEMBER_IN_ALIAS					EQU 0C0000153h
STATUS_ALIAS_EXISTS					EQU 0C0000154h
STATUS_LOGON_NOT_GRANTED				EQU 0C0000155h
STATUS_TOO_MANY_SECRETS					EQU 0C0000156h
STATUS_SECRET_TOO_LONG					EQU 0C0000157h
STATUS_INTERNAL_DB_ERROR				EQU 0C0000158h
STATUS_FULLSCREEN_MODE					EQU 0C0000159h
STATUS_TOO_MANY_CONTEXT_IDS				EQU 0C000015Ah
STATUS_LOGON_TYPE_NOT_GRANTED				EQU 0C000015Bh
STATUS_NOT_REGISTRY_FILE				EQU 0C000015Ch
STATUS_NT_CROSS_ENCRYPTION_REQUIRED			EQU 0C000015Dh
STATUS_DOMAIN_CTRLR_CONFIG_ERROR			EQU 0C000015Eh
STATUS_FT_MISSING_MEMBER				EQU 0C000015Fh
STATUS_ILL_FORMED_SERVICE_ENTRY			EQU 0C0000160h
STATUS_ILLEGAL_CHARACTER				EQU 0C0000161h
STATUS_UNMAPPABLE_CHARACTER				EQU 0C0000162h
STATUS_UNDEFINED_CHARACTER				EQU 0C0000163h
STATUS_FLOPPY_VOLUME					EQU 0C0000164h
STATUS_FLOPPY_ID_MARK_NOT_FOUND			EQU 0C0000165h
STATUS_FLOPPY_WRONG_CYLINDER				EQU 0C0000166h
STATUS_FLOPPY_BAD_REGISTERS				EQU 0C0000168h
STATUS_DISK_RECALIBRATE_FAILED			EQU 0C0000169h
STATUS_DISK_OPERATION_FAILED				EQU 0C000016Ah
STATUS_DISK_RESET_FAILED				EQU 0C000016Bh
STATUS_SHARED_IRQ_BUSY					EQU 0C000016Ch
STATUS_FT_ORPHANING					EQU 0C000016Dh
STATUS_BIOS_FAILED_TO_CONNECT_INTERRUPT		EQU 0C000016Eh
STATUS_PARTITION_FAILURE				EQU 0C0000172h
STATUS_INVALID_BLOCK_LENGTH				EQU 0C0000173h
STATUS_DEVICE_NOT_PARTITIONED				EQU 0C0000174h
STATUS_UNABLE_TO_LOCK_MEDIA				EQU 0C0000175h
STATUS_UNABLE_TO_UNLOAD_MEDIA				EQU 0C0000176h
STATUS_EOM_OVERFLOW					EQU 0C0000177h
STATUS_NO_MEDIA						EQU 0C0000178h
STATUS_NO_SUCH_MEMBER					EQU 0C000017Ah
STATUS_INVALID_MEMBER					EQU 0C000017Bh
STATUS_KEY_DELETED					EQU 0C000017Ch
STATUS_NO_LOG_SPACE					EQU 0C000017Dh
STATUS_TOO_MANY_SIDS					EQU 0C000017Eh
STATUS_LM_CROSS_ENCRYPTION_REQUIRED			EQU 0C000017Fh
STATUS_KEY_HAS_CHILDREN					EQU 0C0000180h
STATUS_CHILD_MUST_BE_VOLATILE				EQU 0C0000181h
STATUS_DEVICE_CONFIGURATION_ERROR			EQU 0C0000182h
STATUS_DRIVER_INTERNAL_ERROR				EQU 0C0000183h
STATUS_INVALID_DEVICE_STATE				EQU 0C0000184h
STATUS_IO_DEVICE_ERROR					EQU 0C0000185h
STATUS_DEVICE_PROTOCOL_ERROR				EQU 0C0000186h
STATUS_BACKUP_CONTROLLER				EQU 0C0000187h
STATUS_LOG_FILE_FULL					EQU 0C0000188h
STATUS_TOO_LATE						EQU 0C0000189h
STATUS_NO_TRUST_LSA_SECRET				EQU 0C000018Ah
STATUS_NO_TRUST_SAM_ACCOUNT				EQU 0C000018Bh
STATUS_TRUSTED_DOMAIN_FAILURE				EQU 0C000018Ch
STATUS_TRUSTED_RELATIONSHIP_FAILURE			EQU 0C000018Dh
STATUS_EVENTLOG_FILE_CORRUPT				EQU 0C000018Eh
STATUS_EVENTLOG_CANT_START				EQU 0C000018Fh
STATUS_TRUST_FAILURE					EQU 0C0000190h
STATUS_MUTANT_LIMIT_EXCEEDED				EQU 0C0000191h
STATUS_NETLOGON_NOT_STARTED				EQU 0C0000192h
STATUS_ACCOUNT_EXPIRED					EQU 0C0000193h  
STATUS_POSSIBLE_DEADLOCK				EQU 0C0000194h
STATUS_NETWORK_CREDENTIAL_CONFLICT			EQU 0C0000195h
STATUS_REMOTE_SESSION_LIMIT				EQU 0C0000196h
STATUS_EVENTLOG_FILE_CHANGED				EQU 0C0000197h
STATUS_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT		EQU 0C0000198h
STATUS_NOLOGON_WORKSTATION_TRUST_ACCOUNT		EQU 0C0000199h
STATUS_NOLOGON_SERVER_TRUST_ACCOUNT			EQU 0C000019Ah
STATUS_DOMAIN_TRUST_INCONSISTENT			EQU 0C000019Bh
STATUS_FS_DRIVER_REQUIRED				EQU 0C000019Ch
STATUS_NO_USER_SESSION_KEY				EQU 0C0000202h
STATUS_USER_SESSION_DELETED				EQU 0C0000203h
STATUS_RESOURCE_LANG_NOT_FOUND			EQU 0C0000204h
STATUS_INSUFF_SERVER_RESOURCES			EQU 0C0000205h
STATUS_INVALID_BUFFER_SIZE				EQU 0C0000206h
STATUS_INVALID_ADDRESS_COMPONENT			EQU 0C0000207h
STATUS_INVALID_ADDRESS_WILDCARD			EQU 0C0000208h
STATUS_TOO_MANY_ADDRESSES				EQU 0C0000209h
STATUS_ADDRESS_ALREADY_EXISTS				EQU 0C000020Ah
STATUS_ADDRESS_CLOSED					EQU 0C000020Bh
STATUS_CONNECTION_DISCONNECTED			EQU 0C000020Ch
STATUS_CONNECTION_RESET					EQU 0C000020Dh
STATUS_TOO_MANY_NODES					EQU 0C000020Eh
STATUS_TRANSACTION_ABORTED				EQU 0C000020Fh
STATUS_TRANSACTION_TIMED_OUT				EQU 0C0000210h
STATUS_TRANSACTION_NO_RELEASE				EQU 0C0000211h
STATUS_TRANSACTION_NO_MATCH				EQU 0C0000212h
STATUS_TRANSACTION_RESPONDED				EQU 0C0000213h
STATUS_TRANSACTION_INVALID_ID				EQU 0C0000214h
STATUS_TRANSACTION_INVALID_TYPE			EQU 0C0000215h
STATUS_NOT_SERVER_SESSION				EQU 0C0000216h
STATUS_NOT_CLIENT_SESSION				EQU 0C0000217h
STATUS_CANNOT_LOAD_REGISTRY_FILE			EQU 0C0000218h
STATUS_DEBUG_ATTACH_FAILED				EQU 0C0000219h
STATUS_SYSTEM_PROCESS_TERMINATED			EQU 0C000021Ah
STATUS_DATA_NOT_ACCEPTED				EQU 0C000021Bh
STATUS_NO_BROWSER_SERVERS_FOUND			EQU 0C000021Ch
STATUS_VDM_HARD_ERROR					EQU 0C000021Dh
STATUS_DRIVER_CANCEL_TIMEOUT				EQU 0C000021Eh
STATUS_REPLY_MESSAGE_MISMATCH				EQU 0C000021Fh
STATUS_MAPPED_ALIGNMENT					EQU 0C0000220h
STATUS_IMAGE_CHECKSUM_MISMATCH			EQU 0C0000221h
STATUS_LOST_WRITEBEHIND_DATA				EQU 0C0000222h
STATUS_CLIENT_SERVER_PARAMETERS_INVALID		EQU 0C0000223h
STATUS_PASSWORD_MUST_CHANGE				EQU 0C0000224h
STATUS_NOT_FOUND						EQU 0C0000225h
STATUS_NOT_TINY_STREAM					EQU 0C0000226h
STATUS_RECOVERY_FAILURE					EQU 0C0000227h
STATUS_STACK_OVERFLOW_READ				EQU 0C0000228h
STATUS_FAIL_CHECK						EQU 0C0000229h
STATUS_DUPLICATE_OBJECTID				EQU 0C000022Ah
STATUS_OBJECTID_EXISTS					EQU 0C000022Bh
STATUS_CONVERT_TO_LARGE					EQU 0C000022Ch
STATUS_RETRY						EQU 0C000022Dh
STATUS_FOUND_OUT_OF_SCOPE				EQU 0C000022Eh
STATUS_ALLOCATE_BUCKET					EQU 0C000022Fh
STATUS_PROPSET_NOT_FOUND				EQU 0C0000230h
STATUS_MARSHALL_OVERFLOW				EQU 0C0000231h
STATUS_INVALID_VARIANT					EQU 0C0000232h
STATUS_DOMAIN_CONTROLLER_NOT_FOUND			EQU 0C0000233h
STATUS_ACCOUNT_LOCKED_OUT				EQU 0C0000234h 
STATUS_HANDLE_NOT_CLOSABLE				EQU 0C0000235h
STATUS_CONNECTION_REFUSED				EQU 0C0000236h
STATUS_GRACEFUL_DISCONNECT				EQU 0C0000237h
STATUS_ADDRESS_ALREADY_ASSOCIATED			EQU 0C0000238h
STATUS_ADDRESS_NOT_ASSOCIATED				EQU 0C0000239h
STATUS_CONNECTION_INVALID				EQU 0C000023Ah
STATUS_CONNECTION_ACTIVE				EQU 0C000023Bh
STATUS_NETWORK_UNREACHABLE				EQU 0C000023Ch
STATUS_HOST_UNREACHABLE					EQU 0C000023Dh
STATUS_PROTOCOL_UNREACHABLE				EQU 0C000023Eh
STATUS_PORT_UNREACHABLE					EQU 0C000023Fh
STATUS_REQUEST_ABORTED					EQU 0C0000240h
STATUS_CONNECTION_ABORTED				EQU 0C0000241h
STATUS_BAD_COMPRESSION_BUFFER				EQU 0C0000242h
STATUS_USER_MAPPED_FILE					EQU 0C0000243h
STATUS_AUDIT_FAILED					EQU 0C0000244h
STATUS_TIMER_RESOLUTION_NOT_SET			EQU 0C0000245h
STATUS_CONNECTION_COUNT_LIMIT				EQU 0C0000246h
STATUS_LOGIN_TIME_RESTRICTION				EQU 0C0000247h
STATUS_LOGIN_WKSTA_RESTRICTION			EQU 0C0000248h
STATUS_IMAGE_MP_UP_MISMATCH				EQU 0C0000249h
STATUS_INSUFFICIENT_LOGON_INFO			EQU 0C0000250h
STATUS_BAD_DLL_ENTRYPOINT				EQU 0C0000251h
STATUS_BAD_SERVICE_ENTRYPOINT				EQU 0C0000252h
STATUS_LPC_REPLY_LOST					EQU 0C0000253h
STATUS_IP_ADDRESS_CONFLICT1				EQU 0C0000254h
STATUS_IP_ADDRESS_CONFLICT2				EQU 0C0000255h
STATUS_REGISTRY_QUOTA_LIMIT				EQU 0C0000256h
STATUS_PATH_NOT_COVERED					EQU 0C0000257h
STATUS_NO_CALLBACK_ACTIVE				EQU 0C0000258h
STATUS_LICENSE_QUOTA_EXCEEDED				EQU 0C0000259h
STATUS_PWD_TOO_SHORT					EQU 0C000025Ah
STATUS_PWD_TOO_RECENT					EQU 0C000025Bh
STATUS_PWD_HISTORY_CONFLICT				EQU 0C000025Ch
STATUS_PLUGPLAY_NO_DEVICE				EQU 0C000025Eh
STATUS_UNSUPPORTED_COMPRESSION			EQU 0C000025Fh
STATUS_INVALID_HW_PROFILE				EQU 0C0000260h
STATUS_INVALID_PLUGPLAY_DEVICE_PATH			EQU 0C0000261h
STATUS_DRIVER_ORDINAL_NOT_FOUND			EQU 0C0000262h
STATUS_DRIVER_ENTRYPOINT_NOT_FOUND			EQU 0C0000263h
STATUS_RESOURCE_NOT_OWNED				EQU 0C0000264h
STATUS_TOO_MANY_LINKS					EQU 0C0000265h
STATUS_QUOTA_LIST_INCONSISTENT			EQU 0C0000266h
STATUS_FILE_IS_OFFLINE					EQU 0C0000267h
STATUS_EVALUATION_EXPIRATION				EQU 0C0000268h
STATUS_ILLEGAL_DLL_RELOCATION				EQU 0C0000269h
STATUS_LICENSE_VIOLATION				EQU 0C000026Ah
STATUS_DLL_INIT_FAILED_LOGOFF				EQU 0C000026Bh
STATUS_DRIVER_UNABLE_TO_LOAD				EQU 0C000026Ch
STATUS_DFS_UNAVAILABLE					EQU 0C000026Dh
STATUS_VOLUME_DISMOUNTED				EQU 0C000026Eh
STATUS_WX86_INTERNAL_ERROR				EQU 0C000026Fh
STATUS_WX86_FLOAT_STACK_CHECK				EQU 0C0000270h
STATUS_VALIDATE_CONTINUE				EQU 0C0000271h
STATUS_NO_MATCH						EQU 0C0000272h
STATUS_NO_MORE_MATCHES					EQU 0C0000273h
STATUS_INVALID_VLM_OPERATION				EQU 0C0000274h
STATUS_NOT_A_REPARSE_POINT				EQU 0C0000275h
STATUS_IO_REPARSE_TAG_INVALID				EQU 0C0000276h
STATUS_IO_REPARSE_TAG_MISMATCH			EQU 0C0000277h
STATUS_IO_REPARSE_DATA_INVALID			EQU 0C0000278h
STATUS_IO_REPARSE_TAG_NOT_HANDLED			EQU 0C0000279h
STATUS_REPARSE_POINT_NOT_RESOLVED			EQU 0C0000280h
STATUS_DIRECTORY_IS_A_REPARSE_POINT			EQU 0C0000281h
STATUS_RANGE_LIST_CONFLICT				EQU 0C0000282h
STATUS_SOURCE_ELEMENT_EMPTY				EQU 0C0000283h
STATUS_DESTINATION_ELEMENT_FULL			EQU 0C0000284h
STATUS_ILLEGAL_ELEMENT_ADDRESS			EQU 0C0000285h
STATUS_MAGAZINE_NOT_PRESENT				EQU 0C0000286h
STATUS_REINITIALIZATION_NEEDED			EQU 0C0000287h
STATUS_DEVICE_REQUIRES_CLEANING			EQU 080000288h
STATUS_DEVICE_DOOR_OPEN					EQU 080000289h
STATUS_ENCRYPTION_FAILED				EQU 0C000028Ah
STATUS_DECRYPTION_FAILED				EQU 0C000028Bh
STATUS_RANGE_NOT_FOUND					EQU 0C000028Ch
STATUS_NO_RECOVERY_POLICY				EQU 0C000028Dh
STATUS_NO_EFS						EQU 0C000028Eh
STATUS_WRONG_EFS						EQU 0C000028Fh
STATUS_NO_USER_KEYS					EQU 0C0000290h
STATUS_FILE_NOT_ENCRYPTED				EQU 0C0000291h
STATUS_NOT_EXPORT_FORMAT				EQU 0C0000292h
STATUS_FILE_ENCRYPTED					EQU 0C0000293h
STATUS_WAKE_SYSTEM					EQU 040000294h
STATUS_WMI_GUID_NOT_FOUND				EQU 0C0000295h
STATUS_WMI_INSTANCE_NOT_FOUND				EQU 0C0000296h
STATUS_WMI_ITEMID_NOT_FOUND				EQU 0C0000297h
STATUS_WMI_TRY_AGAIN					EQU 0C0000298h
STATUS_SHARED_POLICY					EQU 0C0000299h
STATUS_POLICY_OBJECT_NOT_FOUND			EQU 0C000029Ah
STATUS_WOW_ASSERTION					EQU 0C0009898h
RPC_NT_INVALID_STRING_BINDING				EQU 0C0020001h
RPC_NT_WRONG_KIND_OF_BINDING				EQU 0C0020002h
RPC_NT_INVALID_BINDING					EQU 0C0020003h
RPC_NT_PROTSEQ_NOT_SUPPORTED				EQU 0C0020004h
RPC_NT_INVALID_RPC_PROTSEQ				EQU 0C0020005h
RPC_NT_INVALID_STRING_UUID				EQU 0C0020006h
RPC_NT_INVALID_ENDPOINT_FORMAT			EQU 0C0020007h
RPC_NT_INVALID_NET_ADDR					EQU 0C0020008h
RPC_NT_NO_ENDPOINT_FOUND				EQU 0C0020009h
RPC_NT_INVALID_TIMEOUT					EQU 0C002000Ah
RPC_NT_OBJECT_NOT_FOUND					EQU 0C002000Bh
RPC_NT_ALREADY_REGISTERED				EQU 0C002000Ch
RPC_NT_TYPE_ALREADY_REGISTERED			EQU 0C002000Dh
RPC_NT_ALREADY_LISTENING				EQU 0C002000Eh
RPC_NT_NO_PROTSEQS_REGISTERED				EQU 0C002000Fh
RPC_NT_NOT_LISTENING					EQU 0C0020010h
RPC_NT_UNKNOWN_MGR_TYPE					EQU 0C0020011h
RPC_NT_UNKNOWN_IF						EQU 0C0020012h
RPC_NT_NO_BINDINGS					EQU 0C0020013h
RPC_NT_NO_PROTSEQS					EQU 0C0020014h
RPC_NT_CANT_CREATE_ENDPOINT				EQU 0C0020015h
RPC_NT_OUT_OF_RESOURCES					EQU 0C0020016h
RPC_NT_SERVER_UNAVAILABLE				EQU 0C0020017h
RPC_NT_SERVER_TOO_BUSY					EQU 0C0020018h
RPC_NT_INVALID_NETWORK_OPTIONS			EQU 0C0020019h
RPC_NT_NO_CALL_ACTIVE					EQU 0C002001Ah
RPC_NT_CALL_FAILED					EQU 0C002001Bh
RPC_NT_CALL_FAILED_DNE					EQU 0C002001Ch
RPC_NT_PROTOCOL_ERROR					EQU 0C002001Dh
RPC_NT_UNSUPPORTED_TRANS_SYN				EQU 0C002001Fh
RPC_NT_UNSUPPORTED_TYPE					EQU 0C0020021h
RPC_NT_INVALID_TAG					EQU 0C0020022h
RPC_NT_INVALID_BOUND					EQU 0C0020023h
RPC_NT_NO_ENTRY_NAME					EQU 0C0020024h
RPC_NT_INVALID_NAME_SYNTAX				EQU 0C0020025h
RPC_NT_UNSUPPORTED_NAME_SYNTAX			EQU 0C0020026h
RPC_NT_UUID_NO_ADDRESS					EQU 0C0020028h
RPC_NT_DUPLICATE_ENDPOINT				EQU 0C0020029h
RPC_NT_UNKNOWN_AUTHN_TYPE				EQU 0C002002Ah
RPC_NT_MAX_CALLS_TOO_SMALL				EQU 0C002002Bh
RPC_NT_STRING_TOO_LONG					EQU 0C002002Ch
RPC_NT_PROTSEQ_NOT_FOUND				EQU 0C002002Dh
RPC_NT_PROCNUM_OUT_OF_RANGE				EQU 0C002002Eh
RPC_NT_BINDING_HAS_NO_AUTH				EQU 0C002002Fh
RPC_NT_UNKNOWN_AUTHN_SERVICE				EQU 0C0020030h
RPC_NT_UNKNOWN_AUTHN_LEVEL				EQU 0C0020031h
RPC_NT_INVALID_AUTH_IDENTITY				EQU 0C0020032h
RPC_NT_UNKNOWN_AUTHZ_SERVICE				EQU 0C0020033h
EPT_NT_INVALID_ENTRY					EQU 0C0020034h
EPT_NT_CANT_PERFORM_OP					EQU 0C0020035h
EPT_NT_NOT_REGISTERED					EQU 0C0020036h
RPC_NT_NOTHING_TO_EXPORT				EQU 0C0020037h
RPC_NT_INCOMPLETE_NAME					EQU 0C0020038h
RPC_NT_INVALID_VERS_OPTION				EQU 0C0020039h
RPC_NT_NO_MORE_MEMBERS					EQU 0C002003Ah
RPC_NT_NOT_ALL_OBJS_UNEXPORTED			EQU 0C002003Bh
RPC_NT_INTERFACE_NOT_FOUND				EQU 0C002003Ch
RPC_NT_ENTRY_ALREADY_EXISTS				EQU 0C002003Dh
RPC_NT_ENTRY_NOT_FOUND					EQU 0C002003Eh
RPC_NT_NAME_SERVICE_UNAVAILABLE			EQU 0C002003Fh
RPC_NT_INVALID_NAF_ID					EQU 0C0020040h
RPC_NT_CANNOT_SUPPORT					EQU 0C0020041h
RPC_NT_NO_CONTEXT_AVAILABLE				EQU 0C0020042h
RPC_NT_INTERNAL_ERROR					EQU 0C0020043h
RPC_NT_ZERO_DIVIDE					EQU 0C0020044h
RPC_NT_ADDRESS_ERROR					EQU 0C0020045h
RPC_NT_FP_DIV_ZERO					EQU 0C0020046h
RPC_NT_FP_UNDERFLOW					EQU 0C0020047h
RPC_NT_FP_OVERFLOW					EQU 0C0020048h
RPC_NT_NO_MORE_ENTRIES					EQU 0C0030001h
RPC_NT_SS_CHAR_TRANS_OPEN_FAIL			EQU 0C0030002h
RPC_NT_SS_CHAR_TRANS_SHORT_FILE			EQU 0C0030003h
RPC_NT_SS_IN_NULL_CONTEXT				EQU 0C0030004h
RPC_NT_SS_CONTEXT_MISMATCH				EQU 0C0030005h
RPC_NT_SS_CONTEXT_DAMAGED				EQU 0C0030006h
RPC_NT_SS_HANDLES_MISMATCH				EQU 0C0030007h
RPC_NT_SS_CANNOT_GET_CALL_HANDLE			EQU 0C0030008h
RPC_NT_NULL_REF_POINTER					EQU 0C0030009h
RPC_NT_ENUM_VALUE_OUT_OF_RANGE			EQU 0C003000Ah
RPC_NT_BYTE_COUNT_TOO_SMALL				EQU 0C003000Bh
RPC_NT_BAD_STUB_DATA					EQU 0C003000Ch
RPC_NT_CALL_IN_PROGRESS					EQU 0C0020049h
RPC_NT_NO_MORE_BINDINGS					EQU 0C002004Ah
RPC_NT_GROUP_MEMBER_NOT_FOUND				EQU 0C002004Bh
EPT_NT_CANT_CREATE					EQU 0C002004Ch
RPC_NT_INVALID_OBJECT					EQU 0C002004Dh
RPC_NT_NO_INTERFACES					EQU 0C002004Fh
RPC_NT_CALL_CANCELLED					EQU 0C0020050h
RPC_NT_BINDING_INCOMPLETE				EQU 0C0020051h
RPC_NT_COMM_FAILURE					EQU 0C0020052h
RPC_NT_UNSUPPORTED_AUTHN_LEVEL			EQU 0C0020053h
RPC_NT_NO_PRINC_NAME					EQU 0C0020054h
RPC_NT_NOT_RPC_ERROR					EQU 0C0020055h
RPC_NT_UUID_LOCAL_ONLY					EQU 040020056h
RPC_NT_SEC_PKG_ERROR					EQU 0C0020057h
RPC_NT_NOT_CANCELLED					EQU 0C0020058h
RPC_NT_INVALID_ES_ACTION				EQU 0C0030059h
RPC_NT_WRONG_ES_VERSION					EQU 0C003005Ah
RPC_NT_WRONG_STUB_VERSION				EQU 0C003005Bh
RPC_NT_INVALID_PIPE_OBJECT				EQU 0C003005Ch
RPC_NT_INVALID_PIPE_OPERATION				EQU 0C003005Dh
RPC_NT_WRONG_PIPE_VERSION				EQU 0C003005Eh
RPC_NT_PIPE_CLOSED					EQU 0C003005Fh
RPC_NT_PIPE_DISCIPLINE_ERROR				EQU 0C0030060h
RPC_NT_PIPE_EMPTY						EQU 0C0030061h
RPC_NT_INVALID_ASYNC_HANDLE				EQU 0C0020062h
RPC_NT_INVALID_ASYNC_CALL				EQU 0C0020063h
RPC_NT_SEND_INCOMPLETE					EQU 0400200AFh
STATUS_FLOAT_MULTIPLE_FAULTS				EQU 0C00002B4h
STATUS_FLOAT_MULTIPLE_TRAPS				EQU 0C00002B5h
STATUS_ILLEGAL_VLM_REFERENCE				EQU 0C00002C0h



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<TYPEDEFS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



BOOL								TYPEDEF DWORD
BOOLEAN							TYPEDEF BYTE
CHAR								TYPEDEF BYTE
CSHORT							TYPEDEF WORD
FPBYTE							TYPEDEF FAR PTR BYTE
FPWORD							TYPEDEF NEAR PTR WORD
HANDLE							TYPEDEF DWORD
LONG								TYPEDEF DWORD
LPBYTE							TYPEDEF PTR BYTE
LPDWORD							TYPEDEF PTR DWORD
LPVOID							TYPEDEF PTR
LPCVOID							TYPEDEF PTR
LPSTR								TYPEDEF DWORD
LPCSTR							TYPEDEF DWORD
LPWSTR							TYPEDEF PTR WORD
NPBYTE							TYPEDEF NEAR PTR BYTE
NPWORD							TYPEDEF NEAR PTR WORD
NTSTATUS							TYPEDEF DWORD
PBYTE								TYPEDEF PTR BYTE
pEJOB								TYPEDEF DWORD
pEPROCESS_QUOTA_BLOCK					TYPEDEF DWORD
pETHREAD							TYPEDEF DWORD
pHANDLE_TABLE						TYPEDEF DWORD
pKEVENT							TYPEDEF DWORD
pKSEMAPHORE							TYPEDEF DWORD
pKTHREAD							TYPEDEF DWORD
pMMWSL							TYPEDEF DWORD
pOBJECT_NAME_INFORMATION				TYPEDEF DWORD
pPAGEFAULT_HISTORY					TYPEDEF DWORD
pPEB								TYPEDEF DWORD
pPEB_FREE_BLOCK						TYPEDEF DWORD
pPEB_LDR_DATA						TYPEDEF DWORD
pPS_JOB_TOKEN_FILTER					TYPEDEF DWORD
pPtrVOID							TYPEDEF DWORD
pRTL_USER_PROCESS_PARAMETERS				TYPEDEF DWORD
pSINGLE_LIST_ENTRY					TYPEDEF DWORD
PPBYTE							TYPEDEF PTR PBYTE
PDWORD							TYPEDEF PTR DWORD 
PWORD								TYPEDEF PTR WORD
pVOID								TYPEDEF PTR
UINT								TYPEDEF DWORD
ULONG								TYPEDEF DWORD
WCHAR								TYPEDEF WORD



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<STRUCTURES>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



;..................................................................................
; UNICODE STRING STRUCTURE
;..................................................................................
UNICODE_STRING						STRUCT			; SIZE = 8 BYTES
	usLength						WORD		?		; @0
	usMaxLength					WORD		?		; @2
	usBuffer						LPWSTR	?		; @4
UNICODE_STRING						ENDS				; 
PUNICODE_STRING						TYPEDEF PTR UNICODE_STRING


;..................................................................................
; OBJECT ATTRIBUTES STRUCTURE
;..................................................................................
OBJECT_ATTRIBUTES_STRUCT				STRUCT
	oasLength						DWORD	?			; ULONG 6 * 4 = 24 byte long structure
	RootDirectory					DWORD	?			; HANDLE
	ObjectName						DWORD	?			; PUNICODE_STRING
	Attributes						DWORD	?			; OBJ_CASE_INSENSITIVE = 40h, OBJ_KERNEL_HANDLE = 200h, OBJ_VALID_ATTRIBUTES = 3F2h ULONG
	SecurityDescriptor				DWORD	?			; pVOID Points to type SECURITY_DESCRIPTOR
	SecurityQualityOfService			DWORD	?			; pVOID Points to type SECURITY_QUALITY_OF_SERVICE
OBJECT_ATTRIBUTES_STRUCT				ENDS				; 



;..................................................................................
; LARGE_INTEGER STRUCTURE
;..................................................................................
LARGE_INTEGER						STRUCT			; SIZE = 8 BYTES
	low_part						DWORD	?			; 
	high_part						DWORD	?			; 
	QUAD_PART						QWORD	?			; 
LARGE_INTEGER						ENDS				; 



;..................................................................................
; MadPrgmr LARGE_INT UNION
;..................................................................................
LARGE_INT							Union
	LowPart						DWORD	?
	HighPart						DWORD	?
	struct
	_LowPart						DWORD	?
	_HighPart						DWORD	?
	ENDS
	QUadPart						QWORD	?
LARGE_INT 							ENDS
ULARGE_INTEGER						TYPEDEF LARGE_INT



;..................................................................................
; DRIVER OBJECT STRUCTURE
;..................................................................................
DRIVER_OBJECT						STRUCT			; SIZE = 168 BYTES
	DRIVER_OBJECT_START_OFFSET			WORD 4			; @ 00h
	DRIVER_OBJECT_STRUC_SIZE			WORD SIZEOF DRIVER_OBJECT ;=0A8h
	_PDEVICE_OBJECT					DWORD PTR DEVICE_OBJECT	; @ 04h
	FLAGS							DWORD 000H			; @ 08h
	DRIVER_IMAGE_START				DWORD ?			; @ 0Ch
	DRIVER_IMAGE_SIZE					DWORD ?			; @ 10h
	PDRIVER_MODULE					DWORD ?			; @ 14h
	PDRVEXT						DWORD ?			; @ 18h
	DEVICENAME						UNICODE_STRING <> 	; @ 1Ch
	PHWDATABASE						DWORD ?			; @ 26h
	PFAST_IO_DISPATCH					DWORD ?			; @ 2Ah
	PDRIVER_INITIALIZE				DWORD ?			; @ 2Eh
	PDRIVER_STARTIO					DWORD ?			; @ 32h
	PDRIVER_UNLOAD					DWORD ?			; @ 34h
	PDISPATCH_IRP_MJ_CREATE				DWORD ?			; @ 38h
	PDISPATCH_IRP_MJ_CREATE_NAMED_PIPE		DWORD ?			; @ 3Ch
	PDISPATCH_IRP_MJ_CLOSE				DWORD ?			; @ 40h
	PDISPATCH_IRP_MJ_READ				DWORD ?			; @ 44h
	PDISPATCH_IRP_MJ_WRITE				DWORD ?			; @ 48h
	PDISPATCH_IRP_MJ_QUERY_INFORMATION		DWORD ?			; @ 4Ch
	PDISPATCH_IRP_MJ_SET_INFORMATION		DWORD ?			; @ 50h
	PDISPATCH_IRP_MJ_QUERY_EA			DWORD ?			; @ 54h
	PDISPATCH_IRP_MJ_SET_EA				DWORD ?			; @ 58h
	PDISPATCH_IRP_MJ_FLUSH_BUFFERS		DWORD ?			; @ 5Ch
	PDISPATCH_IRP_MJ_QUERY_VOLUME_INFORMATION	DWORD ?			; @ 60h
	PDISPATCH_IRP_MJ_SET_VOLUME_INFORMATION	DWORD ?			; @ 64h
	PDISPATCH_IRP_MJ_DIRECTORY_CONTROL		DWORD ?			; @ 68h
	PDISPATCH_IRP_MJ_FILE_SYSTEM_CONTROL	DWORD ?			; @ 6Ch
	PDISPATCH_IRP_MJ_DEVICE_CONTROL		DWORD ?			; @ 70h
	PDISPATCH_IRP_MJ_INTERNAL_DEVICE_CONTROL	DWORD ?			; @ 74h
	PDISPATCH_IRP_MJ_SHUT_DOWN			DWORD ?			; @ 78h
	PDISPATCH_IRP_MJ_LOCKCONTROL			DWORD ?			; @ 7Ch
	PDISPATCH_IRP_MJ_CLEANUP			DWORD ?			; @ 80h
	PDISPATCH_IRP_MJ_CREATE_MAILSLOT		DWORD ?			; @ 84h
	PDISPATCH_IRP_MJ_QUERY_SECURITY		DWORD ?			; @ 88h
	PDISPATCH_IRP_MJ_SET_SECURITY			DWORD ?			; @ 8Ch
	PDISPATCH_IRP_MJ_SET_POWER			DWORD ?			; @ 90h
	PDISPATCH_IRP_MJ_WMI				DWORD ?			; @ 94h
	PDISPATCH_IRP_MJ_18				DWORD ?			; @ 98h
	PDISPATCH_IRP_MJ_19				DWORD ?			; @ 9Ch
 	PDISPATCH_IRP_MJ_1A				DWORD ?			; @ A0h
	PDISPATCH_IRP_MJ_1B				DWORD ?			; @ A4h
DRIVER_OBJECT						ENDS
PDRIVER_OBJECT						TYPEDEF PTR DRIVER_OBJECT



;..................................................................................
; DRIVER EXTENSION STRUCTURE
;..................................................................................
DRIVER_EXTENSION						STRUC			; SIZE = 20 BYTES
	DriverObject					DRIVER_OBJECT {}	; 
	AddDevice						DWORD	?		; PDRIVER_ADD_DEVICE
	Count							DWORD	?		; 
	ServiceKeyName					UNICODE_STRING {}	; 
DRIVER_EXTENSION						ENDS			; 
PDRIVER_EXTENSION						TYPEDEF PTR DRIVER_EXTENSION



;..................................................................................
; DEVICE OBJECT STRUCTURE
;..................................................................................
DEVICE_OBJECT						STRUCT	; SIZE = 184 BYTES
	DEVICE_OBJECT_OFFSET				WORD	3	; Type
	DEVICE_OBJECT_SIZE				WORD	108h	; Size SIZEOF DEVICE_OBJECT
	CURRENT_COUNT					DWORD	?	; ReferenceCount
	PDRIVER_OBJECT                            DWORD	PTR DRIVER_OBJECT	 
	PNEXT_DEVICE_OBJECT                       DWORD	PTR DEVICE_OBJECT	
	PATTACHED_DEVICE_OBJECT                   DWORD	PTR DEVICE_OBJECT	
	PCURRENT_IRP                              DWORD	PTR _IRP	
	PTIMER                                    DWORD	?	; @ 1Ah
	FLAGS                                     DWORD	?	; @ 1Eh
	CHARACTERISTIC                            DWORD	?	; @ 22h
	PVPB                                      DWORD	?	; DoNotUse1
	PDEVICE_EXTENSION                         DWORD	?	; @ 28h
	DEVICE_TYPE                               DWORD	?	; 
	STACK_SIZE                                DWORD	?	; 
								UNION		; Queue union
	LIST_ENTRY						DWORD	?	; ListEntry
	WAIT_CONTEXT_BLOCK				DWORD ?	; Wcb
								ENDS		; end Queue union
	ALLIGNMENT_REQUIREMENT                    DWORD	?	; 
	DEVICE_QUEUE					DWORD	?	; 
	DPC							DWORD	?	; 
	ACTIVE_THREAD_COUNT				DWORD	?	; ActiveThreadCount
	PSECURITY_DESCRIPTOR				DWORD	?	; SecurityDescriptor
	KEVENT 						DWORD	?	; DeviceLock
	SECTOR_SIZE						WORD	?	; SectorSize
	SPARE1						WORD	?	; Spare1
;struct _DEVOBJ_EXTENSION  *DeviceObjectExtension;		; 
	Reserved						DWORD	?	; 
DEVICE_OBJECT						ENDS		; 
_PDEVICE_OBJECT						TYPEDEF PTR DEVICE_OBJECT



;..................................................................................
; INPUT OUTPUT STACK LOCATION STRUCTURE
;..................................................................................
IO_READ							STRUCT	; 
	_Length						DWORD ?	; 
	Key							DWORD ?	; 
	ByteOffset						DWORD ?	; 
IO_READ							ENDS		; 



;..................................................................................
; INPUT OUTPUT STACK LOCATION STRUCTURE
;..................................................................................
IO_WRITE							STRUCT	; 
	_Length						DWORD ?	; 
	Key							DWORD ?	; 
	ByteOffset						DWORD ?	; 
IO_WRITE							ENDS		; 



;..................................................................................
; INPUT OUTPUT CONTROL STRUCTURE
;..................................................................................
IO_CONTROL							STRUCT	; 
	OutputBufferLength				DWORD ?	; 
	InputBufferLength					DWORD ?	; 
	IoControlCode					DWORD ?	; 
	Type3InputBuffer					DWORD ?	; 
IO_CONTROL							ENDS		; 



;..................................................................................
; INPUT OUTPUT SCSI STRUCTURE
;..................................................................................
IO_SCSI							STRUCT	; 
	PSCSI_REQUEST_BLOCK				DWORD ?	; 
IO_SCSI							ENDS		; 



;..................................................................................
; INPUT OUTPUT STACK LOCATION STRUCTURE
;..................................................................................
IO_STACK_LOCATION						STRUCT	; SIZE = 36 BYTES
	MajorFunction					BYTE ?	; 
	MinorFunction					BYTE ?	; 
	Flags							BYTE ?	; 
	Control						BYTE ?	; 
								UNION		; 
	Read							IO_READ {}	; 
	Write							IO_WRITE {}	; 
	DeviceIoControl					IO_CONTROL {}
	Scsi							IO_SCSI {}	; 
	PDEVICE_OBJECT					DWORD PTR DEVICE_OBJECT ?
	PFILE_OBJECT					DWORD PTR FILE_OBJECT ?
	PCompletionRoutine				DWORD ?	; 
	PContext						DWORD ?	; 
								ENDS		; 
IO_STACK_LOCATION						ENDS		; 
PIO_STACK_LOCATION					TYPEDEF PTR IO_STACK_LOCATION



;..................................................................................
; INPUT OUTPUT STATUS BLOCK STRUCTURE
;..................................................................................
IO_STATUS_BLOCK						STRUCT	; SIZE = 8 BYTES
	Status						DWORD ?	; NTSTATUS
	Information						DWORD ?	; ULONG_PTR
IO_STATUS_BLOCK						ENDS 



;..................................................................................
; INPUT OUTPUT REQUEST PACKET STRUCTURE
;..................................................................................
_IRP								STRUCT		; SIZE = 112 BYTES
								WORD 6		; @ 0 Type			CSHORT
								WORD SIZEOF _IRP	; @ 2 Size = 94h		USHORT
	PMdlAddress						DWORD ?		; @ 4				PMDL
	Flags							DWORD ?		; @ 8				ULONG
								UNION			; AssociatedIrp union	
	PMasterIrp						DWORD ?		; @ 12 PTR _IRP		LONG
	SystemBuffer					DWORD ?		; @ 12			pVOID
								ENDS			; end AssociatedIrp union
	ThreadListEntry                           DWORD ?		; @ 16			LIST_ENTRY
								DWORD ?		; @ 20
	IoStatus						IO_STATUS_BLOCK {}; @ 24 and @ 28 {}	IO_STATUS_BLOCK
	RequestorMode					BYTE ?		; @ 32			KPROCESSOR_MODE
	PendingReturned					BYTE ? 		; @ 33 			BOOLEAN
	StackCount						BYTE ?		; @ 34			CHAR
	CurrentLocation					BYTE ?		; @ 35			CHAR
	Cancel						BYTE ? 		; @ 36 boolean		CHAR
	CancelIrql						BYTE ?		; @ 37			KIRQL
	ApcEnvironment					BYTE ?		; @ 38			CCHAR
	AllocationFlags					BYTE ? 		; @ 39 boolean true = 4	UCHAR
	PUserIosb						DWORD ?		; @ 40			PIO_STATUS_BLOCK
	PUserEvent						DWORD ?		; @ 44			PKEVENT
	Overlay						DWORD ?		; @ 48			PIO_APC_ROUTINE
								DWORD ?		; @ 52			pVOID
	PCancelRoutine                            DWORD ?		; @ 56			PDRIVER_CANCEL
	PUserBuffer                               DWORD ?		; @ 60			pVOID
								UNION			; Tail
	PApc							DWORD ?		; @ 64			
	CompletionKey					DWORD ?		; @ 64
								STRUCT		; Overlay
								UNION			; x 
	DeviceQueueEntry					DWORD ?		; @ 64
								STRUCT		; y
	PDriverContExt					DWORD 4 DUP (?)	; @ 64, @ 68, @ 72, @ 76pVOID
								ENDS			; y
								ENDS			; x
	PThread						DWORD ?		; @ 80			PETHREAD 
	AuxiliaryBuffer					DWORD ?		; @ 84			PCHAR
	ListEntry						DWORD ?		; @ 88			
								DWORD ?		; @ 92
	PCurrentIrpStackLocation			PIO_STACK_LOCATION ?; @ 96			IO_STACK_LOCATION
	OriginalFileObject				DWORD	?		; @ 100			PFILE_OBJECT
								ENDS			; Overlay
								ENDS			; Tail
_IRP								ENDS 			; 
PIRP								TYPEDEF PTR _IRP



;..................................................................................
; GENERIC STRUCTURE
;..................................................................................
GENERIC_S							STRUC		; 
	Start							DWORD	?	; PHYSICAL_ADDRESS
	genericLength					DWORD	?	; ULONG
GENERIC_S							ENDS		; 



;..................................................................................
; PORT STRUCTURE
;..................................................................................
PORT_S							STRUC		; 
	Start							DWORD	?	; PHYSICAL_ADDRESS
	portLength						DWORD	?	; ULONG
PORT_S							ENDS		; 



;..................................................................................
; INTERRUPT STRUCTURE
;..................................................................................
INTERRUPT_S							STRUC		; 
	Level							DWORD	?	; ULONG
	Vector						DWORD	?	; ULONG
	Affinity						DWORD	?	; ULONG
INTERRUPT_S							ENDS		; 


;..................................................................................
; MEMORY STRUCTURE
;..................................................................................
MEMORY_S							STRUC		; 
	Start							DWORD	?	; PHYSICAL_ADDRESS
	memoryLength					DWORD	?	; ULONG
MEMORY_S							ENDS		; 



;..................................................................................
; DMA STRUCTURE
;..................................................................................
DMA_S								STRUC		; 
	Channel						DWORD	?	; ULONG
	Port							DWORD	?	; ULONG
	Reserved1						DWORD	?	; ULONG
DMA_S								ENDS		; 



;..................................................................................
; DEVICE PRIVATE STRUCTURE
;..................................................................................
DEVICE_PRIVATE_S						STRUC		; 
	Data0							DWORD ?	; ULONG
	Data1							DWORD ?	; ULONG
	Data2							DWORD ?	; ULONG
DEVICE_PRIVATE_S						ENDS		; 



;..................................................................................
; BUS NUMBER STRUCTURE
;..................................................................................
BUS_NUMBER_S						STRUC		; 
	Start							DWORD	?	; ULONG
	busnumberLength					DWORD	?	; ULONG
	Reserved						DWORD	?	; ULONG
BUS_NUMBER_S						ENDS		; 



;..................................................................................
; DEVICE SPECIFIC DATA STRUCTURE
;..................................................................................
DEVICE_SPECIFIC_DATA					STRUC		; 
	DataSize						DWORD	?	; ULONG
	Reserved1						DWORD	?	; ULONG
	Reserved2						DWORD	?	; ULONG
DEVICE_SPECIFIC_DATA					ENDS		; 



;..................................................................................
; CM PARTIAL RESOURCE DESCRIPTOR STRUCTURE
;..................................................................................
_CM_PARTIAL_RESOURCE_DESCRIPTOR			STRUC		; 
	cmType						BYTE	?	; UCHAR
	ShareDisposition					BYTE	?	; UCHAR
	Flags							WORD	?	; USHORT
								UNION		; u union
	Generic						GENERIC_S			{}
	Port							PORT_S			{}
	Interupt						INTERRUPT_S			{}
	Memory						MEMORY_S			{}
	Dma							DMA_S				{}
	DevicePrivate					DEVICE_PRIVATE_S		{}
	BusNumber						BUS_NUMBER_S		{}
	DeviceSpecificData				DEVICE_SPECIFIC_DATA	{}
								ENDS
_CM_PARTIAL_RESOURCE_DESCRIPTOR			ENDS		
PCM_PARTIAL_RESOURCE_DESCRIPTOR			TYPEDEF PTR _CM_PARTIAL_RESOURCE_DESCRIPTOR



;..................................................................................
; CM PARTIAL RESOURCE LIST STRUCTURE
;..................................................................................
_CM_PARTIAL_RESOURCE_LIST				STRUC		; 
	Version						WORD	?	; USHORT
	Revision						WORD	?	; USHORT
	Count							DWORD	?	; ULONG
	PartialDescriptors0				_CM_PARTIAL_RESOURCE_DESCRIPTOR	{}
	PartialDescriptors1				_CM_PARTIAL_RESOURCE_DESCRIPTOR	{}
_CM_PARTIAL_RESOURCE_LIST				ENDS		; 
PCM_PARTIAL_RESOURCE_LIST				TYPEDEF PTR _CM_PARTIAL_RESOURCE_LIST



;..................................................................................
; DEVICE DESCRIPTION STRUCTURE
;..................................................................................
_DEVICE_DESCRIPTION					STRUC		; SIZE = 40 BYTES
	Version						DWORD	?	; ULONG
	Master						BYTE	?	; BOOLEAN
	ScatterGather					BYTE	?	; BOOLEAN
	DemandMode						BYTE	?	; BOOLEAN
	AutoInitialize					BYTE	?	; BOOLEAN
	Dma32BitAddresses					BYTE	?	; BOOLEAN
	IgnoreCount						BYTE	?	; BOOLEAN
	Reserved1						BYTE	?	; BOOLEAN must be false
	Dma64BitAddresses					BYTE	?	; BOOLEAN
	DoNotUse						DWORD ?	; ULONG
	DmaChannel						DWORD ?	; ULONG
	InterfaceType					DWORD ?	; INTERFACE_TYPE
	DmaWidth						DWORD ?	; DMA_WIDTH
	DmaSpeed						DWORD ?	; DMA_SPEED
	MaximumLength					DWORD ?	; ULONG
	DmaPort						DWORD ?	; ULONG
_DEVICE_DESCRIPTION					ENDS		; 
PDEVICE_DESCRIPTION					TYPEDEF PTR _DEVICE_DESCRIPTION



;..................................................................................
; DMA ADAPTER STRUCTURE
;..................................................................................
_DMA_ADAPTER						STRUC		; SIZE = 8 BYTES
	Context						DWORD ?	; IN pVOID 
	dd_in_struc						_DEVICE_DESCRIPTION <> 	; IN *DeviceDescriptor,
	NumberOfMapRegisters				DWORD ?	; OUT PULONG
_DMA_ADAPTER						ENDS		; 



;..................................................................................
; DEVICE CAPABILITIES STRUCTURE
;..................................................................................
DEVICE_CAPABILITIES					STRUC		; SIZE = 64 BYTES
	dcSize						WORD	?	; USHORT
	Version						WORD	?	; USHORT version 1
	Spare1						DWORD	2	; ULONG
	LockSupported					DWORD	1	; ULONG
	EjectSupported					DWORD	1	; ULONG
	Removable						DWORD	1	; ULONG
	DockDevice						DWORD	1	; ULONG
	UniqueID						DWORD	1	; ULONG
	SilentInstall					DWORD	1	; ULONG
	RawDeviceOK						DWORD	1	; ULONG
	SurpriseRemovalOK					DWORD	1	; ULONG
	Reserved						DWORD	22	; ULONG
	Address						DWORD	?	; ULONG
	UINumber						DWORD	?	; ULONG
;	DeviceState[PowerSystemMaximum]				; DEVICE_POWER_STATE
;	SystemWake								; SYSTEM_POWER_STATE
;	DeviceWake								; DEVICE_POWER_STATE
	D1Latency						DWORD	?	; ULONG
	D2Latency						DWORD	?	; ULONG
	D3Latency						DWORD	?	; ULONG
DEVICE_CAPABILITIES					ENDS		; 
PDEVICE_CAPABILITIES			TYPEDEF PTR	DEVICE_CAPABILITIES



;..................................................................................
; DEVICE EXTENSION STRUCTURE
;..................................................................................
_DEVICE_EXTENSION						STRUC
	DeviceObject					_PDEVICE_OBJECT	{}
	LowerDeviceObject					_PDEVICE_OBJECT	{}
	Pdo							_PDEVICE_OBJECT	{}
	ifname						UNICODE_STRING	{}
;	RemoveLock						IO_REMOVE_LOCK
;	devstate						DEVSTATE
;	prevstate						DEVSTATE
;	powerstate						POWERSTATE
;	devpower						DEVICE_POWER_STATE
;	syspower						SYSTEM_POWER_STATE
	devcaps						DEVICE_CAPABILITIES {}
_DEVICE_EXTENSION						ENDS
PDEVICE_EXTENSION						TYPEDEF PTR _DEVICE_EXTENSION



;..................................................................................
; KWAIT REASON ENUMERATION
;..................................................................................
_KWAIT_REASON						UNION		; typedef enum SIZE = 4 BYTES
	Executive						DWORD ?
	FreePage						DWORD ?
	PageIn						DWORD ?
	PoolAllocation					DWORD ?
	DelayExecution					DWORD ?
	Suspended						DWORD ?
	UserRequest						DWORD ?
	WrExecutive						DWORD ?
	WrFreePage						DWORD ?
	WrPageIn						DWORD ?
	WrPoolAllocation					DWORD ?
	WrDelayExecution					DWORD ?
	WrSuspended						DWORD ?
	WrUserRequest					DWORD ?
	WrEventPair						DWORD ?
	WrQueue						DWORD ?
	WrLpcReceive					DWORD ?
	WrLpcReply						DWORD ?
	WrVirtualMemory					DWORD ?
	WrPageOut						DWORD ?
	WrRendezvous					DWORD ?
	Spare2						DWORD ?
	Spare3						DWORD ?
	Spare4						DWORD ?
	Spare5						DWORD ?
	Spare6						DWORD ?
	WrKernel						DWORD ?
	MaximumWaitReason					DWORD ?
_KWAIT_REASON						ENDS		; 



;..................................................................................
; SYSTEM THREAD STRUCTURE
;..................................................................................
_SYSTEM_THREAD						STRUC		; SIZE = 64 BYTES
	qKernelTime						QWORD	?	; 100 nsec units
	qUserTime						QWORD	?	; 100 nsec units
	qCreateTime						QWORD	?	; relative to 01-01-1601
	d18							DWORD	?	; 
	pStartAddress					DWORD	?	; pVOID
	Cid							DWORD	?	; CLIENT_ID ??? process/thread ids
	dPriority						DWORD	?	; 
	dBasePriority					DWORD	?	; 
	dContextSwitches					DWORD	?	; 
	dThreadState					DWORD	?	; 2=running, 5=waiting
	WaitReason						DWORD	?	; instead of enumerated _KWAIT_REASON {} 
	dReserved01						DWORD	?	; 
_SYSTEM_THREAD						ENDS		; 



;..................................................................................
; VM COUNTERS STRUCTURE
;..................................................................................
VM_COUNTERS							STRUC		; SIZE = 44 BYTES
	PeakVirtualSize					DWORD	?	; SIZE_T = unsigned int = DWORD
	VirtualSize						DWORD	?	; 
	PageFaultCount					DWORD	?	; 
	PeakWorkingSetSize				DWORD	?	; 
	WorkingSetSize					DWORD	?	; 
	QuotaPeakPagedPoolUsage				DWORD	?	; 
	QuotaPagedPoolUsage				DWORD	?	; 
	QuotaPeakNonPagedPoolUsage			DWORD	?	; 
	QuotaNonPagedPoolUsage				DWORD	?	; 
	PagefileUsage					DWORD	?	; 
	PeakPagefileUsage					DWORD	?	; 
VM_COUNTERS							ENDS		; 
	PVM_COUNTERS					TYPEDEF PTR VM_COUNTERS



;..................................................................................
; SYSTEM PROCESS INFORMATION STRUCTURE
;..................................................................................
_SYSTEM_PROCESS_INFORMATION				STRUC		; SIZE = 136 BYTES
	dNext							DWORD	?	; relative offset
	dThreadCount					DWORD	?	; 
	dReserved01						DWORD	?	; 
	dReserved02						DWORD	?	; 
	dReserved03						DWORD	?	; 
	dReserved04						DWORD	?	; 
	dReserved05						DWORD	?	; 
	dReserved06						DWORD	?	; 
	qCreateTime						QWORD	?	; relative to 01-01-1601
	qUserTime						QWORD	?	; 100 nsec units
	qKernelTime						QWORD	?	; 100 nsec units
	usName						UNICODE_STRING {}
	BasePriority					DWORD	?	; KPRIORITY
	dUniqueProcessId					DWORD	?	; 
	dInheritedFromUniqueProcessId			DWORD	?	; 
	dHandleCount					DWORD	?	; 
	dReserved07						DWORD	?	; 
	dReserved08						DWORD	?	; 
	VmCounters						VM_COUNTERS {}
	dCommitCharge					DWORD	?	; bytes
	ast							_SYSTEM_THREAD {}	; []
_SYSTEM_PROCESS_INFORMATION				ENDS		; 



;..................................................................................
; SYSTEM MODULE STRUCTURE
;..................................................................................
_SYSTEM_MODULE						STRUC		; SIZE = 284 BYTES
	dReserved01						DWORD	?	; @0
	d04							DWORD	?	; @4
	pAddress						DWORD	?	; @8 pVOID
	dSize							DWORD	?	; @12 bytes
	dFlags						DWORD	?	; @16
	wId							WORD	?	; @20 zero based
	wRank							WORD	?	; @22 0 if not assigned 
	w18							WORD	?	; @24
	wNameOffset						WORD	?	; @26
	abName 						BYTE	256 dup(?)	; @28 MAXIMUM_FILENAME_LENGTH = 256
_SYSTEM_MODULE						ENDS		; 



;..................................................................................
; GARY NEBBETT'S SYSTEM MODULE INFORMATION STRUCTURE
;..................................................................................
_SYSTEM_MODULE_INFORMATION				STRUC		; SIZE = 282 BYTES
	Reserved						DWORD ?, ?
	Base							DWORD ?
	smiSize						DWORD ?
	Flags							DWORD ?
	Index							WORD	?
	Unknown						WORD	?
	LoadCount						WORD	?
	word_NameOffset					WORD	?
	byte_array_ImageName				BYTE 256 dup(?)
_SYSTEM_MODULE_INFORMATION				ENDS		; 
PSYSTEM_MODULE_INFORMATION				TYPEDEF PTR _SYSTEM_MODULE_INFORMATION



;..................................................................................
; SVEN SCHREIBER'S ADULTERATED MODULE LIST STRUCTURE
;..................................................................................
_MODULE_LIST						STRUC		; SIZE = 4 BYTES
	count_Modules					DWORD ?
	actual_Modules					_SYSTEM_MODULE_INFORMATION <>
_MODULE_LIST						ENDS
PMODULE_LIST						TYPEDEF PTR _MODULE_LIST



;..................................................................................
; SVEN SCHREIBER'S IMAGE EXPORT DIRECTORY STRUCTURE
;..................................................................................
_IMAGE_EXPORT_DIRECTORY					STRUC		; SIZE = 40 BYTES
	Characteristics					DWORD	?
	TimeDateStamp					DWORD	?
	MajorVersion					WORD	?
	MinorVersion					WORD	?
	iedName						DWORD	?
	Base							DWORD	?
	NumberOfFunctions					DWORD	?
	NumberOfNames					DWORD	?
	AddressOfFunctions				DWORD	?
	AddressOfNames					DWORD	?
	AddressOfNameOrdinals				DWORD	?
_IMAGE_EXPORT_DIRECTORY					ENDS
PIMAGE_EXPORT_DIRECTORY					TYPEDEF PTR _IMAGE_EXPORT_DIRECTORY	



;..................................................................................
; SVEN SCHREIBER'S IMAGE FILE HEADER STRUCTURE
;..................................................................................
_IMAGE_FILE_HEADER					STRUC		; SIZE = 20 BYTES
	Machine						WORD	?
	NumberOfSections					WORD	?
	TimeDateStamp					DWORD	?
	PointerToSymbolTable				DWORD	?
	NumberOfSymbols					DWORD	?
	SizeOfOptionHeader				WORD	?
	Characteristics					WORD	?
_IMAGE_FILE_HEADER					ENDS
PIMAGE_FILE_HEADER					TYPEDEF PTR _IMAGE_FILE_HEADER



;..................................................................................
; SVEN SCHREIBER'S IMAGE DATA DIRECTORY STRUCTURE
;..................................................................................
_IMAGE_DATA_DIRECTORY					STRUC		; SIZE = 8 BYTES
	VirtualAddress					DWORD	?
	iddSize						DWORD	?
_IMAGE_DATA_DIRECTORY					ENDS
PIMAGE_DATA_DIRECTORY					TYPEDEF PTR _IMAGE_DATA_DIRECTORY



;..................................................................................
; SVEN SCHREIBER'S IMAGE OPTIONAL HEADER STRUCTURE
;..................................................................................
_IMAGE_OPTIONAL_HEADER					STRUC		; SIZE = 104 BYTES
	Magic							WORD	?
	MajorLinkerVersion				BYTE	?
	MinorLinkerVersion				BYTE	?
	SizeOfCode						DWORD	?
	SizeOfInitializedData				DWORD	?
	SizeOfUninitializedData				DWORD	?
	AddressOfEntryPoint				DWORD	?
	BaseOfCode						DWORD	?
	BaseOfData						DWORD	?
	ImageBase						DWORD	?
	SectionalAlignment				DWORD	?
	FileAlignment					DWORD	?
	MajorOperatingSystemVersion			WORD	?
	MinorOperatingSystemVersion			WORD	?
	MajorImageVersion					WORD	?
	MinorImageVersion					WORD	?
	MajorSubsystemVersion				WORD	?
	MinorSubsystemVersion				WORD	?
	Win32VersionValue					DWORD	?
	SizeOfImage						DWORD	?
	SizeOfHeaders					DWORD	?
	CheckSum						DWORD	?
	Subsystem						WORD	?
	DllCharacteristics				WORD	?
	SizeOfStackReserve				DWORD	?
	SizeOfStackCommit					DWORD	?
	SizeOfHeapReserve					DWORD	?
	SizeOfHeapCommit					DWORD	?	
	LoaderFlags						DWORD	?
	NumberOfRvaAndSizes				DWORD	?
	DataDirectory					_IMAGE_DATA_DIRECTORY <>	; dup 16 in C
_IMAGE_OPTIONAL_HEADER					ENDS
PIMAGE_OPTIONAL_HEADER					TYPEDEF PTR _IMAGE_OPTIONAL_HEADER



;..................................................................................
; SVEN SCHREIBER'S IMAGE NT HEADERS STRUCTURE
;..................................................................................
_IMAGE_NT_HEADER						STRUC			; SIZE = 248 BYTES
	Signature						DWORD	?
	FileHeader						_IMAGE_FILE_HEADER <>
	OptionalHeader					_IMAGE_OPTIONAL_HEADER	<>
_IMAGE_NT_HEADER						ENDS
PIMAGE_NT_HEADER						TYPEDEF PTR _IMAGE_NT_HEADER



;..................................................................................
; ICZELION'S STRUCTURE
;..................................................................................
IMAGE_SECTION_HEADER					STRUC
	Name1							BYTE 8 dup(?)
								UNION
	PhysicalAddress					DWORD	?
	VirtualSize						DWORD ?
								ENDS
	VirtualAddress					DWORD	?
	SizeOfRawData					DWORD	?
	PointerToRawData					DWORD	?
	PointerToRelocations				DWORD	?
	PointerToLinenumbers				DWORD	?
	NumberOfRelocations				WORD	?
	NumberOfLinenumbers				WORD	?
	Characteristics					DWORD	?
IMAGE_SECTION_HEADER ENDS
PIMAGE_SECTION_HEADER					TYPEDEF PTR IMAGE_SECTION_HEADER



;..................................................................................
; WINNT IMAGE DOS HEADER STRUCTURE
;..................................................................................
_IMAGE_DOS_HEADER						STRUC			; DOS.EXE HEADER
	e_magic						WORD	?		; Magic number
	e_cblp						WORD	?		; Bytes on last page of file
	e_cp							WORD	?		; Pages in file
	e_crlc						WORD	?		; Relocations
	e_cparhdr						WORD	?		; Size of header in paragraphs
	e_minalloc						WORD	?		; Minimum extra paragraphs needed
	e_maxalloc						WORD	?		; Maximum extra paragraphs needed
	e_ss							WORD	?		; Initial (relative) SS value
	e_sp							WORD	?		; Initial SP value
	e_csum						WORD	?		; Checksum
	e_ip							WORD	?		; Initial IP value
	e_cs							WORD	?		; Initial (relative) CS value
	e_lfarlc						WORD	?		; File address of relocation table
	e_ovno						WORD	?		; Overlay number
	e_res							WORD	4 dup(?)	; Reserved words
	e_oemid						WORD	?		; OEM identifier (for e_oeminfo)
	e_oeminfo						WORD	?		; OEM information e_oemid specific
	e_res2						WORD	10 dup(?)	; Reserved words
	e_lfanew						DWORD	?		; File address of new exe header
 _IMAGE_DOS_HEADER					ENDS
PIMAGE_DOS_HEADER						TYPEDEF PTR _IMAGE_DOS_HEADER



;..................................................................................
; ACCESS MASK STRUCTURE
;..................................................................................
_ACCESS_MASK						STRUC		; 
	SpecificRights					WORD	?	; 
	StandardRights					BYTE	?	; 
	AccessSystemAcl					BYTE	?	; 
	Reserved						BYTE	?, ?, ? 
	GenericAll						BYTE	?	; 
	GenericExecute					BYTE	?	; 
	GenericWrite					BYTE	?	; 
	GenericRead						BYTE	?	; 
_ACCESS_MASK						ENDS		; 
PACCESS_MASK						TYPEDEF PTR _ACCESS_MASK



;..................................................................................
; SYSTEM HANDLE STRUCTURE
;..................................................................................
_SYSTEM_HANDLE						STRUC		; 
	dIdProcess						DWORD	?	; 
	bObjectType						BYTE	?	; OB_TYPE_*
	bFlags						BYTE	?	; bits 0..2 HANDLE_FLAG_*
	wValue						WORD	?	; multiple of 4
	pObject						DWORD	?	; PROJECT
	GrantedAccess					DWORD	?	; or values instead of ACCESS_MASK <>
_SYSTEM_HANDLE						ENDS		; 



;..................................................................................
; SYSTEM PAGE FILE INFORMATION STRUCTURE
;..................................................................................
_SYSTEM_PAGE_FILE_INFORMATION				STRUC		; 
	dNext							DWORD	?	;  relative offset
	dTotal						DWORD	?	; pages
	dInUse						DWORD	?	; pages
	dPeak							DWORD	?	; pages
	usName						UNICODE_STRING {}
_SYSTEM_PAGE_FILE_INFORMATION				ENDS		; 



;..................................................................................
; SYSTEM LOAD DRIVER STRUCTURE
;..................................................................................
_SYSTEM_LOAD_DRIVER					STRUC		; 
	usImageFile						UNICODE_STRING {}	; input
	pBaseAddress					DWORD	?	; pVOID = output
	hSystemImage					DWORD	?	; HANDLE = output
	pEntryPoint						DWORD	?	; pVOID =  output
	pDirectoryEntry					DWORD	?	; pVOID = output
_SYSTEM_LOAD_DRIVER					ENDS		; 



;..................................................................................
; SYSTEM UNLOAD DRIVER STRUCTURE
;..................................................................................
_SYSTEM_UNLOAD_DRIVER					STRUC		; 
	hSystemImage					DWORD	?	; HANDLE = received via SystemLoadDriver
_SYSTEM_UNLOAD_DRIVER					ENDS		; 



;..................................................................................
; SYSTEM ADD DRIVER STRUCTURE
;..................................................................................
_SYSTEM_ADD_DRIVER					STRUC		; 
	usImageFile						UNICODE_STRING {}
_SYSTEM_ADD_DRIVER					ENDS		; 


;..................................................................................
; NTDDK'S PROCESS DEVICEMAP INFORMATION STRUCTURE
;..................................................................................
PROCESS_DEVICEMAP_INFORMATION				STRUC
	DriveMap						DWORD ?
	DriveType						WCHAR 32 DUP (?)
PROCESS_DEVICEMAP_INFORMATION				ENDS



;..................................................................................
; NTDDK'S CLIENT ID STRUCTURE
;..................................................................................
CLIENT_ID							STRUC		; SIZE = 8 BYTES
	UniqueProcess					DWORD ?
	UniqueThread					DWORD ?
CLIENT_ID							ENDS
PCLIENT_ID							TYPEDEF PTR CLIENT_ID



;..................................................................................
; NTDDK'S PROCESS BASIC INFORMATION STRUCTURE
;..................................................................................
_PROCESS_BASIC_INFORMATION				STRUC		; SIZE = 24 BYTES
	ExitStatus						DWORD ?	; NTSTATUS
	PebBaseAddress					DWORD ?	; PPEB
	AffinityMask					DWORD ?	; ULONG_PTR
	BasePriority					DWORD ?	; KPRIORITY
	UniqueProcessId					DWORD ?	; ULONG_PTR
	InheritedFromUniqueProcessId			DWORD ?	; ULONG_PTR
_PROCESS_BASIC_INFORMATION				ENDS
PPROCESS_BASIC_INFORMATION				TYPEDEF PTR PROCESS_BASIC_INFORMATION;



;..................................................................................
; ELICZ'S THREAD BASIC INFORMATION STRUCTURE
;..................................................................................
THREAD_BASIC_INFORMATION				STRUC
	ExitStatus						DWORD ?
	TebBaseAddress					DWORD ?
	ClientId						CLIENT_ID {}
	AffinityMask					DWORD ?
	BasePriority					DWORD ?
	DynamicPriority					DWORD ?
THREAD_BASIC_INFORMATION				ENDS



;..................................................................................
; ELICZ'S PEB LDR DATA STRUCTURE
;..................................................................................
PEB_LDR_DATA						STRUC		; SIZE = 24h BYTES
	cbsize						DWORD ?	; @00 == 24H	
	Flags							DWORD ?	; @04h
	Unknown8						DWORD ?	; @08h
	InLoadOrderModuleListHead			DWORD ?	; 0Ch
	PreviousInLoadOrderLdrEntry			DWORD ?	; 10h
	InMemoryOrderModuleListHead			DWORD ?	; 14h
	PreviousInMemoryOrderLdrEntry			DWORD ?	; 18h
	InInitializationOrderModuleListHead		DWORD ?	; @1Ch
	PreviousInInitializationOrderLdrEntry	DWORD ?	; @20h
PEB_LDR_DATA						ENDS		; 



;..................................................................................
; ELICZ'S LDR ENTRY STRUCTURE
;..................................................................................
LDR_ENTRY							STRUC			; SIZE = 48h BYTES
	NextInLoadOrderLdrEntry				DWORD ?		; @00
	PreviousInLoadOrderLdrEntry			DWORD ?		; @04
	NextInMemoryOrderLdrEntry			DWORD ?		; @08h
	PreviousInMemoryOrderLdrEntry			DWORD ?		; @0Ch	
	NextInInitializationOrderLdrEntry		DWORD ?		; @10h
	PreviousInInitializationOrderLdrEntry	DWORD ?		; @14h
	ModuleBase						DWORD ?		; @18h
	EntryPoint						DWORD ?		; @1Ch
	ModuleSize						DWORD ?		; @20h
	ModuleFileName					UNICODE_STRING {}	; @24h
	ModuleBaseName					UNICODE_STRING {}	; @2Ch
	Flags							DWORD ?		; @34h
	LoadCount						WORD ?		; @38h
	TlsIndex						WORD ?		; @3Ah
	LdrpHashTableEntry0				DWORD ?		; @3Ch
	LdrpHashTableEntry1				DWORD ?		; @40h
	TimeStamp						DWORD ?		; @44h
LDR_ENTRY							ENDS



;..................................................................................
; ELICZ'S PROCESS PARAMETERS STRUCTURE
;..................................................................................
PROCESS_PARAMETERS					STRUC			; SIZE = 290h BYTES
	Unknown00						DWORD ?		; @0h = 1000h
	Unknown04						DWORD ?		; @4h
	Flags							DWORD ?		; @8h
	Unknown0C						DWORD ?		; @0Ch
	CsrConsoleInfo					DWORD ?		; @10h  for Csr calls
	Unknown14						DWORD ?		; @14h
	StdInputHandle					DWORD ?		; @18h
	StdOutputHandle					DWORD ?		; @1Ch
	StdErrorHandle					DWORD ?		; @20h
	CurrentDirectory					UNICODE_STRING {}	; @24h
	DirectoryFlags					DWORD ?		; @2Ch == 18h
	SearchPath						UNICODE_STRING {}	; @30h
	ImagePath						UNICODE_STRING {}	; @38h
	CommandLine						UNICODE_STRING {}	; @40h
	Environment						DWORD ?		; @48h
	Unknown4C						DWORD ?		; @4Ch
	Unknown50						DWORD ?		; @50h
	Unknown54						DWORD ?		; @54h
	Unknown58						DWORD ?		; @58h
	Unknown5C						DWORD ?		; @5Ch
	Unknown60						DWORD ?		; @60h
	Unknown64						DWORD ?		; @64h
	Unknown68						DWORD ?		; @68h
	Unknown6C						DWORD ?		; @6Ch
	WindowTitle						UNICODE_STRING {}	; @70h
	WindowStation					UNICODE_STRING {}	; @78h
	CommandLine2					UNICODE_STRING {}	; @80h
	Unknown88						DWORD 82H DUP (?)	; @88h
PROCESS_PARAMETERS 					ENDS



;..................................................................................
; ELICZ'S PEB STRUCTURE
;..................................................................................
PEB								STRUC			; size = 1E8h,  NT4 size = 150h
	dwFlags						DWORD ?		; @0h
	Unknown04						DWORD ?		; @4h == -1
	ImageBaseAddress					DWORD ?		; @8h
	PebLdrData						DWORD ?		; @0Ch == *PEB_LDR_DATA
	ProcessParameters					DWORD ?		; @10h == *PROCESS_PARAMETERS
	SubSystemData					DWORD ?		; @14h == 0
	ProgramHeap						DWORD ?		; @18h
	LockingContext					DWORD ?		; @1Ch == FastPebLock
	LockRoutine						DWORD ?		; @20h == RtlEnterCriticalSection
	UnlockRoutine					DWORD ?		; @24h == RtlLeaveCriticalSection
	DirChange						DWORD ?		; @28h == 1
	Unknown2C						DWORD ?		; @2Ch == apfnDispatch
	Unknown30						DWORD ?		; @30h == 0
	Unknown34						DWORD ?		; @34h == 0
	Unknown38						DWORD ?		; @38h == 0
	Unknown3C						DWORD ?		; @3Ch == 0
	Unknown40						DWORD ?		; @40h == TlsBitMap
	Unknown44						DWORD ?		; @44h == 3FH
	Unknown48						DWORD ?		; @48h == 0
	ProgramHeap02					DWORD ?		; @4Ch
	ProgramHeap02a					DWORD ?		; @50h
	InProgramHeap02					DWORD ?		; @54h
	AnsiCodePage					DWORD ?		; @58h
	OemCodePage						DWORD ?		; @5Ch
	UnicodeCodePage					DWORD ?		; @60h
	NumberProcessors					DWORD ?		; @64h
	GlobalFlag						DWORD ?		; @68h
	Unknown6C						DWORD ?		; @6Ch  == 0
	CritSectTimeout					DWORD ?		; @70h
	Unknown74						DWORD ?		; @74h
	HeapSegmentReserve				DWORD ?		; @78h
	HeapSegementCommit				DWORD ?		; @7Ch
	HeapDeCommitTotalFreeTreshold			DWORD ?		; @80h  == 10000h
	HeapDeCommitFreeBlockTreshold			DWORD ?		; @84h  == 1000h
	Unknown88						DWORD ?		; @288h
	Unknown8C						DWORD ?		; @8Ch  == 386h
	Unknown90						DWORD ?		; @90h  == RtlpProcessHeapsListBuffer
	Unknown94						DWORD ?		; @94h
	Unknown98						DWORD ?		; @98h  == 0
	Unknown9C						DWORD ?		; @9Ch  == 14H
	UnknownA0						DWORD ?		; @0A0h  == LoaderLock
	dwMajorVersion					DWORD ?		; @0A4h
	dwMinorVersion					DWORD ?		; @0A8h
	dwBuildNumber					WORD ?		; @0ACh
	CSDVersion						WORD ?		; @0AEh
	dwPlatformId					DWORD ?		; @0B0h
	Subsystem						DWORD ?		; @0B4h
	MajorSusbsytemVersion				DWORD ?		; @0B8h
	MinorSusbsytemVersion				DWORD ?		; @0BCh
	ProcessAffinityMask				DWORD ?		; @0C0h
	UnknownC4						DWORD 044h DUP (?); @0C4h
	SessionId						DWORD ?		; @1D4h
	Unknown1D8						DWORD ?		; @1D8h
	Unknown1DC						DWORD ?		; @1DCh
	Unknown1E0						DWORD ?		; @1E0h
	Unknown1E4						DWORD ?		; @1E4h
PEB								ENDS			; 



;..................................................................................
; MadPrgmr PEB STRUCTURE
;..................................................................................
EXECOP							RECORD		SpareBits:30, _ExecuteOptions:2
_PEB								STRUC
	InheritedAddressSpace				BYTE			?	; @0h
	ReadImageFileExecOptions			BYTE			?	; @1h
	BeingDebugged					BYTE			?	; @2h
	SpareBool						BYTE			?	; @3h
	Mutant						pVOID			?	; @4h
	ImageBaseAddress					pVOID			?	; @8h
	Ldr							pPEB_LDR_DATA	?	; @0Ch
	ProcessParameters					pRTL_USER_PROCESS_PARAMETERS ? ; @10h
	SubSystemData					pVOID			?	; @14h
	ProcessHeap						pVOID			?	; @18h
	FastPebLock						pVOID			?	; @1Ch
	FastPebLockRoutine				pVOID			?	; @20h
	FastPebUnlockRoutine				pVOID			?	; @24h
	EnvironmentUpdateCount				DWORD			?	; @28h
	KernelCallbackTable				pVOID			?	; @2Ch
	SystemReserved					DWORD			(?)	; @30h
	ExecuteOptions					EXECOP		<>	; @34h
	FreeList						pPEB_FREE_BLOCK	?	; @38h
	TlsExpansionCounter				DWORD			?	; @3Ch
	TlsBitmap						pVOID			?	; @40h
	TlsBitmapBits					DWORD			2 DUP (?) ; @44h
	ReadOnlySharedMemoryBase			pVOID			?	; @4Ch
	ReadOnlySharedMemoryHeap			pVOID			?	; @50h
	ReadOnlyStaticServerData			pPtrVOID		?	; @54h
	AnsiCodePageData					pVOID			?	; @58h
	OemCodePageData					pVOID			?	; @5Ch
	UnicodeCaseTableData				pVOID			?	; @60h
	NumberOfProcessors				DWORD			?	; @64h
	NtGlobalFlag					DWORD			?	; @68h
	Pad1							DWORD			?	; @6Ch
	CriticalSectionTimeout				LARGE_INT		<>	; @70h
	HeapSegmentReserve				DWORD			?	; @78h
	HeapSegmentCommit					DWORD			?	; @7Ch
	HeapDeCommitTotalFreeThreshold		DWORD			?	; @80h
	HeapDeCommitFreeBlockThreshold		DWORD			?	; @84h
	NumberOfHeaps					DWORD			?	; @88h
	MaximumNumberOfHeaps				DWORD			?	; @8Ch
	ProcessHeaps					pPtrVOID		?	; @90h
	GdiSharedHandleTable				pVOID			?	; @94h
	ProcessStarterHelper				pVOID			?	; @98h
	GdiDCAttributeList				DWORD			?	; @9Ch
	LoaderLock						pVOID			?	; @0A0h
	OSMajorVersion					DWORD			?	; @0A4h
	OSMinorVersion					DWORD			?	; @0A8h
	OSBuildNumber					WORD			?	; @0ACh
	OSCSDVersion					WORD			?	; @0AEh
	OSPlatformId					DWORD			?	; @0B0h
	ImageSubsystem					DWORD			?	; @0B4h
	ImageSubsystemMajorVersion			DWORD			?	; @0B8h
	ImageSubsystemMinorVersion			DWORD			?	; @0BCh
	ImageProcessAffinityMask			DWORD			?	; @0C0h
	GdiHandleBuffer					DWORD			34 DUP (?) ; @0C4h
	PostProcessInitRoutine				DWORD			?	; @14Ch
	TlsExpansionBitmap				pVOID			?	; @150h
	TlsExpansionBitmapBits				DWORD			32 DUP (?) ; @154h
	SessionId						DWORD			?	; @1D4h
	AppCompatFlags					ULARGE_INTEGER	<>	; @1D8h
	AppCompatFlagsUser				ULARGE_INTEGER	<>	; @1E0h
	pShimData						pVOID			?	; @1E8h
	AppCompatInfo					pVOID			?	; @1ECh
	CSDVersion						UNICODE_STRING	<>	; @1F0h
	ActivationContextData				pVOID			?	; @1F8h
	ProcessAssemblyStorageMap			pVOID			?	; @1FCh
	SystemDefaultActContextData			pVOID			?	; @200h
	SystemAssemblyStoargeMap			pVOID			?	; @204h
	MinimumStackCommit				DWORD			?	; @208h
_PEB								ENDS



;..................................................................................
; ELICZ'S TEB STRUCTURE
;..................................................................................
TEB								STRUC			; SIZE = 0FA4h,  NT4 size = 0F88h
	ExceptionList					DWORD ?		; @0h
	StackBase						DWORD ?		; @4h
	StackLimit						DWORD ?		; @8h
	SubSystemTib					DWORD ?		; @0Ch
								UNION			; 
	FiberData						DWORD ?		; @10h
	Version						DWORD ?		; @10h
								ENDS			; 
	ArbitraryUserPointer				DWORD ?		; @14h
	Self							DWORD ?		; @18h
	EnvironmentPtr					DWORD ?		; @1Ch
	ClientId						CLIENT_ID {}	; @20h
	RpcHandle						DWORD ?		; @28h
	TlsStorage						DWORD ?		; @2Ch
	pPEB							DWORD ?		; @30h
	LastErrorValue					DWORD ?		; @34h Get/SetLastError
	OwnedLocksCount					DWORD ?		; @38h aka CountOfOwnedCriticalSections
	Unknown3C						DWORD ?		; @3Ch
	Win32ThreadInfo					DWORD ?		; @40h
	Unknown44						DWORD 20h DUP (?); @44h
	Locale						DWORD ?		; @0C4h
	UnknownC8						DWORD 17Bh DUP (?); @0C8h
	RealClientId					CLIENT_ID {}	; @6B4h
	Unknown6BC						DWORD ?		; @6BCh
	GdiClientId						CLIENT_ID {}	; @6C0h
	GdiThreadLocalInfo				DWORD ?		; @6C8h
	Win32ClientInfo					DWORD ?		; @6CCh probably array
	Unknown6D0						DWORD 149h DUP (?); @6D0h
	LastStatusValue					DWORD ?		; @0BF4h
	WindowStation					UNICODE_STRING {}; @0BF8h
	UnknownC00						DWORD 083h DUP (?); @0C00h
	ThreadStack						DWORD ?		; @0E0Ch
	UnknownE10						DWORD 43h DUP (?); @0E10h
	RpcTls						DWORD ?		; @0F1Ch ptr to RPC_TLS
	UnknownF20						DWORD ?		; @0F20h
	UnknownF24						DWORD ?		; @0F24h
	HardErrorsMode					DWORD ?		; @0F28h
	UnknownF2C						DWORD 01BH DUP (?); @0F2Ch
	LogonLocale						DWORD ?		; @0F98h
	LogonLocale2					DWORD ?		; @0F9C
	UnknownFA0						DWORD ?		; @0FA0h
TEB								ENDS			; 



;..................................................................................
; ELICZ'S KUSER SHARED DATA STRUCTURE
;..................................................................................
KUSER_SHARED_DATA						STRUC			; SIZE = 2D8h
	TickCount						DWORD ?		; @0h
	TickCountMultiplier				DWORD ?		; @4h
	ElapsedTime						QWORD ?		; @8h
	ElapsedTimeCompareHigh				DWORD ?		; @10h
	SystemTime						QWORD ?		; @14h LocalTime = SystemTime - TimeZoneBias
	SystemTimeCompareHigh				DWORD ?		; @1Ch
	TimeZoneBias					QWORD ?		; @20h
	TimeZoneBiasCompareHigh				DWORD ?		; @28h
	ImageNumberLow					WORD ?		; @2Ch
	ImageNumberHigh					WORD ?		; @2Eh
	SystemRoot						WCHAR MAX_PATH DUP (?) ; @30h
	Unknown238						DWORD ?		; @238h
	CryptoExponent					DWORD ?		; @23Ch
	TimeZoneId						DWORD ?		; @240h
	Unknown244						DWORD 25H DUP (?)	; @244h
KUSER_SHARED_DATA						ENDS			; 



;..................................................................................
; ELICZ'S RPC TLS STRUCTURE
;..................................................................................
RPC_TLS							STRUC			; SIZE = 60h BYTES
	fAsync						DWORD ?		; @0h
	HandleToThread					DWORD ?		; @4h
	HandleToThreadEvent				DWORD ?		; @8h
	Context						DWORD ?		; @0Ch
	SecurityContext					DWORD ?		; @10h
	BufferCacheArray					DWORD 8h DUP (?)	; @14h
	CancelTimeout					DWORD ?		; @34h
	fCallCanceled					DWORD ?		; @38h
	Unknown3C						DWORD ?		; @3Ch
	ExtendedStatus					DWORD ?		; @40h
	SavedProcedure					DWORD ?		; @44h
	SavedParameter					DWORD ?		; @48h
	ActiveCall						DWORD ?		; @4Ch
	Unknown50						DWORD 4h DUP (?)	; @50h
RPC_TLS							ENDS			; 



;..................................................................................
; ELICZ'S SYSTEM BASIC INFORMATION STRUCTURE
;..................................................................................
SYSTEM_BASIC_INFORMATION				STRUCT DWORD					
	Machine						DWORD ? 		; pure fantasy, 0 = local
	MaximumIncrement					DWORD ?		; 
	PageSize						DWORD ?		; 1000
	PhysicalPages					DWORD ?		; KiloBytes = NoPages*(PageSize >> 0A)
	LowestPhysicalPage				DWORD ?		; 1
	HighestPhysicalPage				DWORD ?		; 1FFFh
	AllocationGranularity				DWORD ?		; 10000h
	LowestUserAddress					DWORD ?		; 10000h
	HighestUserAddress				DWORD ?		; 7FFEFFFFh
	ActiveProcessors					DWORD ?		; mask
	NumberProcessors					BYTE  ?		;
SYSTEM_BASIC_INFORMATION				ENDS			;



;..................................................................................
; ELICZ'S SYSTEM BASIC INFORMATION STRUCTURE
;..................................................................................
SYSTEM_PROCESSOR_INFORMATION STRUCT DWORD
	Architecture					WORD ?
	Level							WORD ?
	Revision						WORD ?
	Reserved06						WORD ?		; alignment
	FeatureBits						DWORD ?
SYSTEM_PROCESSOR_INFORMATION				ENDS


;..................................................................................
; ELICZ'S SYSTEM PERFORMANCE INFORMATION STRUCTURE
;..................................................................................
SYSTEM_PERFORMANCE_INFORMATION			STRUCT DWORD
	IdleTime						QWORD ?		; @0h
	ReadTransferCount					QWORD ?		; @8h Io data
	WriteTransferCount				QWORD ?		; @10h
	OtherTransferCount				QWORD ?		; @18h
	ReadOperationCount				DWORD ?		; @20h
	WriteOperationCount				DWORD ?		; @24h
	OtherOperationCount				DWORD ?		; @28h
	AvailablePages					DWORD ?		; @2Ch, Mm data
	TotalCommittedPages				DWORD ?		; @30h
	TotalCommitLimit					DWORD ?		; @34h
	PeakCommitment					DWORD ?		; @38h
	MemInfoCounter00					DWORD ?		; @3Ch
	MemInfoCounter01					DWORD ?		; @40h
	MemInfoCounter02					DWORD ?		; @44h
	MemInfoCounter03					DWORD ?		; @48h
	MemInfoCounter04					DWORD ?		; @4Ch
	MemInfoCounter05					DWORD ?		; @50h
	MemInfoCounter06					DWORD ?		; @54h
	MemInfoCounter07					DWORD ?		; @58h
	MemInfoCounter08					DWORD ?		; @5Ch
	MemInfoCounter09					DWORD ?		; @60h
	MemInfoCounter10					DWORD ?		; @64h
	MemInfoCounter11					DWORD ?		; @68h
	MemInfoCounter12					DWORD ?		; @6Ch
	PagedPoolSize					DWORD ?		; @70h
	NonpagedPoolSize					DWORD ?		; @74h
	PoolUsage02						DWORD ?		; @78h
	PoolUsage03						DWORD ?		; @7Ch
	PoolUsage05						DWORD ?		; @80h
	PoolUsage06						DWORD ?		; @84h
	TotalFreeSystemPtes				DWORD ?		; @88h
	SystemCodePage					DWORD ?		; @8Ch
	TotalSystemDriverPages				DWORD ?		; @90h
	TotalSystemCodePages				DWORD ?		; @94h
	PoolUsage07						DWORD ?		; @98h
	PoolUsage04						DWORD ?		; @9Ch
	UnknownA0						DWORD ?		; @0A0h
	SystemCachePage					DWORD ?		; @0A4h
	PagedPoolUsage					DWORD ?		; @0A8h
	SystemDriverPage					DWORD ?		; @0ACh
	FastReadNoWait					DWORD ?		; @0B0h, Cc data
	FastReadWait					DWORD ?		; @0B4h
	FastReadResourceMiss				DWORD ?		; @0B8h
	FastReadNotPossible				DWORD ?		; @0BCh
	FastMdlReadNoWait					DWORD ?		; @0C0h
	FastMdlReadWait					DWORD ?		; @0C4h
	FastMdlReadResourceMiss				DWORD ?		; @0C8h
	FastMdlReadNotPossible				DWORD ?		; @0CCh
	MapDataNoWait					DWORD ?		; @0D0h
	MapDataWait						DWORD ?		; @0D4h
	MapDataNoWaitMiss					DWORD ?		; @0D8h
 	MapDataWaitMiss					DWORD ?		; @0DCh
	PinMappedDataCount				DWORD ?		; @0E0h
	PinReadNoWait					DWORD ?  		; @0E4h
	PinReadWait						DWORD ?		; @0E8h
	PinReadNoWaitMiss					DWORD ?		; @0ECh
	PinReadWaitMiss					DWORD ?		; @0F0h
	CopyReadNoWait					DWORD ?		; @0F4h
	CopyReadWait					DWORD ?		; @0F8h
	CopyReadNoWaitMiss				DWORD ?		; @0FCh
	CopyReadWaitMiss					DWORD ?		; @100h
 	MdlReadNoWait					DWORD ?		; @104h
	MdlReadWait						DWORD ?		; @108h
	MdlReadNoWaitMiss					DWORD ?		; @10Ch
	MdlReadWaitMiss					DWORD ?		; @110h
	ReadAheadIos					DWORD ?		; @114h
	LazyWriteIos					DWORD ?		; @118h
	LazyWritePages					DWORD ?		; @11Ch
	DataFlushes						DWORD ?		; @120h
	DataPages						DWORD ?		; @124h
	ContextSwaps					DWORD ?  		; @128h
	PCRB4AC						DWORD ?		; @12Ch
 	PCRB4B8						DWORD ?		; @130h
	SyscallsCalled					DWORD ?		; @134h
SYSTEM_PERFORMANCE_INFORMATION			ENDS			; 


;..................................................................................
; ELICZ'S SYSTEM TIME INFORMATION STRUCTURE
;..................................................................................
SYSTEM_TIME_INFORMATION					STRUC			; 
	BootTime						QWORD ?
	SystemTime						QWORD ?
	TimeZoneBias					QWORD ?
	CurrentTimeZoneId					QWORD ?
	BootTimeBias					QWORD ?
	InterruptTimeBias					QWORD ?
SYSTEM_TIME_INFORMATION					ENDS			; 


;..................................................................................
; SYSTEM THREAD INFORMATION STRUCTURE
;..................................................................................
SYSTEM_THREAD_INFORMATION				STRUC			; size THREAD_INFO_SIZE
	KernelTime						QWORD ?		; @0h
	UserTime						QWORD ?		; @8h
	CreateTime						QWORD ?		; @10h
	TickCount						DWORD ?		; @18h
	StartAddress					DWORD ?		; @1Ch
	ClientId						CLIENT_ID {}	; @20h
	DynamicPriority					DWORD ?		; @28h
	BasePriority					DWORD ?		; @2Ch
	ContextSwitches					DWORD ?		; @30h
	State							DWORD ?		; @34h
	WaitReason						DWORD ?		; @38h
	Reserved3C						DWORD ?		; @3Ch
SYSTEM_THREAD_INFORMATION				ENDS			; 



;..................................................................................
; NT4 SYSTEM PROCESS INFORMATION STRUCTURE
;..................................................................................
NT4_SYSTEM_PROCESS_INFORMATION			STRUC			; 
	SizeOfBlock						DWORD ?           ; @0h NULL for info end
	ThreadCount						DWORD ?		; @4h # of threads in this block
	Reserved08						DWORD 6h DUP (?)	; @8h
	CreateTime						QWORD ?		; @20h
	UserTime						QWORD ?		; @28h
	KernelTime						QWORD ?		; @30h
	ProcessName						UNICODE_STRING <>	; @38h
	Priority						DWORD ?		; @40h
	ProcessId						DWORD ?		; @44h
	ParentProcessId					DWORD ?		; @48h
	HandleCount						DWORD ?		; @4Ch
	SessionId						DWORD ?		; @50h
	Reserved54						DWORD ?		; @54h
	PeakVirtualSize					DWORD ?		; @58h
	VirtualSize						DWORD ?		; @5Ch
	PageFaultCount					DWORD ?		; @60h
	PeakWorkingSetSize				DWORD ?		; @64h
	WorkingSetSize					DWORD ?		; @68h
	QuotaPeakPagedPoolUsage				DWORD ?		; @6Ch
	QuotaPagedPoolUsage				DWORD ?		; @70h
	QuotaPeakNonPagedPoolUsage			DWORD ?		; @74h
	QuotaNonPagedPoolUsage				DWORD ?		; @78h
	PagefileUsage					DWORD ?		; @7Ch
	PeakPagefileUsage					DWORD ?		; @80h
	PrivatePages					DWORD ?		; @84h
	ThreadInformation					SYSTEM_THREAD_INFORMATION {} ; @88h array
NT4_SYSTEM_PROCESS_INFORMATION			ENDS



;..................................................................................
; NT5 SYSTEM PROCESS INFORMATION STRUCTURE
;..................................................................................
NT5_SYSTEM_PROCESS_INFORMATION			STRUC
	SizeOfBlock						DWORD ?           ; @0h NULL for info end
	ThreadCount						DWORD ?		; @4h # of threads in this block
	Reserved08						DWORD 6h DUP (?)	; @8h
	CreateTime						QWORD ?		; @20h
	UserTime						QWORD ?		; @28h
	KernelTime						QWORD ?		; @30h
	ProcessName						UNICODE_STRING <>	; @38h
	Priority						DWORD ?		; @40h
	ProcessId						DWORD ?		; @44h
	ParentProcessId					DWORD ?		; @48h
	HandleCount						DWORD ?		; @4Ch
	SessionId						DWORD ?		; @50h
	Reserved54						DWORD ?		; @54h
	PeakVirtualSize					DWORD ?		; @58h
	VirtualSize						DWORD ?		; @5Ch
	PageFaultCount					DWORD ?		; @60h
	PeakWorkingSetSize				DWORD ?		; @64h
	WorkingSetSize					DWORD ?		; @68h
	QuotaPeakPagedPoolUsage				DWORD ?		; @6Ch
	QuotaPagedPoolUsage				DWORD ?		; @70h
	QuotaPeakNonPagedPoolUsage			DWORD ?		; @74h
	QuotaNonPagedPoolUsage				DWORD ?		; @78h
	PagefileUsage					DWORD ?		; @7Ch
	PeakPagefileUsage					DWORD ?		; @80h
	PrivatePages					DWORD ?		; @84h
	ReadOperationCount				QWORD ?		; @088h
	WriteOperationCount				QWORD ?		; @90h
	OtherOperationCount				QWORD ?		; @98h
	ReadTransferCount					QWORD ?		; @0A0h
	WriteTransferCount				QWORD ?		; @0A8h
	OtherTransferCount				QWORD ?		; @0B0h
	ThreadInformation					SYSTEM_THREAD_INFORMATION {} ; @0B8h array
NT5_SYSTEM_PROCESS_INFORMATION			ENDS



IFDEF NT4
	SYSTEM_PROCESS_INFORMATION TEXTEQU <NT4_SYSTEM_PROCESS_INFORMATION>
ELSE
	SYSTEM_PROCESS_INFORMATION TEXTEQU <NT5_SYSTEM_PROCESS_INFORMATION>
ENDIF



;..................................................................................
; ELICZ'S SYSTEM SYSCALL INFORMATION STRUCTURE
;..................................................................................
SYSTEM_SYSCALL_INFORMATION				STRUC
	SizeOfBlock						DWORD ?
	SyscallTables					DWORD ?
	SizeOfTable00					DWORD ?
      ;etc.. SizeOfTable(SyscallTables-1)
      ;follow copied tables:
      ;Table00 DWORD SizeOfTable00 DUP (?)
      ;etc.. Table(SyscallTables-1) DWORD SizeOfTable(SyscallTables-1) DUP (?)
SYSTEM_SYSCALL_INFORMATION				ENDS



;..................................................................................
; ELICZ'S SYSTEM GLOBALFLAG INFORMATION STRUCTURE
;..................................................................................
SYSTEM_GLOBALFLAG_INFORMATION				STRUC
	GlobalFlag						DWORD ?
SYSTEM_GLOBALFLAG_INFORMATION				ENDS



;..................................................................................
; ELICZ'S SYSTEM LOADEDMODULE STRUCTURE
;..................................................................................
SYSTEM_LOADEDMODULE					STRUC
	Unknown00						DWORD ?		; @0h
	Unknown04						DWORD ?		; @4h
	ModuleBase						DWORD ?		; @08h
	ModuleSize						DWORD ?		; @0Ch
	Unknown10						DWORD ?		; @10h
	Unknown14						DWORD ?		; @14h
	Unknown18						WORD ?		; @18h
	BaseNameOffset					WORD ?		; @1Ah
	ModuleFileName					CHAR 100h DUP (?); @1Ch always ansi
SYSTEM_LOADEDMODULE					ENDS


;..................................................................................
; ELICZ'S SYSTEM LOADEDMODULE INFORMATION STRUCTURE
;..................................................................................
SYSTEM_LOADEDMODULE_INFORMATION 			STRUC
	ModuleCount						DWORD ?
	ModuleInformation					SYSTEM_LOADEDMODULE <>  ; @4h array
SYSTEM_LOADEDMODULE_INFORMATION			ENDS



;..................................................................................
; ELICZ'S SYSTEM HANDLE STRUCTURE
;..................................................................................
SYSTEM_HANDLE						STRUC
	ProcessId						DWORD ?
	ObjectType						BYTE ?
	Flags							BYTE ?			;0..7
	Handle						WORD ?
	ObjectPointer					DWORD ?
	Access						DWORD ?
SYSTEM_HANDLE						ENDS


;..................................................................................
; ELICZ'S SYSTEM HANDLE INFORMATION STRUCTURE
;..................................................................................
SYSTEM_HANDLE_INFORMATION STRUCT
	HandleCount						DWORD ?
	HandleInformation					SYSTEM_HANDLE <>	; array
SYSTEM_HANDLE_INFORMATION				ENDS



;..................................................................................
; ELICZ'S SYSTEM OBJECT INFORMATION STRUCTURE
;..................................................................................
SYSTEM_OBJECT_INFORMATION				STRUC
SYSTEM_OBJECT_INFORMATION				ENDS



;..................................................................................
; ELICZ'S SYSTEM PAGEFILE INFORMATION STRUCTURE
;..................................................................................
SYSTEM_PAGEFILE_INFORMATION				STRUC			; 
	SizeOfBlock						DWORD ?		; @0h  NULL for info end
	CurrentSize						DWORD ?		; @4h  in pages
	TotalUsedPages					DWORD ?		; @8h  in pages
	PeakUsedPages					DWORD ?		; @0Ch  in pages
	PagefileName					UNICODE_STRING {}	; @10h
SYSTEM_PAGEFILE_INFORMATION				ENDS			; 



;..................................................................................
; ELICZ'S SYSTEM DEBUGGER INFORMATION STRUCTURE
;..................................................................................
SYSTEM_DEBUGGER_INFORMATION				STRUC
	KernelDebuggerEnabled				BYTE ?		; i386kd
	KernelDebuggerNotPresent			BYTE ?
SYSTEM_DEBUGGER_INFORMATION				ENDS


;..................................................................................
; ELICZ'S SYSTEM SESSIONPROCESS INFORMATION STRUCTURE
;..................................................................................
SYSTEM_SESSIONPROCESS_INFORMATION			STRUC
	SessionId						DWORD ?
	BufferSize						DWORD ?
	Buffer						DWORD ?	; ptr to SYSTEM_PROCESS_INFORMATION
SYSTEM_SESSIONPROCESS_INFORMATION ENDS


;..................................................................................
; NTDDK PROCESS BASIC INFORMATION STRUCTURE
;..................................................................................
PROCESS_BASIC_INFORMATION				STRUC
	ExitStatus						DWORD ?
	PebBaseAddress					DWORD ?
	AffinityMask					DWORD ?
	BasePriority					DWORD ?
	UniqueProcessId					DWORD ?
	InheritedFromUniqueProcessId			DWORD ?
PROCESS_BASIC_INFORMATION				ENDS



;..................................................................................
; NTDDK QUOTA LIMITS STRUCTURE
;..................................................................................
QUOTA_LIMITS						STRUC	; corrected by EliCZ: size must be 20H
	PagedPoolLimit					DWORD ?
	NonPagedPoolLimit					DWORD ?
	MinimumWorkingSetSize				DWORD ?
	MaximumWorkingSetSize				DWORD ?
	PagefileLimit					DWORD ?
	Reserved14						DWORD ?   ; added (probably qword alignment)
	TimeLimit						QWORD ?
QUOTA_LIMITS						ENDS



;..................................................................................
; NTDDK IO COUNTERS STRUCTURE
;..................................................................................
IO_COUNTERS							STRUC		; corrected by EliCZ: NT4 :NOT_SUPPORTED, NT5: long integers
	ReadOperationCount				QWORD ?	; was DWORD ?
	WriteOperationCount				QWORD ?	; was DWORD ?
	OtherOperationCount				QWORD ?	; was DWORD ?
	ReadTransferCount					QWORD ?
	WriteTransferCount				QWORD ?
	OtherTransferCount				QWORD ?
IO_COUNTERS							ENDS



;..................................................................................
; NTDDK KERNEL USER TIMES STRUCTURE
;..................................................................................
KERNEL_USER_TIMES						STRUC
	CreateTime						QWORD ?
	ExitTime						QWORD ?
	KernelTime						QWORD ?
	UserTime						QWORD ?
KERNEL_USER_TIMES						ENDS



;..................................................................................
; NTDDK POOLED USAGE AND LIMITS STRUCTURE
;..................................................................................
POOLED_USAGE_AND_LIMITS					STRUC
	PeakPagedPoolUsage				DWORD ?
	PagedPoolUsage					DWORD ?
	PagedPoolLimit					DWORD ?
	PeakNonPagedPoolUsage				DWORD ?
	NonPagedPoolUsage					DWORD ?
	NonPagedPoolLimit					DWORD ?
	PeakPagefileUsage					DWORD ?
	PagefileUsage					DWORD ?
	PagefileLimit					DWORD ?
POOLED_USAGE_AND_LIMITS 				ENDS



;..................................................................................
; NTDDK PROCESS WS WATCH INFORMATION STRUCTURE
;..................................................................................
PROCESS_WS_WATCH_INFORMATION 				STRUC
	FaultingPc						DWORD ?
	FaultingVa						DWORD ?
PROCESS_WS_WATCH_INFORMATION				ENDS



;..................................................................................
; NTDDK PROCESS DEVICEMAP INFORMATION STRUCTURE
;..................................................................................
PROCESS_DEVICEMAP_INFORMATION				STRUC
	DriveMap						DWORD ?
	DriveType						WCHAR 32 DUP (?)
PROCESS_DEVICEMAP_INFORMATION				ENDS



;..................................................................................
; PREVENT MEDIA REMOVAL STRUCTURE
;..................................................................................
_PREVENT_MEDIA_REMOVAL 					STRUC
	PreventMediaRemoval				BYTE	?	; BOOLEAN 
_PREVENT_MEDIA_REMOVAL					ENDS
	


;..................................................................................
; DISK GEOMETRY STRUCTURE
;..................................................................................
_DISK_GEOMETRY						STRUC
	Cylinders						LARGE_INTEGER {}
	MediaType						DWORD ?	; enum _MEDIA_TYPE 
	TracksPerCylinder					DWORD	?
	SectorsPerTrack					DWORD	?
	BytesPerSector					DWORD	?
_DISK_GEOMETRY						ENDS


;..................................................................................
; SYSTEM SERVICE TABLE STRUCTURE
;..................................................................................
SYSTEM_SERVICE_TABLE					STRUC
	ServiceTable					DWORD	?	; PNTPROC array of entry points 
	CounterTable					DWORD	?	; PDWORD array of usage entries 
	ServiceLimit					DWORD	?	; number of table entries 
	ArgumentTable					DWORD	?	; array of byte counts 
SYSTEM_SERVICE_TABLE					ENDS
PSYSTEM_SERVICE_TABLE					TYPEDEF PTR SYSTEM_SERVICE_TABLE



;..................................................................................
; NTDDK'S PROCESSINFOCLASS ENUMERATION
;..................................................................................
_PROCESSINFOCLASS						UNION
    ProcessBasicInformation				DWORD 0
    ProcessQuotaLimits					DWORD 1
    ProcessIoCounters					DWORD 2
    ProcessVmCounters					DWORD 3
    ProcessTimes						DWORD 4
    ProcessBasePriority					DWORD 5
    ProcessRaisePriority				DWORD 6
    ProcessDebugPort					DWORD 7
    ProcessExceptionPort				DWORD 8
    ProcessAccessToken					DWORD 9
    ProcessLdtInformation				DWORD 10
    ProcessLdtSize					DWORD 11
    ProcessDefaultHardErrorMode			DWORD 12
    ProcessIoPortHandlers				DWORD 13
    ProcessPooledUsageAndLimits			DWORD 14
    ProcessWorkingSetWatch				DWORD 15
    ProcessUserModeIOPL					DWORD 16
    ProcessEnableAlignmentFaultFixup		DWORD 17
    ProcessPriorityClass				DWORD 18
    ProcessWx86Information				DWORD 19
    ProcessHandleCount					DWORD 20
    ProcessAffinityMask					DWORD 21
    ProcessPriorityBoost				DWORD 22
    ProcessDeviceMap					DWORD 23
    ProcessSessionInformation				DWORD 24
    ProcessForegroundInformation			DWORD 25
    ProcessWow64Information				DWORD 26
    MaxProcessInfoClass					DWORD 27
_PROCESSINFOCLASS						ENDS



;..................................................................................
; MEMORY DESCRIPTOR LIST DATA STRUCTURE
;..................................................................................
_MDL								STRUC
	Next							DWORD	?	; pointer to _MDL *Next;
	mdlSize						CSHORT ?
	MdlFlags						CSHORT ?
	Process						DWORD ?	; pointer to _EPROCESS *Process
	MappedSystemVa					pVOID ?
	StartVa						pVOID ?
	ByteCount						ULONG ?
	ByteOffset						ULONG ?
_MDL								ENDS
PMDL								TYPEDEF PTR _MDL



;..................................................................................
; NTDDK'S RUN TIME LIBRARY BITMAP STRUCTURE
;..................................................................................
_RTL_BITMAP							STRUC
	SizeOfBitMap					DWORD ?	; ULONG Number of bits in bit map
	Buffer						DWORD ?	; PULONG Pointer to the bit map itself
_RTL_BITMAP							ENDs
PRTL_BITMAP							TYPEDEF PTR _RTL_BITMAP



;..................................................................................
; NTDDK'S RUN TIME LIBRARY BITMAP RUN STRUCTURE
;..................................................................................
_RTL_BITMAP_RUN						STRUC
	StartingIndex					DWORD ?
	NumberOfBits					DWORD ?
_RTL_BITMAP_RUN						ENDS
PRTL_BITMAP_RUN						TYPEDEF PTR _RTL_BITMAP_RUN



;..................................................................................
; NTDDK'S _OSVERSIONINFOA STRUCTURE
;..................................................................................
_OSVERSIONINFOA						STRUC
	dwOSVersionInfoSize				DWORD ?
	dwMajorVersion					DWORD ?
	dwMinorVersion					DWORD ?
	dwBuildNumber					DWORD ?
	dwPlatformId					DWORD ?
	szCSDVersion					BYTE 128 dup (?)
_OSVERSIONINFOA						ENDS
POSVERSIONINFOA						TYPEDEF PTR _OSVERSIONINFOA



;..................................................................................
; NTDDK'S _OSVERSIONINFOW STRUCTURE
;..................................................................................
_OSVERSIONINFOW						STRUC
	dwOSVersionInfoSize				DWORD ?
	dwMajorVersion					DWORD ?
	dwMinorVersion					DWORD ?
	dwBuildNumber					DWORD ?
	dwPlatformId					DWORD ?
	szCSDVersion					BYTE 128 dup (?)
_OSVERSIONINFOW						ENDS
POSVERSIONINFOW						TYPEDEF PTR _OSVERSIONINFOW


;..................................................................................
; NTDDK'S _OSVERSIONINFOEAX STRUCTURE
;..................................................................................
_OSVERSIONINFOEXA						STRUC
	dwOSVersionInfoSize				DWORD ?
	dwMajorVersion					DWORD ?
	dwMinorVersion					DWORD ?
	dwBuildNumber					DWORD ?
	dwPlatformId					DWORD ?
	szCSDVersion					BYTE 128 dup (?)
	wServicePackMajor					WORD ?
	wServicePackMinor					WORD ?
	wSuiteMask						WORD ?
	wProductType					BYTE ?
	wReserved						BYTE ?
_OSVERSIONINFOEXA						ENDS
POSVERSIONINFOEXA						TYPEDEF PTR _OSVERSIONINFOEXA



;..................................................................................
; NTDDK'S _OSVERSIONINFOEAXW STRUCTURE
;..................................................................................
_OSVERSIONINFOEXW						STRUC
	dwOSVersionInfoSize				DWORD ?
	dwMajorVersion					DWORD ?
	dwMinorVersion					DWORD ?
	dwBuildNumber					DWORD ?
	dwPlatformId					DWORD ?
	szCSDVersion					BYTE 128 dup (?)
	wServicePackMajor					WORD ?
	wServicePackMinor					WORD ?
	wSuiteMask						WORD ?
	wProductType					BYTE ?
	wReserved						BYTE ?
_OSVERSIONINFOEXW						ENDS
POSVERSIONINFOEXW						TYPEDEF PTR _OSVERSIONINFOEXW


;..................................................................................
; NTDDK'S RUN TIME LIBRARY RANGE STRUCTURE
;..................................................................................
_RTL_RANGE							STRUC
	Start							QWORD ?	; ULONGLONG 
	rEnd							QWORD ?	; ULONGLONG
	UserData						DWORD ?	; pVOID
	Owner							DWORD ?	; pVOID
	Attributes						BYTE	?	; UCHAR
	Flags							BYTE	?	; UCHAR
_RTL_RANGE							ENDS
PRTL_RANGE							TYPEDEF PTR _RTL_RANGE



;..................................................................................
; NTDDK'S RUN TIME LIBRARY RANGE LIST STRUCTURE
;..................................................................................
_RTL_RANGE_LIST						STRUC
	ListHead						DWORD ?	; LIST_ENTRY
	Flags							DWORD ?
	Count							DWORD ?
	Stamp							DWORD	?
_RTL_RANGE_LIST						ENDS
PRTL_RANGE_LIST						TYPEDEF PTR _RTL_RANGE_LIST



;..................................................................................
; NTDDK'S RUN TIME LIBRARY RANGE LIST ITERATOR STRUCTURE
;..................................................................................
_RTL_RANGE_LIST_ITERATOR				STRUC
	RangeListHead					DWORD ?
	MergedHead						DWORD ?
	Current						DWORD ?
	Stamp							DWORD ?
_RTL_RANGE_LIST_ITERATOR				ENDS
PRTL_RANGE_LIST_ITERATOR				TYPEDEF PTR _RTL_RANGE_LIST_ITERATOR



;..................................................................................
; NTDDK'S LIST HEADER STRUCTURE
;..................................................................................
_SLIST_HEADER						STRUC
	Alignment						DWORD ?
    								STRUC
	Depth							DWORD 16 dup (?)	; SINGLE_LIST_ENTRY <>
	Sequence						DWORD 8 dup (?)	; WORD
	Next							DWORD 40 dup (?)	; WORD
								ENDS
_SLIST_HEADER						ENDS
PSLIST_HEADER						TYPEDEF PTR _SLIST_HEADER



;..................................................................................
; WDM'S TIME FIELDS STRUCTURE
;..................................................................................
_TIME_FIELDS						STRUC
	Year							WORD	?		; from 1601
	Month							WORD	?		; 1 to 12
	Day							WORD	?		; 1 to 31
	Hour							WORD	?		; 0 to 23
	Minute						WORD	?		; 0 to 59
	Second						WORD	?		; 0 to 59
	Milliseconds					WORD	?		; 0 to 999
	Weekday						WORD	?		; 0 to 6 == Sunday to Saturday
_TIME_FIELDS						ENDS



;..................................................................................
; MadPrgmr LIST_ENTRY STRUCTURE
;..................................................................................
LIST_ENTRY							STRUC
	Flink							DWORD				?
	Blink							DWORD				?
LIST_ENTRY							ENDS



;..................................................................................
; MadPrgmr DISPATCHER HEADER STRUCTURE
;..................................................................................
DISPATCHER_HEADER						STRUC
	dhType						BYTE				?
	dhAbsolute						BYTE				?
	dhSize						BYTE				?
	dhInserted						BYTE				?
	SignalState						DWORD				?
	WaitListHead					LIST_ENTRY			<>
DISPATCHER_HEADER						ENDS



;..................................................................................
; MadPrgmr SINGLE LIST ENTRY STRUCTURE
;..................................................................................
SINGLE_LIST_ENTRY						STRUC
	Next							pSINGLE_LIST_ENTRY	?
SINGLE_LIST_ENTRY						ENDS



;..................................................................................
; MadPrgmr KGDTENTRY STRUCTURE
;..................................................................................
unnamed11_Bits      					RECORD			uBaseHi:8, uGranularity:1, uDefault_Big:1, uReserved_0:1, uSys:1, uLimitHi:4, uPres:1, uDpl:2, uType:5, BaseMid:8
KGDTENTRY							STRUC
	gdtLimitLow						WORD				?
	gdtBaseLow						WORD				?
								UNION
								STRUC
	BaseMid						BYTE				?
	Flags1						BYTE				?
	Flags2						BYTE				?
	BaseHi						BYTE				?
								ENDS
	Bits							unnamed11_Bits		<>
								ENDS
KGDTENTRY ENDS



;..................................................................................
; MadPrgmr KIDTENTRY STRUCTURE
;..................................................................................
KIDTENTRY							STRUC
	idtOffset						WORD				?
	idtSelector						WORD				?
	idtAccess						WORD				?
	idtExtendedOffset					WORD				?
KIDTENTRY							ENDS



;..................................................................................
; MadPrgmr EX PUSH LOCK UNION
;..................................................................................
PUSHLOCK_BITS						RECORD			Shared:1Eh, Exclusive:1, Waiting:1
EX_PUSH_LOCK						UNION
	plBITS						PUSHLOCK_BITS		<>
	Value							DWORD				?
	eplPtr						pVOID				?
EX_PUSH_LOCK						ENDS



;..................................................................................
; MadPrgmr EX RUNDOWN REF UNION
;..................................................................................
EX_RUNDOWN_REF						UNION
	Count							DWORD				?
	errPtr						pVOID				?
EX_RUNDOWN_REF						ENDS



;..................................................................................
; MadPrgmr EX FAST REF UNION
;..................................................................................
EX_FAST_REF							UNION
	Object						DWORD				?
	RefCnt						DWORD				?
	Value							DWORD				?
EX_FAST_REF							ENDS



;..................................................................................
; MadPrgmr KEVENT STRUCT
;..................................................................................
KEVENT							STRUC
	Header						DISPATCHER_HEADER		<>
KEVENT							ENDS



;..................................................................................
; MadPrgmr FAST_MUTEX STRUCT
;..................................................................................
FAST_MUTEX							STRUC
	Count							DWORD				?
	Owner							pKTHREAD			?
	Contention						DWORD				?
	Event							KEVENT			<>
	OldIrql						DWORD				?
FAST_MUTEX							ENDS



;..................................................................................
; MadPrgmr SE AUDIT PROCESS CREATION INFO STRUCT
;..................................................................................
SE_AUDIT_PROCESS_CREATION_INFO			STRUC
	ImageFileName					pOBJECT_NAME_INFORMATION ?
SE_AUDIT_PROCESS_CREATION_INFO			ENDS



;..................................................................................
; MadPrgmr KPROCESS STRUCTURE
;..................................................................................
KPROCESS							STRUC
	Header						DISPATCHER_HEADER		<>	; @0h
	ProfileListHead					LIST_ENTRY			<>	; @10h
	DirectoryTableBase				DWORD 2 DUP			(?)	; @18h
	LdtDescriptor					KGDTENTRY			<>	; @20h
	Int21Descriptor					KIDTENTRY			<>	; @28h
	IopmOffset						WORD				?	; @30h
	Iopl							BYTE				?	; @32h
	Unused						BYTE				?	; @33h
	ActiveProcessors					DWORD				?	; @34h
	KernelTime						DWORD				?	; @38h
	UserTime						DWORD				?	; @3Ch
	ReadyListHead					LIST_ENTRY			<>	; @40h
	SwapListEntry					SINGLE_LIST_ENTRY		<>	; @48h
	VdmTrapcHandler					pVOID				?	; @4Ch
	ThreadListHead					LIST_ENTRY         	<>	; @50h
	ProcessLock						DWORD				?	; @58h
	Affinity						DWORD				?	; @5Ch
	StackCount						DWORD				?	; @60h
	BasePriority					BYTE				?	; @62h
	ThreadQuantum					BYTE				?	; @63h
	AutoAlignment					BYTE				?	; @64h
	State							BYTE				?	; @65h
	ThreadSeed						BYTE				?	; @66h
	DisableBoost					BYTE				?	; @67h
	PowerState						BYTE				?	; @68h
	DisableQuantum					BYTE				?	; @69h
	IdealNode						BYTE				?	; @6Ah
	Spare							BYTE				?	; @6Bh
KPROCESS							ENDS



;..................................................................................
; MadPrgmr MMSUPPORT STRUCTURE
;..................................................................................
MMSUPPORT_FLAGS						RECORD			MemoryPriority:8, AllowWorkingSetAdjustment:8, Available:10, AddressSpaceBeingDeleted:1, WorkingSetHard:1, TrimHard:1, SessionLeader:1, BeingTrimmed:1, SessionSpace:1
MMSUPPORT							STRUC
	LastTrimTime					LARGE_INT			<>	; @0h
	Flags							MMSUPPORT_FLAGS		<>	; @8h
	PageFaultCount					DWORD				?	; @0Ch
	PeakWorkingSetSize				DWORD				?	; @10h
	WorkingSetSize					DWORD				?	; @14h
	MinimumWorkingSetSize				DWORD				?	; @18h
	MaximumWorkingSetSize				DWORD				?	; @1Ch
	VmWorkingSetList					pMMWSL			?	; @20h
	WorkingSetExpansionLinks			LIST_ENTRY			<>	; @24h
	Claim							DWORD				?	; @2Ch
	NextEstimationSlot				DWORD				?	; @30h
	NextAgingSlot					DWORD				?	; @34h
	EstimatedAvailable				DWORD				?	; @38h
	GrowthSinceLastEstimate				DWORD				?	; @3Ch
MMSUPPORT							ENDS



;..................................................................................
; MadPrgmr EPROCESS STRUCTURE
;..................................................................................
HARDWARE_PTE_X86						RECORD			PageFrameNumber:20,  Reserved_1:1, Prototype:1, CopyOnWrite:1, Global:1, LargePage:1, Dirty:1, Accessed:1, CacheDisable:1, WriteThrough:1, Owner:1, Write:1, Valid:1
EPROC_FLAGS							RECORD			Unused:0Bh, InjectInpageErrors:1, LaunchPrefetched:1, HasAddressSpace:1, OverrideAddressSpace:1, ProcessInSession:1, WriteWatch:1, SessionCreationUnderway:1, BreakOnTermination:1, SetTimerResolution:1, AddressSpaceInitialized:2, HasPhysicalVad:1, ForkFailed:1, Outswapped:1, OutswapEnabled:1, VmDeleted:1, Wow64SplitPages:1, ProcessDelete:1, ProcessExiting:1, NoDebugInherit:1,CreateReported:1
EPROCESS							STRUC
	Pcb							KPROCESS			<>	; @0h
	ProcessLock						EX_PUSH_LOCK		<>	; @6Ch
	CreateTime						LARGE_INT			<>	; @70h
	ExitTime						LARGE_INT			<>	; @78h
	RundownProtect					EX_RUNDOWN_REF		<>	; @80h
	UniqueProcessId					pVOID				?	; @84h
	ActiveProcessLinks				LIST_ENTRY			<>	; @88h
	QuotaUsage						DWORD 3 DUP			(?)	; @90h
	QuotaPeak						DWORD 3 DUP			(?)	; @9Ch
	CommitCharge					DWORD				?	; @0A8h
	PeakVirtualSize					DWORD				?	; @ACh
	VirtualSize						DWORD				?	; @0B0h
	SessionProcessLinks				LIST_ENTRY			<>	; @0B4h
	DebugPort						pVOID				?	; @0BCh
	ExceptionPort					pVOID				?	; @0C0h
	ObjectTable						pHANDLE_TABLE		?	; @0C4h
	Token							EX_FAST_REF			<>	; @0C8h
	WorkingSetLock					FAST_MUTEX			<>	; @0CCh
	WorkingSetPage					DWORD				?	; @0ECh
	AddressCreationLock				FAST_MUTEX			<>	; @0F0h
	HyperSpaceLock					DWORD				?	; @110h
	ForkInProgress					pETHREAD			?	; @114h
	HardwareTrigger					DWORD				?	; @118h
	VadRoot						pVOID				?	; @11Ch
	VadHint						pVOID				?	; @120h
	CloneRoot						pVOID				?	; @124h
	NumberOfPrivatePages				DWORD				?	; @128h
	NumberOfLockedPages				DWORD				?	; @12Ch
	Win32Process					pVOID				?	; @130h
	Job							pEJOB				?	; @134h
	SectionObject					pVOID				?	; @138h
	SectionBaseAddress				pVOID				?	; @13Ch
	QuotaBlock						pEPROCESS_QUOTA_BLOCK	?	; @140h
	WorkingSetWatch					pPAGEFAULT_HISTORY	?	; @144h
	Win32WindowStation				pVOID				?	; @148h
	InheritedFromUniqueProcessId			pVOID				?	; @14Ch
	LdtInformation					pVOID				?	; @150h
	VadFreeHint						pVOID				?	; @154h
	VdmObjects						pVOID				?	; @158h
	DeviceMap						pVOID				?	; @15Ch
	PhysicalVadList					LIST_ENTRY			<>	; @160h
	PageDirectoryPte					HARDWARE_PTE_X86		<>	; @168h
	Filler						QWORD				?	; @168h
	Session						pVOID				?	; @170h
	ImageFileName					BYTE 16 DUP			(?)	; @174h
	JobLinks						LIST_ENTRY			<>	; @184h
	LockedPagesList					pVOID				?	; @18Ch
	ThreadListHead					LIST_ENTRY			<>	; @190h
	SecurityPort					pVOID			?	; @198h
	PaeTop						pVOID			?	; @19Ch
	ActiveThreads					DWORD			?	; @1A0h
	GrantedAccess					DWORD			?	; @1A4h
	DefaultHardErrorProcessing			DWORD			?	; @1A8h
	LastThreadExitStatus				DWORD			?	; @1ACh
	Peb							pPEB			?	; @1B0h
	PrefetchTrace					EX_FAST_REF		<>	; @1B4h
	ReadOperationCount				LARGE_INT		<>	; @1B8h
	WriteOperationCount				LARGE_INT		<>	; @1C0h
	OtherOperationCount				LARGE_INT		<>	; @1C8h
	ReadTransferCount					LARGE_INT		<>	; @1D0h
	WriteTransferCount				LARGE_INT		<>	; @1D8h
	OtherTransferCount				LARGE_INT		<>	; @1E0h
	CommitChargeLimit					DWORD			?	; @1E8h
	CommitChargePeak					DWORD			?	; @1ECh
	AweInfo						pVOID			?	; @1F0h
	SeAuditProcessCreationInfo			SE_AUDIT_PROCESS_CREATION_INFO <> ; @1F4h
	Vm							MMSUPPORT		<>	; @1F8h
	LastFaultCount					DWORD			?	; @238h
	ModifiedPageCount					DWORD			?	; @23Ch
	NumberOfVads					DWORD			?	; @240h
	JobStatus						DWORD			?	; @244h
	Flags							EPROC_FLAGS		<>	; @248h
	ExitStatus						DWORD			?	; @24ch
	NextPageColor					WORD			?	; @250h
	SubSystemMinorVersion				BYTE			?	; @252h
	SubSystemMajorVersion				BYTE			?	; @253h
	SubSystemVersion					WORD			?	; @252h
	PriorityClass					BYTE			?	; @254h
	WorkingSetAcquiredUnsafe			BYTE			?	; @255h
EPROCESS							ENDS



;..................................................................................
; MadPrgmr PAGE FAULT HISTORY STRUCTURE
;..................................................................................
PAGEFAULT_HISTORY						STRUC
	CurrentIndex					DWORD			?	; @0h
	MaxIndex						DWORD			?	; @4h
	SpinLock						DWORD			?	; @8h
	Reserved						pVOID			?	; @0Ch
	WatchInfo						PROCESS_WS_WATCH_INFORMATION <> ; @10h
PAGEFAULT_HISTORY						ENDS



;..................................................................................
; MadPrgmr EPROCESS QUOTA ENTRY STRUCTURE
;..................................................................................
EPROCESS_QUOTA_ENTRY					STRUC
	eqeUsage						DWORD			?	; @0h
	eqeLimit						DWORD			?	; @4h
	eqePeak						DWORD			?	; @8h
	eqeReturn						DWORD			?	; @0Ch
EPROCESS_QUOTA_ENTRY					ENDS



;..................................................................................
; MadPrgmr EPROCESS QUOTA ENTRY STRUCTURE
;..................................................................................
EPROCESS_QUOTA_BLOCK Struct
	QuotaEntry						EPROCESS_QUOTA_ENTRY 3 DUP (<>) ; @0h
	QuotaList						LIST_ENTRY		<>	; @30h
	ReferenceCount					DWORD			?	; @38h
	ProcessCount					DWORD			?	; @3Ch
EPROCESS_QUOTA_BLOCK ENDS



;..................................................................................
; MadPrgmr OWNER ENTRY STRUCTURE
;..................................................................................
OWNER_ENTRY							STRUC
	OwnerThread						DWORD			?	; @0h
								UNION
	OwnerCount						DWORD			?	; @4h
	TableSize						DWORD			?	; @4h
								ENDS
OWNER_ENTRY							ENDS
pOWNER_ENTRY						TYPEDEF PTR OWNER_ENTRY



;..................................................................................
; MadPrgmr OWNER ENTRY STRUCTURE
;..................................................................................
ERESOURCE							STRUC
	SystemResourcesList				LIST_ENTRY		<>	; @0h
	OwnerTable						pOWNER_ENTRY	?	; @8h
	ActiveCount						WORD			?	; @0Ch
	Flag							WORD			?	; @0Eh
	SharedWaiters					pKSEMAPHORE		?	; @10h
	ExclusiveWaiters					pKEVENT		?	; @14h
	OwnerThreads					OWNER_ENTRY		2 DUP (<>) ; @18h
	ContentionCount					DWORD			?	; @28h
	NumberOfSharedWaiters				WORD			?	; @02Ch
	NumberOfExclusiveWaiters			WORD			?	; @2Eh
								UNION
	Address						pVOID			?	; @30h
	CreatorBackTraceIndex				DWORD			?	; @30h
								ENDS
	SpinLock						DWORD			?	; @34h
ERESOURCE							ENDS



;..................................................................................
; MadPrgmr IO COUNTERS STRUCTURE
;..................................................................................
IO_COUNTERS							STRUC
	ReadOperationCount				QWORD			?	; @0h
	WriteOperationCount				QWORD			?	; @8h
	OtherOperationCount				QWORD			?	; @10h
	ReadTransferCount					QWORD			?	; @18h
	WriteTransferCount				QWORD			?	; @20h
	OtherTransferCount				QWORD			?	; @28h
IO_COUNTERS							ENDS



;..................................................................................
; MadPrgmr EJOB STRUCTURE
;..................................................................................
EJOB Struct
	Event							KEVENT		<>	; @0h
	JobLinks						LIST_ENTRY		<>	; @10h
	ProcessListHead					LIST_ENTRY		<>	; @18h
	JobLock						ERESOURCE		<>	; @20h
	TotalUserTime					LARGE_INT		<>	; @58h
	TotalKernelTime					LARGE_INT		<>	; @60h
	ThisPeriodTotalUserTime				LARGE_INT		<>	; @68h
	ThisPeriodTotalKernelTime			LARGE_INT		<>	; @70h
	TotalPageFaultCount				DWORD			?	; @78h
	TotalProcesses					DWORD			?	; @7Ch
	ActiveProcesses					DWORD			?	; @80h
	TotalTerminatedProcesses			DWORD			?	; @84h
	PerProcessUserTimeLimit				LARGE_INT		<>	; @88h
	PerJobUserTimeLimit				LARGE_INT		<>	; @90h
	LimitFlags						DWORD			?	; @98h
	MinimumWorkingSetSize				DWORD			?	; @9Ch
	MaximumWorkingSetSize				DWORD			?	; @0A0h
	ActiveProcessLimit				DWORD			?	; @0A4h
	Affinity						DWORD			?	; @0A8h
	PriorityClass					BYTE			?	; @0ACh
	Pad1							BYTE			3 DUP (?) ; @0ADh
	UIRestrictionsClass				DWORD			?	; @0B0h
	SecurityLimitFlags				DWORD			?	; @0B4h
	Token							pVOID			?	; @0B8h
	Filter						pPS_JOB_TOKEN_FILTER ?	; @0BCh
	EndOfJobTimeAction				DWORD			?	; @0C0h
	CompletionPort					pVOID			?	; @0C4h
	CompletionKey					pVOID			?	; @0C8h
	SessionId						DWORD			?	; @0CCh
	SchedulingClass					DWORD			?	; @0D0h
	Pad2							DWORD			?	; @0D4h
	ReadOperationCount				QWORD			?	; @0D8h
	WriteOperationCount				QWORD			?	; @0E0h
	OtherOperationCount				QWORD			?	; @0E8h
	ReadTransferCount					QWORD			?	; @0F0h
	WriteTransferCount				QWORD			?	; @0F8h
	OtherTransferCount				QWORD			?	; @100h
	IoInfo						IO_COUNTERS		<>	; @108h
	ProcessMemoryLimit				DWORD			?	; @138h
	JobMemoryLimit					DWORD			?	; @13Ch
	PeakProcessMemoryUsed				DWORD			?	; @140h
	PeakJobMemoryUsed					DWORD			?	; @144h
	CurrentJobMemoryUsed				DWORD			?	; @148h
	MemoryLimitsLock					FAST_MUTEX		<>	; @14Ch
	JobSetLinks						LIST_ENTRY		<>	; @16ch
	MemberLevel						DWORD			?	; @174h
	JobFlags						DWORD			?	; @178h
EJOB								ENDS



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<NTOSKRNL.LIB PROTOS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



	ExAcquireFastMutexUnsafe			PROTO :DWORD																	; ordinal 1
	ExAcquireRundownProtection			PROTO																			; ordinal 2		; XP
	ExInitializeRundownProtection			PROTO																			; ordinal 3		; XP
	ExInterlockedAddLargeStatistic		PROTO :DWORD, :DWORD																; ordinal 4
	ExInterlockedCompareExchange64		PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 5
	ExInterlockedFlushSList				PROTO :DWORD																	; ordinal 6
	ExInterlockedPopEntrySList			PROTO :DWORD, :DWORD																; ordinal 7
	ExInterlockedPushEntrySList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 8
	ExReInitializeRundownProtection		PROTO																			; ordinal 9		; XP
	ExReleaseFastMutexUnsafe			PROTO :DWORD																	; ordinal 10
	ExReleaseResourceLite				PROTO :DWORD																	; ordinal 11
	ExReleaseRundownProtection			PROTO																			; ordinal 12	; XP
	ExRundownCompleted				PROTO																			; ordinal 13	; XP
	ExWaitForRundownProtection			PROTO																			; ordinal 14	; XP
	ExfInterlockedAddUlong 				PROTO :DWORD, :DWORD, :DWORD															; ordinal 15
	ExfInterlockedCompareExchange			PROTO																			; ordinal 16	; XP
	ExfInterlockedInsertHeadList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 17
  	ExfInterlockedInsertTailList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 18
	ExfInterlockedPopEntryList			PROTO :DWORD, :DWORD																; ordinal 19
	ExfInterlockedPushEntryList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 20
	ExfInterlockedRemoveHeadList			PROTO :DWORD, :DWORD																; ordinal 21
	Exfi386InterlockedDecrementLong		PROTO :DWORD																	; ordinal 22
	Exfi386InterlockedExchangeUlong		PROTO :DWORD, :DWORD																; ordinal 23
	Exfi386InterlockedIncrementLong		PROTO :DWORD																	; ordinal 24
	HalExamineMBR					PROTO	:DWORD, :DWORD, :DWORD, :DWORD													; ordinal 25	; XP
	InterlockedCompareExchange			PROTO :DWORD, :DWORD, :DWORD															; ordinal 26
	InterlockedDecrement				PROTO :DWORD																	; ordinal 27
	InterlockedExchange				PROTO :DWORD, :DWORD																; ordinal 28
	InterlockedExchangeAdd				PROTO :DWORD, :DWORD																; ordinal 29
	InterlockedIncrement				PROTO :DWORD																	; ordinal 30
	InterlockedPopEntrySList			PROTO	:DWORD																	; ordinal 31	; XP
	InterlockedPushEntrySList			PROTO	:DWORD, :DWORD																; ordinal 32	; XP
;	IoAssignDriveLetters				PROTO																			; ordinal 33	; XP
;	IoReadPartitionTable				PROTO	:DWORD, :DWORD, :DWORD, :DWORD													; ordinal 34	; XP
;	IoSetPartitionInformation			PROTO	:DWORD, :DWORD, :DWORD, :DWORD													; ordinal 35	; XP
;	IoWritePartitionTable				PROTO																			; ordinal 36	; XP
	IofCallDriver					PROTO :DWORD, :DWORD																; ordinal 37
	IofCompleteRequest				PROTO :DWORD, :DWORD																; ordinal 38
	KeAcquireInStackQueuedSpin			PROTO																			; ordinal 39	; XP
	KeReleaseInStackQueuedSpin			PROTO																			; ordinal 40	; XP
; W2K	KeSetSwapContextNotifyRoutine			PROTO :DWORD																	; W2K
; W2K	KeSetThreadSelectNotifyRoutine		PROTO :DWORD																	; W2K
	KeSetTimeUpdateNotifyRoutine			PROTO :DWORD																	; ordinal 41
	KefAcquireSpinLockAtDpcLevel			PROTO	:DWORD																	; ordinal 42
	KefReleaseSpinLockFromDpcLevel		PROTO	:DWORD																	; ordinal 43
	KiAcquireSpinLock 				PROTO :DWORD																	; ordinal 44
	KiReleaseSpinLock					PROTO :DWORD 																	; ordinal 45
	ObfDereferenceObject				PROTO :DWORD																	; ordinal 46
	ObfReferenceObject				PROTO :DWORD																	; ordinal 47
	RtlPrefetchMemoryNonTempo			PROTO																			; ordinal 48	; XP
;	RtlUlongByteSwap					PROTO :DWORD																	; ordinal 49
;	RtlUlonglongByteSwap				PROTO :DWORD																	; ordinal 50
;	RtlUshortByteSwap					PROTO :DWORD																	; ordinal 51
	WmiGetClock						PROTO																			; ordinal 52	; XP
	Kei386EoiHelper					PROTO																			; ordinal 53
	Kii386SpinOnSpinLock				PROTO :DWORD, :DWORD																; ordinal 54
	CcCanIWrite						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 55
	CcCopyRead						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 56
	CcCopyWrite						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 57
	CcDeferWrite					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 58
	CcFastCopyRead					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 59
	CcFastCopyWrite					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 60
	CcFastMdlReadWait					PROTO 																		; ordinal 61
	CcFastReadNotPossible				PROTO 																		; ordinal 62
	CcFastReadWait					PROTO 																		; ordinal 63
	CcFlushCache					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 64
	CcGetDirtyPages					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 65
	CcGetFileObjectFromBcb				PROTO :DWORD																	; ordinal 66
	CcGetFileObjectFromSectionPtrs		PROTO :DWORD																	; ordinal 67
	CcGetFlushedValidData				PROTO :DWORD, :DWORD																; ordinal 68
	CcGetLsnForFileObject				PROTO :DWORD, :DWORD																; ordinal 69
	CcInitializeCacheMap				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 70
	CcIsThereDirtyData				PROTO :DWORD																	; ordinal 71
	CcMapData						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 72
	CcMdlRead						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 73
	CcMdlReadComplete					PROTO :DWORD, :DWORD																; ordinal 74
	CcMdlWriteAbort					PROTO																			; ordinal 75	; XP
	CcMdlWriteComplete				PROTO :DWORD, :DWORD, :DWORD															; ordinal 76
	CcPinMappedData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 77
	CcPinRead						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 78
	CcPrepareMdlWrite					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 79
	CcPreparePinWrite					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 80
	CcPurgeCacheSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 81
	CcRemapBcb						PROTO :DWORD																	; ordinal 82
	CcRepinBcb						PROTO :DWORD																	; ordinal 83
	CcScheduleReadAhead				PROTO :DWORD, :DWORD, :DWORD															; ordinal 84
	CcSetAdditionalCacheAttributes		PROTO :DWORD, :DWORD, :DWORD															; ordinal 85
	CcSetBcbOwnerPointer				PROTO :DWORD, :DWORD																; ordinal 86
	CcSetDirtyPageThreshold				PROTO :DWORD, :DWORD																; ordinal 87
	CcSetDirtyPinnedData				PROTO :DWORD, :DWORD																; ordinal 88
	CcSetFileSizes					PROTO :DWORD, :DWORD																; ordinal 89
	CcSetLogHandleForFile				PROTO :DWORD, :DWORD, :DWORD															; ordinal 90
	CcSetReadAheadGranularity			PROTO :DWORD, :DWORD																; ordinal 91
	CcUninitializeCacheMap				PROTO :DWORD, :DWORD, :DWORD															; ordinal 92
	CcUnpinData						PROTO :DWORD																	; ordinal 93
	CcUnpinDataForThread				PROTO :DWORD, :DWORD																; ordinal 94
	CcUnpinRepinnedBcb				PROTO :DWORD, :DWORD, :DWORD															; ordinal 95
	CcWaitForCurrentLazyWriterActivity		PROTO																			; ordinal 96
	CcZeroData						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 97
	CmRegisterCallback				PROTO																			; ordinal 98	; XP
	CmUnRegisterCallback				PROTO																			; ordinal 99	; XP
	DbgBreakPoint					PROTO																			; ordinal 100
	DbgBreakPointWithStatus				PROTO :DWORD																	; ordinal 101
	DbgLoadImageSymbols				PROTO :DWORD, :DWORD, :DWORD															; ordinal 102
;	DbgPrint						PROTO 																		; ordinal 103
	DbgPrintEx						PROTO																			; ordinal 104	; XP
	DbgPrintReturnControlC				PROTO 																		; ordinal 105
	DbgPrompt						PROTO :DWORD, :DWORD, :DWORD															; ordinal 106
; W2K	ExAcquireResourceExclusive			PROTO :DWORD, :DWORD																; W2K
	DbgQueryDebugFilterState			PROTO																			; ordinal 107	; XP
	DbgSetDebugFilterState				PROTO																			; ordinal 108	; XP
	ExAcquireResourceExclusiveLite		PROTO :DWORD, :DWORD																; ordinal 109
	ExAcquireResourceSharedLite			PROTO :DWORD, :DWORD																; ordinal 110
	ExAcquireSharedStarveExclusive		PROTO :DWORD, :DWORD																; ordinal 111
	ExAcquireSharedWaitForExclusive		PROTO :DWORD, :DWORD																; ordinal 112
	ExAllocateFromPagedLookasideList		PROTO :DWORD																	; ordinal 113
	ExAllocatePool					PROTO :DWORD, :DWORD																; ordinal 114
	ExAllocatePoolWithQuota				PROTO :DWORD, :DWORD																; ordinal 115
	ExAllocatePoolWithQuotaTag			PROTO :DWORD, :DWORD, :DWORD															; ordinal 116
	ExAllocatePoolWithTag				PROTO :DWORD, :DWORD, :DWORD															; ordinal 117
	ExAllocatePoolWithTagPriority			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 118
	ExConvertExclusiveToSharedLite		PROTO	:DWORD																	; ordinal 119
	ExCreateCallback					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 120
	ExDeleteNPagedLookasideList			PROTO	:DWORD																	; ordinal 121
	ExDeletePagedLookasideList			PROTO	:DWORD																	; ordinal 122
; W2K	ExDeleteResource					PROTO	:DWORD																	; W2K
	ExDeleteResourceLite				PROTO	:DWORD																	; ordinal 123
	ExDesktopObjectType				PROTO 																		; ordinal 124
	ExDisableResourceBoostLite			PROTO	:DWORD																	; ordinal 125
	ExEnumHandleTable					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 126
	ExEventObjectType					PROTO 																		; ordinal 127
	ExExtendZone					PROTO :DWORD, :DWORD, :DWORD															; ordinal 128
	ExFreePool						PROTO	:DWORD																	; ordinal 129
	ExFreePoolWithTag					PROTO :DWORD, :DWORD																; ordinal 130
	ExFreeToPagedLookasideList			PROTO :DWORD, :DWORD																; ordinal 131
	ExGetCurrentProcessorCount			PROTO																			; ordinal 132	; XP
	ExGetCurrentProcessorCpuU			PROTO																			; ordinal 133	; XP
	ExGetExclusiveWaiterCount			PROTO :DWORD																	; ordinal 134
	ExGetPreviousMode					PROTO																			; ordinal 135
	ExGetSharedWaiterCount				PROTO :DWORD																	; ordinal 136
	ExInitializeNPagedLookasideList		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 137
	ExInitializePagedLookasideList		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 138
; W2K	ExInitializeResource				PROTO :DWORD																	; W2K
	ExInitializeResourceLite			PROTO :DWORD																	; ordinal 139
	ExInitializeZone					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 140
	ExInterlockedAddLargeInteger			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 141
	ExInterlockedAddUlong				PROTO :DWORD, :DWORD, :DWORD															; ordinal 142
	ExInterlockedDecrementLong			PROTO :DWORD, :DWORD																; ordinal 143
	ExInterlockedExchangeUlong			PROTO :DWORD, :DWORD, :DWORD															; ordinal 144
	ExInterlockedExtendZone				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 145
	ExInterlockedIncrementLong			PROTO :DWORD, :DWORD																; ordinal 146
	ExInterlockedInsertHeadList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 147
	ExInterlockedInsertTailList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 148
	ExInterlockedPopEntryList			PROTO :DWORD, :DWORD																; ordinal 149
	ExInterlockedPushEntryList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 150
	ExInterlockedRemoveHeadList			PROTO :DWORD, :DWORD																; ordinal 151
	ExIsProcessorFeaturePresent			PROTO :DWORD																	; ordinal 152
	ExIsResourceAcquiredExclusiveLite		PROTO :DWORD																	; ordinal 153
	ExIsResourceAcquiredSharedLite		PROTO :DWORD																	; ordinal 154
	ExLocalTimeToSystemTime				PROTO :DWORD, :DWORD																; ordinal 155
	ExNotifyCallback					PROTO :DWORD, :DWORD, :DWORD															; ordinal 156
	ExQueryPoolBlockSize				PROTO :DWORD, :DWORD																; ordinal 157
	ExQueueWorkItem					PROTO :DWORD, :DWORD																; ordinal 158
	ExRaiseAccessViolation				PROTO																			; ordinal 159
	ExRaiseDatatypeMisalignment			PROTO																			; ordinal 160
	ExRaiseException					PROTO :DWORD																	; ordinal 161
	ExRaiseHardError					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 162
	ExRaiseStatus					PROTO :DWORD																	; ordinal 163
	ExRegisterCallback				PROTO :DWORD, :DWORD, :DWORD															; ordinal 164
	ExReinitializeResourceLite			PROTO :DWORD																	; ordinal 165
	ExReleaseResourceForThread			PROTO :DWORD, :DWORD																; ordinal 166
; W2K	ExReleaseResourceForThreadLite		PROTO :DWORD, :DWORD																; W2K
	ExSemaphoreObjectType				PROTO C																		; ordinal 167
	ExSetResourceOwnerPointer			PROTO :DWORD, :DWORD																; ordinal 168
	ExSetTimerResolution				PROTO :DWORD, :DWORD																; ordinal 169
	ExSystemExceptionFilter				PROTO																			; ordinal 170
	ExSystemTimeToLocalTime				PROTO :DWORD, :DWORD																; ordinal 171
	ExUnregisterCallback				PROTO :DWORD																	; ordinal 172
	ExUuidCreate					PROTO :DWORD																	; ordinal 173
	ExVerifySuite					PROTO																			; ordinal 174	; XP
	ExWindowStationObjectType			PROTO 																		; ordinal 175
	Exi386InterlockedDecrementLong		PROTO :DWORD																	; ordinal 176
	Exi386InterlockedExchangeUlong		PROTO :DWORD, :DWORD																; ordinal 177
	Exi386InterlockedIncrementLong		PROTO :DWORD																	; ordinal 178
	FsRtlAcquireFileExclusive			PROTO :DWORD																	; ordinal 179
	FsRtlAddLargeMcbEntry				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 180
	FsRtlAddMcbEntry					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 181
	FsRtlAddToTunnelCache				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 182
	FsRtlAllocateFileLock				PROTO :DWORD, :DWORD																; ordinal 183
	FsRtlAllocatePool					PROTO :DWORD, :DWORD																; ordinal 184
	FsRtlAllocatePoolWithQuota			PROTO :DWORD, :DWORD																; ordinal 185
	FsRtlAllocatePoolWithQuotaTag			PROTO :DWORD, :DWORD, :DWORD															; ordinal 186
	FsRtlAllocatePoolWithTag			PROTO :DWORD, :DWORD, :DWORD															; ordinal 187
	FsRtlAllocateResource				PROTO																			; ordinal 188
	FsRtlAreNamesEqual				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 189
	FsRtlBalanceReads					PROTO :DWORD																	; ordinal 190
	FsRtlCheckLockForReadAccess			PROTO :DWORD, :DWORD																; ordinal 191
	FsRtlCheckLockForWriteAccess			PROTO :DWORD, :DWORD																; ordinal 192
	FsRtlCheckOplock					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 193
	FsRtlCopyRead					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 194
	FsRtlCopyWrite					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 195
	FsRtlCurrentBatchOplock				PROTO :DWORD																	; ordinal 196
	FsRtlDeleteKeyFromTunnelCache			PROTO :DWORD, :DWORD, :DWORD															; ordinal 197
	FsRtlDeleteTunnelCache				PROTO :DWORD																	; ordinal 198
	FsRtlDeregisterUncProvider			PROTO :DWORD																	; ordinal 199
	FsRtlDissectDbcs					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 200
	FsRtlDissectName					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 201
	FsRtlDoesDbcsContainWildCards			PROTO :DWORD																	; ordinal 202
	FsRtlDoesNameContainWildCards			PROTO :DWORD																	; ordinal 203
	FsRtlFastCheckLockForRead			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 204
	FsRtlFastCheckLockForWrite			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 205
	FsRtlFastUnlockAll				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 206
	FsRtlFastUnlockAllByKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 207
	FsRtlFastUnlockSingle				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 208
	FsRtlFindInTunnelCache				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 209
	FsRtlFreeFileLock					PROTO :DWORD																	; ordinal 210
	FsRtlGetFileSize					PROTO :DWORD, :DWORD																; ordinal 211
	FsRtlGetNextFileLock				PROTO :DWORD, :DWORD																; ordinal 212
	FsRtlGetNextLargeMcbEntry			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 213
	FsRtlGetNextMcbEntry				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 214
	FsRtlIncrementCcFastReadNoWait		PROTO																			; ordinal 215	; XP
	FsRtlIncrementCcFastReadNotPossible		PROTO																			; ordinal 216	; XP
	FsRtlIncrementCcFastReadResourceMiss	PROTO																			; ordinal 217	; XP
	FsRtlIncrementCcFastReadWait			PROTO																			; ordinal 218	; XP
	FsRtlInitializeFileLock				PROTO :DWORD, :DWORD, :DWORD															; ordinal 219
	FsRtlInitializeLargeMcb				PROTO :DWORD, :DWORD																; ordinal 220
	FsRtlInitializeMcb				PROTO :DWORD, :DWORD																; ordinal 221
	FsRtlInitializeOplock				PROTO :DWORD																	; ordinal 222
	FsRtlInitializeTunnelCache			PROTO :DWORD																	; ordinal 223
	FsRtlInsertFilterContext			PROTO :DWORD, :DWORD																; ordinal 224
	FsRtlInsertPerStreamContext			PROTO																			; ordinal 225	; XP
	FsRtlIsDbcsInExpression				PROTO :DWORD, :DWORD																; ordinal 226
	FsRtlIsFatDbcsLegal				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 227
	FsRtlIsHpfsDbcsLegal				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 228
	FsRtlIsNameInExpression				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 229
	FsRtlIsNtstatusExpected				PROTO :DWORD																	; ordinal 230
	FsRtlIsPagingFile					PROTO																			; ordinal 231	; XP
	FsRtlIsTotalDeviceFailure			PROTO :DWORD																	; ordinal 232
	FsRtlLegalAnsiCharacterArray			PROTO 																		; ordinal 233
; W2K	FsRtlLookupFilterContextInternal		PROTO :DWORD, :DWORD, :DWORD															; W2K
	FsRtlLookupLargeMcbEntry			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 234
	FsRtlLookupLastLargeMcbEntry			PROTO :DWORD, :DWORD, :DWORD															; ordinal 235
	FsRtlLookupLastLargeMcbEntryAndIndex	PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 236
	FsRtlLookupLastMcbEntry				PROTO :DWORD, :DWORD, :DWORD															; ordinal 237
	FsRtlLookupMcbEntry				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 238
	FsRtlLookupPerFileObjectContext		PROTO																			; ordinal 239	; XP
	FsRtlLookupPerStreamContext			PROTO																			; ordinal 240	; XP
	FsRtlMdlRead					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 241
	FsRtlMdlReadComplete				PROTO :DWORD, :DWORD																; ordinal 242
	FsRtlMdlReadCompleteDev				PROTO :DWORD, :DWORD, :DWORD															; ordinal 243
	FsRtlMdlReadDev					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 244
	FsRtlMdlWriteComplete				PROTO :DWORD, :DWORD, :DWORD															; ordinal 245
	FsRtlMdlWriteCompleteDev			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 246
	FsRtlNormalizeNtstatus				PROTO :DWORD, :DWORD																; ordinal 247
	FsRtlNotifyChangeDirectory			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 248
	FsRtlNotifyCleanup				PROTO :DWORD, :DWORD, :DWORD															; ordinal 249
	FsRtlNotifyFilterChangeDirectory		PROTO																			; ordinal 250	; XP
	FsRtlNotifyFilterReportChangeDirectory	PROTO																			; ordinal 251	; XP
	FsRtlNotifyFullChangeDirectory		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 252
	FsRtlNotifyFullReportChange			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 253
	FsRtlNotifyInitializeSync			PROTO :DWORD																	; ordinal 254
	FsRtlNotifyReportChange				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 255
	FsRtlNotifyUninitializeSync			PROTO :DWORD																	; ordinal 256
	FsRtlNotifyVolumeEvent				PROTO :DWORD, :DWORD																; ordinal 257
	FsRtlNumberOfRunsInLargeMcb			PROTO :DWORD																	; ordinal 258
	FsRtlNumberOfRunsInMcb				PROTO :DWORD																	; ordinal 259
	FsRtlOplockFsctrl					PROTO :DWORD, :DWORD, :DWORD															; ordinal 260
	FsRtlOplockIsFastIoPossible			PROTO :DWORD																	; ordinal 261
	FsRtlPostPagingFileStackOverflow		PROTO :DWORD, :DWORD, :DWORD															; ordinal 262
	FsRtlPostStackOverflow				PROTO :DWORD, :DWORD, :DWORD															; ordinal 263
	FsRtlPrepareMdlWrite				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 264
	FsRtlPrepareMdlWriteDev				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 265
	FsRtlPrivateLock					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 266
	FsRtlProcessFileLock				PROTO :DWORD, :DWORD, :DWORD															; ordinal 267
	FsRtlRegisterFileSystemFile			PROTO																			; ordinal 268	; XP
	FsRtlRegisterUncProvider			PROTO :DWORD, :DWORD, :DWORD															; ordinal 269
	FsRtlReleaseFile					PROTO :DWORD																	; ordinal 270
; W2K	FsRtlRemoveFilterContext			PROTO :DWORD, :DWORD, :DWORD															; W2K
	FsRtlRemoveLargeMcbEntry			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 271
	FsRtlRemoveMcbEntry				PROTO :DWORD, :DWORD, :DWORD															; ordinal 272
	FsRtlRemovePerFileObjectContexts		PROTO																			; ordinal 273	; XP
	FsRtlRemovePerStreamContexts			PROTO																			; ordinal 274	; XP
	FsRtlResetLargeMcb				PROTO :DWORD, :DWORD																; ordinal 275
	FsRtlSplitLargeMcb				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 276
	FsRtlSyncVolumes					PROTO :DWORD, :DWORD, :DWORD															; ordinal 277
	FsRtlTeardownFilterContexts			PROTO :DWORD																	; ordinal 278
	FsRtlTruncateLargeMcb				PROTO :DWORD, :DWORD, :DWORD															; ordinal 279
	FsRtlTruncateMcb					PROTO :DWORD, :DWORD																; ordinal 280
	FsRtlUninitializeFileLock			PROTO :DWORD																	; ordinal 281
	FsRtlUninitializeLargeMcb			PROTO :DWORD																	; ordinal 282
	FsRtlUninitializeMcb				PROTO :DWORD																	; ordinal 283
	FsRtlUninitializeOplock				PROTO :DWORD																	; ordinal 284
	HalDispatchTable					PROTO 																		; ordinal 285
	HalPrivateDispatchTable				PROTO 																		; ordinal 286
	InbvAcquireDisplayOwnership			PROTO																			; ordinal 288
	InbvCheckDisplayOwnership			PROTO																			; ordinal 289
	InbvDisplayString					PROTO :DWORD																	; ordinal 290
	InbvEnableBootDriver				PROTO :DWORD																	; ordinal 291
	InbvEnableDisplayString				PROTO :DWORD																	; ordinal 292
	InbvInstallDisplayStringFilter		PROTO :DWORD																	; ordinal 293
	InbvIsBootDriverInstalled			PROTO																			; ordinal 294
	InbvNotifyDisplayOwnershipLost		PROTO :DWORD																	; ordinal 295
	InbvResetDisplay					PROTO																			; ordinal 296
	InbvSetScrollRegion				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 297
	InbvSetTextColor					PROTO :DWORD																	; ordinal 298
	InbvSolidColorFill				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 299
	InitSafeBootMode					PROTO C																		; ordinal 300
	IoAcquireCancelSpinLock				PROTO :DWORD																	; ordinal 301
	IoAcquireRemoveLockEx				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 302
	IoAcquireVpbSpinLock				PROTO :DWORD																	; ordinal 303
	IoAdapterObjectType				PROTO C																		; ordinal 304
	IoAllocateAdapterChannel			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 305
	IoAllocateController				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 306
	IoAllocateDriverObjectExtension		PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 307
	IoAllocateErrorLogEntry				PROTO :DWORD, :DWORD																; ordinal 308
	IoAllocateIrp					PROTO :DWORD, :DWORD																; ordinal 309
	IoAllocateMdl					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 310
	IoAllocateWorkItem				PROTO :DWORD																	; ordinal 311
	IoAssignResources					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 312
	IoAttachDevice					PROTO :DWORD, :DWORD, :DWORD															; ordinal 313
	IoAttachDeviceByPointer				PROTO :DWORD, :DWORD																; ordinal 314
	IoAttachDeviceToDeviceStack			PROTO :DWORD, :DWORD																; ordinal 315
	IoAttachDeviceToDeviceStackEx			PROTO																			; ordinal 316	; XP
	IoBuildAsynchronousFsdRequest			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 317
	IoBuildDeviceIoControlRequest			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 318
	IoBuildPartialMdl					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 319
	IoBuildSynchronousFsdRequest			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 320
	IoCallDriver					PROTO :DWORD, :DWORD																; ordinal 321
	IoCancelFileOpen					PROTO :DWORD, :DWORD																; ordinal 322
	IoCancelIrp						PROTO :DWORD																	; ordinal 323
	IoCheckDesiredAccess				PROTO :DWORD, :DWORD																; ordinal 324
	IoCheckEaBufferValidity				PROTO :DWORD, :DWORD, :DWORD															; ordinal 325
	IoCheckFunctionAccess				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 326
	IoCheckQuerySetVolumeInformation		PROTO :DWORD, :DWORD, :DWORD															; ordinal 327
	IoCheckQuerySetFileInformation		PROTO :DWORD, :DWORD, :DWORD															; ordinal 328
	IoCheckQuotaBufferValidity			PROTO :DWORD, :DWORD, :DWORD															; ordinal 329
	IoCheckShareAccess				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 330
	IoCompleteRequest					PROTO :DWORD, :DWORD																; ordinal 331
	IoConnectInterrupt				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 332
	IoCreateController				PROTO :DWORD																	; ordinal 333
	IoCreateDevice					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 334
	IoCreateDisk					PROTO																			; ordinal 335	; XP
	IoCreateDriver					PROTO :DWORD, :DWORD																; ordinal 336
	IoCreateFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 337
	IoCreateFileSpecifyDevice			PROTO																			; ordinal 338	; XP
	IoCreateNotificationEvent			PROTO :DWORD, :DWORD																; ordinal 339
	IoCreateStreamFileObject			PROTO :DWORD, :DWORD																; ordinal 340
	IoCreateStreamFileObjectEx			PROTO																			; ordinal 341	; XP
	IoCreateStreamFileObjectLite			PROTO :DWORD, :DWORD																; ordinal 342
	IoCreateSymbolicLink				PROTO :DWORD, :DWORD																; ordinal 343
	IoCreateSynchronizationEvent			PROTO :DWORD, :DWORD																; ordinal 344
	IoCreateUnprotectedSymbolicLink		PROTO :DWORD, :DWORD																; ordinal 345
	IoCsqInitialize					PROTO																			; ordinal 346	; XP
	IoCsqInsertIrp					PROTO																			; ordinal 347	; XP
	IoCsqRemoveIrp					PROTO																			; ordinal 348	; XP
	IoCsqRemoveNextIrp				PROTO																			; ordinal 349	; XP
	IoDeleteController				PROTO :DWORD																	; ordinal 350
	IoDeleteDevice					PROTO :DWORD																	; ordinal 351
	IoDeleteDriver					PROTO :DWORD																	; ordinal 352
	IoDeleteSymbolicLink				PROTO :DWORD																	; ordinal 353
	IoDetachDevice					PROTO :DWORD																	; ordinal 354
	IoDeviceHandlerObjectSize			PROTO 																		; ordinal 355
	IoDeviceHandlerObjectType			PROTO 																		; ordinal 356
	IoDeviceObjectType				PROTO 																		; ordinal 357
	IoDisconnectInterrupt				PROTO :DWORD																	; ordinal 358
	IoDriverObjectType				PROTO 																		; ordinal 359
	IoEnqueueIrp					PROTO :DWORD																	; ordinal 360
	IoEnumerateDeviceObjectList			PROTO																			; ordinal 361	; XP
	IoFastQueryNetworkAttributes			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 362
	IoFileObjectType					PROTO 																		; ordinal 363
	IoForwardAndCatchIrp				PROTO	:DWORD, :DWORD																; ordinal 364	; XP
	IoForwardIrpSynchronously			PROTO																			; ordinal 365	; XP
	IoFreeController					PROTO :DWORD																	; ordinal 367
	IoFreeIrp						PROTO :DWORD																	; ordinal 368
	IoFreeMdl						PROTO :DWORD																	; ordinal 369
	IoFreeWorkItem					PROTO :DWORD																	; ordinal 370
	IoGetAttachedDevice				PROTO :DWORD																	; ordinal 371
	IoGetAttachedDeviceReference			PROTO :DWORD																	; ordinal 372
	IoGetBaseFileSystemDeviceObject		PROTO :DWORD																	; ordinal 373
	IoGetBootDiskInformation			PROTO :DWORD, :DWORD																; ordinal 374
	IoGetConfigurationInformation			PROTO																			; ordinal 375
	IoGetCurrentProcess				PROTO																			; ordinal 376
	IoGetDeviceAttachmentBase			PROTO																			; ordinal 377	; XP
	IoGetDeviceInterfaceAlias			PROTO :DWORD, :DWORD, :DWORD															; ordinal 378
	IoGetDeviceInterfaces				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 379
	IoGetDeviceObjectPointer			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 380
	IoGetDeviceProperty				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 381
	IoGetDeviceToVerify				PROTO :DWORD																	; ordinal 382
	IoGetDiskDeviceObject				PROTO																			; ordinal 383	; XP
	IoGetDmaAdapter					PROTO :DWORD, :DWORD, :DWORD															; ordinal 384
	IoGetDriverObjectExtension			PROTO :DWORD, :DWORD																; ordinal 385
	IoGetFileObjectGenericMapping			PROTO																			; ordinal 386
	IoGetInitialStack					PROTO																			; ordinal 387
	IoGetLowerDeviceObject				PROTO																			; ordinal 388	; XP
	IoGetRelatedDeviceObject			PROTO :DWORD																	; ordinal 389
	IoGetRequestorProcess				PROTO :DWORD																	; ordinal 390
	IoGetRequestorProcessId				PROTO :DWORD																	; ordinal 391
	IoGetRequestorSessionId				PROTO :DWORD, :DWORD																; ordinal 392
	IoGetStackLimits					PROTO :DWORD, :DWORD																; ordinal 393
	IoGetTopLevelIrp					PROTO																			; ordinal 394
	IoInitializeIrp					PROTO :DWORD, :DWORD, :DWORD															; ordinal 395
	IoInitializeRemoveLockEx			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 396
	IoInitializeTimer					PROTO :DWORD, :DWORD, :DWORD															; ordinal 397
	IoInvalidateDeviceRelations			PROTO :DWORD, :DWORD																; ordinal 398
	IoInvalidateDeviceState				PROTO :DWORD																	; ordinal 399
	IoIsFileOriginRemote				PROTO																			; ordinal 400	; XP
	IoIsOperationSynchronous			PROTO :DWORD																	; ordinal 401
	IoIsSystemThread					PROTO :DWORD																	; ordinal 402
	IoIsValidNameGraftingBuffer			PROTO :DWORD, :DWORD																; ordinal 403
	IoIsWdmVersionAvailable				PROTO :DWORD, :DWORD																; ordinal 404
	IoMakeAssociatedIrp				PROTO :DWORD, :DWORD																; ordinal 405
	IoOpenDeviceInterfaceRegistryKey		PROTO :DWORD, :DWORD, :DWORD															; ordinal 406
	IoOpenDeviceRegistryKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 407
	IoPageRead						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 408
	IoPnPDeliverServicePowerNotification	PROTO :DWORD, :DWORD																; ordinal 409
	IoQueryDeviceDescription			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 410
	IoQueryFileDosDeviceName			PROTO																			; ordinal 411	; XP
	IoQueryFileInformation				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 412
	IoQueryVolumeInformation			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 413
	IoQueueThreadIrp					PROTO :DWORD																	; ordinal 414
	IoQueueWorkItem					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 415
	IoRaiseHardError					PROTO :DWORD, :DWORD, :DWORD															; ordinal 416
	IoRaiseInformationalHardError			PROTO :DWORD, :DWORD, :DWORD															; ordinal 417
	IoReadDisksSignature				PROTO																			; ordinal 418	; XP
	IoReadOperationCount				PROTO 																		; ordinal 419
	IoReadPartitionTableEx				PROTO	:DWORD, :DWORD																; ordinal 420	; XP
	IoReadTransferCount				PROTO 																		; ordinal 421
	IoRegisterBootDriverReinitialization	PROTO :DWORD, :DWORD, :DWORD															; ordinal 422
	IoRegisterDeviceInterface			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 423
	IoRegisterDriverReinitialization		PROTO :DWORD, :DWORD, :DWORD															; ordinal 424
	IoRegisterFileSystem				PROTO :DWORD																	; ordinal 425
	IoRegisterFsRegistrationChange		PROTO :DWORD, :DWORD																; ordinal 426
	IoRegisterLastChanceShutdownNotification	PROTO :DWORD																	; ordinal 427
	IoRegisterPlugPlayNotification		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 428
	IoRegisterShutdownNotification		PROTO :DWORD																	; ordinal 429
	IoReleaseCancelSpinLock				PROTO :DWORD																	; ordinal 430
	IoReleaseRemoveLockAndWaitEx			PROTO :DWORD, :DWORD, :DWORD															; ordinal 431
	IoReleaseRemoveLockEx				PROTO :DWORD, :DWORD, :DWORD															; ordinal 432
	IoReleaseVpbSpinLock				PROTO :DWORD																	; ordinal 433
	IoRemoveShareAccess				PROTO :DWORD, :DWORD																; ordinal 434
	IoReportDetectedDevice				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 435
	IoReportHalResourceUsage			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 436
	IoReportResourceForDetection			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 437
	IoReportResourceUsage				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 438
	IoReportTargetDeviceChange			PROTO :DWORD, :DWORD																; ordinal 439
	IoReportTargetDeviceChangeAsynchronous	PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 440
	IoRequestDeviceEject				PROTO :DWORD																	; ordinal 441
	IoReuseIrp						PROTO :DWORD, :DWORD																; ordinal 442
	IoSetCompletionRoutineEx			PROTO																			; ordinal 443	; XP
	IoSetDeviceInterfaceState			PROTO :DWORD, :DWORD																; ordinal 444
	IoSetDeviceToVerify				PROTO :DWORD, :DWORD																; ordinal 445
	IoSetFileOrigin					PROTO																			; ordinal 446	; XP
	IoSetHardErrorOrVerifyDevice			PROTO :DWORD, :DWORD																; ordinal 447
	IoSetInformation					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 448
	IoSetIoCompletion					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 449
	IoSetPartitionInformationEx			PROTO	:DWORD, :DWORD, :DWORD															; ordinal 450	; XP
	IoSetShareAccess					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 451
	IoSetStartIoAttributes				PROTO																			; ordinal 452	; XP
	IoSetSystemPartition				PROTO																			; ordinal 453	; XP
	IoSetThreadHardErrorMode			PROTO :DWORD																	; ordinal 454
	IoSetTopLevelIrp					PROTO :DWORD																	; ordinal 455
	IoStartNextPacket					PROTO :DWORD, :DWORD																; ordinal 456
	IoStartNextPacketByKey				PROTO :DWORD, :DWORD, :DWORD															; ordinal 457
	IoStartPacket					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 458
	IoStartTimer					PROTO :DWORD																	; ordinal 459
	IoStatisticsLock					PROTO C																		; ordinal 460
	IoStopTimer						PROTO :DWORD																	; ordinal 461
	IoSynchronousInvalidateDeviceRelations	PROTO :DWORD, :DWORD																; ordinal 462
	IoSynchronousPageWrite				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 463
	IoThreadToProcess					PROTO :DWORD																	; ordinal 464
	IoUnregisterFileSystem				PROTO :DWORD																	; ordinal 465
	IoUnregisterFsRegistrationChange		PROTO :DWORD, :DWORD																; ordinal 466
	IoUnregisterPlugPlayNotification		PROTO :DWORD																	; ordinal 467
	IoUnregisterShutdownNotification		PROTO :DWORD																	; ordinal 468
	IoUpdateShareAccess				PROTO :DWORD, :DWORD																; ordinal 469
	IoVallidateDeviceIoControlAccess		PROTO																			; ordinal 470	; XP
	IoVerifyPartitionTable				PROTO	:DWORD, :DWORD																; ordinal 471	; XP
	IoVerifyVolume					PROTO :DWORD, :DWORD																; ordinal 472
	IoVolumeDeviceToDosName				PROTO	:DWORD, :DWORD																; ordinal 473	; XP
	IoWMIAllocateInstanceIds			PROTO :DWORD, :DWORD, :DWORD															; ordinal 474
	IoWMIDeviceObjectToInstanceName		PROTO	:DWORD, :DWORD, :DWORD															; ordinal 475	; XP
	IoWMIExecuteMethod				PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 476	; XP
	IoWMIHandleToInstanceName			PROTO	:DWORD, :DWORD, :DWORD															; ordinal 477	; XP
	IoWMIOpenBlock					PROTO	:DWORD, :DWORD, :DWORD															; ordinal 478	; XP
	IoWMIQueryAllData					PROTO	:DWORD, :DWORD, :DWORD															; ordinal 479	; XP
	IoWMIQueryAllDataMultiple			PROTO	:DWORD, :DWORD, :DWORD, :DWORD													; ordinal 480	; XP
	IoWMIQuerySingleInstance			PROTO	:DWORD, :DWORD, :DWORD, :DWORD													; ordinal 481	; XP
	IoWMIQuerySingleInstanceMultiple		PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 482	; XP
	IoWMIRegistrationControl			PROTO :DWORD, :DWORD																; ordinal 483
	IoWMISetNotificationCallback			PROTO	:DWORD, :DWORD, :DWORD															; ordinal 484	; XP
	IoWMISetSingleInstance				PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 485	; XP
	IoWMISetSingleItem				PROTO	:DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 486	; XP
	IoWMISuggestInstanceName			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 487
	IoWMIWriteEvent					PROTO :DWORD																	; ordinal 488
	IoWriteErrorLogEntry				PROTO :DWORD																	; ordinal 489
	IoWriteOperationCount				PROTO 																		; ordinal 490
	IoWritePartitionTableEx				PROTO	:DWORD, :DWORD																; ordinal 491	; XP
	IoWriteTransferCount				PROTO 																		; ordinal 492
	KdDebuggerEnabled					PROTO 																		; ordinal 493
	KdDebuggerNotPresent				PROTO 																		; ordinal 494
	KdDisableDebugger					PROTO																			; ordinal 495
	KdEnableDebugger					PROTO																			; ordinal 496
	KdEnteredDebugger					PROTO 																		; ordinal 497
	KdPollBreakIn					PROTO																			; ordinal 498
	KdPowerTransition					PROTO																			; ordinal 499	; XP
	Ke386CallBios					PROTO :DWORD, :DWORD																; ordinal 500
	Ke386IoSetAccessProcess				PROTO :DWORD, :DWORD																; ordinal 501
	Ke386QueryIoAccessMap				PROTO :DWORD, :DWORD																; ordinal 502
	Ke386SetIoAccessMap				PROTO :DWORD, :DWORD																; ordinal 503
	KeAcquireInterruptSpinLock			PROTO	:DWORD																	; ordinal 504	; XP
	KeAcquireSpinLockAtDpcLevel			PROTO :DWORD																	; ordinal 505
	KeAddSystemServiceTable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 506
	KeAreApcsDisabled					PROTO																			; ordinal 507	; XP
	KeAttachProcess					PROTO :DWORD																	; ordinal 508
	KeBugCheck						PROTO :DWORD																	; ordinal 509
	KeBugCheckEx					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 510
	KeCancelTimer					PROTO :DWORD																	; ordinal 511
	KeCapturePersistentThreadState		PROTO																			; ordinal 512 	; XP
	KeClearEvent					PROTO :DWORD																	; ordinal 513
	KeConnectInterrupt				PROTO :DWORD																	; ordinal 514
	KeDcacheFlushCount				PROTO 																		; ordinal 515
	KeDelayExecutionThread				PROTO :DWORD, :DWORD, :DWORD															; ordinal 516
	KeDeregisterBugCheckCallback			PROTO :DWORD																	; ordinal 516
	KeDeregistereBugCheckReasonCallback		PROTO																			; ordinal 518	; XP
	KeDetachProcess					PROTO																			; ordinal 519
	KeDisconnectInterrupt				PROTO :DWORD																	; ordinal 520
	KeEnterCriticalRegion				PROTO																			; ordinal 521
	KeEnterKernelDebugger				PROTO																			; ordinal 522
	KeFindConfigurationEntry			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 523
	KeFindConfigurationNextEntry			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 524
	KeFlushEntireTb					PROTO :DWORD, :DWORD																; ordinal 525
	KeGetCurrentThread				PROTO																			; ordinal 526
	KeGetPreviousMode					PROTO																			; ordinal 527
	KeGetRecommendedSharedDataAlignment		PROTO																			; ordinal 528	; XP
	KeI386AbiosCall					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 529
	KeI386AllocateGdtSelectors			PROTO :DWORD, :DWORD																; ordinal 530
	KeI386Call16BitCStyleFunction			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 531
	KeI386Call16BitFunction				PROTO :DWORD																	; ordinal 532
	KeI386FlatToGdtSelector				PROTO :DWORD, :DWORD, :DWORD															; ordinal 533
	KeI386GetLid					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 534
	KeI386MachineType					PROTO 																		; ordinal 535
	KeI386ReleaseGdtSelectors			PROTO :DWORD, :DWORD																; ordinal 536
	KeI386ReleaseLid					PROTO :DWORD, :DWORD																; ordinal 537
	KeI386SetGdtSelector				PROTO :DWORD, :DWORD																; ordinal 538
	KeIcacheFlushCount				PROTO 																		; ordinal 539
	KeInitializeApc					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 540
	KeInitializeDeviceQueue				PROTO :DWORD																	; ordinal 541
	KeInitializeDpc					PROTO :DWORD, :DWORD, :DWORD															; ordinal 542
	KeInitializeEvent					PROTO :DWORD, :DWORD, :DWORD															; ordinal 543
	KeInitializeInterrupt				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 544
	KeInitializeMutant				PROTO :DWORD, :DWORD																; ordinal 545
	KeInitializeMutex					PROTO :DWORD, :DWORD																; ordinal 546
	KeInitializeQueue					PROTO :DWORD, :DWORD																; ordinal 547
	KeInitializeSemaphore				PROTO :DWORD, :DWORD, :DWORD															; ordinal 548
	KeInitializeSpinLock				PROTO :DWORD																	; ordinal 549
	KeInitializeTimer					PROTO :DWORD																	; ordinal 550
	KeInitializeTimerEx				PROTO :DWORD, :DWORD																; ordinal 551
	KeInsertByKeyDeviceQueue			PROTO :DWORD, :DWORD, :DWORD															; ordinal 552
	KeInsertDeviceQueue				PROTO :DWORD, :DWORD																; ordinal 553
	KeInsertHeadQueue					PROTO :DWORD, :DWORD																; ordinal 554
	KeInsertQueue					PROTO :DWORD, :DWORD																; ordinal 555
	KeInsertQueueApc					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 556
	KeInsertQueueDpc					PROTO :DWORD, :DWORD, :DWORD															; ordinal 557
	KeIsAttachedProcess				PROTO																			; ordinal 558	; XP
	KeIsExecutingDpc					PROTO																			; ordinal 559
	KeLeaveCriticalRegion				PROTO																			; ordinal 560
	KeLoaderBlock					PROTO 																		; ordinal 561
	KeNumberProcessors				PROTO 																		; ordinal 562
	KeProfileInterrupt				PROTO :DWORD																	; ordinal 563
	KeProfileInterruptWithSource			PROTO :DWORD, :DWORD																; ordinal 564
	KePulseEvent					PROTO :DWORD, :DWORD, :DWORD															; ordinal 565
	KeQueryActiveProcessors				PROTO																			; ordinal 566
	KeQueryInterruptTime				PROTO																			; ordinal 567
	KeQueryPriorityThread				PROTO :DWORD																	; ordinal 568
	KeQueryRuntimeThread				PROTO																			; ordinal 569	; XP
	KeQuerySystemTime					PROTO :DWORD																	; ordinal 570
	KeQueryTickCount					PROTO :DWORD																	; ordinal 571
	KeQueryTimeIncrement				PROTO																			; ordinal 572
	KeRaiseUserException				PROTO :DWORD																	; ordinal 573
	KeReadStateEvent					PROTO :DWORD																	; ordinal 574
	KeReadStateMutant					PROTO :DWORD																	; ordinal 575
	KeReadStateMutex					PROTO :DWORD																	; ordinal 576
	KeReadStateQueue					PROTO :DWORD																	; ordinal 577
	KeReadStateSemaphore				PROTO :DWORD																	; ordinal 578
	KeReadStateTimer					PROTO :DWORD																	; ordinal 579
	KeRegisterBugCheckCallback			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 580
	KeRegisterBugCheckReasonCallback		PROTO																			; ordinal 581	; XP
	KeReleaseInterruptSpinLock			PROTO																			; ordinal 582	; XP
	KeReleaseMutant					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 583
	KeReleaseMutex					PROTO :DWORD, :DWORD																; ordinal 584
	KeReleaseSemaphore				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 585
	KeReleaseSpinLockFromDpcLevel			PROTO :DWORD																	; ordinal 586
	KeRemoveByKeyDeviceQueue			PROTO :DWORD, :DWORD																; ordinal 587
	KeRemoveByKeyDeviceQueueIfBusy		PROTO																			; ordinal 588	; XP
	KeRemoveDeviceQueue				PROTO :DWORD																	; ordinal 589
	KeRemoveEntryDeviceQueue			PROTO :DWORD, :DWORD																; ordinal 590
	KeRemoveQueue					PROTO :DWORD, :DWORD, :DWORD															; ordinal 591
	KeRemoveQueueDpc					PROTO :DWORD																	; ordinal 592
	KeRemoveSystemServiceTable			PROTO																			; ordinal 593	; XP
	KeResetEvent					PROTO :DWORD																	; ordinal 594
	KeRestoreFloatingPointState			PROTO :DWORD																	; ordinal 595
	KeRevertToUserAffinityThread			PROTO																			; ordinal 596
	KeRundownQueue					PROTO :DWORD																	; ordinal 597
	KeSaveFloatingPointState			PROTO :DWORD																	; ordinal 598
	KeSaveStateForHibernate				PROTO C																		; ordinal 599
	KeServiceDescriptorTable			PROTO C																		; ordinal 600
	KeSetAffinityThread				PROTO :DWORD, :DWORD																; ordinal 601
	KeSetBasePriorityThread				PROTO :DWORD, :DWORD																; ordinal 602
	KeSetDmaIoCoherency				PROTO :DWORD																	; ordinal 603
	KeSetEvent						PROTO :DWORD, :DWORD, :DWORD															; ordinal 604
	KeSetEventBoostPriority				PROTO :DWORD, :DWORD																; ordinal 605
	KeSetIdealProcessorThread			PROTO :DWORD, :DWORD																; ordinal 606
	KeSetImportanceDpc				PROTO :DWORD, :DWORD																; ordinal 607
	KeSetKernelStackSwapEnable			PROTO :DWORD																	; ordinal 608
	KeSetPriorityThread				PROTO :DWORD, :DWORD																; ordinal 609
	KeSetProfileIrql					PROTO :DWORD																	; ordinal 610
	KeSetSystemAffinityThread			PROTO :DWORD																	; ordinal 611
	KeSetTargetProcessorDpc				PROTO :DWORD, :DWORD																; ordinal 612
	KeSetTimeIncrement				PROTO :DWORD, :DWORD																; ordinal 613
	KeSetTimer						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 614
	KeSetTimerEx					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 615
	KeStackAttachProcess				PROTO :DWORD, :DWORD																; ordinal 616
	KeSynchronizeExecution				PROTO :DWORD, :DWORD, :DWORD															; ordinal 617
	KeTerminateThread					PROTO :DWORD																	; ordinal 618
	KeTickCount						PROTO C																		; ordinal 619
	KeUnstackDetachProcess				PROTO :DWORD																	; ordinal 620
	KeUpdateRunTime					PROTO :DWORD																	; ordinal 621
	KeUpdateSystemTime				PROTO																			; ordinal 622
	KeUserModeCallback				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 623
	KeWaitForMultipleObjects			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 624
	KeWaitForMutexObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 625
	KeWaitForSingleObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 626
	KiBugCheckData					PROTO C																		; ordinal 627
	KiCoprocessorError				PROTO																			; ordinal 628
	KiDeliverApc					PROTO :DWORD, :DWORD, :DWORD															; ordinal 629
	KiDispatchInterrupt				PROTO																			; ordinal 630
	KiEnableTimerWatchdog				PROTO C																		; ordinal 631
	KiIpiServiceRoutine				PROTO :DWORD, :DWORD																; ordinal 632
	KiUnexpectedInterrupt				PROTO C																		; ordinal 633
	LdrAccessResource					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 634
	LdrEnumResources					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 635
	LdrFindResourceDirectory_U			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 636
	LdrFindResource_U					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 637
	LpcPortObjectType					PROTO C																		; ordinal 638
	LpcRequestPort					PROTO :DWORD, :DWORD																; ordinal 639
	LpcRequestWaitReplyPort				PROTO :DWORD, :DWORD, :DWORD															; ordinal 640
	LsaCallAuthenticationPackage			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 641
	LsaDeregisterLogonProcess			PROTO :DWORD																	; ordinal 642
	LsaFreeReturnBuffer				PROTO :DWORD																	; ordinal 643
	LsaLogonUser					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 644
	LsaLookupAuthenticationPackage		PROTO :DWORD, :DWORD, :DWORD															; ordinal 645
	LsaRegisterLogonProcess				PROTO :DWORD, :DWORD, :DWORD															; ordinal 646
	Mm64BitPhysicalAddress				PROTO C																		; ordinal 647
	MmAddPhysicalMemory				PROTO :DWORD, :DWORD																; ordinal 648
	MmAddVerifierThunks				PROTO																			; ordinal 649	; XP
	MmAdjustWorkingSetSize				PROTO :DWORD, :DWORD, :DWORD															; ordinal 650
	MmAdvanceMdl					PROTO																			; ordinal 651	; XP
	MmAllocateContiguousMemory			PROTO :DWORD, :DWORD, :DWORD															; ordinal 652
	MmAllocateContiguousMemorySpecifyCache	PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 653
	MmAllocateMappingAddress			PROTO																			; ordinal 654	; XP
	MmAllocateNonCachedMemory			PROTO :DWORD																	; ordinal 655
	MmAllocatePagesForMdl				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 656
	MmBuildMdlForNonPagedPool			PROTO :DWORD																	; ordinal 657
	MmCanFileBeTruncated				PROTO :DWORD, :DWORD																; ordinal 658
	MmCreateMdl						PROTO :DWORD, :DWORD, :DWORD															; ordinal 659
	MmCreateSection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 660
	MmDisableModifiedWriteOfSection		PROTO :DWORD																	; ordinal 661
	MmFlushImageSection				PROTO :DWORD, :DWORD																; ordinal 662
	MmForceSectionClosed				PROTO :DWORD, :DWORD																; ordinal 663
	MmFreeContiguousMemory				PROTO :DWORD																	; ordinal 664
	MmFreeContiguousMemorySpecifyCache		PROTO :DWORD, :DWORD, :DWORD															; ordinal 665
	MmFreeMappingAddress				PROTO																			; ordinal 666	; XP
	MmFreeNonCachedMemory				PROTO :DWORD, :DWORD																; ordinal 667
	MmFreePagesFromMdl				PROTO :DWORD																	; ordinal 668
	MmGetPhysicalAddress				PROTO :DWORD																	; ordinal 669
	MmGetPhysicalMemoryRanges			PROTO 																		; ordinal 670
	MmGetSystemRoutineAddress			PROTO :DWORD																	; ordinal 671
	MmGetVirtualForPhysical				PROTO :DWORD, :DWORD																; ordinal 672
	MmGrowKernelStack					PROTO :DWORD																	; ordinal 673
	MmHighestUserAddress				PROTO C																		; ordinal 674
	MmIsAddressValid					PROTO :DWORD																	; ordinal 675
	MmIsDriverVerifying				PROTO :DWORD																	; ordinal 676
	MmIsNonPagedSystemAddressValid		PROTO :DWORD																	; ordinal 677
	MmIsRecursiveIoFault				PROTO																			; ordinal 678
	MmIsThisAnNtAsSystem				PROTO																			; ordinal 679
	MmIsVerifierEnabled				PROTO																			; ordinal 680	; XP
	MmLockPagableDataSection			PROTO :DWORD																	; ordinal 681
	MmLockPagableImageSection			PROTO :DWORD																	; ordinal 682
	MmLockPagableSectionByHandle			PROTO :DWORD																	; ordinal 683
	MmMapIoSpace					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 684
	MmMapLockedPages					PROTO :DWORD, :DWORD																; ordinal 685
	MmMapLockedPagesSpecifyCache			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 686
	MmMapLockedPagesWithReserve			PROTO																			; ordinal 687	; XP
	MmMapMemoryDumpMdl				PROTO :DWORD																	; ordinal 688
	MmMapUserAddressesToPage			PROTO :DWORD, :DWORD, :DWORD															; ordinal 689
	MmMapVideoDisplay					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 690
	MmMapViewInSessionSpace				PROTO :DWORD, :DWORD, :DWORD															; ordinal 691
	MmMapViewInSystemSpace				PROTO :DWORD, :DWORD, :DWORD															; ordinal 692
	MmMapViewOfSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 693
	MmMarkPhysicalMemoryAsBad			PROTO																			; ordinal 694	; XP
	MmMarkPhysicalMemoryAsGood			PROTO																			; ordinal 695	; XP
	MmPageEntireDriver				PROTO :DWORD																	; ordinal 696
	MmPrefetchPages					PROTO																			; ordinal 697	; XP
	MmProbeAndLockPages				PROTO :DWORD, :DWORD, :DWORD															; ordinal 698
	MmProbeAndLockProcessPages			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 699
	MmProbeAndLockSelectedPages			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 700
	MmProtectMdlSystemAddress			PROTO																			; ordinal 701	; XP
	MmQuerySystemSize					PROTO																			; ordinal 702
	MmRemovePhysicalMemory				PROTO :DWORD, :DWORD																; ordinal 703
	MmResetDriverPaging				PROTO :DWORD																	; ordinal 704
	MmSectionObjectType				PROTO C																		; ordinal 705
	MmSecureVirtualMemory				PROTO :DWORD, :DWORD, :DWORD															; ordinal 706
	MmSetAddressRangeModified			PROTO :DWORD, :DWORD																; ordinal 707
	MmSetBankedSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 708
	MmSizeOfMdl						PROTO :DWORD, :DWORD																; ordinal 709
	MmSystemRangeStart				PROTO C																		; ordinal 710
	MmTrimAllSystemPagableMemory			PROTO :DWORD																	; ordinal 711
	MmUnlockPagableImageSection			PROTO :DWORD																	; ordinal 712
	MmUnlockPages					PROTO :DWORD																	; ordinal 713
	MmUnmapIoSpace					PROTO :DWORD, :DWORD																; ordinal 714
	MmUnmapLockedPages				PROTO :DWORD, :DWORD																; ordinal 715
	MmUnmapReservedMapping				PROTO																			; ordinal 716	; XP
	MmUnmapVideoDisplay				PROTO :DWORD, :DWORD																; ordinal 717
	MmUnmapViewInSessionSpace			PROTO :DWORD																	; ordinal 718
	MmUnmapViewInSystemSpace			PROTO :DWORD																	; ordinal 719
	MmUnmapViewOfSection				PROTO :DWORD, :DWORD																; ordinal 720
	MmUnsecureVirtualMemory				PROTO :DWORD																	; ordinal 721
	MmUserProbeAddress				PROTO C																		; ordinal 722
	NlsAnsiCodePage					PROTO C																		; ordinal 723
	NlsLeadByteInfo					PROTO C																		; ordinal 724
	NlsMbCodePageTag					PROTO C																		; ordinal 725
	NlsMbOemCodePageTag				PROTO C																		; ordinal 726
	NlsOemCodePage					PROTO C																		; ordinal 727
	NlsOemLeadByteInfo				PROTO C																		; ordinal 728
	NtAddAtom						PROTO :DWORD, :DWORD, :DWORD															; ordinal 729
	NtAdjustPrivilegesToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 730
	NtAllocateLocallyUniqueId			PROTO :DWORD																	; ordinal 731
	NtAllocateUuids					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 732
	NtAllocateVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 733
	NtBuildNumber					PROTO C																		; ordinal 734
	NtClose						PROTO :DWORD																	; ordinal 735
	NtConnectPort					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 736
	NtCreateEvent					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 737
	NtCreateFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 738
	NtCreateSection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 739
	NtDeleteAtom					PROTO :DWORD																	; ordinal 740
	NtDeleteFile					PROTO :DWORD																	; ordinal 741
	NtDeviceIoControlFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 742
	NtDuplicateObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 743
	NtDuplicateToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 744
	NtFindAtom						PROTO :DWORD, :DWORD, :DWORD															; ordinal 745
	NtFreeVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 746
	NtFsControlFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 747
	NtGlobalFlag					PROTO C																		; ordinal 748
	NtLockFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 749
	NtMakePermanentObject				PROTO																			; ordinal 750	; XP
	NtMapViewOfSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 751
	NtNotifyChangeDirectoryFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 752
	NtOpenFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 753
	NtOpenProcess					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 754
	NtOpenProcessToken				PROTO :DWORD, :DWORD, :DWORD															; ordinal 755
	NtOpenProcessTokenEx				PROTO																			; ordinal 756	; XP
;	NtOpenThread					PROTO																			; ordinal 757	; XP
;	NtOpenThreadToken					PROTO																			; ordinal 758	; XP
	NtOpenThreadTokenEx				PROTO																			; ordinal 759	; XP
	NtQueryDirectoryFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 760
	NtQueryEaFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 761
	NtQueryInformationAtom				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 762
	NtQueryInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 763
	NtQueryInformationProcess			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 764
;	NtQueryInformationThread			PROTO																			; ordinal 765	; XP
	NtQueryInformationToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 766
	NtQueryQuotaInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 767
	NtQuerySecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 768
	NtQuerySystemInformation			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 769
	NtQueryVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 770
	NtReadFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 771
	NtRequestPort					PROTO :DWORD, :DWORD																; ordinal 772
	NtRequestWaitReplyPort				PROTO :DWORD, :DWORD, :DWORD															; ordinal 773
	NtSetEaFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 774
	NtSetEvent						PROTO :DWORD, :DWORD																; ordinal 775
	NtSetInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 776
	NtSetInformationProcess				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 777
	NtSetInformationThread				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 778
	NtSetQuotaInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 779
	NtSetSecurityObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 780
	NtSetVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 781
	NtShutdownSystem					PROTO																			; ordinal 782	; XP
	NtTraceEvent					PROTO																			; ordinal 783	; XP
	NtUnlockFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 784
	NtVdmControl					PROTO :DWORD, :DWORD																; ordinal 785
	NtWaitForSingleObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 786
	NtWriteFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 787
	ObAssignSecurity					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 788
	ObCheckCreateObjectAccess			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 789
	ObCheckObjectAccess				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 790
	ObCloseHandle					PROTO																			; ordinal 791	; XP
	ObCreateObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 792
	ObCreateObjectType				PROTO																			; ordinal 793	; XP
	ObDereferenceObject				PROTO :DWORD																	; ordinal 794
	ObDereferenceSecurityDescriptor		PROTO																			; ordinal 795	; XP
	ObFindHandleForObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 796
;	ObGetObjectPointerCount				PROTO :DWORD																	; XP NO SERVICE PACK 1
	ObGetObjectSecurity				PROTO :DWORD, :DWORD, :DWORD															; ordinal 797
	ObInsertObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 798
	ObLogSecurityDescriptor				PROTO																			; ordinal 799	; XP
	ObMakeTemporaryObject				PROTO :DWORD																	; ordinal 800
	ObOpenObjectByName				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 801
	ObOpenObjectByPointer				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 802
	ObQueryNameString					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 803
	ObQueryObjectAuditingByHandle			PROTO :DWORD, :DWORD																; ordinal 804
	ObReferenceObjectByHandle			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 805
	ObReferenceObjectByName				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 806
	ObReferenceObjectByPointer			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 807
	ObReferenceSecurityDescriptor			PROTO																			; ordinal 808	; XP
	ObReleaseObjectSecurity				PROTO :DWORD, :DWORD																; ordinal 809
	ObSetHandleAttributes				PROTO																			; ordinal 810	; XP
	ObSetSecurityDescriptorInfo			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 811
	ObSetSecurityObjectByPoint			PROTO																			; ordinal 812	; XP
	PfxFindPrefix					PROTO :DWORD, :DWORD																; ordinal 813
	PfxInitialize					PROTO :DWORD																	; ordinal 814
	PfxInsertPrefix					PROTO :DWORD, :DWORD, :DWORD															; ordinal 815
	PfxRemovePrefix					PROTO :DWORD, :DWORD																; ordinal 816
	PoCallDriver					PROTO :DWORD, :DWORD																; ordinal 817
	PoCancelDeviceNotify				PROTO :DWORD																	; ordinal 818
	PoQueueShutdownWorkItem				PROTO																			; ordinal 819	; XP
	PoRegisterDeviceForIdleDetection		PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 820
	PoRegisterDeviceNotify				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 821
	PoRegisterSystemState				PROTO :DWORD, :DWORD																; ordinal 822
	PoRequestPowerIrp					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 823
	PoRequestShutdownEvent				PROTO																			; ordinal 824	; XP
	PoSetHiberRange					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 825
	PoSetPowerState					PROTO :DWORD, :DWORD, :DWORD															; ordinal 826
	PoSetSystemState					PROTO :DWORD																	; ordinal 827
	PoShutdownBugCheck				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 828
	PoStartNextPowerIrp				PROTO :DWORD																	; ordinal 829
	PoUnregisterSystemState				PROTO :DWORD																	; ordinal 830
	ProbeForRead					PROTO :DWORD, :DWORD, :DWORD															; ordinal 831
	ProbeForWrite					PROTO :DWORD, :DWORD, :DWORD															; ordinal 832
	PsAssignImpersonationToken			PROTO :DWORD, :DWORD																; ordinal 833
	PsChargePoolQuota					PROTO :DWORD, :DWORD, :DWORD															; ordinal 834
	PsChargeProcessNonPagedPool			PROTO																			; ordinal 835	; XP
	PsChargeProcessPagedPoolQuota			PROTO																			; ordinal 836	; XP
	PsChargeProcessPoolQuota			PROTO																			; ordinal 837	; XP
	PsCreateSystemProcess				PROTO :DWORD, :DWORD, :DWORD															; ordinal 838
	PsCreateSystemThread				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 839
	PsDereferenceImpersonation			PROTO																			; ordinal 840	; XP
	PsDereferencePrimaryToken			PROTO																			; ordinal 841	; XP
	PsDisableImpersonation				PROTO :DWORD, :DWORD																; ordinal 842
	PsEstablishWin32Callouts			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 843
	PsGetContextThread				PROTO																			; ordinal 844	; XP
	PsGetCurrentProcess				PROTO																			; ordinal 845	; XP
	PsGetCurrentProcessId				PROTO																			; ordinal 846
	PsGetCurrentProcessSession			PROTO																			; ordinal 847	; XP
	PsGetCurrentThread				PROTO																			; ordinal 848	; XP
	PsGetCurrentThreadId				PROTO																			; ordinal 849
	PsGetCurrentThreadPrevious			PROTO																			; ordinal 850	; XP
	PsGetCurrentThreadStackBase			PROTO																			; ordinal 851	; XP
	PsGetCurrentThreadStackLimit			PROTO																			; ordinal 852	; XP
	PsGetJobLock					PROTO																			; ordinal 853	; XP
	PsGetJobSessionId					PROTO																			; ordinal 854	; XP
	PsGetJobUIRestrictionsClass			PROTO																			; ordinal 855	; XP
	PsGetProcessCreateTimeQuadPart		PROTO																			; ordinal 856	; XP
	PsGetProcessDebugPort				PROTO																			; ordinal 857	; XP
	PsGetProcessExitProcessCalled			PROTO																			; ordinal 858	; XP
	PsGetProcessExitStatus				PROTO																			; ordinal 859	; XP
	PsGetProcessExitTime				PROTO																			; ordinal 860
	PsGetProcessId					PROTO																			; ordinal 861	; XP
	PsGetProcessImageFileName			PROTO																			; ordinal 862	; XP
	PsGetProcessInheritedFromUniqueProcessId	PROTO																			; ordinal 863	; XP
	PsGetProcessJob					PROTO																			; ordinal 864	; XP
	PsGetProcessPeb					PROTO																			; ordinal 865	; XP
	PsGetProcessPriorityClass			PROTO																			; ordinal 866	; XP
	PsGetProcessSectionBaseAddress		PROTO																			; ordinal 867	; XP
	PsGetProcessSecurityPort			PROTO																			; ordinal 868	; XP
	PsGetProcessSessionId				PROTO																			; ordinal 869	; XP
	PsGetProcessWin32Process			PROTO																			; ordinal 870	; XP
	PsGetProcessWin32WindowStation		PROTO																			; ordinal 871	; XP
	PsGetThreadFreezeCount				PROTO																			; ordinal 872	; XP
	PsGetThreadHardErrorsAreDisabled		PROTO																			; ordinal 873	; XP
	PsGetThreadId					PROTO																			; ordinal 874	; XP
	PsGetThreadProcess				PROTO																			; ordinal 875	; XP
	PsGetThreadProcessId				PROTO																			; ordinal 876	; XP
	PsGetThreadSessionId				PROTO																			; ordinal 877	; XP
	PsGetThreadTeb					PROTO																			; ordinal 878	; XP
	PsGetThreadWin32Thread				PROTO																			; ordinal 879	; XP
	PsGetVersion					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 880
	PsImpersonateClient				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 881
	PsInitialSystemProcess				PROTO 																		; ordinal 882
	PsIsProcessBeingDebugged			PROTO																			; ordinal 883	; XP
	PsIsSystemThread					PROTO																			; ordinal 884	; XP
	PsIsThreadImpersonating				PROTO																			; ordinal 885	; XP
	PsIsThreadTerminating				PROTO	:DWORD																	; ordinal 886
	PsJobType						PROTO 																		; ordinal 887
	PsLookupProcessByProcessId			PROTO :DWORD, :DWORD																; ordinal 888
	PsLookupProcessThreadByCid			PROTO :DWORD, :DWORD, :DWORD															; ordinal 889
	PsLookupThreadByThreadId			PROTO :DWORD, :DWORD																; ordinal 890
	PsProcessType					PROTO 																		; ordinal 891
	PsReferenceImpersonationToken			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 892
	PsReferencePrimaryToken				PROTO :DWORD																	; ordinal 893
	PsRemoveCreateThreadNotifyRoutine		PROTO																			; ordinal 894	; XP
	PsRemoveLoadImageNotifyRoutine		PROTO																			; ordinal 895	; XP
	PsRestoreImpersonation				PROTO :DWORD, :DWORD																; ordinal 896
	PsReturnPoolQuota					PROTO :DWORD, :DWORD, :DWORD															; ordinal 897
	PsReturnProcessNonPagedPool			PROTO																			; ordinal 898	; XP
	PsReturnProcessPagedPoolQuota			PROTO																			; ordinal 899	; XP
	PsRevertThreadToSelf				PROTO																			; ordinal 900	; XP
	PsRevertToSelf					PROTO																			; ordinal 901
	PsSetContextThread				PROTO																			; ordinal 902	; XP
	PsSetCreateProcessNotifyRoutine		PROTO :DWORD, :DWORD																; ordinal 903
	PsSetCreateThreadNotifyRoutine		PROTO :DWORD																	; ordinal 904
	PsSetJobUIRestrictionsClass			PROTO																			; ordinal 905	; XP
	PsSetLegoNotifyRoutine				PROTO :DWORD																	; ordinal 906
	PsSetLoadImageNotifyRoutine			PROTO :DWORD																	; ordinal 907
	PsSetProcessPriorityByClass			PROTO :DWORD, :DWORD																; ordinal 908
	PsSetProcessPriorityClass			PROTO																			; ordinal 909	; XP
	PsSetProcessSecurityPort			PROTO																			; ordinal 910	; XP
	PsSetProcessWin32Process			PROTO																			; ordinal 911	; XP
	PsSetProcessWindowStation			PROTO																			; ordinal 912	; XP
	PsSetThreadHardErrorsAreDisabled		PROTO																			; ordinal 913	; XP
	PsSetThreadWin32Thread				PROTO																			; ordinal 914	; XP
	PsTerminateSystemThread				PROTO :DWORD																	; ordinal 915
	PsThreadType					PROTO C																		; ordinal 916
	READ_REGISTER_BUFFER_UCHAR			PROTO :DWORD, :DWORD, :DWORD															; ordinal 917
	READ_REGISTER_BUFFER_ULONG			PROTO :DWORD, :DWORD, :DWORD															; ordinal 918
	READ_REGISTER_BUFFER_USHORT			PROTO :DWORD, :DWORD, :DWORD															; ordinal 919
	READ_REGISTER_UCHAR				PROTO :DWORD																	; ordinal 920
	READ_REGISTER_ULONG				PROTO :DWORD																	; ordinal 921
	READ_REGISTER_USHORT				PROTO :DWORD																	; ordinal 922
	RtlAbsoluteToSelfRelativeSD			PROTO :DWORD, :DWORD, :DWORD															; ordinal 923
	RtlAddAccessAllowedAce				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 924
	RtlAddAce						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 925
	RtlAddAtomToAtomTable				PROTO :DWORD, :DWORD, :DWORD															; ordinal 926
	RtlAddRange						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 927
	RtlAllocateHeap					PROTO :DWORD, :DWORD, :DWORD															; ordinal 928
	RtlAnsiCharToUnicodeChar			PROTO :DWORD																	; ordinal 929
	RtlAnsiStringToUnicodeSize			PROTO :DWORD																	; ordinal 930
	RtlAnsiStringToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 931
	RtlAppendAsciizToString				PROTO :DWORD, :DWORD																; ordinal 932
	RtlAppendStringToString				PROTO :DWORD, :DWORD																; ordinal 933
	RtlAppendUnicodeStringToString		PROTO :DWORD, :DWORD																; ordinal 934
	RtlAppendUnicodeToString			PROTO :DWORD, :DWORD																; ordinal 935
	RtlAreAllAccessesGranted			PROTO :DWORD, :DWORD																; ordinal 936
	RtlAreAnyAccessesGranted			PROTO :DWORD, :DWORD																; ordinal 937
	RtlAreBitsClear					PROTO :DWORD, :DWORD, :DWORD															; ordinal 938
	RtlAreBitsSet					PROTO :DWORD, :DWORD, :DWORD															; ordinal 939
	RtlAssert						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 940
;	RtlCaptureContext					PROTO :DWORD																	; ordinal 941
	RtlCaptureStackBackTrace			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 942
	RtlCharToInteger					PROTO :DWORD, :DWORD, :DWORD															; ordinal 943
	RtlCheckRegistryKey				PROTO :DWORD, :DWORD																; ordinal 944
	RtlClearAllBits					PROTO :DWORD																	; ordinal 945
	RtlClearBit						PROTO																			; ordinal 946	; XP
	RtlClearBits					PROTO :DWORD, :DWORD, :DWORD															; ordinal 947
	RtlCompareMemory					PROTO :DWORD, :DWORD, :DWORD															; ordinal 948
	RtlCompareMemoryUlong				PROTO :DWORD, :DWORD, :DWORD															; ordinal 949
	RtlCompareString					PROTO :DWORD, :DWORD, :DWORD															; ordinal 950
	RtlCompareUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 951
	RtlCompressBuffer					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 952
	RtlCompressChunks					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 953
	RtlConvertLongToLargeInteger			PROTO :DWORD																	; ordinal 954
	RtlConvertSidToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 955
	RtlConvertUlongToLargeInteger			PROTO :DWORD																	; ordinal 956
	RtlCopyLuid						PROTO :DWORD, :DWORD																; ordinal 957
	RtlCopyRangeList					PROTO :DWORD, :DWORD																; ordinal 958
	RtlCopySid						PROTO :DWORD, :DWORD, :DWORD															; ordinal 959
	RtlCopyString					PROTO :DWORD, :DWORD																; ordinal 960
	RtlCopyUnicodeString				PROTO :DWORD, :DWORD																; ordinal 961
	RtlCreateAcl					PROTO :DWORD, :DWORD, :DWORD															; ordinal 962
	RtlCreateAtomTable				PROTO :DWORD, :DWORD																; ordinal 963
	RtlCreateHeap					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 964
	RtlCreateRegistryKey				PROTO :DWORD, :DWORD																; ordinal 965
	RtlCreateSecurityDescriptor			PROTO :DWORD, :DWORD																; ordinal 966
	RtlCreateSystemVolumeInformation		PROTO																			; ordinal 967	; XP
	RtlCreateUnicodeString				PROTO :DWORD, :DWORD																; ordinal 968
	RtlCustomCPToUnicodeN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 969
	RtlDecompressBuffer				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 970
	RtlDecompressChunks				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 971
	RtlDecompressFragment				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 972
	RtlDelete						PROTO :DWORD																	; ordinal 973
	RtlDeleteAce					PROTO :DWORD, :DWORD																; ordinal 974
	RtlDeleteAtomFromAtomTable			PROTO :DWORD, :DWORD																; ordinal 975
	RtlDeleteElementGenericTable			PROTO :DWORD, :DWORD																; ordinal 976
;	RtlDeleteElementGenericTableAvl		PROTO																			; ordinal 977	; XP
	RtlDeleteNoSplay					PROTO :DWORD, :DWORD																; ordinal 978
	RtlDeleteOwnersRanges				PROTO :DWORD, :DWORD																; ordinal 979
	RtlDeleteRange					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 980
	RtlDeleteRegistryValue				PROTO :DWORD, :DWORD, :DWORD															; ordinal 981
	RtlDescribeChunk					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 982
	RtlDestroyAtomTable				PROTO :DWORD																	; ordinal 983
	RtlDestroyHeap					PROTO :DWORD																	; ordinal 984
	RtlDowncaseUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 985
	RtlEmptyAtomTable					PROTO :DWORD, :DWORD																; ordinal 986
	RtlEnlargedIntegerMultiply			PROTO :DWORD, :DWORD																; ordinal 987
	RtlEnlargedUnsignedDivide			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 988
	RtlEnlargedUnsignedMultiply			PROTO :DWORD, :DWORD																; ordinal 989
	RtlEnumerateGenericTable			PROTO :DWORD, :DWORD																; ordinal 990
;	RtlEnumerateGenericTableAvl			PROTO																			; ordinal 991	; XP
;	RtlEnumerateGenericTableLikeADirectory	PROTO																			; ordinal 992	; XP
	RtlEnumerateGenericTableWithoutSplaying	PROTO :DWORD, :DWORD																; ordinal 993
;	RtlEnumerateGenericTableWithoutSplayingAvl	PROTO																		; ordinal 994	; XP
;	RtlEnumerateGenericTableWithoutSplayingEx	PROTO																			; WITHOUT SERVICE PACK 1
	RtlEqualLuid					PROTO :DWORD, :DWORD																; ordinal 995
	RtlEqualSid						PROTO :DWORD, :DWORD																; ordinal 996
	RtlEqualString					PROTO :DWORD, :DWORD, :DWORD															; ordinal 997
	RtlEqualUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 998
	RtlExtendedIntegerMultiply			PROTO :DWORD, :DWORD, :DWORD															; ordinal 999
	RtlExtendedLargeIntegerDivide			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1000
	RtlExtendedMagicDivide				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1001
	RtlFillMemory					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1002
	RtlFillMemoryUlong				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1003
	RtlFindClearBits					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1004
	RtlFindClearBitsAndSet				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1005
;	RtlFindClearRuns					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1006
	RtlFindFirstRunClear				PROTO :DWORD, :DWORD																; ordinal 1007
	RtlFindLastBackwardRunClear			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1008
	RtlFindLeastSignificantBit			PROTO :DWORD, :DWORD																; ordinal 1009
	RtlFindLongestRunClear				PROTO :DWORD, :DWORD																; ordinal 1010
	RtlFindMessage					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1011
	RtlFindMostSignificantBit			PROTO :DWORD, :DWORD																; ordinal 1012
	RtlFindNextForwardRunClear			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1013
	RtlFindRange					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 1014
	RtlFindSetBits					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1015
	RtlFindSetBitsAndClear				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1016
	RtlFindUnicodePrefix				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1017
	RtlFormatCurrentUserKeyPath			PROTO :DWORD																	; ordinal 1018
	RtlFreeAnsiString					PROTO :DWORD																	; ordinal 1019
	RtlFreeHeap						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1020
	RtlFreeOemString					PROTO :DWORD																	; ordinal 1021
	RtlFreeRangeList					PROTO :DWORD																	; ordinal 1022
	RtlFreeUnicodeString				PROTO :DWORD																	; ordinal 1023
	RtlGUIDFromString					PROTO :DWORD, :DWORD																; ordinal 1024
	RtlGenerate8dot3Name				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1025
	RtlGetAce						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1026
	RtlGetCallersAddress				PROTO :DWORD, :DWORD																; ordinal 1027
	RtlGetCompressionWorkSpaceSize		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1028
	RtlGetDaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1029
	RtlGetDefaultCodePage				PROTO :DWORD, :DWORD																; ordinal 1030
	RtlGetElementGenericTable			PROTO :DWORD, :DWORD																; ordinal 1031
	RtlGetElementGenericTableEx			PROTO																			; ordinal 1032	; XP
	RtlGetFirstRange					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1033
	RtlGetGroupSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1034
	RtlGetNextRange					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1035
	RtlGetNtGlobalFlags				PROTO																			; ordinal 1036
	RtlGetOwnerSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1037
	RtlGetSaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1038
;	RtlGetSetBootStatusData				PROTO																			; ordinal 1039	; XP
	RtlGetVersion					PROTO	:DWORD																	; ordinal 1040	; XP
;	RtlHashUnicodeString				PROTO																			; ordinal 1041	; XP
	RtlImageDirectoryEntryToData			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1042
	RtlImageNtHeader					PROTO :DWORD																	; ordinal 1043
	RtlInitAnsiString					PROTO :DWORD, :DWORD																; ordinal 1044
	RtlInitCodePageTable				PROTO :DWORD, :DWORD																; ordinal 1045
	RtlInitString					PROTO :DWORD, :DWORD																; ordinal 1046
	RtlInitUnicodeString				PROTO :DWORD, :DWORD																; ordinal 1047
	RtlInitializeBitMap				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1048
	RtlInitializeGenericTable			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1049
	RtlInitializeGenericTableEx			PROTO																			; ordinal 1050	; XP
	RtlInitializeRangeList				PROTO :DWORD																	; ordinal 1051
	RtlInitializeSid					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1052
	RtlInitializeUnicodePrefix			PROTO :DWORD																	; ordinal 1053
	RtlInsertElementGenericTable			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1054
;	RtlInsertElementGenericTableAvl		PROTO																			; ordinal 1055	; XP
	RtlInsertElementGenericTableFull		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1056
;	RtlInsertElementGenericTableFullAvl		PROTO																			; ordinal 1057	; XP
	RtlInsertUnicodePrefix				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1058
;	RtlInt64ToUnicodeString				PROTO																			; ordinal 1059	; XP
	RtlIntegerToChar					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1060
	RtlIntegerToUnicode				PROTO																			; ordinal 1061	; XP
	RtlIntegerToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1062
	RtlInvertRangeList				PROTO :DWORD, :DWORD																; ordinal 1063
	RtlIpv4AddressToStringA				PROTO																			; ordinal 1064	; XP
	RtlIpv4AddressToStringW				PROTO																			; ordinal 1065	; XP
	RtlIpv4StringToAddressA				PROTO																			; ordinal 1066	; XP
	RtlIpv4StringToAddressW				PROTO																			; ordinal 1067	; XP
	RtlIpv6AddressToStringA				PROTO																			; ordinal 1068	; XP
	RtlIpv6AddressToStringW				PROTO																			; ordinal 1069	; XP
	RtlIpv6StringToAddressA				PROTO																			; ordinal 1070	; XP
	RtlIpv6StringToAddressW				PROTO																			; ordinal 1071	; XP
	RtlIsGenericTableEmpty				PROTO :DWORD																	; ordinal 1072
	RtlIsGenericTableEmptyAvl			PROTO																			; ordinal 1073	; XP
	RtlIsNameLegalDOS8Dot3				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1074
	RtlIsRangeAvailable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 1075
	RtlIsValidOemCharacter				PROTO :DWORD																	; ordinal 1076
	RtlLargeIntegerAdd				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1077
	RtlLargeIntegerArithmeticShift		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1078
	RtlLargeIntegerDivide				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1079
	RtlLargeIntegerNegate				PROTO :DWORD, :DWORD																; ordinal 1080
	RtlLargeIntegerShiftLeft			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1081
	RtlLargeIntegerShiftRight			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1082
	RtlLargeIntegerSubtract				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1083
	RtlLengthRequiredSid				PROTO :DWORD																	; ordinal 1084
	RtlLengthSecurityDescriptor			PROTO :DWORD																	; ordinal 1085
	RtlLengthSid					PROTO :DWORD																	; ordinal 1086
;	RtlLockBootStatusData				PROTO																			; ordinal 1087	; XP
	RtlLookupAtomInAtomTable			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1088
	RtlLookupElementGenericTable			PROTO :DWORD, :DWORD																; ordinal 1089
;	RtlLookupElementGenericTableAvl		PROTO																			; ordinal 1090	; XP
	RtlLookupElementGenericTableFull		PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1091
;	RtlLookupElementGenericTableFullAvl		PROTO																			; ordinal 1092	; XP
	RtlMapGenericMask					PROTO :DWORD, :DWORD																; ordinal 1093
	RtlMapSecurityErrorToNtSt			PROTO																			; ordinal 1094	; XP
	RtlMergeRangeLists				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1095
	RtlMoveMemory					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1096
	RtlMultiByteToUnicodeN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1097
	RtlMultiByteToUnicodeSize			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1098
	RtlNextUnicodePrefix				PROTO :DWORD, :DWORD																; ordinal 1099
	RtlNtStatusToDosError				PROTO :DWORD																	; ordinal 1100
;	RtlNtStatusToDosErrorNoTeb			PROTO :DWORD																	; ordinal 1101
	RtlNumberGenericTableElements			PROTO :DWORD																	; ordinal 1102
	RtlNumberGenericTableElementsEx		PROTO																			; ordinal 1103	; XP
	RtlNumberOfClearBits				PROTO :DWORD																	; ordinal 1104
	RtlNumberOfSetBits				PROTO :DWORD																	; ordinal 1105
	RtlOemStringToCountedUnicodeString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1106
	RtlOemStringToUnicodeSize			PROTO :DWORD																	; ordinal 1107
	RtlOemStringToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1108
	RtlOemToUnicodeN					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1109
	RtlPinAtomInAtomTable				PROTO :DWORD, :DWORD																; ordinal 1110
	RtlPrefixString					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1111
	RtlPrefixUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1112
	RtlQueryAtomInAtomTable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1113
	RtlQueryRegistryValues				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1114
	RtlQueryTimeZoneInformation			PROTO :DWORD																	; ordinal 1115
	RtlRaiseException					PROTO :DWORD																	; ordinal 1116
	RtlRandom						PROTO :DWORD																	; ordinal 1117
;	RtlRandomEx						PROTO																			; ordinal 1118	; XP
	RtlRealPredecessor				PROTO :DWORD																	; ordinal 1119
	RtlRealSuccessor					PROTO :DWORD																	; ordinal 1120
	RtlRemoveUnicodePrefix				PROTO :DWORD, :DWORD																; ordinal 1121
	RtlReserveChunk					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1122
	RtlSecondsSince1970ToTime			PROTO :DWORD, :DWORD																; ordinal 1123
	RtlSecondsSince1980ToTime			PROTO :DWORD, :DWORD																; ordinal 1124
	RtlSelfRelativeToAbsoluteSD2			PROTO :DWORD, :DWORD																; ordinal 1125
	RtlSelfRelativeToAbsoluteSD			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 1126
	RtlSetAllBits					PROTO :DWORD																	; ordinal 1127
	RtlSetBit						PROTO																			; ordinal 1128	; XP
	RtlSetBits						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1129
	RtlSetDaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1130
	RtlSetGroupSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1131
	RtlSetOwnerSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1132
	RtlSetSaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1133
	RtlSetTimeZoneInformation			PROTO :DWORD																	; ordinal 1134
	RtlSizeHeap						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1135
	RtlSplay						PROTO :DWORD																	; ordinal 1136
	RtlStringFromGUID					PROTO :DWORD, :DWORD																; ordinal 1137
	RtlSubAuthorityCountSid				PROTO :DWORD																	; ordinal 1138
	RtlSubAuthoritySid				PROTO :DWORD, :DWORD																; ordinal 1139
	RtlSubtreePredecessor				PROTO :DWORD																	; ordinal 1140
	RtlSubtreeSuccessor				PROTO :DWORD																	; ordinal 1141
	RtlTestBit						PROTO																			; ordinal 1142	; XP
	RtlTimeFieldsToTime				PROTO :DWORD, :DWORD																; ordinal 1143
	RtlTimeToElapsedTimeField			PROTO																			; ordinal 1144	; XP
	RtlTimeToSecondsSince1970			PROTO :DWORD, :DWORD																; ordinal 1145
	RtlTimeToSecondsSince1980			PROTO :DWORD, :DWORD																; ordinal 1146
	RtlTimeToTimeFields				PROTO :DWORD, :DWORD																; ordinal 1147
;	RtlTraceDatabaseAdd				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1148
;	RtlTraceDatabaseCreate				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1149
;	RtlTraceDatabaseDestroy				PROTO :DWORD																	; ordinal 1150
;	RtlTraceDatabaseEnumerate			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1151
;	RtlTraceDatabaseFind				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1152
;	RtlTraceDatabaseLock				PROTO :DWORD																	; ordinal 1153
;	RtlTraceDatabaseUnlock				PROTO :DWORD																	; ordinal 1154
;	RtlTraceDatabaseValidate			PROTO :DWORD																	; ordinal 1155
	RtlUnicodeStringToAnsiSize			PROTO :DWORD																	; ordinal 1156
	RtlUnicodeStringToAnsiString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1157
	RtlUnicodeStringToCountedOemString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1158
	RtlUnicodeStringToInteger			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1159
	RtlUnicodeStringToOemSize			PROTO :DWORD																	; ordinal 1160
	RtlUnicodeStringToOemString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1161
	RtlUnicodeToCustomCPN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1162
	RtlUnicodeToMultiByteN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1163
	RtlUnicodeToMultiByteSize			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1164
	RtlUnicodeToOemN					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1165
	RtlUnlockBootStatusData				PROTO																			; ordinal 1166	; XP
	RtlUnwind						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1167
	RtlUpcaseUnicodeChar				PROTO :DWORD																	; ordinal 1168
	RtlUpcaseUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1169
	RtlUpcaseUnicodeStringToAnsiString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1170
	RtlUpcaseUnicodeStringToCountedOemString	PROTO :DWORD, :DWORD, :DWORD															; ordinal 1171
	RtlUpcaseUnicodeStringToOemString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1172
	RtlUpcaseUnicodeToCustomCPN			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1173
	RtlUpcaseUnicodeToMultiByteN			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1174
	RtlUpcaseUnicodeToOemN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1175
	RtlUpperChar					PROTO :DWORD																	; ordinal 1176
	RtlUpperString					PROTO :DWORD, :DWORD																; ordinal 1177
	RtlValidRelativeSecurityDescriptor		PROTO :DWORD, :DWORD, :DWORD															; ordinal 1178
	RtlValidSecurityDescriptor			PROTO :DWORD																	; ordinal 1179
	RtlValidSid						PROTO :DWORD																	; ordinal 1180
;	RtlVerifyVersionInfo				PROTO																			; ordinal 1181	; XP
	RtlVolumeDeviceToDosName			PROTO :DWORD, :DWORD																; ordinal 1182
	RtlWalkFrameChain					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1183
	RtlWriteRegistryValue				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1184
	RtlZeroHeap						PROTO :DWORD, :DWORD																; ordinal 1185
	RtlZeroMemory					PROTO :DWORD, :DWORD																; ordinal 1186
	RtlxAnsiStringToUnicodeSize			PROTO :DWORD																	; ordinal 1187
	RtlxOemStringToUnicodeSize			PROTO :DWORD																	; ordinal 1188
	RtlxUnicodeStringToAnsiSize			PROTO :DWORD																	; ordinal 1189
	RtlxUnicodeStringToOemSize			PROTO :DWORD																	; ordinal 1190
	SeAccessCheck					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 1191
	SeAppendPrivileges				PROTO :DWORD, :DWORD																; ordinal 1192
	SeAssignSecurity					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1193
	SeAssignSecurityEx				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1194
	SeAuditHardLinkCreation				PROTO																			; ordinal 1195	; XP
	SeAuditingFileEvents				PROTO :DWORD, :DWORD																; ordinal 1196
	SeAuditingFileOrGlobalEvents			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1197
	SeAuditingHardLinkEvents			PROTO																			; ordinal 1198	; XP
	SeCaptureSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1199
	SeCaptureSubjectContext				PROTO :DWORD																	; ordinal 1200
	SeCloseObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1201
	SeCreateAccessState				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1202
	SeCreateClientSecurity				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1203
	SeCreateClientSecurityFromSubjectContext	PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1204
	SeDeassignSecurity				PROTO :DWORD																	; ordinal 1205
	SeDeleteAccessState				PROTO :DWORD																	; ordinal 1206
	SeDeleteObjectAuditAlarm			PROTO :DWORD, :DWORD																; ordinal 1207
	SeExports						PROTO																			; ordinal 1208	; XP
	SeFilterToken					PROTO																			; ordinal 1209	; XP
	SeFreePrivileges					PROTO :DWORD																	; ordinal 1210
	SeImpersonateClient				PROTO :DWORD, :DWORD																; ordinal 1211
	SeImpersonateClientEx				PROTO :DWORD, :DWORD																; ordinal 1212
	SeLockSubjectContext				PROTO :DWORD																	; ordinal 1213
	SeMarkLogonSessionForTerminationNotification	PROTO :DWORD																; ordinal 1214
	SeOpenObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1215
	SeOpenObjectForDeleteAuditAlarm		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1216
	SePrivilegeCheck					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1217
	SePrivilegeObjectAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1218
	SePublicDefaultDacl				PROTO C																		; ordinal 1219
	SeQueryAuthenticationIdToken			PROTO :DWORD, :DWORD																; ordinal 1220
	SeQueryInformationToken				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1221
	SeQuerySecurityDescriptorInfo			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1222
	SeQuerySessionIdToken				PROTO :DWORD, :DWORD																; ordinal 1223
	SeRegisterLogonSessionTerminatedRoutine	PROTO :DWORD																	; ordinal 1224
	SeReleaseSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1225
	SeReleaseSubjectContext				PROTO :DWORD																	; ordinal 1226
	SeSetAccessStateGenericMapping		PROTO :DWORD, :DWORD																; ordinal 1227
	SeSetSecurityDescriptorInfo			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1228
	SeSetSecurityDescriptorInfoEx			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1229
	SeSinglePrivilegeCheck				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1230
	SeSystemDefaultDacl				PROTO C																		; ordinal 1231
	SeTokenImpersonationLevel			PROTO :DWORD																	; ordinal 1232
	SeTokenIsAdmin					PROTO :DWORD																	; ordinal 1233
	SeTokenIsRestricted				PROTO :DWORD																	; ordinal 1234
	SeTokenObjectType					PROTO																			; ordinal 1235	; XP
	SeTokenType						PROTO :DWORD																	; ordinal 1236
	SeUnlockSubjectContext				PROTO :DWORD																	; ordinal 1237
	SeUnregisterLogonSessionTerminatedRoutine	PROTO :DWORD																	; ordinal 1238
	SeValidSecurityDescriptor			PROTO :DWORD, :DWORD																; ordinal 1239
;	VerSetConditionMask				PROTO																			; ordinal 1240	; XP
	VfFailDeviceNode					PROTO																			; ordinal 1241	; XP
	VfFailDriver					PROTO																			; ordinal 1242	; XP
	VfFailSystemBIOS					PROTO																			; ordinal 1243	; XP
	VfIsVerificationEnabled				PROTO																			; ordinal 1244	; XP
	WRITE_REGISTER_BUFFER_UCHAR			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1245
	WRITE_REGISTER_BUFFER_ULONG			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1246
	WRITE_REGISTER_BUFFER_USHORT			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1247
	WRITE_REGISTER_UCHAR				PROTO :DWORD, :DWORD																; ordinal 1248
	WRITE_REGISTER_ULONG				PROTO :DWORD, :DWORD																; ordinal 1249
	WRITE_REGISTER_USHORT				PROTO :DWORD, :DWORD																; ordinal 1250
	WmiFlushTrace					PROTO 																		; ordinal 1251	; XP
	WmiQueryTrace					PROTO 																		; ordinal 1252	; XP
	WmiQueryTraceInformation			PROTO 																		; ordinal 1253	; XP
	WmiStartTrace					PROTO 																		; ordinal 1254	; XP
	WmiStopTrace					PROTO 																		; ordinal 1255	; XP
	WmiTraceMessage					PROTO 																		; ordinal 1256	; XP
	WmiTraceMessageVa					PROTO 																		; ordinal 1257	; XP
	WmiUpdateTrace					PROTO																			; ordinal 1258	; XP
	XIPDispatch						PROTO																			; ordinal 1259	; XP
	ZwAccessCheckAndAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 1260
;	ZwAddBootEntry					PROTO																			; ordinal 1261	; XP
	ZwAdjustPrivilegesToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1262
	ZwAlertThread					PROTO :DWORD																	; ordinal 1263
	ZwAllocateVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1264
;	ZwAssignProcessToJobObject			PROTO																			; ordinal 1265	; XP
	ZwCancelIoFile					PROTO :DWORD, :DWORD																; ordinal 1266
	ZwCancelTimer					PROTO :DWORD, :DWORD																; ordinal 1267
	ZwClearEvent					PROTO :DWORD																	; ordinal 1268
	ZwClose						PROTO :DWORD																	; ordinal 1269
	ZwCloseObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1270
	ZwConnectPort					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 1271
	ZwCreateDirectoryObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1272
	ZwCreateEvent					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1273
	ZwCreateFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 1274
;	ZwCreateJobObject					PROTO																			; ordinal 1275	; XP
	ZwCreateKey						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1276
	ZwCreateSection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1277
	ZwCreateSymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1278
	ZwCreateTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1279
;	ZwDeleteBootEntry					PROTO																			; ordinal 1280	; XP
	ZwDeleteFile					PROTO :DWORD																	; ordinal 1281
	ZwDeleteKey						PROTO :DWORD																	; ordinal 1282
	ZwDeleteValueKey					PROTO :DWORD, :DWORD																; ordinal 1283
	ZwDeviceIoControlFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 1284
	ZwDisplayString					PROTO :DWORD																	; ordinal 1285
	ZwDuplicateObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1286
	ZwDuplicateToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1287
;	ZwEnumerateBootEntries				PROTO																			; ordinal 1288	; XP
	ZwEnumerateKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1289
	ZwEnumerateValueKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1290
	ZwFlushInstructionCache				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1291
	ZwFlushKey						PROTO :DWORD																	; ordinal 1292
	ZwFlushVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1293
	ZwFreeVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1294
	ZwFsControlFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 1295
	ZwInitiatePowerAction				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1296
	ZwIsProcessInJob					PROTO																			; ordinal 1297	; XP
	ZwLoadDriver					PROTO :DWORD																	; ordinal 1298
	ZwLoadKey						PROTO :DWORD, :DWORD																; ordinal 1299
	ZwMakeTemporaryObject				PROTO :DWORD																	; ordinal 1300
	ZwMapViewOfSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 1301
	ZwNotifyChangeKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 1302
;	ZwOpenDirectoryObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1303
;	ZwOpenEvent						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1304
	ZwOpenFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1305
;	ZwOpenJobObject					PROTO																			; ordinal 1306	; XP
	ZwOpenKey						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1307
	ZwOpenProcess					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1308
	ZwOpenProcessToken				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1309
;	ZwOpenProcessTokenEx				PROTO																			; ordinal 1310	; XP
	ZwOpenSection					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1311
	ZwOpenSymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1312
	ZwOpenThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1313
	ZwOpenThreadToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1314
;	ZwOpenThreadTokenEx				PROTO																			; ordinal 1315	; XP
	ZwOpenTimer						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1316
	ZwPowerInformation				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1317
	ZwPulseEvent					PROTO :DWORD, :DWORD																; ordinal 1318
;	ZwQueryBootEntryOrder				PROTO																			; ordinal 1319	; XP
;	ZwQueryBootOptions				PROTO																			; ordinal 1320	; XP
	ZwQueryDefaultLocale				PROTO :DWORD, :DWORD																; ordinal 1321
	ZwQueryDefaultUILanguage			PROTO :DWORD																	; ordinal 1322
	ZwQueryDirectoryFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 1323
	ZwQueryDirectoryObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1324
	ZwQueryEaFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1325
;	ZwQueryFullAttributesFile			PROTO																			; ordinal 1326	; XP
	ZwQueryInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1327
;	ZwQueryInformationJobObject			PROTO																			; ordinal 1328	; XP
	ZwQueryInformationProcess			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1329
;	ZwQueryInformationThread			PROTO																			; ordinal 1330	; XP
	ZwQueryInformationToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1331
	ZwQueryInstallUILanguage			PROTO :DWORD																	; ordinal 1332
	ZwQueryKey						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1333
	ZwQueryObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1334
	ZwQuerySection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1335
	ZwQuerySecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1336
	ZwQuerySymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1337
	ZwQuerySystemInformation			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1338
	ZwQueryValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1339
	ZwQueryVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1340
	ZwReadFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1341
	ZwReplaceKey					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1342
	ZwRequestWaitReplyPort				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1343
	ZwResetEvent					PROTO :DWORD, :DWORD																; ordinal 1344
	ZwRestoreKey					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1345
	ZwSaveKey						PROTO :DWORD, :DWORD																; ordinal 1346
;	ZwSaveKeyEx						PROTO																			; ordinal 1347	; XP
;	ZwSetBootEntryOrder				PROTO																			; ordinal 1348	; XP
;	ZwSetBootOptions					PROTO																			; ordinal 1349	; XP
;	ZwSetDefaultLocale				PROTO																			; ordinal 1350	; XP
	ZwSetDefaultUILanguage				PROTO :DWORD																	; ordinal 1351
	ZwSetEaFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1352
	ZwSetEvent						PROTO :DWORD, :DWORD																; ordinal 1353
	ZwSetInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1354
	ZwSetInformationJobObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1355
	ZwSetInformationObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1356
	ZwSetInformationProcess				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1357
	ZwSetInformationThread				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1358
	ZwSetSecurityObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1359
	ZwSetSystemInformation				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1360
	ZwSetSystemTime					PROTO :DWORD, :DWORD																; ordinal 1361
	ZwSetTimer						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1362
	ZwSetValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1363
	ZwSetVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1364
;	ZwTerminateJobObject				PROTO																			; ordinal 1365	; XP
	ZwTerminateProcess				PROTO :DWORD, :DWORD																; ordinal 1366
;	ZwTranslateFilePath				PROTO																			; ordinal 1367	; XP
	ZwUnloadDriver					PROTO :DWORD																	; ordinal 1368
	ZwUnloadKey						PROTO :DWORD																	; ordinal 1369
	ZwUnmapViewOfSection				PROTO :DWORD, :DWORD																; ordinal 1370
	ZwWaitForMultipleObjects			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1371
	ZwWaitForSingleObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1372
	ZwWriteFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1373
	ZwYieldExecution					PROTO																			; ordinal 1374
;	_CIcos						PROTO	C																		; ordinal 1375	; XP
;	_CIsin						PROTO C																		; ordinal 1376	; XP
;	_CIsqrt						PROTO C																		; ordinal 1377	; XP
	_abnormal_termination				PROTO C																		; ordinal 1378
	_alldiv						PROTO C																		; ordinal 1379
;	_alldvrm						PROTO	C																		; ordinal 1380	; XP
	_allmul						PROTO C																		; ordinal 1381
;	_alloca_probe					PROTO	C																		; ordinal 1382	; XP
	_allrem						PROTO C																		; ordinal 1383
	_allshl						PROTO C																		; ordinal 1384
	_allshr						PROTO C																		; ordinal 1385
	_aulldiv						PROTO C																		; ordinal 1386
;	_aulldvrm						PROTO C																		; ordinal 1387	; XP
	_aullrem						PROTO C																		; ordinal 1388
	_aullshr						PROTO C																		; ordinal 1389
	_except_handler2					PROTO C																		; ordinal 1390
	_except_handler3					PROTO C																		; ordinal 1391
	_global_unwind2					PROTO C																		; ordinal 1392
	_itoa							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1393
	_itow							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1394
	_local_unwind2					PROTO C																		; ordinal 1395
	_purecall						PROTO C																		; ordinal 1396
	_snprintf						PROTO C :DWORD, :DWORD, :DWORD, :VARARG													; ordinal 1397
	_snwprintf						PROTO C :DWORD, :DWORD, :DWORD, :VARARG													; ordinal 1398
	_stricmp						PROTO C :DWORD, :DWORD																; ordinal 1399
	_strlwr						PROTO C :DWORD																	; ordinal 1400
	_strnicmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1401
	_strnset						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1402
	_strrev						PROTO C :DWORD																	; ordinal 1403
	_strset						PROTO C :DWORD, :DWORD																; ordinal 1404
	_strupr						PROTO C :DWORD																	; ordinal 1405
	_vsnprintf						PROTO C :DWORD, :DWORD, :DWORD, :VARARG													; ordinal 1406
;	_vsnwprintf						PROTO	C																		; ordinal 1407	; XP
	_wcsicmp						PROTO C :DWORD, :DWORD																; ordinal 1408
	_wcslwr						PROTO C :DWORD																	; ordinal 1409
	_wcsnicmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1410
	_wcsnset						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1411
	_wcsrev						PROTO C :DWORD																	; ordinal 1412
	_wcsupr						PROTO C :DWORD																	; ordinal 1413
	atoi							PROTO C :DWORD																	; ordinal 1414
	atol							PROTO C :DWORD																	; ordinal 1415
	isdigit						PROTO C :DWORD																	; ordinal 1416
	islower						PROTO C :DWORD																	; ordinal 1417
	isprint						PROTO C :DWORD																	; ordinal 1418
	isspace						PROTO C :DWORD																	; ordinal 1419
	isupper						PROTO C :DWORD																	; ordinal 1420
	isxdigit						PROTO C :DWORD																	; ordinal 1421
	mbstowcs						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1422
	mbtowc						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1423
	memchr						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1424
	memcpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1425
	memmove						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1426
	memset						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1427
	qsort							PROTO C :VARARG																	; ordinal 1428
	rand							PROTO C																		; ordinal 1429
	sprintf						PROTO C :DWORD, :DWORD, :VARARG														; ordinal 1430
	srand							PROTO C :DWORD																	; ordinal 1431
	strcat						PROTO C :DWORD, :DWORD																; ordinal 1432
	strchr						PROTO C :DWORD, :DWORD																; ordinal 1433
	strcmp						PROTO C :DWORD, :DWORD																; ordinal 1434
	strcpy						PROTO C :DWORD, :DWORD																; ordinal 1435
	strlen						PROTO C :DWORD																	; ordinal 1436
	strncat						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1437
	strncmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1438
	strncpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1439
	strrchr						PROTO C :DWORD, :DWORD																; ordinal 1440
	strspn						PROTO C :DWORD, :DWORD																; ordinal 1441
	strstr						PROTO C :DWORD, :DWORD																; ordinal 1442
	swprintf						PROTO C :DWORD, :DWORD, :VARARG														; ordinal 1443
	tolower						PROTO C :DWORD																	; ordinal 1444
	toupper						PROTO C :DWORD																	; ordinal 1445
	towlower						PROTO C :DWORD																	; ordinal 1446
	towupper						PROTO C :DWORD																	; ordinal 1447
;	vDbgPrintEx						PROTO C																		; ordinal 1448	; XP
;	vDbgPrintExWithPrefix				PROTO C																		; ordinal 1449	; XP
	vsprintf						PROTO C :DWORD, :DWORD, :VARARG														; ordinal 1450
	wcscat						PROTO C :DWORD, :DWORD																; ordinal 1451
	wcschr						PROTO C :DWORD, :DWORD																; ordinal 1452
	wcscmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1453
	wcscpy						PROTO C :DWORD, :DWORD																; ordinal 1454
	wcscspn						PROTO C :DWORD, :DWORD																; ordinal 1455
	wcslen						PROTO C :DWORD																	; ordinal 1456
	wcsncat						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1457
	wcsncmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1458
	wcsncpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1459
	wcsrchr						PROTO C :DWORD, :DWORD																; ordinal 1460
	wcsspn						PROTO C :DWORD, :DWORD																; ordinal 1461
	wcsstr						PROTO C :DWORD, :DWORD																; ordinal 1462
	wcstombs						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1463
	wctomb						PROTO C :DWORD, :DWORD																; ordinal 1464



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<HAL.LIB PROTOS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



	ExAcquireFastMutex				PROTO	:DWORD																	; ordinal 1
	ExReleaseFastMutex 				PROTO :DWORD																	; ordinal 2
	ExTryToAcquireFastMutex 			PROTO :DWORD																	; ordinal 3
	HalClearSoftwareInterrupt			PROTO :DWORD																	; ordinal 4
	HalRequestSoftwareInterrupt			PROTO :DWORD																	; ordinal 5
	HalSystemVectorDispatchEntry 			PROTO :DWORD, :DWORD, :DWORD															; ordinal 6
	KeAcquireInStackQueuedSpinLock		PROTO :DWORD																	; ordinal 7		; XP	
	KeAcquireInStackQueuedSpinLockRaiseToSynch PROTO :DWORD																	; ordinal 8		; XP
	KeAcquireQueuedSpinLock				PROTO :DWORD																	; ordinal 9
	KeAcquireQueuedSpinLockRaiseToSynch		PROTO :DWORD																	; ordinal 10
	KeAcquireSpinLockRaiseToSynch			PROTO :DWORD																	; ordinal 11
	KeReleaseInStackQueuedSpinLock		PROTO :DWORD, :DWORD																; ordinal 12	; XP	
	KeReleaseQueuedSpinLock				PROTO :DWORD, :DWORD																; ordinal 13
	KeTryToAcquireQueuedSpinLock			PROTO :DWORD, :DWORD																; ordinal 14
	KeTryToAcquireQueuedSpinLockRaiseToSynch	PROTO :DWORD, :DWORD																; ordinal 15
	KeAcquireSpinLock					PROTO :DWORD, :DWORD																; ordinal 16
	KfLowerIrql						PROTO :DWORD																	; ordinal 17
	KfRaiseIrql						PROTO :DWORD																	; ordinal 18
	KfReleaseSpinLock					PROTO :DWORD, :DWORD																; ordinal 19
	HalAcquireDisplayOwnership			PROTO :DWORD																	; ordinal 20
	HalAdjustResourceList				PROTO :DWORD																	; ordinal 21
	HalAllProcessorsStarted				PROTO																			; ordinal 22
	HalAllocateAdapterChannel			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 23
	HalAllocateCommonBuffer				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 24
	HalAllocateCrashDumpRegisters			PROTO :DWORD, :DWORD																; ordinal 25
	HalAssignSlotResources				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 26
	HalBeginSystemInterrupt				PROTO :DWORD, :DWORD, :DWORD															; ordinal 27
	HalCalibratePerformanceCounter		PROTO :DWORD, :DWORD, :DWORD															; ordinal 28
	HalDisableSystemInterrupt			PROTO :DWORD, :DWORD																; ordinal 29
	HalDisplayString					PROTO :DWORD																	; ordinal 30
	HalEnableSystemInterrupt			PROTO :DWORD, :DWORD, :DWORD															; ordinal 31
	HalEndSystemInterrupt				PROTO :DWORD, :DWORD																; ordinal 32
	HalFlushCommonBuffer				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 33
	HalFreeCommonBuffer				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 34
	HalGetAdapter					PROTO :DWORD, :DWORD																; ordinal 35
	HalGetBusData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 36
	HalGetBusDataByOffset				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 37
	HalGetEnvironmentVariable			PROTO :DWORD, :DWORD, :DWORD															; ordinal 38
	HalGetInterruptVector				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 39
	HalHandleNMI					PROTO :DWORD																	; ordinal 40
	HalInitSystem					PROTO :DWORD, :DWORD																; ordinal 41
	HalInitializeProcessor				PROTO :DWORD, :DWORD																; ordinal 42
	HalMakeBeep						PROTO :DWORD																	; ordinal 43
	HalProcessorIdle					PROTO																			; ordinal 44
	HalQueryDisplayParameters			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 45
	HalQueryRealTimeClock				PROTO :DWORD																	; ordinal 46
	HalReadDmaCounter					PROTO :DWORD																	; ordinal 47
	HalReportResourceUsage				PROTO																			; ordinal 48
	HalRequestIpi					PROTO :DWORD																	; ordinal 49
	HalReturnToFirmware				PROTO :DWORD																	; ordinal 50
	HalSetBusData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 51
	HalSetBusDataByOffset				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 52
	HalSetDisplayParameters				PROTO :DWORD, :DWORD																; ordinal 53
	HalSetEnvironmentVariable			PROTO :DWORD, :DWORD																; ordinal 54
	HalSetProfileInterval				PROTO	:DWORD																	; ordinal 55                             
	HalSetRealTimeClock				PROTO :DWORD																	; ordinal 56
	HalSetTimeIncrement				PROTO :DWORD																	; ordinal 57
	HalStartNextProcessor				PROTO :DWORD, :DWORD																; ordinal 58
	HalStartProfileInterrupt			PROTO :DWORD																	; ordinal 59
	HalStopProfileInterrupt				PROTO :DWORD																	; ordinal 60
	HalTranslateBusAddress				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 61
	IoAssignDriveLetters 				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 62
	IoFlushAdapterBuffers 				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 63
	IoFreeAdapterChannel				PROTO :DWORD																	; ordinal 64
	IoFreeMapRegisters 				PROTO :DWORD, :DWORD, :DWORD															; ordinal 65
	IoMapTransfer					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 66
	IoReadPartitionTable				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 67
	IoSetPartitionInformation   			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 68
	IoWritePartitionTable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD 												; ordinal 69
	KdComPortInUse					PROTO 																		; ordinal 70
; W2K	KdPortGetByte  					PROTO :DWORD																	; ordinal w2k
; W2K	KdPortInitialize					PROTO :DWORD, :DWORD, :DWORD															; ordinal w2k
; W2K	KdPortPollByte					PROTO :DWORD																	; ordinal w2k
; W2K	KdPortPutByte					PROTO :DWORD																	; ordinal w2k
; W2K	KdPortRestore					PROTO																			; ordinal w2k
; W2K	KdPortSave						PROTO																			; ordinal w2k
	KeAcquireSpinLock					PROTO :DWORD, :DWORD																; ordinal 71
	KeFlushWriteBuffer				PROTO																			; ordinal 72
	KeGetCurrentIrql					PROTO																			; ordinal 73
	KeLowerIrql						PROTO :DWORD																	; ordinal 74
	KeQueryPerformanceCounter			PROTO :DWORD																	; ordinal 75
	KeRaiseIrql						PROTO :DWORD, :DWORD																; ordinal 76
	KeRaiseIrqlToDpcLevel				PROTO																			; ordinal 77
	KeRaiseIrqlToSynchLevel				PROTO																			; ordinal 78
	KeReleaseSpinLock					PROTO :DWORD, :DWORD																; ordinal 79
	KeStallExecutionProcessor			PROTO :DWORD																	; ordinal 80
	READ_PORT_BUFFER_UCHAR				PROTO :DWORD, :DWORD, :DWORD															; ordinal 81
	READ_PORT_BUFFER_ULONG				PROTO :DWORD, :DWORD, :DWORD															; ordinal 82
	READ_PORT_BUFFER_USHORT				PROTO :DWORD, :DWORD, :DWORD															; ordinal 83
	READ_PORT_UCHAR					PROTO :DWORD																	; ordinal 84
	READ_PORT_ULONG					PROTO :DWORD																	; ordinal 85
	READ_PORT_USHORT					PROTO :DWORD																	; ordinal 86
	WRITE_PORT_BUFFER_UCHAR				PROTO :DWORD, :DWORD, :DWORD															; ordinal 87
	WRITE_PORT_BUFFER_ULONG				PROTO :DWORD, :DWORD, :DWORD															; ordinal 88
	WRITE_PORT_BUFFER_USHORT			PROTO :DWORD, :DWORD, :DWORD															; ordinal 89
	WRITE_PORT_UCHAR					PROTO :DWORD, :DWORD																; ordinal 90
	WRITE_PORT_ULONG					PROTO :DWORD, :DWORD																; ordinal 91
	WRITE_PORT_USHORT					PROTO :DWORD, :DWORD																; ordinal 92



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<NTDLL.LIB PROTOS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



	PropertyLengthAsVariant				PROTO																			; ordinal 1
	RtlConvertPropertyToVariant			PROTO																			; ordinal 2
	RtlConvertVariantToProperty			PROTO																			; ordinal 3
	RtlInterlockedPushListSList			PROTO 																		; ordinal 4		; XP
	RtlUlongByteSwap					PROTO :DWORD																	; ordinal 5
	RtlUlonglongByteSwap				PROTO :DWORD																	; ordinal 6
	RtlUshortByteSwap					PROTO :DWORD																	; ordinal 7
	CsrAllocateCaptureBuffer			PROTO :DWORD, :DWORD																; ordinal 8
	CsrAllocateMessagePointer			PROTO :DWORD, :DWORD, :DWORD															; ordinal 9
	CsrCaptureMessageBuffer				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 10
	CsrCaptureMessageMultiUnicodeStringsInPlace	PROTO																		; ordinal 11	; XP 
	CsrCaptureMessageString				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 12
	CsrCaptureTimeout					PROTO :DWORD, :DWORD																; ordinal 13
	CsrClientCallServer				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 14
	CsrClientConnectToServer			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 15
	CsrFreeCaptureBuffer				PROTO :DWORD																	; ordinal 16
	CsrGetProcessId					PROTO																			; ordinal 17	; XP
	CsrIdentifyAlertableThread			PROTO																			; ordinal 18
	CsrNewThread					PROTO																			; ordinal 19
	CsrProbeForRead					PROTO :DWORD, :DWORD, :DWORD															; ordinal 20
	CsrProbeForWrite					PROTO :DWORD, :DWORD, :DWORD															; ordinal 21
	CsrSetPriorityClass				PROTO :DWORD, :DWORD																; ordinal 22
	DbgBreakPoint					PROTO																			; ordinal 23
;	DbgPrint						PROTO 																		; ordinal 24
;	DbgPrintEx						PROTO																			; ordinal 25	; XP
;	DbgPrintReturnControlC				PROTO 																		; ordinal 26
	DbgPrompt						PROTO :DWORD, :DWORD, :DWORD															; ordinal 27
; W2K	DbgSsHandleKmApiMsg				PROTO :DWORD, :DWORD																; W2K
; W2K	DbgSsInitialize					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; W2K
;	DbgQueryDebugFilterState			PROTO																			; ordinal 28	; XP
;	DbgSetDebugFilterState				PROTO																			; ordinal 29	; XP
	DbgUiConnectToDbg					PROTO																			; ordinal 30
	DbgUiContinue					PROTO :DWORD, :DWORD																; ordinal 31
	DbgUiConvertStateChangeSt			PROTO																			; ordinal 32	; XP  
	DbgUiDebugActiveProcess				PROTO																			; ordinal 33	; XP
	DbgUiGetThreadDebugObject			PROTO																			; ordinal 34	; XP
	DbgUiIssueRemoteBreaking			PROTO																			; ordinal 35	; XP
	DbgUiRemoteBreakin				PROTO																			; ordinal 36	; XP
	DbgUiSetThreadDebugObject			PROTO																			; ordinal 37	; XP
	DbgUiStopDebugging				PROTO																			; ordinal 38	; XP 
	DbgUiWaitStateChange				PROTO :DWORD, :DWORD																; ordinal 39
	DbgUserBreakPoint					PROTO																			; ordinal 40
	KiRaiseUserExceptionDispatcher		PROTO																			; ordinal 41
	KiUserApcDispatcher				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 42
	KiUserCallbackDispatcher			PROTO :DWORD, :DWORD, :DWORD															; ordinal 43
	KiUserExceptionDispatcher			PROTO :DWORD, :DWORD																; ordinal 44
	LdrAccessOutOfProcessResource			PROTO																			; ordinal 45	; XP
	LdrAccessResource					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 46
	LdrAddRefDll					PROTO																			; ordinal 47	; XP
	LdrAlternateResourcesEnabled			PROTO																			; ordinal 48
	LdrCreateOutOfProcessImage			PROTO																			; ordinal 49	; XP
; ?	LdrDestroyOutOfProcessImage			PTOTO																			; ordinal 50	; XP
	LdrDisableThreadCalloutsForDll		PROTO :DWORD																	; ordinal 51
	LdrEnumResources					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 52
	LdrFindCreateProcessManif			PROTO																			; ordinal 53	; XP
	LdrFindEntryForAddress				PROTO :DWORD, :DWORD																; ordinal 54
	LdrFindResourceDirectory_U			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 55
	LdrFindResourceEx_U				PROTO																			; ordinal 56	; XP
	LdrFindResource_U					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 57
	LdrFlushAlternateResourceModules		PROTO																			; ordinal 58
	LdrGetDllHandle					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 59
	LdrGetDllHandleEx					PROTO																			; ordinal 60	; XP
	LdrGetProcedureAddress				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 61
	LdrInitShimEngineDynamic			PROTO																			; ordinal 62	; XP
	LdrInitializeThunk				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 63
	LdrLoadAlternateResourceModule		PROTO :DWORD, :DWORD																; ordinal 64
	LdrLoadDll						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 65
	LdrLockLoaderLock					PROTO																			; ordinal 66	; XP
	LdrProcessRelocationBlock			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 67
	LdrQueryImageFileExecutionOptions		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 68
	LdrQueryProcessModuleInformation		PROTO :DWORD, :DWORD, :DWORD															; ordinal 69
	LdrSetAppCompatDllRedirect			PROTO																			; ordinal 70	; XP
	LdrSetDllManifestProber				PROTO																			; ordinal 71	; XP
	LdrShutdownProcess				PROTO																			; ordinal 72
	LdrShutdownThread					PROTO																			; ordinal 73
	LdrUnloadAlternateResourceModule		PROTO :DWORD																	; ordinal 74
	LdrUnloadDll					PROTO :DWORD																	; ordinal 75
	LdrUnlockLoaderLock				PROTO																			; ordinal 76	; XP
	LdrVerifyImageMatchesChecksum			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 77
; W2K	_NPXEMULATORTABLE					PROTO C																		; W2K
	_NlsAnsiCodePage					PROTO C																		; ordinal 78
	_NlsMbCodePageTag					PROTO C																		; ordinal 79
	_NlsMbOemCodePageTag				PROTO C																		; ordinal 80
	NtAcceptConnectPort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 81
	NtAccessCheck					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 82
	NtAccessCheckAndAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 83
	NtAccessCheckByType				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 84
	NtAccessCheckByTypeAndAuditAlarm		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 85
	NtAccessCheckByTypeResultList			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 86
	NtAccessCheckByTypeResultListAndAuditAlarm		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 87
	NtAccessCheckByTypeResultListAndAuditAlarmByHandle	PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 88
	NtAddAtom						PROTO :DWORD, :DWORD, :DWORD															; ordinal 89
	NtAddBootEntry					PROTO																			; ordinal 90	; XP
	NtAdjustGroupsToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 91
	NtAdjustPrivilegesToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 92
	NtAlertResumeThread				PROTO :DWORD, :DWORD																; ordinal 93
	NtAlertThread					PROTO :DWORD																	; ordinal 94
	NtAllocateLocallyUniqueId			PROTO :DWORD																	; ordinal 95
	NtAllocateUserPhysicalPages			PROTO :DWORD, :DWORD, :DWORD															; ordinal 96
	NtAllocateUuids					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 97
	NtAllocateVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 98
	NtAreMappedFilesTheSame				PROTO :DWORD, :DWORD																; ordinal 99
	NtAssignProcessToJobObject			PROTO :DWORD, :DWORD																; ordinal 100
	NtCallbackReturn					PROTO :DWORD, :DWORD, :DWORD															; ordinal 101
	NtCancelDeviceWakeupRequest			PROTO :DWORD																	; ordinal 102
	NtCancelIoFile					PROTO :DWORD, :DWORD																; ordinal 103
	NtCancelTimer					PROTO :DWORD, :DWORD																; ordinal 104
	NtClearEvent					PROTO :DWORD																	; ordinal 105
	NtClose						PROTO :DWORD																	; ordinal 106
	NtCloseObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD															; ordinal 107
	NtCompactKeys					PROTO																			; ordinal 108	; XP
	NtCompareTokens					PROTO																			; ordinal 109	; XP
	NtCompleteConnectPort				PROTO :DWORD																	; ordinal 110
	NtCompressKey					PROTO																			; ordinal 111	; XP
	NtConnectPort					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 112
	NtContinue						PROTO :DWORD, :DWORD																; ordinal 113
	NtCreateChannel					PROTO :DWORD, :DWORD																; ordinal 114
	NtCreateDirectoryObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 115
	NtCreateEvent					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 116
	NtCreateEventPair					PROTO :DWORD, :DWORD, :DWORD															; ordinal 227
	NtCreateFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 118
	NtCreateIoCompletion				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 119
	NtCreateJobObject					PROTO :DWORD, :DWORD, :DWORD															; ordinal 120
	NtCreateJobSet					PROTO																			; ordinal 121	; XP
	NtCreateKey						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 122
	NtCreateKeyedEvent				PROTO																			; ordinal 123	; XP
	NtCreateMailslotFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 124
	NtCreateMutant					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 125
	NtCreateNamedPipeFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 126
	NtCreatePagingFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 127
	NtCreatePort					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 128
	NtCreateProcess					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 129
	NtCreateProcessEx					PROTO																			; ordinal 130	; XP
	NtCreateProfile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 131
	NtCreateSection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 132
	NtCreateSemaphore					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 133
	NtCreateSymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 134
	NtCreateThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 135
	NtCreateTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 136
	NtCreateToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 137
	NtCreateWaitablePort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 138
	NtCurrentTeb					PROTO																			; ordinal 139
	NtDebugActiveProcess				PROTO																			; ordinal 140	; XP
	NtDebugContinue					PROTO																			; ordinal 141	; XP
	NtDelayExecution					PROTO :DWORD, :DWORD																; ordinal 142
	NtDeleteAtom					PROTO :DWORD																	; ordinal 143
	NtDeleteBootEntry					PROTO																			; ordinal 144	; XP
	NtDeleteFile					PROTO :DWORD																	; ordinal 145
	NtDeleteKey						PROTO :DWORD																	; ordinal 146
	NtDeleteObjectAuditAlarm			PROTO :DWORD, :DWORD, :DWORD															; ordinal 147
	NtDeleteValueKey					PROTO :DWORD, :DWORD																; ordinal 148
	NtDeviceIoControlFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 149
	NtDisplayString					PROTO :DWORD																	; ordinal 150
	NtDuplicateObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 151
	NtDuplicateToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 152
	NtEnumerateBootEntries				PROTO																			; ordinal 153	; XP
	NtEnumerateKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 154
	NtEnumerateSystemEnvironmentValuesEx	PROTO																			; ordinal 155	; XP
	NtEnumerateValueKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 156
	NtExtendSection					PROTO :DWORD, :DWORD																; ordinal 157
	NtFilterToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 158
	NtFindAtom						PROTO :DWORD, :DWORD, :DWORD															; ordinal 159
	NtFlushBuffersFile				PROTO :DWORD, :DWORD																; ordinal 160
	NtFlushInstructionCache				PROTO :DWORD, :DWORD, :DWORD															; ordinal 161
	NtFlushKey						PROTO :DWORD																	; ordinal 162
	NtFlushVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 163
	NtFlushWriteBuffer				PROTO																			; ordinal 164
	NtFreeUserPhysicalPages				PROTO :DWORD, :DWORD, :DWORD															; ordinal 165
	NtFreeVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 166
	NtFsControlFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 167
	NtGetContextThread				PROTO :DWORD, :DWORD																; ordinal 168
	NtGetDevicePowerState				PROTO :DWORD, :DWORD																; ordinal 169
	NtGetPlugPlayEvent				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 170
; W2K	NtGetTickCount					PROTO																			; W2K
	NtGetWriteWatch					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 171
	NtImpersonateAnonymousToken			PROTO :DWORD																	; ordinal 172
	NtImpersonateClientOfPort			PROTO :DWORD, :DWORD																; ordinal 173
	NtImpersonateThread				PROTO :DWORD, :DWORD, :DWORD															; ordinal 174
	NtInitializeRegistry				PROTO :DWORD																	; ordinal 175
	NtInitiatePowerAction				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 176
	NtIsProcessInJob					PROTO																			; ordinal 177	; XP
	NtIsSystemResumeAutomatic			PROTO																			; ordinal 178
; W2K	NtListenChannel					PROTO :DWORD, :DWORD																; W2K
	NtListenPort					PROTO :DWORD, :DWORD																; ordinal 179
	NtLoadDriver					PROTO :DWORD																	; ordinal 180
	NtLoadKey2						PROTO :DWORD, :DWORD, :DWORD															; ordinal 181
	NtLoadKey						PROTO :DWORD, :DWORD																; ordinal 182
	NtLockFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 183
	NtLockProductActivationKeys			PROTO 																		; ordinal 184	; XP
	NtLockRegistryKey					PROTO																			; ordinal 185	; XP
	NtLockVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 186
;	NtMakePermanentObject				PROTO																			; ordinal 187	; XP
	NtMakeTemporaryObject				PROTO :DWORD																	; ordinal 188
	NtMapUserPhysicalPages				PROTO :DWORD, :DWORD, :DWORD															; ordinal 189
	NtMapUserPhysicalPagesScatter			PROTO :DWORD, :DWORD, :DWORD															; ordinal 190
	NtMapViewOfSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 191
	NtModifyBootEntry					PROTO 																		; ordinal 192	; XP
	NtNotifyChangeDirectoryFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 193
	NtNotifyChangeKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 194
	NtNotifyChangeMultipleKeys			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 195
; W2K	NtOpenChannel					PROTO :DWORD, :DWORD																; W2K
	NtOpenDirectoryObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 196
	NtOpenEvent						PROTO :DWORD, :DWORD, :DWORD															; ordinal 197
	NtOpenEventPair					PROTO :DWORD, :DWORD, :DWORD															; ordinal 198
	NtOpenFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 199
	NtOpenIoCompletion				PROTO :DWORD, :DWORD, :DWORD															; ordinal 200
	NtOpenJobObject					PROTO :DWORD, :DWORD, :DWORD															; ordinal 201
	NtOpenKey						PROTO :DWORD, :DWORD, :DWORD															; ordinal 202
	NtOpenKeyedEvent					PROTO																			; ordinal 203	; XP
	NtOpenMutant					PROTO :DWORD, :DWORD, :DWORD															; ordinal 204
	NtOpenObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 205
	NtOpenProcess					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 206
	NtOpenProcessToken				PROTO :DWORD, :DWORD, :DWORD															; ordinal 207
;	NtOpenProcessTokenEx				PROTO																			; ordinal 208	; XP
	NtOpenSection					PROTO :DWORD, :DWORD, :DWORD															; ordinal 209
	NtOpenSemaphore					PROTO :DWORD, :DWORD, :DWORD															; ordinal 210
	NtOpenSymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD															; ordinal 211
	NtOpenThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 212
	NtOpenThreadToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 213
;	NtOpenThreadTokenEx				PROTO																			; ordinal 214	; XP
	NtOpenTimer						PROTO :DWORD, :DWORD, :DWORD															; ordinal 215
	NtPlugPlayControl					PROTO :DWORD, :DWORD, :DWORD															; ordinal 216
	NtPowerInformation				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 217
	NtPrivilegeCheck					PROTO :DWORD, :DWORD, :DWORD															; ordinal 218
	NtPrivilegeObjectAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 219
	NtPrivilegedServiceAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 220
	NtProtectVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 221
	NtPulseEvent					PROTO :DWORD, :DWORD																; ordinal 222
	NtQueryAttributesFile				PROTO :DWORD, :DWORD																; ordinal 223
	NtQueryBootEntryOrder				PROTO																			; ordinal 224	; XP
	NtQueryBootOptions				PROTO																			; ordinal 225	; XP
	NtQueryDebugFilterState				PROTO																			; ordinal 226	; XP
	NtQueryDefaultLocale				PROTO :DWORD, :DWORD																; ordinal 227
	NtQueryDefaultUILanguage			PROTO :DWORD																	; ordinal 228
	NtQueryDirectoryFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 229
	NtQueryDirectoryObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 230
	NtQueryEaFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 231
	NtQueryEvent					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 232
	NtQueryFullAttributesFile			PROTO :DWORD, :DWORD																; ordinal 233
	NtQueryInformationAtom				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 234
	NtQueryInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 235
	NtQueryInformationJobObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 236
	NtQueryInformationPort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 237
	NtQueryInformationProcess			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 238
	NtQueryInformationThread			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 239
	NtQueryInformationToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 240
	NtQueryInstallUILanguage			PROTO :DWORD																	; ordinal 241
	NtQueryIntervalProfile				PROTO :DWORD, :DWORD																; ordinal 242
	NtQueryIoCompletion				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 243
	NtQueryKey						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 244
	NtQueryMultipleValueKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 245
	NtQueryMutant					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 246
	NtQueryObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 247
	NtQueryOpenSubKeys				PROTO :DWORD, :DWORD																; ordinal 248
	NtQueryPerformanceCounter			PROTO :DWORD, :DWORD																; ordinal 249
	NtQueryPortInformationProcess			PROTO																			; ordinal 250	; XP
	NtQueryQuotaInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 251
	NtQuerySection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 252
	NtQuerySecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 253
	NtQuerySemaphore					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 254
	NtQuerySymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD															; ordinal 255
	NtQuerySystemEnvironmentValue			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 256
	NtQuerySystemEnvironmentValueEx		PROTO 																		; ordinal 257	; XP
	NtQuerySystemInformation			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 258
	NtQuerySystemTime					PROTO :DWORD																	; ordinal 259
	NtQueryTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 260
	NtQueryTimerResolution				PROTO :DWORD, :DWORD, :DWORD															; ordinal 261
	NtQueryValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 262
	NtQueryVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 263
	NtQueryVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 264
	NtQueueApcThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 265
	NtRaiseException					PROTO :DWORD, :DWORD, :DWORD															; ordinal 266
	NtRaiseHardError					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 267
	NtReadFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 268
	NtReadFileScatter					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 279
	NtReadRequestData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 270
	NtReadVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 271
	NtRegisterThreadTerminatePort			PROTO :DWORD																	; ordinal 272
	NtReleaseKeyedEvent				PROTO																			; ordinal 273	; XP
	NtReleaseMutant					PROTO :DWORD, :DWORD																; ordinal 274
	NtReleaseSemaphore				PROTO :DWORD, :DWORD, :DWORD															; ordinal 275
	NtRemoveIoCompletion				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 276
	NtRemoveProcessDebug				PROTO																			; ordinal 277	; XP
	NtRenameKey						PROTO																			; ordinal 278	; XP
	NtReplaceKey					PROTO :DWORD, :DWORD, :DWORD															; ordinal 279
	NtReplyPort						PROTO :DWORD, :DWORD																; ordinal 280
	NtReplyWaitReceivePort				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 281
	NtReplyWaitReceivePortEx			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 282
	NtReplyWaitReplyPort				PROTO :DWORD, :DWORD																; ordinal 283
; W2K	NtReplyWaitSendChannel				PROTO :DWORD, :DWORD, :DWORD															; W2K
	NtRequestDeviceWakeup				PROTO :DWORD																	; ordinal 284
	NtRequestPort					PROTO :DWORD, :DWORD																; ordinal 285
	NtRequestWaitReplyPort				PROTO :DWORD, :DWORD, :DWORD															; ordinal 286
	NtRequestWakeupLatency				PROTO :DWORD																	; ordinal 287
	NtResetEvent					PROTO :DWORD, :DWORD																; ordinal 288
	NtResetWriteWatch					PROTO :DWORD, :DWORD, :DWORD															; ordinal 289
	NtRestoreKey					PROTO :DWORD, :DWORD, :DWORD															; ordinal 290
	NtResumeProcess					PROTO																			; ordinal 291	; XP
	NtResumeThread					PROTO :DWORD, :DWORD																; ordinal 292
	NtSaveKey						PROTO :DWORD, :DWORD																; ordinal 293
	NtSaveKeyEx						PROTO																			; ordinal 294	; XP
	NtSaveMergedKeys					PROTO :DWORD, :DWORD, :DWORD															; ordinal 295
	NtSecureConnectPort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 296
; W2K	NtSendWaitReplyChannel				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; W2K
	NtSetBootEntryOrder				PROTO																			; ordinal 297	; XP
	NtSetBootOptions					PROTO																			; ordinal 298	; XP
	NtSetContextChannel				PROTO :DWORD																	; ordinal 299
	NtSetContextThread				PROTO :DWORD, :DWORD																; ordinal 300
	NtSetDefaultHardErrorPort			PROTO :DWORD																	; ordinal 301
	NtSetDefaultLocale				PROTO :DWORD, :DWORD																; ordinal 302
	NtSetDefaultUILanguage				PROTO :DWORD																	; ordinal 303
	NtSetEaFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 304
	NtSetEvent						PROTO :DWORD, :DWORD																; ordinal 305
	NtSetEventBoostPriority				PROTO																			; ordinal 306	; XP
	NtSetHighEventPair				PROTO :DWORD																	; ordinal 307
	NtSetHighWaitLowEventPair			PROTO :DWORD																	; ordinal 308
	NtSetInformationDebugObject			PROTO																			; ordinal 309	; XP
	NtSetInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 310
	NtSetInformationJobObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 311
	NtSetInformationKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 312
	NtSetInformationObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 313
	NtSetInformationProcess				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 314
	NtSetInformationThread				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 315
	NtSetInformationToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 316
	NtSetIntervalProfile				PROTO :DWORD, :DWORD																; ordinal 317
	NtSetIoCompletion					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 318
	NtSetLdtEntries					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 319
	NtSetLowEventPair					PROTO :DWORD																	; ordinal 320
	NtSetLowWaitHighEventPair			PROTO :DWORD																	; ordinal 321
	NtSetQuotaInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 322
	NtSetSecurityObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 323
	NtSetSystemEnvironmentValue			PROTO :DWORD, :DWORD																; ordinal 324
	NtSetSystemEnvironmentValueEx			PROTO																			; ordinal 325	; XP
	NtSetSystemInformation				PROTO :DWORD, :DWORD, :DWORD															; ordinal 326
	NtSetSystemPowerState				PROTO :DWORD, :DWORD, :DWORD															; ordinal 327
	NtSetSystemTime					PROTO :DWORD, :DWORD																; ordinal 328
	NtSetThreadExecutionState			PROTO :DWORD, :DWORD																; ordinal 329
	NtSetTimer						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 330
	NtSetTimerResolution				PROTO :DWORD, :DWORD, :DWORD															; ordinal 331
	NtSetUuidSeed					PROTO :DWORD																	; ordinal 332
	NtSetValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 333
	NtSetVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 334
;	NtShutdownSystem					PROTO :DWORD																	; ordinal 335
	NtSignalAndWaitForSingleObject		PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 336
	NtStartProfile					PROTO :DWORD																	; ordinal 337
	NtStopProfile					PROTO :DWORD																	; ordinal 338
	NtSuspendProcess					PROTO 																		; ordinal 339	; XP
	NtSuspendThread					PROTO :DWORD, :DWORD																; ordinal 340
	NtSystemDebugControl				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 341
	NtTerminateJobObject				PROTO :DWORD, :DWORD																; ordinal 342
	NtTerminateProcess				PROTO :DWORD, :DWORD																; ordinal 343
	NtTerminateThread					PROTO :DWORD, :DWORD																; ordinal 344
	NtTestAlert						PROTO																			; ordinal 345
;	NtTraceEvent					PROTO																			; ordinal 346	; XP
	NtTranslateFilePath				PROTO																			; ordinal 347	; XP
	NtUnloadDriver					PROTO :DWORD																	; ordinal 348
	NtUnloadKey						PROTO :DWORD																	; ordinal 349
	NtUnloadKeyEx					PROTO																			; ordinal 350	; XP
	NtUnlockFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 351
	NtUnlockVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 352
	NtUnmapViewOfSection				PROTO :DWORD, :DWORD																; ordinal 353
	NtVdmControl					PROTO :DWORD, :DWORD																; ordinal 354
	NtWaitForDebugEvent				PROTO																			; ordinal 355	; XP
	NtWaitForKeyedEvent				PROTO																			; ordinal 356	; XP
	NtWaitForMultipleObjects			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 357
	NtWaitForSingleObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 358
	NtWaitHighEventPair				PROTO :DWORD																	; ordinal 359
	NtWaitLowEventPair				PROTO :DWORD																	; ordinal 360
	NtWriteFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 361
	NtWriteFileGather					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 362
	NtWriteRequestData				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 363
	NtWriteVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 364
	NtYieldExecution					PROTO																			; ordinal 365
	PfxFindPrefix					PROTO :DWORD, :DWORD																; ordinal 366
	PfxInitialize					PROTO :DWORD																	; ordinal 367
	PfxInsertPrefix					PROTO :DWORD, :DWORD, :DWORD															; ordinal 368
	PfxRemovePrefix					PROTO :DWORD, :DWORD																; ordinal 369
	RestoreEm87Context				PROTO C																		; ordinal 370
	RtlAbortRXact					PROTO :DWORD																	; ordinal 371
	RtlAbsoluteToSelfRelativeSD			PROTO :DWORD, :DWORD, :DWORD															; ordinal 372
	RtlAcquirePebLock					PROTO																			; ordinal 373
	RtlAcquireResourceExclusive			PROTO :DWORD, :DWORD																; ordinal 374
	RtlAcquireResourceShared			PROTO :DWORD, :DWORD																; ordinal 375
	RtlActivateActivationContext			PROTO																			; ordinal 376	; XP
	RtlActivateActivationContextEx		PROTO																			; ordinal 377	; XP
	RtlActivateActivationContextUnsafeFast	PROTO																			; ordinal 378	; XP
	RtlAddAccessAllowedAce				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 379
	RtlAddAccessAllowedAceEx			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 380
	RtlAddAccessAllowedObjectAce			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 381
	RtlAddAccessDeniedAce				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 382
	RtlAddAccessDeniedAceEx				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 383
	RtlAddAccessDeniedObjectAce			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 384
	RtlAddAce						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 385
	RtlAddActionToRXact				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 386
	RtlAddAtomToAtomTable				PROTO :DWORD, :DWORD, :DWORD															; ordinal 387
	RtlAddAttributeActionToRXact			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 388
	RtlAddAuditAccessAce				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 389
	RtlAddAuditAccessAceEx				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 390
	RtlAddAuditAccessObjectAce			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 391
	RtlAddCompoundAce					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 392
	RtlAddRange						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 393
	RtlAddRefActivationContex			PROTO																			; ordinal 394	; XP
	RtlAddRefMemoryStream				PROTO																			; ordinal 395	; XP
	RtlAddVectoredExceptionHandler		PROTO																			; ordinal 396	; XP
	RtlAddressInSectionTable			PROTO																			; ordinal 397	; XP
	RtlAdjustPrivilege				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 398
	RtlAllocateAndInitializeSid			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 399
	RtlAllocateHandle					PROTO :DWORD, :DWORD																; ordinal 400
	RtlAllocateHeap					PROTO :DWORD, :DWORD, :DWORD															; ordinal 401
	RtlAnsiCharToUnicodeChar			PROTO :DWORD																	; ordinal 402
	RtlAnsiStringToUnicodeSize			PROTO :DWORD																	; ordinal 403
	RtlAnsiStringToUnicodeString			PROTO :DWORD, :DWORD, :DWORD 															; ordinal 404
	RtlAppendAsciizToString				PROTO :DWORD, :DWORD																; ordinal 405
	RtlAppendPathElement				PROTO																			; ordinal 406	; XP
	RtlAppendStringToString				PROTO :DWORD, :DWORD																; ordinal 407
	RtlAppendUnicodeStringToString		PROTO :DWORD, :DWORD																; ordinal 408
	RtlAppendUnicodeToString			PROTO :DWORD, :DWORD																; ordinal 409
	RtlApplicationVerifierStop			PROTO																			; ordinal 410	; XP
	RtlApplyRXact					PROTO :DWORD																	; ordinal 411
	RtlApplyRXactNoFlush				PROTO :DWORD																	; ordinal 412
	RtlAreAllAccessesGranted			PROTO :DWORD, :DWORD																; ordinal 413
	RtlAreAnyAccessesGranted			PROTO :DWORD, :DWORD																; ordinal 414
	RtlAreBitsClear					PROTO :DWORD, :DWORD, :DWORD															; ordinal 415
	RtlAreBitsSet					PROTO :DWORD, :DWORD, :DWORD															; ordinal 416
	RtlAssert2						PROTO 																		; ordinal 417	; XP
	RtlAssert						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 418
; W2K	RtlCallbackLpcClient				PROTO :DWORD, :DWORD, :DWORD															; W2K
	RtlCancelTimer					PROTO :DWORD, :DWORD																; ordinal 419
	RtlCaptureContext					PROTO																			; ordinal 420	; XP
	RtlCaptureStackBackTrace			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 421
	RtlCaptureStackContext				PROTO																			; ordinal 422	; XP
	RtlCharToInteger					PROTO :DWORD, :DWORD, :DWORD															; ordinal 423
	RtlCheckForOrphanedCriticalSections		PROTO :DWORD																	; ordinal 424
	RtlCheckProcessParameters			PROTO																			; ordinal 425	; XP
	RtlCheckRegistryKey				PROTO :DWORD, :DWORD																; ordinal 426
	RtlClearAllBits					PROTO :DWORD																	; ordinal 427
	RtlClearBits					PROTO :DWORD, :DWORD, :DWORD															; ordinal 428
	RtlCloneMemoryStream				PROTO																			; ordinal 429	; XP
	RtlCommitMemoryStream				PROTO																			; ordinal 430	; XP
	RtlCompactHeap					PROTO :DWORD, :DWORD																; ordinal 431
	RtlCompareMemory					PROTO :DWORD, :DWORD, :DWORD															; ordinal 432
	RtlCompareMemoryUlong				PROTO :DWORD, :DWORD, :DWORD															; ordinal 433
	RtlCompareString					PROTO :DWORD, :DWORD, :DWORD															; ordinal 434
	RtlCompareUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 435
	RtlCompressBuffer					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 436
	RtlComputeCrc32					PROTO																			; ordinal 437	; XP
	RtlComputeImportTableHash			PROTO																			; ordinal 438	; XP
	RtlComputePrivatizedDllName_U			PROTO																			; ordinal 439	; XP
	RtlConsoleMultiByteToUnicodeN			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 440
	RtlConvertExclusiveToShared			PROTO :DWORD																	; ordinal 441
	RtlConvertLongToLargeInteger			PROTO :DWORD																	; ordinal 442
	RtlConvertSharedToExclusive			PROTO :DWORD																	; ordinal 443
	RtlConvertSidToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 444
	RtlConvertToAutoInheritSecurityObject	PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 445
	RtlConvertUiListToApiList			PROTO :DWORD, :DWORD, :DWORD															; ordinal 446
	RtlConvertUlongToLargeInteger			PROTO :DWORD																	; ordinal 447
	RtlCopyLuid						PROTO :DWORD, :DWORD																; ordinal 448
	RtlCopyLuidAndAttributesArray			PROTO :DWORD, :DWORD, :DWORD															; ordinal 449
	RtlCopyMemoryStreamTo				PROTO																			; ordinal 450	; XP
	RtlCopyOutOfProcessMemory			PROTO																			; ordinal 451	; XP
	RtlCopyRangeList					PROTO :DWORD, :DWORD																; ordinal 452
	RtlCopySecurityDescriptor			PROTO :DWORD, :DWORD																; ordinal 453
	RtlCopySid						PROTO :DWORD, :DWORD, :DWORD															; ordinal 454
	RtlCopySidAndAttributesArray			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 455
	RtlCopyString					PROTO :DWORD, :DWORD																; ordinal 456
	RtlCopyUnicodeString				PROTO :DWORD, :DWORD																; ordinal 457
	RtlCreateAcl					PROTO :DWORD, :DWORD, :DWORD															; ordinal 458
	RtlCreateActivationContext			PROTO																			; ordinal 459	; XP
	RtlCreateAndSetSD					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 460
	RtlCreateAtomTable				PROTO :DWORD, :DWORD																; ordinal 461
	RtlCreateBootStatusDataFile			PROTO																			; ordinal 462	; XP
	RtlCreateEnvironment				PROTO :DWORD, :DWORD																; ordinal 463
	RtlCreateHeap					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 464
	RtlCreateLpcServer				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 465
	RtlCreateProcessParameters			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 466
	RtlCreateQueryDebugBuffer			PROTO :DWORD, :DWORD																; ordinal 467
	RtlCreateRegistryKey				PROTO :DWORD, :DWORD																; ordinal 468
	RtlCreateSecurityDescriptor			PROTO :DWORD, :DWORD																; ordinal 469
	RtlCreateTagHeap					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 470
	RtlCreateTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 471
	RtlCreateTimerQueue				PROTO :DWORD																	; ordinal 472
	RtlCreateUnicodeString				PROTO :DWORD, :DWORD																; ordinal 473
	RtlCreateUnicodeStringFromAsciiz		PROTO :DWORD, :DWORD																; ordinal 474
	RtlCreateUserProcess				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 475
	RtlCreateUserSecurityObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 476
	RtlCreateUserThread				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 477
	RtlCustomCPToUnicodeN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 478
	RtlCutoverTimeToSystemTime			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 479
	RtlDeNormalizeProcessParams			PROTO :DWORD																	; ordinal 480
	RtlDeactivateActivationContext		PROTO 																		; ordinal 481	; XP
	RtlDeactivateActivationContextUnsafeFast	PROTO																			; ordinal 482	; XP
	RtlDebugPrintTimes				PROTO																			; ordinal 483
	RtlDecompressBuffer				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 484
	RtlDecompressFragment				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 485
	RtlDefaultNpAcl					PROTO :DWORD																	; ordinal 486
	RtlDelete						PROTO :DWORD																	; ordinal 487
	RtlDeleteAce					PROTO :DWORD, :DWORD																; ordinal 488
	RtlDeleteAtomFromAtomTable			PROTO :DWORD, :DWORD																; ordinal 489
	RtlDeleteCriticalSection			PROTO :DWORD																	; ordinal 490
	RtlDeleteElementGenericTable			PROTO :DWORD, :DWORD																; ordinal 491
	RtlDeleteElementGenericTableAvl		PROTO																			; ordinal 492	; XP
	RtlDeleteNoSplay					PROTO :DWORD, :DWORD																; ordinal 493
	RtlDeleteOwnersRanges				PROTO :DWORD, :DWORD																; ordinal 494
	RtlDeleteRange					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 495
	RtlDeleteRegistryValue				PROTO :DWORD, :DWORD, :DWORD															; ordinal 496
	RtlDeleteResource					PROTO :DWORD																	; ordinal 497
	RtlDeleteSecurityObject				PROTO :DWORD																	; ordinal 498
	RtlDeleteTimer					PROTO :DWORD, :DWORD, :DWORD															; ordinal 499
	RtlDeleteTimerQueue				PROTO :DWORD																	; ordinal 500
	RtlDeleteTimerQueueEx				PROTO :DWORD, :DWORD																; ordinal 501
	RtlDeregisterWait					PROTO :DWORD																	; ordinal 502
	RtlDeregisterWaitEx				PROTO :DWORD, :DWORD																; ordinal 503
	RtlDestroyAtomTable				PROTO :DWORD																	; ordinal 504
	RtlDestroyEnvironment				PROTO :DWORD																	; ordinal 505
	RtlDestroyHandleTable				PROTO :DWORD																	; ordinal 506
	RtlDestroyHeap					PROTO :DWORD																	; ordinal 507
	RtlDestroyProcessParameters			PROTO :DWORD																	; ordinal 508
	RtlDestroyQueryDebugBuffer			PROTO :DWORD																	; ordinal 509
	RtlDetermineDosPathNameType_U			PROTO :DWORD																	; ordinal 510
	RtlDllShutdownInProgress			PROTO																			; ordinal 511	; XP
	RtlDnsHostNameToComputerName			PROTO :DWORD, :DWORD, :DWORD															; ordinal 512
	RtlDoesFileExists_U				PROTO :DWORD																	; ordinal 513
	RtlDosApplyFileIsolationRedirection_Ustr	PROTO																			; ordinal 514	; XP
	RtlDosPathNameToNtPathName_U			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 515
	RtlDosSearchPath_U				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 516
	RtlDosSearchPath_Ustr				PROTO 																		; ordinal 517	; XP
	RtlDowncaseUnicodeChar				PROTO																			; ordinal 518	; XP
	RtlDowncaseUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 519
	RtlDumpResource					PROTO :DWORD																	; ordinal 520
	RtlDuplicateUnicodeString			PROTO																			; ordinal 521	; XP
	RtlEmptyAtomTable					PROTO :DWORD, :DWORD																; ordinal 522
	RtlEnableEarlyCriticalSectionEventCreation	PROTO																		; ordinal 523
	RtlEnlargedIntegerMultiply			PROTO :DWORD, :DWORD																; ordinal 524
	RtlEnlargedUnsignedDivide			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 525
	RtlEnlargedUnsignedMultiply			PROTO :DWORD, :DWORD																; ordinal 526
	RtlEnterCriticalSection				PROTO :DWORD																	; ordinal 527
	RtlEnumProcessHeaps				PROTO :DWORD, :DWORD																; ordinal 528
	RtlEnumerateGenericTable			PROTO :DWORD, :DWORD																; ordinal 529
	RtlEnumerateGenericTableAvl			PROTO																			; ordinal 530	; XP
	RtlEnumerateGenericTableLikeADirectory	PROTO																			; ordinal 531	; XP
	RtlEnumerateGenericTableWithoutSplaying	PROTO :DWORD, :DWORD																; ordinal 532
	RtlEnumerateGenericTableWithoutSplayingAvl	PROTO																		; ordinal 533	; XP
	RtlEqualComputerName				PROTO :DWORD, :DWORD																; ordinal 534
	RtlEqualDomainName				PROTO :DWORD, :DWORD																; ordinal 535
	RtlEqualLuid					PROTO :DWORD, :DWORD																; ordinal 536
	RtlEqualPrefixSid					PROTO :DWORD, :DWORD																; ordinal 537
	RtlEqualSid						PROTO :DWORD, :DWORD																; ordinal 538
	RtlEqualString					PROTO :DWORD, :DWORD, :DWORD															; ordinal 539
	RtlEqualUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 540
	RtlEraseUnicodeString				PROTO :DWORD																	; ordinal 541
	RtlExitUserThread					PROTO 																		; ordinal 542	; XP
	RtlExpandEnvironmentStrings_U			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 543
	RtlExtendHeap					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 544
	RtlExtendedIntegerMultiply			PROTO :DWORD, :DWORD, :DWORD															; ordinal 545
	RtlExtendedLargeIntegerDivide			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 546
	RtlExtendedMagicDivide				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 547
;	RtlFillMemory					PROTO :DWORD, :DWORD, :DWORD															; ordinal 548
	RtlFillMemoryUlong				PROTO :DWORD, :DWORD, :DWORD															; ordinal 549
	RtlFinalReleaseOutOfProce			PROTO																			; ordinal 550	; XP
; ?	RtlFindActivationContextSectionGuid		PROTO																			; ordinal 551	; XP
; ?	RtlFindActivationContextSectionString	PROTO																			; ordinal 552 	; XP
	RtlFindCharInUnicodeString			PROTO																			; ordinal 553	; XP
	RtlFindClearBits					PROTO :DWORD, :DWORD, :DWORD															; ordinal 554
	RtlFindClearBitsAndSet				PROTO :DWORD, :DWORD, :DWORD															; ordinal 555
	RtlFindClearRuns					PROTO																			; ordinal 556	; XP
	RtlFindLastBackwardRunClear			PROTO :DWORD, :DWORD, :DWORD															; ordinal 557
	RtlFindLeastSignificantBit			PROTO :DWORD, :DWORD																; ordinal 558
	RtlFindLongestRunClear				PROTO :DWORD, :DWORD																; ordinal 559
	RtlFindMessage					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 560
	RtlFindMostSignificantBit			PROTO :DWORD, :DWORD																; ordinal 561
	RtlFindNextForwardRunClear			PROTO :DWORD, :DWORD, :DWORD															; ordinal 562
	RtlFindRange					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 563
	RtlFindSetBits					PROTO :DWORD, :DWORD, :DWORD															; ordinal 564
	RtlFindSetBitsAndClear				PROTO :DWORD, :DWORD, :DWORD															; ordinal 565
	RtlFirstEntrySList				PROTO																			; ordinal 566	; XP
	RtlFirstFreeAce					PROTO :DWORD, :DWORD																; ordinal 567
	RtlFlushSecureMemoryCache			PROTO																			; ordinal 568	; XP
	RtlFormatCurrentUserKeyPath			PROTO :DWORD																	; ordinal 569
	RtlFormatMessage					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 570
	RtlFreeAnsiString					PROTO :DWORD																	; ordinal 571
	RtlFreeHandle					PROTO :DWORD, :DWORD																; ordinal 572
	RtlFreeHeap						PROTO :DWORD, :DWORD, :DWORD															; ordinal 573
	RtlFreeOemString					PROTO :DWORD																	; ordinal 574
	RtlFreeRangeList					PROTO :DWORD																	; ordinal 575
	RtlFreeSid						PROTO :DWORD																	; ordinal 576
	RtlFreeThreadActivationContextStack		PROTO																			; ordinal 577	; XP
	RtlFreeUnicodeString				PROTO :DWORD																	; ordinal 578
	RtlFreeUserThreadStack				PROTO :DWORD, :DWORD																; ordinal 579
	RtlGUIDFromString					PROTO :DWORD, :DWORD																; ordinal 580
	RtlGenerate8dot3Name				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 581
	RtlGetAce						PROTO :DWORD, :DWORD, :DWORD															; ordinal 582
	RtlGetActiveActivationContext			PROTO 																		; ordinal 583	; XP
	RtlGetCallersAddress				PROTO :DWORD, :DWORD																; ordinal 584
	RtlGetCompressionWorkSpaceSize		PROTO :DWORD, :DWORD, :DWORD															; ordinal 585
	RtlGetControlSecurityDescriptor		PROTO :DWORD, :DWORD, :DWORD															; ordinal 586
	RtlGetCurrentDirectory_U			PROTO :DWORD, :DWORD																; ordinal 587
	RtlGetCurrentPeb					PROTO																			; ordinal 588	; XP
	RtlGetDaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 589
	RtlGetElementGenericTable			PROTO :DWORD, :DWORD																; ordinal 590
	RtlGetElementGenericTableAvl			PROTO																			; ordinal 591	; XP
	RtlGetFirstRange					PROTO :DWORD, :DWORD, :DWORD															; ordinal 591
	RtlGetFrame						PROTO																			; ordinal 593	; XP
	RtlGetFullPathName_U				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 594
	RtlGetGroupSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 595 
	RtlGetLastNtStatus				PROTO																			; ordinal 596	; XP
	RtlGetLastWin32Error				PROTO 																		; ordinal 597	; XP
	RtlGetLengthWithoutLastFullDosOrNtPathElement	PROTO																		; ordinal 598	; XP
	RtlGetLengthWithoutTrailingPathSeperators	PROTO																			; ordianl 599	; XP
	RtlGetLongestNtPathLength			PROTO																			; ordinal 600
	RtlGetNativeSystemInformation			PROTO																			; ordinal 601	; XP
	RtlGetNextRange					PROTO :DWORD, :DWORD, :DWORD															; ordinal 602
	RtlGetNtGlobalFlags				PROTO																			; ordinal 603
	RtlGetNtProductType				PROTO :DWORD																	; ordinal 604
	RtlGetNtVersionNumbers				PROTO																			; ordinal 605	; XP
	RtlGetOwnerSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 606
	RtlGetProcessHeaps				PROTO :DWORD, :DWORD																; ordinal 607
	RtlGetSaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 608
	RtlGetSecurityDescriptorRMControl		PROTO :DWORD, :DWORD																; ordinal 609
;	RtlGetSetBootStatusData				PROTO																			; ordinal 610	; XP
	RtlGetUserInfoHeap				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 611
;	RtlGetVersion					PROTO :DWORD																	; ordinal 612
	RtlHashUnicodeString				PROTO																			; ordinal 613	; XP
	RtlIdentifierAuthoritySid			PROTO :DWORD																	; ordinal 614
	RtlImageDirectoryEntryToData			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 615
	RtlImageNtHeader					PROTO :DWORD																	; ordinal 616
	RtlImageRvaToSection				PROTO :DWORD, :DWORD, :DWORD															; ordinal 617
	RtlImageRvaToVa					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 618
; W2K	RtlImpersonateLpcClient				PROTO :DWORD, :DWORD																; W2k
	RtlImpersonateSelf				PROTO :DWORD																	; ordinal 619
	RtlInitAnsiString					PROTO :DWORD, :DWORD																; ordinal 620
	RtlInitCodePageTable				PROTO :DWORD, :DWORD																; ordinal 621
	RtlInitMemoryStream				PROTO																			; ordinal 622	; XP
	RtlInitNlsTables					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 623
	RtlInitOutOfProcessMemoryStream		PROTO																			; ordinal 624	; XP
	RtlInitString					PROTO :DWORD, :DWORD																; ordinal 625
	RtlInitUnicodeString				PROTO :DWORD, :DWORD																; ordinal 626
	RtlInitUnicodeStringEx				PROTO 																		; ordinal 627	; XP
	RtlInitializeAtomPackage			PROTO :DWORD																	; ordinal 628
	RtlInitializeBitMap				PROTO :DWORD, :DWORD, :DWORD															; ordinal 629
	RtlInitializeContext				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 630
	RtlInitializeCriticalSection			PROTO :DWORD																	; ordinal 631
	RtlInitializeCriticalSectionAndSpinCount	PROTO :DWORD, :DWORD																; ordinal 632
	RtlInitializeGenericTable			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 633
	RtlInitializeGenericTableAvl			PROTO																			; ordinal 634	; XP
	RtlInitializeHandleTable			PROTO :DWORD, :DWORD, :DWORD															; ordinal 635
	RtlInitializeRXact				PROTO :DWORD, :DWORD, :DWORD															; ordinal 636
	RtlInitializeRangeList				PROTO :DWORD																	; ordinal 637
	RtlInitializeResource				PROTO :DWORD																	; ordinal 638
	RtlInitializeSListHead				PROTO																			; ordinal 639	; XP
	RtlInitializeSid					PROTO :DWORD, :DWORD, :DWORD															; ordinal 640
	RtlInsertElementGenericTable			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 641
	RtlInsertElementGenericTableAvl		PROTO																			; ordinal 642	; XP
	RtlInt64ToUnicodeString				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 643
	RtlIntegerToChar					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 644
	RtlIntegerToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 645 
	RtlInterlockedFlushSList			PROTO																			; ordinal 646	; XP
	RtlInterlockedPopEntrySList			PROTO																			; ordinal 647	; XP
	RtlInterlockedPushEntrySList			PROTO																			; ordinal 648	; XP
	RtlInvertRangeList				PROTO :DWORD, :DWORD																; ordinal 649
;	RtlIpv4AddressToStringA				PROTO																			; ordinal 650	; XP
;	RtlIpv4AddressToStringW				PROTO																			; ordinal 651	; XP
;	RtlIpv4StringToAddressA				PROTO																			; ordinal 652	; XP
;	RtlIpv4StringToAddressW				PROTO																			; ordinal 653	; XP
;	RtlIpv6AddressToStringA				PROTO																			; ordinal 654	; XP
;	RtlIpv6AddressToStringW				PROTO																			; ordinal 655	; XP
;	RtlIpv6StringToAddressA				PROTO																			; ordinal 656	; XP
;	RtlIpv6StringToAddressW				PROTO																			; ordinal 657	; XP
	RtlIsActivationContextActive			PROTO																			; ordinal 658	; XP
	RtlIsDosDeviceName_U				PROTO :DWORD																	; ordinal 659
	RtlIsGenericTableEmpty				PROTO :DWORD																	; ordinal 660
;	RtlIsGenericTableEmptyAvl			PROTO																			; ordinal 661	; XP
	RtlIsNameLegalDOS8Dot3				PROTO :DWORD, :DWORD, :DWORD															; ordinal 662
	RtlIsRangeAvailable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 663
	RtlIsTextUnicode					PROTO :DWORD, :DWORD, :DWORD															; ordinal 664
	RtlIsValidHandle					PROTO :DWORD, :DWORD																; ordinal 665
	RtlIsValidIndexHandle				PROTO :DWORD, :DWORD, :DWORD															; ordinal 666
	RtlLargeIntegerAdd				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 667
	RtlLargeIntegerArithmeticShift		PROTO :DWORD, :DWORD, :DWORD															; ordinal 668
	RtlLargeIntegerDivide				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 669
	RtlLargeIntegerNegate				PROTO :DWORD, :DWORD																; ordinal 670
	RtlLargeIntegerShiftLeft			PROTO :DWORD, :DWORD, :DWORD															; ordinal 671
	RtlLargeIntegerShiftRight			PROTO :DWORD, :DWORD, :DWORD															; ordinal 672
	RtlLargeIntegerSubtract				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 673
	RtlLargeIntegerToChar				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 674
	RtlLeaveCriticalSection				PROTO :DWORD																	; ordinal 675
	RtlLengthRequiredSid				PROTO :DWORD																	; ordinal 676
	RtlLengthSecurityDescriptor			PROTO :DWORD																	; ordinal 677
	RtlLengthSid					PROTO :DWORD																	; ordinal 678
	RtlLocalTimeToSystemTime			PROTO :DWORD, :DWORD																; ordinal 679
	RtlLockBootStatusData				PROTO																			; ordinal 680	; XP
	RtlLockHeap						PROTO :DWORD																	; ordinal 681
	RtlLockMemoryStreamRegion			PROTO																			; ordinal 682	; XP
	RtlLogStackBackTrace				PROTO																			; ordinal 683	; XP
	RtlLookupAtomInAtomTable			PROTO :DWORD, :DWORD, :DWORD															; ordinal 684
	RtlLookupElementGenericTable			PROTO :DWORD, :DWORD																; ordinal 685
	RtlLookupElementGenericTableAv1		PROTO																			; ordinal 686	; XP
	RtlMakeSelfRelativeSD				PROTO :DWORD, :DWORD, :DWORD															; ordinal 687
	RtlMapGenericMask					PROTO :DWORD, :DWORD																; ordinal 688
	RtlMapSecurityErrorToNtStatus			PROTO																			; ordinal 689	; XP
	RtlMergeRangeLists				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 690
;	RtlMoveMemory					PROTO :DWORD, :DWORD, :DWORD															; ordinal 691
	RtlMultiAppendUnicodeStringBuffer		PROTO																			; ordinal 692	; XP
	RtlMultiByteToUnicodeN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 693
	RtlMultiByteToUnicodeSize			PROTO :DWORD, :DWORD, :DWORD															; ordinal 694
	RtlNewInstanceSecurityObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 695
	RtlNewSecurityGrantedAccess			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 696
	RtlNewSecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 697
	RtlNewSecurityObjectEx				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 698
	RtlNewSecurityObjectWithMultipleInheritance	PROTO																		; ordinal 699	; XP
	RtlNormalizeProcessParams			PROTO :DWORD																	; ordinal 700
	RtlNtPathNameToDosPathName			PROTO																			; ordinal 701	; XP
	RtlNtStatusToDosError				PROTO :DWORD																	; ordinal 702
	RtlNtStatusToDosErrorNoTeb			PROTO																			; ordinal 703	; XP
	RtlNumberGenericTableElements			PROTO :DWORD																	; ordinal 704
	RtlNumberGenericTableElementsAv1		PROTO																			; ordinal 705	; XP
	RtlNumberOfClearBits				PROTO :DWORD																	; ordinal 706
	RtlNumberOfSetBits				PROTO :DWORD																	; ordinal 707
	RtlOemStringToUnicodeSize			PROTO :DWORD																	; ordinal 708
	RtlOemStringToUnicodeString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 709
	RtlOemToUnicodeN					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 710
	RtlOpenCurrentUser				PROTO :DWORD, :DWORD																; ordinal 711
	RtlPcToFileHeader					PROTO :DWORD, :DWORD																; ordinal 712
	RtlPinAtomInAtomTable				PROTO :DWORD, :DWORD																; ordinal 713
	RtlPopFrame						PROTO																			; ordinal 714	; XP
	RtlPrefixString					PROTO :DWORD, :DWORD, :DWORD															; ordinal 715
	RtlPrefixUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 716
	RtlProtectHeap					PROTO :DWORD, :DWORD																; ordinal 717
	RtlPushFrame					PROTO																			; ordinal 718	; XP
	RtlQueryAtomInAtomTable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 719
	RtlQueryDepthSList				PROTO																			; ordinal 720	; XP
	RtlQueryEnvironmentVariable_U			PROTO :DWORD, :DWORD, :DWORD															; ordinal 721
	RtlQueryHeapInformation				PROTO																			; ordinal 722	; XP
	RtlQueryInformationAcl				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 723
	RtlQueryInformationActivationContext	PROTO 																		; ordinal 724	; XP
	RtlQueryInformationActiveActivationContext	PROTO																		; ordinal 725	; XP
	RtlQueryInterfaceMemoryStream			PROTO																			; ordinal 726	; XP
	RtlQueryProcessBackTraceInformation		PROTO :DWORD																	; ordinal 727
	RtlQueryProcessDebugInformation		PROTO :DWORD, :DWORD, :DWORD															; ordinal 728
	RtlQueryProcessHeapInformation		PROTO :DWORD																	; ordinal 729
	RtlQueryProcessLockInformation		PROTO :DWORD																	; ordinal 730
	RtlQueryRegistryValues				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 731
	RtlQuerySecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 732
	RtlQueryTagHeap					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 733
	RtlQueryTimeZoneInformation			PROTO :DWORD																	; ordinal 734
	RtlQueueApcW0w64Thread				PROTO																			; ordinal 735	; XP
	RtlQueueWorkItem					PROTO :DWORD, :DWORD, :DWORD															; ordinal 736
	RtlRaiseException					PROTO :DWORD																	; ordinal 737
	RtlRaiseStatus					PROTO :DWORD																	; ordinal 738
	RtlRandom						PROTO :DWORD																	; ordinal 739
	RtlRandomEx						PROTO																			; ordinal 740	; XP
	RtlReAllocateHeap					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 741
	RtlRealPredecessor				PROTO :DWORD																	; ordinal 742
	RtlRealSuccessor					PROTO :DWORD																	; ordinal 743
	RtlRegisterWait					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 747
	RtlReleaseActivationContext			PROTO																			; ordinal 748	; XP
	RtlReleaseMemoryStream				PROTO																			; ordinal 749	; XP
	RtlReleasePebLock					PROTO																			; ordinal 750
	RtlReleaseResource				PROTO :DWORD																	; ordinal 751
	RtlRemoteCall					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 752
	RtlRemoveVectoredExceptionHandler		PROTO																			; ordinal 753	; XP
	RtlResetRtlTranslations				PROTO :DWORD																	; ordinal 754
	RtlRestoreLastWin32Error			PROTO																			; ordinal 755	; XP
	RtlRevertMemoryStream				PROTO																			; ordinal 756	; XP
	RtlRunDecodeUnicodeString			PROTO :DWORD, :DWORD																; ordinal 757
	RtlRunEncodeUnicodeString			PROTO :DWORD, :DWORD																; ordinal 758
	RtlSecondsSince1970ToTime			PROTO :DWORD, :DWORD																; ordinal 759
	RtlSecondsSince1980ToTime			PROTO :DWORD, :DWORD																; ordinal 760
	RtlSeekMemoryStream				PROTO																			; ordinal 761	; XP
	RtlSelfRelativeToAbsoluteSD2			PROTO :DWORD, :DWORD																; ordinal 762
	RtlSelfRelativeToAbsoluteSD			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 763
	RtlSetAllBits					PROTO :DWORD																	; ordinal 764
	RtlSetAttributesSecurityDescriptor		PROTO :DWORD, :DWORD, :DWORD															; ordinal 765
	RtlSetBits						PROTO :DWORD, :DWORD, :DWORD															; ordinal 766
	RtlSetControlSecurityDescriptor		PROTO :DWORD, :DWORD, :DWORD															; ordinal 767
	RtlSetCriticalSectionSpinCount		PROTO :DWORD, :DWORD																; ordinal 768
	RtlSetCurrentDirectory_U			PROTO :DWORD																	; ordinal 769
	RtlSetCurrentEnvironment			PROTO :DWORD, :DWORD																; ordinal 770
	RtlSetDaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 771
	RtlSetEnvironmentVariable			PROTO :DWORD, :DWORD, :DWORD															; ordinal 772
	RtlSetGroupSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 773
	RtlSetHeapInformation				PROTO																			; ordinal 774	; XP
	RtlSetInformationAcl				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 775
	RtlSetIoCompletionCallback			PROTO :DWORD, :DWORD, :DWORD															; ordinal 776
	RtlSetLastWin32Error				PROTO 																		; ordinal 777	; XP
	RtlSetLastWin32ErrorAndNtStatusFromNtStatus	PROTO 																	; ordianl 778	; XP
	RtlSetMemoryStreamSize				PROTO																			; ordinal 779	; XP
	RtlSetOwnerSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD															; ordinal 780
	RtlSetProcessIsCritical				PROTO																			; ordinal 781	; XP
	RtlSetSaclSecurityDescriptor			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 782
	RtlSetSecurityDescriptorRMControl		PROTO :DWORD, :DWORD																; ordinal 783
	RtlSetSecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 784
	RtlSetSecurityObjectEx				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 785
	RtlSetThreadIsCritical				PROTO																			; ordinal 786	; XP
	RtlSetThreadPoolStartFunc			PROTO :DWORD, :DWORD																; ordinal 787
	RtlSetTimeZoneInformation			PROTO :DWORD																	; ordinal 788
	RtlSetTimer						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 789
	RtlSetUnicodeCallouts				PROTO :DWORD																	; ordinal 790
	RtlSetUserFlagsHeap				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 791
	RtlSetUserValueHeap				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 792
	RtlShutdownLpcServer				PROTO :DWORD																	; ordinal 793
	RtlSizeHeap						PROTO :DWORD, :DWORD, :DWORD															; ordinal 794
	RtlSplay						PROTO :DWORD																	; ordinal 795
	RtlStartRXact					PROTO :DWORD																	; ordinal 796
	RtlStringFromGUID					PROTO :DWORD, :DWORD																; ordinal 797
	RtlSubAuthorityCountSid				PROTO :DWORD																	; ordinal 798
	RtlSubAuthoritySid				PROTO :DWORD, :DWORD																; ordinal 799
	RtlSubtreePredecessor				PROTO :DWORD																	; ordinal 800
	RtlSubtreeSuccessor				PROTO :DWORD																	; ordinal 801
	RtlSystemTimeToLocalTime			PROTO :DWORD, :DWORD																; ordinal 802
	RtlTimeFieldsToTime				PROTO :DWORD, :DWORD																; ordinal 803
	RtlTimeToElapsedTimeFields			PROTO :DWORD, :DWORD																; ordinal 804
	RtlTimeToSecondsSince1970			PROTO :DWORD, :DWORD																; ordinal 805
	RtlTimeToSecondsSince1980			PROTO :DWORD, :DWORD																; ordinal 806
	RtlTimeToTimeFields				PROTO :DWORD, :DWORD																; ordinal 807
	RtlTraceDatabaseAdd				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 808
	RtlTraceDatabaseCreate				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 809
	RtlTraceDatabaseDestroy				PROTO :DWORD																	; ordinal 810
	RtlTraceDatabaseEnumerate			PROTO :DWORD, :DWORD, :DWORD															; ordinal 811
	RtlTraceDatabaseFind				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 812
	RtlTraceDatabaseLock				PROTO :DWORD																	; ordinla 813
	RtlTraceDatabaseUnlock				PROTO :DWORD																	; ordinal 814
	RtlTraceDatabaseValidate			PROTO :DWORD																	; ordinal 815
	RtlTryEnterCriticalSection			PROTO :DWORD																	; ordinal 816
	RtlUnhandledExceptionFilter2			PROTO																			; ordinal 817	; XP
	RtlUnhandledExceptionFilter			PROTO																			; ordinal 818	; XP
	RtlUnicodeStringToAnsiSize			PROTO :DWORD																	; ordinal 819
	RtlUnicodeStringToAnsiString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 820
	RtlUnicodeStringToCountedOemString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 821
	RtlUnicodeStringToInteger			PROTO :DWORD, :DWORD, :DWORD															; ordinal 822
	RtlUnicodeStringToOemSize			PROTO :DWORD																	; ordinal 823
	RtlUnicodeStringToOemString			PROTO :DWORD, :DWORD, :DWORD															; ordinal 824
	RtlUnicodeToCustomCPN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 825
	RtlUnicodeToMultiByteN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 826
	RtlUnicodeToMultiByteSize			PROTO :DWORD, :DWORD, :DWORD															; ordinal 827
	RtlUnicodeToOemN					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 828
	RtlUniform						PROTO :DWORD																	; ordinal 829
	RtlUnlockBootStatus				PROTO																			; ordinal 830	; XP
	RtlUnlockHeap					PROTO :DWORD																	; ordinal 831
	RtlUnlockMemoryStreamRegion			PROTO																			; ordinal 832	; XP
;	RtlUnwind						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 833
	RtlUpcaseUnicodeChar				PROTO :DWORD																	; ordinal 834
	RtlUpcaseUnicodeString				PROTO :DWORD, :DWORD, :DWORD															; ordinal 835
	RtlUpcaseUnicodeStringToAnsiString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 836
	RtlUpcaseUnicodeStringToCountedOemString	PROTO :DWORD, :DWORD, :DWORD															; ordinal 837
	RtlUpcaseUnicodeStringToOemString		PROTO :DWORD, :DWORD, :DWORD															; ordinal 838
	RtlUpcaseUnicodeToCustomCPN			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 839
	RtlUpcaseUnicodeToMultiByteN			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 840
	RtlUpcaseUnicodeToOemN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 841
	RtlUpdateTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 842
	RtlUpperChar					PROTO :DWORD																	; ordinal 843
	RtlUpperString					PROTO :DWORD, :DWORD																; ordinal 844
	RtlUsageHeap					PROTO :DWORD, :DWORD, :DWORD															; ordinal 845
	RtlValidAcl						PROTO :DWORD																	; ordinal 846
	RtlValidRelativeSecurityDescriptor		PROTO :DWORD, :DWORD, :DWORD															; ordinal 847
	RtlValidSecurityDescriptor			PROTO :DWORD																	; ordinal 848
	RtlValidSid						PROTO :DWORD																	; ordinal 849
	RtlValidateHeap					PROTO :DWORD, :DWORD, :DWORD															; ordinal 850
	RtlValidateProcessHeaps				PROTO																			; ordinal 851
	RtlValidateUnicodeString			PROTO																			; ordinal 852	; XP
	RtlVerifyVersionInfo				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 853
	RtlWalkFrameChain					PROTO :DWORD, :DWORD, :DWORD															; ordinal 854
	RtlWalkHeap						PROTO :DWORD, :DWORD																; ordinal 855
	RtlWriteMemoryStream				PROTO																			; ordinal 856	; XP
	RtlWriteRegistryValue				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 857
	RtlZeroHeap						PROTO :DWORD, :DWORD																; ordinal 858
;	RtlZeroMemory					PROTO :DWORD, :DWORD																; ordinal 859
	RtlZombifyActivationConte			PROTO																			; ordinal 860	; XP
	RtlpApplyLengthFunction				PROTO																			; ordinal 861	; XP
	RtlpEnsureBufferSize				PROTO																			; ordinal 862	; XP
	RtlpNotOwnerCriticalSection			PROTO																			; ordinal 863	; XP
	RtlpNtCreateKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 864
	RtlpNtEnumerateSubKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 865
	RtlpNtMakeTemporaryKey				PROTO :DWORD																	; ordinal 866
	RtlpNtOpenKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 867
	RtlpNtQueryValueKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 868
	RtlpNtSetValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 869
	RtlpUnWaitCriticalSection			PROTO :DWORD																	; ordinal 870
	RtlpWaitForCriticalSection			PROTO :DWORD																	; ordinal 871
	RtlxAnsiStringToUnicodeSize			PROTO :DWORD																	; ordinal 872
	RtlxOemStringToUnicodeSize			PROTO :DWORD																	; ordinal 873
	RtlxUnicodeStringToAnsiSize			PROTO :DWORD																	; ordinal 874
	RtlxUnicodeStringToOemSize			PROTO :DWORD																	; ordinal 875
	SaveEm87Context					PROTO C																		; ordinal 876
	VerSetConditionMask				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 877
	ZwAcceptConnectPort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 878
	ZwAccessCheck					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 879
	ZwAccessCheckAndAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 880
	ZwAccessCheckByType				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 881
	ZwAccessCheckByTypeAndAuditAlarm		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 882
	ZwAccessCheckByTypeResultList			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 883
	ZwAccessCheckByTypeResultListAndAuditAlarm		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 884
	ZwAccessCheckByTypeResultListAndAuditAlarmByHandle	PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 885
	ZwAddAtom						PROTO :DWORD, :DWORD, :DWORD															; ordinal 886
	ZwAddBootEntry					PROTO																			; ordinal 887	; XP
	ZwAdjustGroupsToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 888
	ZwAdjustPrivilegesToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 889
	ZwAlertResumeThread				PROTO :DWORD, :DWORD																; ordinal 890
	ZwAlertThread					PROTO :DWORD																	; ordinal 891
	ZwAllocateLocallyUniqueId			PROTO :DWORD																	; ordinal 892
	ZwAllocateUserPhysicalPages			PROTO :DWORD, :DWORD, :DWORD															; ordinal 893
	ZwAllocateUuids					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 894
	ZwAllocateVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 895
	ZwAreMappedFilesTheSame				PROTO :DWORD, :DWORD																; ordinal 896
	ZwAssignProcessToJobObject			PROTO :DWORD, :DWORD																; ordinal 897
	ZwCallbackReturn					PROTO :DWORD, :DWORD, :DWORD															; ordinal 898
	ZwCancelDeviceWakeupRequest			PROTO :DWORD																	; ordinal 899
	ZwCancelIoFile					PROTO :DWORD, :DWORD																; ordinal 900
	ZwCancelTimer					PROTO :DWORD, :DWORD																; ordinal 901
	ZwClearEvent					PROTO :DWORD																	; ordinal 902
	ZwClose						PROTO :DWORD																	; ordinal 903
	ZwCloseObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD															; ordinal 904
	ZwCompactKeys					PROTO																			; ordinal 905	; XP
	ZwCompareTokens					PROTO																			; ordinal 906	; XP
	ZwCompleteConnectPort				PROTO :DWORD																	; ordinal 907
	ZwCompressKey					PROTO																			; ordinal 908	; XP
	ZwConnectPort					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 909
	ZwContinue						PROTO :DWORD, :DWORD																; ordinal 910
	ZwCreateChannel					PROTO :DWORD, :DWORD																; ordinal 911
	ZwCreateDirectoryObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 912
	ZwCreateEvent					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 913
	ZwCreateEventPair					PROTO :DWORD, :DWORD, :DWORD															; ordinal 914
	ZwCreateFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 915
	ZwCreateIoCompletion				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 916
	ZwCreateJobObject					PROTO :DWORD, :DWORD, :DWORD															; ordinal 917
	ZwCreateJobSet					PROTO																			; ordinal 918	; XP
	ZwCreateKey						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 919
	ZwCreateKeyEx					PROTO 																		; ordinal 920	; XP
	ZwCreateMailslotFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 921
	ZwCreateMutant					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 922
	ZwCreateNamedPipeFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 923
	ZwCreatePagingFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 924
	ZwCreatePort					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 925
	ZwCreateProcess					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 926
	ZwCreateProcessEx					PROTO 																		; ordinal 927	; XP
	ZwCreateProfile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 928
	ZwCreateSection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 929
	ZwCreateSemaphore					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 930
	ZwCreateSymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 931
	ZwCreateThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 932
	ZwCreateTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 933
	ZwCreateToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 934
	ZwCreateWaitablePort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 935
	ZwDebugActiveprocess				PROTO																			; ordinal 936	; XP
	ZwDebugContinue					PROTO																			; ordinal 937	; XP
	ZwDelayExecution					PROTO :DWORD, :DWORD																; ordinal 938
	ZwDeleteAtom					PROTO :DWORD																	; ordinal 939
	ZwDeleteBootEntry					PROTO																			; ordinal 940	; XP
	ZwDeleteFile					PROTO :DWORD																	; ordinal 941
	ZwDeleteKey						PROTO :DWORD																	; ordinal 942
	ZwDeleteObjectAuditAlarm			PROTO :DWORD, :DWORD, :DWORD															; ordinal 943
	ZwDeleteValueKey					PROTO :DWORD, :DWORD																; ordinal 944
	ZwDeviceIoControlFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 945
	ZwDisplayString					PROTO :DWORD																	; ordinal 946
	ZwDuplicateObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 947
	ZwDuplicateToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 948
	ZwEnumerateBootEntries				PROTO																			; ordinal 949	; XP
	ZwEnumerateKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 950
	ZwEnumerateSystemEnvironmentalValuesEx	PROTO																			; ordinal 951	; XP
	ZwEnumerateValueKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 952
	ZwExtendSection					PROTO :DWORD, :DWORD																; ordinal 953
	ZwFilterToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 954
	ZwFindAtom						PROTO :DWORD, :DWORD, :DWORD															; ordinal 955
	ZwFlushBuffersFile				PROTO :DWORD, :DWORD																; ordinal 956
	ZwFlushInstructionCache				PROTO :DWORD, :DWORD, :DWORD															; ordinal 957
	ZwFlushKey						PROTO :DWORD																	; ordinal 958
	ZwFlushVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 959
	ZwFlushWriteBuffer				PROTO																			; ordinal 960
	ZwFreeUserPhysicalPages				PROTO :DWORD, :DWORD, :DWORD															; ordinal 961
	ZwFreeVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 962
	ZwFsControlFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 963
	ZwGetContextThread				PROTO :DWORD, :DWORD																; ordinal 964
	ZwGetDevicePowerState				PROTO :DWORD, :DWORD																; ordinal 965
	ZwGetPlugPlayEvent				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 966
; W2K	ZwGetTickCount					PROTO																			; W2K
	ZwGetWriteWatch					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 967
	ZwImpersonateAnonymousToken			PROTO :DWORD																	; ordinal 968
	ZwImpersonateClientOfPort			PROTO :DWORD, :DWORD																; ordinal 969
	ZwImpersonateThread				PROTO :DWORD, :DWORD, :DWORD															; ordinal 970
	ZwInitializeRegistry				PROTO :DWORD																	; ordinal 971
	ZwInitiatePowerAction				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 972
	ZwIsPrcessInJob					PROTO																			; ordinal 973	; XP
	ZwIsSystemResumeAutomatic			PROTO																			; ordinal 974
; W2K	ZwListenChannel					PROTO :DWORD, :DWORD																; W2k
	ZwListenPort					PROTO :DWORD, :DWORD																; ordinal 975
	ZwLoadDriver					PROTO :DWORD																	; ordinal 976
	ZwLoadKey2						PROTO :DWORD, :DWORD, :DWORD															; ordinal 977
	ZwLoadKey						PROTO :DWORD, :DWORD																; ordinal 978
	ZwLockFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 979
	ZwLockProductActivationKeys			PROTO																			; ordinal 980	; XP
	ZwLockRegistryKey					PROTO 																		; ordinal 981	; XP
	ZwLockVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 982
	ZwMakePermanentObject				PROTO																			; ordinal 983	; XP
	ZwMakeTemporaryObject				PROTO :DWORD																	; ordinal 984
	ZwMapUserPhysicalPages				PROTO :DWORD, :DWORD, :DWORD															; ordinal 985
	ZwMapUserPhysicalPagesScatter			PROTO :DWORD, :DWORD, :DWORD															; ordinal 986
	ZwMapViewOfSection				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 987
	ZwModifyBootEntry					PROTO																			; ordinal 988	; XP
	ZwNotifyChangeDirectoryFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 989
	ZwNotifyChangeKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 990
	ZwNotifyChangeMultipleKeys			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 991
; W2K	ZwOpenChannel					PROTO :DWORD, :DWORD																; W2K
;	ZwOpenDirectoryObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 992
;	ZwOpenEvent						PROTO :DWORD, :DWORD, :DWORD															; ordinal 993
	ZwOpenEventPair					PROTO :DWORD, :DWORD, :DWORD															; ordinal 994
	ZwOpenFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 995
	ZwOpenIoCompletion				PROTO :DWORD, :DWORD, :DWORD															; ordinal 996
	ZwOpenJobObject					PROTO :DWORD, :DWORD, :DWORD															; ordinal 997
	ZwOpenKey						PROTO :DWORD, :DWORD, :DWORD															; ordinal 998
	ZwOpenKeyedEvent					PROTO																			; ordinal 999	; XP
	ZwOpenMutant					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1000
	ZwOpenObjectAuditAlarm				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD			; ordinal 1001
	ZwOpenProcess					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1002
	ZwOpenProcessToken				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1003
;	ZwOpenProcessTokenEx				PROTO																			; ordinal 1004	; XP
	ZwOpenSection					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1005
	ZwOpenSemaphore					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1006
	ZwOpenSymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1007
	ZwOpenThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1008
	ZwOpenThreadToken					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1009
;	ZwOpenThreadTokenEx				PROTO 																		; ordinal 1010	; XP
	ZwOpenTimer						PROTO :DWORD, :DWORD, :DWORD															; ordinal 1011
	ZwPlugPlayControl					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1012
	ZwPowerInformation				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1013
	ZwPrivilegeCheck					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1014
	ZwPrivilegeObjectAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1015
	ZwPrivilegedServiceAuditAlarm			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1016
	ZwProtectVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1017
	ZwPulseEvent					PROTO :DWORD, :DWORD																; ordinal 1018
	ZwQueryAttributesFile				PROTO :DWORD, :DWORD																; ordinal 1019
	ZwQueryBootEntryOrder				PROTO																			; ordinal 1020	; XP
	ZwQueryBootOptions				PROTO																			; ordinal 1021	; XP
	ZwQueryDebugFilterState				PROTO 																		; ordinal 1022	; XP
	ZwQueryDefaultLocale				PROTO :DWORD, :DWORD																; ordinal 1023
	ZwQueryDefaultUILanguage			PROTO :DWORD																	; ordinal 1024
	ZwQueryDirectoryFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 1025
	ZwQueryDirectoryObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1026
;	ZwQueryEaFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1027
	ZwQueryEvent					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1028
	ZwQueryFullAttributesFile			PROTO :DWORD, :DWORD																; ordinal 1029
	ZwQueryInformationAtom				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1030
	ZwQueryInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1031
	ZwQueryInformationJobObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1032
	ZwQueryInformationPort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1033
	ZwQueryInformationProcess			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1034
	ZwQueryInformationThread			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1035
	ZwQueryInformationToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1036
	ZwQueryInstallUILanguage			PROTO :DWORD																	; ordinal 1037
	ZwQueryIntervalProfile				PROTO :DWORD, :DWORD																; ordinal 1038
	ZwQueryIoCompletion				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1039
	ZwQueryKey						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1040
	ZwQueryMultipleValueKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1041
	ZwQueryMutant					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1042
	ZwQueryObject					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1043
	ZwQueryOpenSubKeys				PROTO :DWORD, :DWORD																; ordinal 1044
	ZwQueryPerformanceCounter			PROTO :DWORD, :DWORD																; ordinal 1045
	ZwQueryPortInformationProcess			PROTO																			; ordinal 1046	; XP
	ZwQueryQuotaInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1047
	ZwQuerySection					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1048
	ZwQuerySecurityObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1049
	ZwQuerySemaphore					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1050
	ZwQuerySymbolicLinkObject			PROTO :DWORD, :DWORD, :DWORD															; ordinal 1051
	ZwQuerySystemEnvironmentValue			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1052
	ZwQuerySystemEnvironmentValueEx		PROTO																			; ordinal 1053	; XP
	ZwQuerySystemInformation			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1054
	ZwQuerySystemTime					PROTO :DWORD																	; ordinal 1055
	ZwQueryTimer					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1056
	ZwQueryTimerResolution				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1057
	ZwQueryValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1058
	ZwQueryVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1059
	ZwQueryVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1060
	ZwQueueApcThread					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1061
	ZwRaiseException					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1062
	ZwRaiseHardError					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1063
;	ZwReadFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1064
	ZwReadFileScatter					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1065
	ZwReadRequestData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1066
	ZwReadVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1067
	ZwRegisterThreadTerminatePort			PROTO :DWORD																	; ordinal 1068
	ZwReleaseKeyedEvent				PROTO																			; ordinal 1069	; XP
	ZwReleaseMutant					PROTO :DWORD, :DWORD																; ordinal 1070
	ZwReleaseSemaphore				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1071
	ZwRemoveIoCompletion				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1072
	ZwRemoveProcessDebug				PROTO																			; ordinal 1073	; XP
	ZwRenameKey						PROTO																			; ordinal 1074	; XP
	ZwReplaceKey					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1075
	ZwReplyPort						PROTO :DWORD, :DWORD																; ordinal 1076
	ZwReplyWaitReceivePort				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1077
	ZwReplyWaitReceivePortEx			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1078
	ZwReplyWaitReplyPort				PROTO :DWORD, :DWORD																; ordinal 1079
; W2K	ZwReplyWaitSendChannel				PROTO :DWORD, :DWORD, :DWORD															; W2K
	ZwRequestDeviceWakeup				PROTO :DWORD																	; ordinal 1080
	ZwRequestPort					PROTO :DWORD, :DWORD																; ordinal 1081
	ZwRequestWaitReplyPort				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1082
	ZwRequestWakeupLatency				PROTO :DWORD																	; ordinal 1083
	ZwResetEvent					PROTO :DWORD, :DWORD																; ordinal 1084
	ZwResetWriteWatch					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1085
	ZwRestoreKey					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1086
	ZwResumeProcess					PROTO																			; ordinal 1087	; XP
	ZwResumeThread					PROTO :DWORD, :DWORD																; ordinal 1088
	ZwSaveKey						PROTO :DWORD, :DWORD																; ordinal 1089
	ZwSaveKeyEx						PROTO																			; ordinal 1090	; XP
	ZwSaveMergedKeys					PROTO :DWORD, :DWORD, :DWORD															; ordinal 1091
	ZwSecureConnectPort				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1092
	ZwSetBootEntryOrder				PROTO																			; ordinal 1093	; XP
	ZwSetBootOptions					PROTO																			; ordinal 1094	; XP
; W2K	ZwSendWaitReplyChannel				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; W2K
; W2K	ZwSetContextChannel				PROTO :DWORD																	; W2K
	ZwSetContextThread				PROTO :DWORD, :DWORD																; ordinal 1095
	ZwSetDebugFilterState				PROTO																			; ordinal 1096	; XP
	ZwSetDefaultHardErrorPort			PROTO :DWORD																	; ordinal 1097
	ZwSetDefaultLocale				PROTO :DWORD, :DWORD																; ordinal 1098
	ZwSetDefaultUILanguage				PROTO :DWORD																	; ordinal 1099
	ZwSetEaFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1100
	ZwSetEvent						PROTO :DWORD, :DWORD																; ordinal 1101
	ZwSetEventBoostPriority				PROTO																			; ordinal 1102	; XP
	ZwSetHighEventPair				PROTO :DWORD																	; ordinal 1103
	ZwSetHighWaitLowEventPair			PROTO :DWORD																	; ordinal 1104
	ZwSetInformationDebugObject			PROTO																			; ordinal 1105	; XP
	ZwSetInformationFile				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1106
;?????ZwSetInformationJobObject			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1107
	ZwSetInformationKey				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1108
	ZwSetInformationObject				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1109
	ZwSetInformationProcess				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1110
	ZwSetInformationThread				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1111
	ZwSetInformationToken				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1112
	ZwSetIntervalProfile				PROTO :DWORD, :DWORD																; ordinal 1113
	ZwSetIoCompletion					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1114
	ZwSetLdtEntries					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1115
	ZwSetLowEventPair					PROTO :DWORD																	; ordinal 1116
	ZwSetLowWaitHighEventPair			PROTO :DWORD																	; ordinal 1117
	ZwSetQuotaInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1118
	ZwSetSecurityObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1119
	ZwSetSystemEnvironmentValue			PROTO :DWORD, :DWORD																; ordinal 1120
	ZwSetSystemEnvironmentValueEx			PROTO																			; ordinal 1121	; XP
	ZwSetSystemInformation				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1122
	ZwSetSystemPowerState				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1123
	ZwSetSystemTime					PROTO :DWORD, :DWORD																; ordinal 1124
	ZwSetThreadExecutionState			PROTO :DWORD, :DWORD																; ordinal 1125
	ZwSetTimer						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 1126
	ZwSetTimerResolution				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1127
	ZwSetUuidSeed					PROTO :DWORD																	; ordinal 1128
	ZwSetValueKey					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1129
	ZwSetVolumeInformationFile			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1130
	ZwShutdownSystem					PROTO :DWORD																	; ordinal 1131
	ZwSignalAndWaitForSingleObject		PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1132
	ZwStartProfile					PROTO :DWORD																	; ordinal 1133
	ZwStopProfile					PROTO :DWORD																	; ordinal 1134
	ZwSuspendProcess					PROTO																			; ordinal 1135	; XP
	ZwSuspendThread					PROTO :DWORD, :DWORD																; ordinal 1136
	ZwSystemDebugControl				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1137
	ZwTerminateJobObject				PROTO :DWORD, :DWORD																; ordinal 1138
	ZwTerminateProcess				PROTO :DWORD, :DWORD																; ordinal 1139
	ZwTerminateThread					PROTO :DWORD, :DWORD																; ordinal 1140
	ZwTestAlert						PROTO																			; ordinal 1141
	ZwTraceEvent					PROTO																			; ordinal 1142	; XP
;	ZwTranslateFilePath				PROTO																			; ordinal 1143	; XP
	ZwUnloadDriver					PROTO :DWORD																	; ordinal 1144
	ZwUnloadKey						PROTO :DWORD																	; ordinal 1145
	ZwUnloadKeyEx					PROTO																			; ordinal 1146	; XP
	ZwUnlockFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1147
	ZwUnlockVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 1148
	ZwUnmapViewOfSection				PROTO :DWORD, :DWORD																; ordinal 1149
	ZwVdmControl					PROTO :DWORD, :DWORD																; ordinal 1150
	ZwWaitForDebugEvent				PROTO																			; ordinal 1151	; XP
	ZwWaitForKeyedEvent				PROTO																			; ordinal 1152	; XP
	ZwWaitForMultipleObjects			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1153
	ZwWaitForSingleObject				PROTO :DWORD, :DWORD, :DWORD															; ordinal 1154
	ZwWaitHighEventPair				PROTO :DWORD																	; ordinal 1155
	ZwWaitLowEventPair				PROTO :DWORD																	; ordinal 1156
	ZwWriteFile						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1157
	ZwWriteFileGather					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 1158
	ZwWriteRequestData				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 1159
	ZwWriteVirtualMemory				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1160
	ZwYieldExecution					PROTO																			; ordinal 1161
; W2K	_CIpow						PROTO C :DWORD																	; W2K
	_CIcos						PROTO	C																		; ordinal 1162	; XP
	_CIlog						PROTO	C																		; ordinal 1163	; XP
	_CIpow						PROTO	C																		; ordinal 1164	; XP
	_CIsin						PROTO	C																		; ordinal 1165	; XP
	_CIsqrt						PROTO	C																		; ordinal 1166	; XP
	__eCommonExceptions				PROTO C :DWORD																	; ordinal 1167
	__eEmulatorInit					PROTO C :DWORD																	; ordinal 1168
	__eF2XM1						PROTO C :DWORD																	; ordinal 1169
	__eFABS						PROTO C :DWORD																	; ordinal 1170
	__eFADD32						PROTO C :DWORD																	; ordinal 1171
	__eFADD64						PROTO C :DWORD																	; ordinal 1172
	__eFADDPreg						PROTO C :DWORD																	; ordinal 1173
	__eFADDreg						PROTO C :DWORD																	; ordinal 1174
	__eFADDtop						PROTO C :DWORD																	; ordinal 1175
	__eFCHS						PROTO C :DWORD																	; ordinal 1176
	__eFCOM						PROTO C :DWORD																	; ordinal 1177
	__eFCOM32						PROTO C :DWORD																	; ordinal 1178
;	__eFCOM64						PROTO C :DWORD																	; ordinal 1179
	__eFCOMP						PROTO C :DWORD																	; ordinal 1180
	__eFCOMP32						PROTO C :DWORD																	; ordinal 1181
	__eFCOMP64						PROTO C :DWORD																	; ordinal 1182
	__eFCOMPP						PROTO C :DWORD																	; ordinal 1183
	__eFCOM64						PROTO C :DWORD																	; ordinal 1184
	__eFDECSTP						PROTO C :DWORD																	; ordinal 1185
	__eFDIV32						PROTO C :DWORD																	; ordinal 1186
	__eFDIV64						PROTO C :DWORD																	; ordinal 1187
	__eFDIVPreg						PROTO C :DWORD																	; ordinal 1188
	__eFDIVR32						PROTO C :DWORD																	; ordinal 1189
	__eFDIVR64						PROTO C :DWORD																 	; ordinal 1190
	__eFDIVRPreg					PROTO C :DWORD																	; ordinal 1191
	__eFDIVRreg						PROTO C :DWORD																	; ordinal 1192
	__eFDIVRtop						PROTO C :DWORD																	; ordinal 1193
	__eFDIVreg						PROTO C :DWORD																	; ordinal 1194
	__eFDIVtop						PROTO C :DWORD																	; ordinal 1195
	__eFFREE						PROTO C :DWORD																	; ordinal 1196
	__eFIADD16						PROTO C :DWORD																	; ordinal 1197
	__eFIADD32						PROTO C :DWORD																	; ordinal 1198
	__eFICOM16						PROTO C :DWORD																	; ordinal 1199
	__eFICOM32						PROTO C :DWORD																	; ordinal 1200
	__eFICOMP16						PROTO C :DWORD																	; ordinal 1201
	__eFICOMP32						PROTO C :DWORD																	; ordinal 1202
	__eFIDIV16						PROTO C :DWORD																	; ordinal 1203
	__eFIDIV32						PROTO C :DWORD																	; ordinal 1204
	__eFIDIVR16						PROTO C :DWORD																	; ordinal 1205
	__eFIDIVR32						PROTO C :DWORD																	; ordinal 1206
	__eFILD16						PROTO C :DWORD																	; ordinal 1207
	__eFILD32						PROTO C :DWORD																	; ordinal 1208
	__eFILD64						PROTO C :DWORD																	; ordinal 1209
	__eFIMUL16						PROTO C :DWORD																	; ordinal 1210
	__eFIMUL32						PROTO C :DWORD																	; ordinal 1211
	__eFINCSTP						PROTO C :DWORD																	; ordinal 1212
	__eFINIT						PROTO C :DWORD																	; ordinal 1213
	__eFIST16						PROTO C :DWORD																	; ordinal 1214
	__eFIST32						PROTO C :DWORD																	; ordinal 1215
	__eFISTP16						PROTO C :DWORD																	; ordinal 1216
	__eFISTP32						PROTO C :DWORD																	; ordinal 1217
	__eFISTP64						PROTO C :DWORD																	; ordinal 1218
	__eFISUB16						PROTO C :DWORD																	; ordinal 1219
	__eFISUB32						PROTO C :DWORD																	; ordinal 1220
	__eFISUBR16						PROTO C :DWORD																	; ordinal 1221
	__eFISUBR32						PROTO C :DWORD																	; ordinal 1222
	__eFLD1						PROTO C :DWORD																	; ordinal 1223
	__eFLD32						PROTO C :DWORD																	; ordinal 1224
	__eFLD64						PROTO C :DWORD																	; ordinal 1225
	__eFLD80						PROTO C :DWORD																	; ordinal 1226
	__eFLDCW						PROTO C :DWORD																	; ordinal 1227
	__eFLDENV						PROTO C :DWORD																	; ordinal 1228
	__eFLDL2E						PROTO C :DWORD																	; ordinal 1229
	__eFLDLN2						PROTO C :DWORD																	; ordinal 1230
	__eFLDPI						PROTO C :DWORD																	; ordinal 1231
	__eFLDZ						PROTO C :DWORD																	; ordinal 1232
	__eFMUL32						PROTO C :DWORD																	; ordinal 1233
	__eFMUL64						PROTO C :DWORD																	; ordinal 1234
	__eFMULPreg						PROTO C :DWORD																	; ordinal 1235
	__eFMULreg						PROTO C :DWORD																	; ordinal 1236
	__eFMULtop						PROTO C :DWORD																	; ordinal 1237
	__eFPATAN						PROTO C :DWORD																	; ordinal 1238
	__eFPREM						PROTO C :DWORD																	; ordinal 1239
	__eFPREM1						PROTO C :DWORD																	; ordinal 1240
	__eFPTAN						PROTO C :DWORD																	; ordinal 1241
	__eFRNDINT						PROTO C :DWORD																	; ordinal 1242
	__eFRSTOR						PROTO C :DWORD																	; ordinal 1243
	__eFSAVE						PROTO C :DWORD																	; ordinal 1244
	__eFSCALE						PROTO C :DWORD																	; ordinal 1245
	__eFSIN						PROTO C :DWORD																	; ordinal 1246
	__eFSQRT						PROTO C :DWORD																	; ordinal 1247
	__eFST						PROTO C :DWORD																	; ordinal 1248
	__eFST32						PROTO C :DWORD																	; ordinal 1249
	__eFST64						PROTO C :DWORD																	; ordinal 1250
	__eFSTCW						PROTO C :DWORD																	; ordinal 1251
	__eFSTENV						PROTO C :DWORD																	; ordinal 1252
	__eFSTP						PROTO C :DWORD																	; ordinal 1253
	__eFSTP32						PROTO C :DWORD																	; ordinal 1254
	__eFSTP64						PROTO C :DWORD																	; ordinal 1255
	__eFSTP80						PROTO C :DWORD																	; ordinal 1256
	__eFSTSW						PROTO C :DWORD																	; ordinal 1257
	__eFSUB32						PROTO C :DWORD																	; ordinal 1258
	__eFSUB64						PROTO C :DWORD																	; ordinal 1259
	__eFSUBPreg						PROTO C :DWORD																	; ordinal 1260
	__eFSUBR32						PROTO C :DWORD																	; ordinal 1261
	__eFSUBR64						PROTO C :DWORD																	; ordinal 1262
	__eFSUBRPreg					PROTO C :DWORD																	; ordinal 1263
	__eFSUBRreg						PROTO C :DWORD																	; ordinal 1264
	__eFSUBRtop						PROTO C :DWORD																	; ordinal 1265
	__eFSUBreg						PROTO C :DWORD																	; ordinal 1266
	__eFSUBtop						PROTO C :DWORD																	; ordinal 1267
	__eFTST						PROTO C :DWORD																	; ordinal 1268
	__eFUCOM						PROTO C :DWORD																	; ordinal 1269
	__eFUCOMP						PROTO C :DWORD																	; ordinal 1270
	__eFUCOMPP						PROTO C :DWORD																	; ordinal 1271
	__eFXAM						PROTO C :DWORD																	; ordinal 1272
	__eFXCH						PROTO C :DWORD																	; ordinal 1273
	__eFXTRACT						PROTO C :DWORD																	; ordinal 1274
	__eFYL2X						PROTO C :DWORD																	; ordinal 1275
	__eFYL2XP1						PROTO C :DWORD																	; ordinal 1276
	__eGetStatusWord					PROTO C :DWORD																	; ordinal 1277
	__isascii						PROTO C :DWORD																	; ordinal 1278
	__iscsym						PROTO C :DWORD																	; ordinal 1279
	__iscsymf						PROTO C :DWORD																	; ordinal 1280
	__toascii						PROTO C :DWORD																	; ordinal 1281
	__alldiv						PROTO C :DWORD, :DWORD																; ordinal 1282
	_alldvrm						PROTO	C																		; ordinal 1283	; XP
	__allmul						PROTO C :DWORD																	; ordinal 1284
	_alloca_probe					PROTO C :DWORD, :DWORD																; ordinal 1285
	__allrem						PROTO C :DWORD, :DWORD																; ordinal 1286
	__allshl						PROTO C :DWORD, :DWORD																; ordinal 1287
	__allshr						PROTO C :DWORD, :DWORD																; ordinal 1288
	_atoi64						PROTO C :DWORD																	; ordinal 1289
	__aulldiv						PROTO C :DWORD, :DWORD																; ordinal 1290
	_aulldvrm						PROTO	C																		; ordinal 1291	; XP
	__aullrem						PROTO C :DWORD, :DWORD																; ordinal 1292
	__aullshr						PROTO C :DWORD, :DWORD																; ordinal 1293
	_chkstk						PROTO C :DWORD																	; ordinal 1294
	_fltused						PROTO C :DWORD																	; ordinal 1295
	_ftol							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1296
	_i64toa						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1297
	_i64tow						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1298
	_itoa							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1299
	_itow							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1300
	_lfind						PROTO	C																		; ordinal 1301	; XP
	_ltoa							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1302
	_ltow							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1303
	_memccpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1304
	_memicmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1305
	_snprintf						PROTO C :DWORD, :DWORD, :DWORD, :VARARG													; ordinal 1306
	_snwprintf						PROTO C :DWORD, :DWORD, :DWORD, :VARARG													; ordinal 1307
	_splitpath						PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 1308
	_strcmpi						PROTO C :DWORD, :DWORD																; ordinal 1309
	_stricmp						PROTO C :DWORD, :DWORD																; ordinal 1310
	_strlwr						PROTO C :DWORD																	; ordinal 1311
	_strnicmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1312
	_strupr						PROTO C :DWORD																	; ordinal 1313
	_tolower						PROTO C :DWORD																	; ordinal 1314
	_toupper						PROTO C :DWORD																	; ordinal 1315
	_ui64toa						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1316
	_ui64tow						PROTO																			; ordinal 1317	; XP
	_ultoa						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1318
	_ultow						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1319
	_vsnprintf						PROTO C :DWORD, :DWORD, :DWORD, :VARARG													; ordinal 1320
	_vsnwprintf						PROTO C																			; ordinal 1321	; XP
	_wcsicmp						PROTO C :DWORD, :DWORD																; ordinal 1322
	_wcslwr						PROTO C :DWORD																	; ordinal 1323
	_wcsnicmp						PROTO C :DWORD, :DWORD																; ordinal 1324
	_wcsupr						PROTO C :DWORD																	; ordinal 1325
	_wtoi							PROTO C :DWORD																	; ordinal 1326
	_wtoi64						PROTO C :DWORD																	; ordinal 1327
	_wtol							PROTO C :DWORD																	; ordinal 1328
	abs							PROTO C :DWORD																	; ordinal 1329
	atan							PROTO C :DWORD																	; ordinal 1330
	atoi							PROTO C :DWORD																	; ordinal 1331
	atol							PROTO C :DWORD																	; ordinal 1332
	ceil							PROTO C :DWORD																	; ordinal 1333
	cos							PROTO C :DWORD																	; ordinal 1335
;	fabs							PROTO C :DWORD																	; ordinal 1336
	floor							PROTO C :DWORD																	; ordinal 1337
	isalnum						PROTO C :DWORD																	; ordinal 1338
	isalpha						PROTO C :DWORD																	; ordinal 1339
	iscntrl						PROTO C :DWORD																	; ordinal 1340
	isdigit						PROTO C :DWORD																	; ordinal 1341
	isgraph						PROTO C :DWORD, :DWORD																; ordinal 1342
	islower						PROTO C :DWORD																	; ordinal 1343
	isprint						PROTO C :DWORD																	; ordinal 1344
	ispunct						PROTO C :DWORD																	; ordinal 1345
	isspace						PROTO C :DWORD																	; ordinal 1346
	isupper						PROTO C :DWORD																	; ordinal 1347
	iswalpha						PROTO C :DWORD																	; ordinal 1348
	iswctype						PROTO C :DWORD, :DWORD																; ordinal 1349
	iswdigit						PROTO C :DWORD																	; ordinal 1350
	iswlower						PROTO C :DWORD																	; ordinal 1351
	iswspace						PROTO C :DWORD																	; ordinal 1352
	iswxdigit						PROTO C :DWORD																	; ordinal 1353
	isxdigit						PROTO C :DWORD																	; ordinal 1354
	labs							PROTO C :DWORD																	; ordinal 1355
	log							PROTO C :DWORD																	; ordinal 1356
	mbstowcs						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1357
	memchr						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1358
	memcmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1359
	memcpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1360
	memmove						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1361
	memset						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1362
	pow							PROTO C :DWORD, :DWORD																; ordinal 1363
	qsort							PROTO C :VARARG																	; ordinal 1364
	sin							PROTO C :DWORD																	; ordinal 1365
	sprintf						PROTO C :DWORD, :DWORD, :VARARG														; ordinal 1366
	sqrt							PROTO C :DWORD																	; ordinal 1367
	sscanf						PROTO C :DWORD, :VARARG																; ordinal 1368
	strcat						PROTO C :DWORD, :DWORD																; ordinal 1369
	strchr						PROTO C :DWORD, :DWORD																; ordinal 1370
	strcmp						PROTO C :DWORD, :DWORD																; ordinal 1371
	strcpy						PROTO C :DWORD, :DWORD																; ordinal 1372
	strcspn						PROTO C :DWORD, :DWORD																; ordinal 1373
	strlen						PROTO C :DWORD																	; ordinal 1374
	strncat						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1375
	strncmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1376
	strncpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1377
	strpbrk						PROTO C :DWORD, :DWORD																; ordinal 1378
	strrchr						PROTO C :DWORD, :DWORD																; ordinal 1379
	strspn						PROTO C :DWORD, :DWORD																; ordinal 1380
	strstr						PROTO C :DWORD, :DWORD																; ordinal 1381
	strtol						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1382
	strtoul						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1383
	swprintf						PROTO C :DWORD, :DWORD, :VARARG														; ordinal 1384
	tan							PROTO C :DWORD																	; ordinal 1385
	tolower						PROTO C :DWORD																	; ordinal 1386
	toupper						PROTO C :DWORD																	; ordinal 1387
	towlower						PROTO C :DWORD																	; ordinal 1388
	towupper						PROTO C :DWORD																	; ordinal 1389
	vDbgPrintEx						PROTO	C																		; ordinal 1390	; XP
	vDbgPrintExWithPrefix				PROTO	C																		; ordinal 1391	; XP
	vsprintf						PROTO C :DWORD, :DWORD, :VARARG														; ordinal 1392
	wcscat						PROTO C :DWORD, :DWORD																; ordinal 1393
	wcschr						PROTO C :DWORD, :DWORD																; ordinal 1394
	wcscmp						PROTO C :DWORD, :DWORD																; ordinal 1395
	wcscpy						PROTO C :DWORD, :DWORD																; ordinal 1396
	wcscspn						PROTO C :DWORD, :DWORD																; ordinal 1397
	wcslen						PROTO C :DWORD																	; ordinal 1398
	wcsncat						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1399
	wcsncmp						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1400
	wcsncpy						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1401
	wcspbrk						PROTO C :DWORD, :DWORD																; ordinal 1402
	wcsrchr						PROTO C :DWORD, :DWORD																; ordinal 1403
	wcsspn						PROTO C :DWORD, :DWORD																; ordinal 1404
	wcsstr						PROTO C :DWORD, :DWORD																; ordinal 1405
	wcstol						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1406
	wcstombs						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1407
	wcstoul						PROTO C :DWORD, :DWORD, :DWORD														; ordinal 1408



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<BOOTVID.DLL PROTOS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



	VidBitBlt						PROTO	; ordinal 1
	VidBufferToScreenBlt				PROTO	; ordinal 2
	VidCleanUp						PROTO	; ordinal 3
	VidDisplayString					PROTO	; ordinal 4
	VidDisplayStringXY				PROTO	; ordinal 5
	VidInitialize					PROTO	; ordinal 6
	VidResetDisplay					PROTO	; ordinal 7
	VidScreenToBufferBlt				PROTO	; ordinal 8
	VidSetScrollRegion				PROTO	; ordinal 9
	VidSetTextColor					PROTO	; ordinal 10
	VidSolidColorFill					PROTO	; ordinal 11



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<WIN32K.LIB PROTOS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................



	FLOATOBJ_AddFloatObj				PROTO																			; ordinal 1
	FLOATOBJ_DivFloatObj				PROTO																			; ordinal 2
	FLOATOBJ_MulFloatObj				PROTO																			; ordinal 3
	FLOATOBJ_SubFloatObj				PROTO																			; ordinal 4
	BRUSHOBJ_hGetColorTransform			PROTO :DWORD																	; ordinal 5
	BRUSHOBJ_pvAllocRbrush				PROTO :DWORD, :DWORD																; ordinal 6
	BRUSHOBJ_pvGetRbrush				PROTO :DWORD																	; ordinal 7
	BRUSHOBJ_ulGetBrushColor			PROTO	:DWORD																	; ordinal 8
	CLIPOBJ_bEnum					PROTO :DWORD, :DWORD, :DWORD															; ordinal 9
	CLIPOBJ_cEnumStart				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 10
	CLIPOBJ_ppoGetPath				PROTO	:DWORD																	; ordinal 11
	EngAcquireSemaphore				PROTO	:DWORD																	; ordinal 12
	EngAllocMem						PROTO :DWORD, :DWORD, :DWORD															; ordinal 13
	EngAllocPrivateUserMem				PROTO :DWORD, :DWORD, :DWORD															; ordinal 14
	EngAllocSectionMem				PROTO																			; ordinal 15	; XP
	EngAllocUserMem					PROTO :DWORD, :DWORD																; ordinal 16
	EngAlphaBlend					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 17
	EngAssociateSurface				PROTO :DWORD, :DWORD, :DWORD															; ordinal 18
	EngBitBlt						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 19
	EngCheckAbort					PROTO :DWORD																	; ordinal 20
	EngClearEvent					PROTO																			; ordinal 21	; XP
	EngComputeGlyphSet				PROTO :DWORD, :DWORD, :DWORD															; ordinal 22
	EngControlSprites					PROTO :DWORD, :DWORD																; ordinal 23
	EngCopyBits						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 24
	EngCreateBitmap					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 25
	EngCreateClip					PROTO																			; ordinal 26
	EngCreateDeviceBitmap				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 27
	EngCreateDeviceSurface				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 28
	EngCreateDriverObj				PROTO :DWORD, :DWORD, :DWORD															; ordinal 29
	EngCreateEvent					PROTO :DWORD																	; ordinal 30
	EngCreatePalette					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 31
	EngCreatePath					PROTO																			; ordinal 32
	EngCreateSemaphore				PROTO																			; ordinal 33
	EngCreateWnd					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 34
	EngDebugBreak					PROTO																			; ordinal 35
	EngDebugPrint					PROTO :DWORD, :DWORD, :DWORD															; ordinal 36
	EngDeleteClip					PROTO :DWORD																	; ordinal 37
	EngDeleteDriverObj				PROTO :DWORD, :DWORD, :DWORD															; ordinal 38
	EngDeleteEvent					PROTO :DWORD																	; ordinal 39
	EngDeleteFile					PROTO :DWORD																	; ordinal 40
	EngDeletePalette					PROTO :DWORD																	; ordinal 41
	EngDeletePath					PROTO	:DWORD																	; ordinal 42
	EngDeleteSafeSemaphore				PROTO :DWORD																	; ordinal 43
	EngDeleteSemaphore				PROTO :DWORD																	; ordinal 44
	EngDeleteSurface					PROTO :DWORD																	; ordinal 45
	EngDeleteWnd					PROTO :DWORD																	; ordinal 46
	EngDeviceIoControl				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 47
	EngDitherColor					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 48
	EngDxIoctl						PROTO																			; ordinal 49	; XP
	EngEnumForms					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 50
	EngEraseSurface					PROTO :DWORD, :DWORD, :DWORD															; ordinal 51
	EngFileIoControl					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 52
	EngFileWrite					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 53
	EngFillPath						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD									; ordinal 54
	EngFindImageProcAddress				PROTO :DWORD, :DWORD																; ordinal 55
	EngFindResource					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 56
	EngFntCacheAlloc					PROTO :DWORD, :DWORD																; ordinal 57
	EngFntCacheFault					PROTO :DWORD, :DWORD																; ordinal 58
	EngFntCacheLookUp					PROTO :DWORD, :DWORD																; ordinal 59
	EngFreeMem						PROTO :DWORD																	; ordinal 60
	EngFreeModule					PROTO :DWORD																	; ordinal 61
	EngFreePrivateUserMem				PROTO :DWORD, :DWORD																; ordinal 62
	EngFreeSectionMem					PROTO																			; ordinal 63	; XP
	EngFreeUserMem					PROTO :DWORD																	; ordinal 64
	EngGetCurrentCodePage				PROTO																			; ordinal 65
	EngGetCurrentProcessId				PROTO																			; ordinal 66
	EngGetCurrentThreadId				PROTO																			; ordinal 67
	EngGetDriverName					PROTO :DWORD																	; ordinal 68
	EngGetFileChangeTime				PROTO :DWORD, :DWORD																; ordinal 69
	EngGetFilePath					PROTO :DWORD, :DWORD																; ordinal 70
	EngGetForm						PROTO :DWORD, :DWORD																; ordinal 71
	EngGetLastError					PROTO																			; ordinal 72
	EngGetPrinter					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 73
	EngGetPrinterData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 74
	EngGetPrinterDataFileName			PROTO :DWORD																	; ordinal 75
	EngGetPrinterDriver   				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 76
	EngGetProcessHandle				PROTO																			; ordinal 77
	EngGetTickCount					PROTO																			; ordinal 78
	EngGetType1FontList				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 79
	EngGradientFill					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 80
	EngHangNotification				PROTO																			; ordinal 81	; XP
	EngInitializeSafeSemaphore			PROTO :DWORD																	; ordinal 82
	EngIsSemaphoreOwned				PROTO																			; ordinal 83	; XP
	EngIsSemaphoreOwnedByCurrentThread		PROTO																			; ordinal 84	; XP
	EngLineTo						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD							; ordinal 85
	EngLoadImage					PROTO :DWORD																	; ordinal 86
	EngLoadModule					PROTO :DWORD																	; ordinal 87
	EngLoadModuleForWrite				PROTO :DWORD, :DWORD																; ordinal 88
	EngLockDirectDrawSurface			PROTO :DWORD																	; ordinal 89
	EngLockDriverObj					PROTO :DWORD																	; ordinal 90
	EngLockSurface					PROTO :DWORD																	; ordinal 91
	EngLpkInstalled					PROTO																			; ordinal 92
	EngMapEvent						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 93
	EngMapFile						PROTO :DWORD, :DWORD, :DWORD															; ordinal 94
	EngMapFontFile					PROTO :DWORD, :DWORD, :DWORD															; ordinal 95
	EngMapFontFileFD					PROTO :DWORD, :DWORD, :DWORD															; ordinal 96
	EngMapModule					PROTO :DWORD, :DWORD																; ordinal 97
	EngMapSection					PROTO																			; ordinal 98	; XP
	EngMarkBandingSurface				PROTO :DWORD																	; ordinal 99
	EngModifySurface					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 100
	EngMovePointer					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 101
	EngMulDiv						PROTO :DWORD, :DWORD, :DWORD															; ordinal 102
	EngMultiByteToUnicodeN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 103
	EngMultiByteToWideChar				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 104
	EngNineGrid						PROTO																			; ordinal 105	; XP
	EngPaint						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 106
	EngPlgBlt						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 107
	EngProbeForRead					PROTO :DWORD, :DWORD, :DWORD															; ordinal 108
	EngProbeForReadAndWrite				PROTO :DWORD, :DWORD, :DWORD															; ordinal 109
	EngQueryDeviceAttribute				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 110
	EngQueryLocalTime					PROTO :DWORD																	; ordinal 111
	EngQueryPalette					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 112
	EngQueryPerformanceCounter			PROTO :DWORD																	; ordinal 113
	EngQueryPerformanceFrequency			PROTO :DWORD																	; ordinal 114
	EngQuerySystemAttribute				PROTO :DWORD, :DWORD																; ordainl 115
	EndReadStatEvent					PROTO																			; ordinal 116	; XP
	EngReleaseSemaphore				PROTO	:DWORD																	; ordinal 117
	EngRestoreFloatingPointState			PROTO :DWORD																	; ordinal 118
	EngSaveFloatingPointState			PROTO :DWORD, :DWORD																; ordinal 119
	EngSecureMem					PROTO :DWORD, :DWORD																; ordinal 120
	EngSetEvent						PROTO :DWORD																	; ordinal 121
	EngSetLastError					PROTO :DWORD																	; ordinal 122
	EngSetPointerShape				PROTO :DWORD 																	; ordinal 123
	EngSetPointerTag					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 124
	EngSetPrinterData					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 125
	EngSort						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 126
	EngStretchBlt					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				; ordinal 127
	EngStretchBltROP					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; ordinal 128
	EngStrokeAndFillPath				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 129
	EngStrokePath					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 130
	EngTextOut						PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD					; ordinal 131
	EngTransparentBlt					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD								; ordinal 132
	EngUnicodeToMultiByteN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 133
	EngUnloadImage					PROTO :DWORD																	; ordinal 134
	EngUnlockDirectDrawSurface			PROTO :DWORD																	; ordinal 135
	EngUnlockDriverObj				PROTO :DWORD																	; ordinal 136
	EngUnlockSurface					PROTO :DWORD																	; ordinal 137
	EngUnmapEvent					PROTO :DWORD																	; ordinal 138
	EngUnmapFile					PROTO :DWORD																	; ordinal 139
	EngUnmapFontFile					PROTO :DWORD																	; ordinal 140
	EngUnmapFontFileFD				PROTO :DWORD																	; ordinal 141
	EngUnsecureMem					PROTO :DWORD																	; ordinal 142
	EngWaitForSingleObject				PROTO :DWORD, :DWORD																; ordinal 143
	EngWideCharToMultiByte				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 144
	EngWritePrinter					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 145
	FLOATOBJ_Add					PROTO :DWORD, :DWORD																; ordinal 146
	FLOATOBJ_AddFloat					PROTO :DWORD, :DWORD																; ordinal 147
	FLOATOBJ_AddLong					PROTO :DWORD, :DWORD																; ordinal 148
	FLOATOBJ_Div					PROTO :DWORD, :DWORD																; ordinal 149
	FLOATOBJ_DivFloat					PROTO :DWORD, :DWORD																; ordinal 150
	FLOATOBJ_DivLong					PROTO :DWORD, :DWORD																; ordinal 151
	FLOATOBJ_Equal					PROTO :DWORD, :DWORD																; ordinal 152
	FLOATOBJ_EqualLong				PROTO :DWORD, :DWORD																; ordinal 153
	FLOATOBJ_GetFloat					PROTO :DWORD																	; ordinal 154
	FLOATOBJ_GetLong					PROTO :DWORD																	; ordinal 155
	FLOATOBJ_GreaterThan				PROTO :DWORD, :DWORD																; ordinal 156
	FLOATOBJ_GreaterThanLong			PROTO :DWORD, :DWORD																; ordinal 157
	FLOATOBJ_LessThan					PROTO :DWORD, :DWORD																; ordinal 158
	FLOATOBJ_LessThanLong				PROTO :DWORD, :DWORD																; ordinal 159
	FLOATOBJ_Mul					PROTO :DWORD, :DWORD																; ordinal 160
	FLOATOBJ_MulFloat					PROTO :DWORD, :DWORD																; ordinal 161
	FLOATOBJ_MulLong					PROTO :DWORD, :DWORD																; ordinal 162
	FLOATOBJ_Neg					PROTO :DWORD																	; ordinal 163
	FLOATOBJ_SetFloat					PROTO :DWORD, :DWORD																; ordinal 164
	FLOATOBJ_SetLong					PROTO :DWORD, :DWORD																; ordinal 165
	FLOATOBJ_Sub					PROTO :DWORD, :DWORD																; ordinal 166
	FLOATOBJ_SubFloat					PROTO :DWORD, :DWORD																; ordinal 167
	FLOATOBJ_SubLong					PROTO :DWORD, :DWORD																; ordinal 168
	FONTOBJ_cGetAllGlyphHandles			PROTO :DWORD, :DWORD																; ordinal 169
	FONTOBJ_cGetGlyphs				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 170
	FONTOBJ_pQueryGlyphAttrs			PROTO :DWORD, :DWORD																; ordinal 171
	FONTOBJ_pfdg					PROTO :DWORD																	; ordinal 172
	FONTOBJ_pifi					PROTO :DWORD																	; ordinal 173
	FONTOBJ_pjOpenTypeTablePointer		PROTO :DWORD, :DWORD, :DWORD															; ordinal 174
	FONTOBJ_pvTrueTypeFontFile			PROTO :DWORD, :DWORD																; ordinal 175
	FONTOBJ_pwszFontFilePaths			PROTO :DWORD, :DWORD																; ordinal 176
	FONTOBJ_pxoGetXform				PROTO :DWORD																	; ordinal 177
	FONTOBJ_vGetInfo					PROTO :DWORD, :DWORD, :DWORD															; ordinal 178
	HT_ComputeRGBGammaTable				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 179
	HT_Get8BPPFormatPalette				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 180
	HT_Get8BPPMaskPalette				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD											; ordinal 181
	HeapVidMemAllocAligned				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 182
	PALOBJ_cGetColors					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 183
	PATHOBJ_bCloseFigure				PROTO :DWORD																	; ordinal 184
	PATHOBJ_bEnum					PROTO :DWORD, :DWORD																; ordinal 185
	PATHOBJ_bEnumClipLines				PROTO :DWORD, :DWORD, :DWORD															; ordinal 186
	PATHOBJ_bMoveTo					PROTO :DWORD, :DWORD, :DWORD															; ordinal 187
	PATHOBJ_bPolyBezierTo				PROTO :DWORD, :DWORD, :DWORD															; ordinal 188
	PATHOBJ_bPolyLineTo				PROTO :DWORD, :DWORD, :DWORD															; ordinal 189
	PATHOBJ_vEnumStart				PROTO :DWORD																	; ordinal 190
	PATHOBJ_vEnumStartClipLines			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 191
	PATHOBJ_vGetBounds				PROTO :DWORD, :DWORD																; ordinal 192
	RtlAnsiCharToUnicodeChar			PROTO :DWORD																	; ordinal 193
	RtlMultiByteToUnicodeN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 194
	RtlRaiseException					PROTO :DWORD																	; ordinal 195
	RtlUnicodeToMultiByteN				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD 												; ordinal 196
	RtlUnicodeToMultiByteSize			PROTO :DWORD, :DWORD, :DWORD															; ordinal 197
;	RtlUnwind						PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 198
	RtlUpcaseUnicodeChar				PROTO :DWORD																	; ordinal 199
	RtlUpcaseUnicodeToMultiByteN			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 200
	STROBJ_bEnum					PROTO :DWORD, :DWORD, :DWORD															; ordinal 201
	STROBJ_bEnumPositionsOnly			PROTO :DWORD, :DWORD, :DWORD															; ordinal 202
	STROBJ_bGetAdvanceWidths			PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 203
	STROBJ_dwGetCodePage				PROTO :DWORD																	; ordinal 204
	STROBJ_fxBreakExtra				PROTO :DWORD																	; ordinal 205
	STROBJ_fxCharacterExtra				PROTO :DWORD																	; ordinal 206
	STROBJ_vEnumStart					PROTO :DWORD																	; ordinal 207
	VidMemFree						PROTO :DWORD, :DWORD																; ordinal 208
	WNDOBJ_bEnum					PROTO :DWORD, :DWORD, :DWORD															; ordinal 209
	WNDOBJ_cEnumStart					PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 210
	WNDOBJ_vSetConsumer				PROTO :DWORD, :DWORD																; ordinal 211
	XFORMOBJ_bApplyXform				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD												; ordinal 212
	XFORMOBJ_iGetFloatObjXform			PROTO :DWORD, :DWORD																; ordinal 213
	XFORMOBJ_iGetXform				PROTO :DWORD, :DWORD																; ordinal 214
	XLATEOBJ_cGetPalette				PROTO :DWORD, :DWORD, :DWORD, :DWORD													; ordinal 215
	XLATEOBJ_hGetColorTransform			PROTO :DWORD																	; ordinal 216
	XLATEOBJ_iXlate					PROTO :DWORD																	; ordinal 217
	XLATEOBJ_piVector					PROTO :DWORD, :DWORD																; ordinal 218
	_abnormal_termination				PROTO C																		; ordinal 219
	_except_handler2					PROTO C																		; ordinal 220
	_global_unwind2					PROTO C																		; ordinal 221
	_itoa							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 222
	_itow							PROTO C :DWORD, :DWORD, :DWORD														; ordinal 223
	_local_unwind2					PROTO C																		; ordinal 224



;..................................................................................
; MY EQUS
;..................................................................................



	IOCTL_SPEAKER_ON					EQU CTL_CODE(8010h, 820h, 0, 0)
	IOCTL_SPEAKER_OFF					EQU CTL_CODE(8010h, 830h, 0, 0)
	IOCTL_READ_HARD_DISK_SECTOR			EQU CTL_CODE(8010h, 840h, 0, 0)
	IOCTL_READ_MEMORY					EQU CTL_CODE(8010h, 850h, 0, 0)
	IOCTL_FUNCTION_ADDRESS				EQU CTL_CODE(8010h, 860h, 0, 0)
	IOCTL_SEH						EQU CTL_CODE(8010h, 870h, 0, 0)
	IOCTL_UNKNOWN1					EQU CTL_CODE(8010h, 880h, 0, 0)
	IOCTL_UNKNOWN2					EQU CTL_CODE(8010h, 890h, 0, 0)



;..................................................................................
; MY EXTERNALS 
;..................................................................................



	EXTRN		DbgPrint:NEAR
	EXTRN		Roak_Dispatch@8:NEAR
	EXTRN		Roaknogs_Driver_Entry@8:NEAR



;.................................................................................
; MY PUBLICS
;.................................................................................



	public	Call_Function_By_Address
	public	Clean_String
	public	Compare_Strings
	public	Convert_Number_To_ASCII
	public	Day_Of_Week
	public	Get_Base
	public	Get_Pointer_To_Module_List
	public	Read_Hard_Disk_Sector
	public	Read_Memory
	public	Roaknogs_Structured_Exception_Handler
	public	Roak_Unload
	public	Space_Function_Name
	public	Speaker_Off
	public	Speaker_On
	public	Time_Date_Stamp_Converteor
	public	Write_Data_To_File
	public	Write_PIMAGE_EXPORT_DIRECTORY_To_File
	public	Write_PIMAGE_NT_HEADER_To_File
	public	Write_Table_Of_Functions_To_File



;.................................................................................
; MY PROTOS
;.................................................................................



	Clean_String					PROTO buffer_address:DWORD
	Compare_Strings					PROTO string_one:DWORD, string_two:DWORD
	Convert_Number_To_ASCII				PROTO number_to_display:DWORD
	Day_Of_Week						PROTO	month:DWORD, day:DWORD, year:DWORD
	Read_Hard_Disk_Sector				PROTO b1:BYTE, b2:BYTE, b3:BYTE, b4:BYTE
	Roaknogs_Structured_Exception_Handler	PROTO p1:DWORD, p2:DWORD
	Roak_Unload						PROTO DriverObject:PDRIVER_OBJECT
	Space_Function_Name				PROTO function_name:DWORD
	Speaker_On						PROTO frequency_high:DWORD, frequency_low:DWORD
	Time_Date_Stamp_Converteor			PROTO tds_number:DWORD
	Write_Data_To_File				PROTO address_of_data_to_write:DWORD, data_size:DWORD, address_of_file_name:DWORD, read_write_test:DWORD
	Write_PIMAGE_EXPORT_DIRECTORY_To_File	PROTO	pre_initialized_base:DWORD, inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD
	Write_PIMAGE_NT_HEADER_To_File		PROTO pBase:DWORD, pre_initialized_base:DWORD
	Write_Table_Of_Functions_To_File		PROTO pre_initialized_base:DWORD, inh_OptionalHeader_DataDirectory_VirtualAddress:DWORD, NumberOfFunctions:DWORD



;..................................................................................
; GENERAL DATA
;..................................................................................



.data
_sDataStruct				STRUC
	Status				DD					?
	osv					DD					?
	c1					DB					?
	c2					DB					?
	c3					DB					?
	c4					DB					?
	b					DB					512 DUP(?)
_sDataStruct				ENDS
	dStruct				_sDataStruct			<>
	SymbolicLinkNameUnicode		UNICODE_STRING			<>	  
	zDosDeviceName			DB '\',0,'D',0,'o',0,'s',0,'D',0,'e',0,'v',0,'i',0,'c',0,'e',0,'s',0,'\',0,'R',0,'o',0,'a',0,'k',0,0,0
	zDeviceName				DB '\',0,'D',0,'e',0,'v',0,'i',0,'c',0,'e',0,'\',0,'R',0,'o',0,'a',0,'k',0,0,0
	buffy 				DB					512 dup(?)



;..................................................................................
; Call_Function_By_Address PROCEDURE DATA
;..................................................................................



	success_msg				DW					0, 0, 0, 0, 'R', 'O', 'A', 'K', ' ', 'N', 'O', 'G', ' ', 'S', 'A', 'Y', 'S', ' ', 'M', 'O', 'D', 'U', 'L', 'E', ' ', 'W', 'A', 'S', ' ', 'F', 'O', 'U', 'N', 'D', '!'
						DW					13, 10, 13, 10, 0, 0, 0, 0, 0, 0, 'L', 'O', 'O', 'K', ' ', 'I', 'N', ' ', 'C', ':', '\', 'R', 'O', 'A', 'K', '.', 'T', 'X', 'T', ' ', 'F', 'O', 'R', ' ', 'M', 'O', 'R', 'E', '!', 500 dup(?)
	err_module_not_found		DB					13, 10, '     ERROR!  MODULE NOT FOUND!', 500 dup(153)
	pointer_to_module_list		PMODULE_LIST			?



;..................................................................................
; Clean_String PROCEDURE DATA
;..................................................................................



	local_string_buffer		DB					512 dup(?)



;..................................................................................
; Day_Of_Week PROCEDURE DATA
;..................................................................................



	day_work_buffer			DB 					256 dup(?)
	time_array				DB					0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4
	day_array				DB					'Sunday    Monday    Tuesday   Wednesday Thursday  Friday    Saturday  '



;..................................................................................
; Get_Base PROCEDURE DATA
;..................................................................................



	module_table_title		DB					13, 10, 13, 10, 'SYSTEM MODULES ON YOUR COMPUTER', 13, 10, 13, 10
	function_address_base		DD					?
	this_is_what_you_want		DB					'v v v THIS IS WHAT YOU WANT v v v ', 13, 10
	nothing_there			DB					'CAN''T SEE # ', 0
	new_line				DB					0Dh, 0Ah
	bytes_to_write			DB					2000 dup(?)



;..................................................................................
; Read_Memory PROCEDURE DATA
;..................................................................................



_My_Serial_Number_Structure		STRUC
	character				DW 					4096 dup(?)
_My_Serial_Number_Structure		ENDS
	memory_offset 			LARGE_INTEGER			<0FE000h, 0, 0>	; 0FEC71h is between 0FE000h and 0FF000h, a 1000h byte page and is in low_part for assembler or QUAD_PART for C compiler
	MySNDeviceNameUnicode		UNICODE_STRING			<>			; because offset used
	MySNDeviceName			DW 					'\', 'D', 'e', 'v', 'i', 'c', 'e', '\', 'P', 'h', 'y', 's', 'i', 'c', 'a', 'l', 'M', 'e', 'm', 'o', 'r', 'y', 0
	out_memory_virtual_address	DD 					0



;.......................................................................................
; Roaknogs_Structured_Exception_Handler PROCEDURE DATA
;.......................................................................................



	roaks_seh				DD					3 dup (?)
	msg_in_except			DB					'HELLO!  EXCEPTION!  THIS IS MY HANDLER!', 0
	msg_test_13_parameter_2		DB					'Let us play with parameter two.', 0
	msg_get_buger			DB					10, 13, 10, 13, '          Get a debugger to see the DbgPrint output for proof of', 10, 13
						DB					                '     exception handling.  You cannot handle arithmetic exceptions,', 10, 13
						DB					                '     page faults, and references through invalid pointers with SEH.', 10, 13
						DB					                '     You can be satisfied to know that a return of 3000 means the', 10, 13
						DB					                '     exception existed and was dealt with while a return of 1000', 10, 13
						DB					                '     means there was no exception.  A return of 5000 means parameter', 10, 13
						DB					                '     two was operated on.  Stuff can happen after an exception.', 10, 13, 500 dup (?)



;..................................................................................
; Space_Function_Name PROCEDURE DATA
;..................................................................................



	function_buffer_name		DB 					256 dup(?)



;..................................................................................
; Speaker_Off PROCEDURE DATA
;..................................................................................



	roak_msg_off			DW					0, 0, 0, 0, 'R', 'O', 'A', 'K', ' ', 'N', 'O', 'G', ' ', 'S', 'A', 'Y', 'S', ' ', 'S', 'P', 'E', 'A', 'K', 'E', 'R', ' ', 'O', 'F', 'F', '!', 500 dup (0)




;..................................................................................
; Speaker_On PROCEDURE DATA
;..................................................................................



	roak_msg_on				DW					0, 0, 0, 0, 'R', 'O', 'A', 'K', ' ', 'N', 'O', 'G', ' ', 'S', 'A', 'Y', 'S', ' ', 'S', 'P', 'E', 'A', 'K', 'E', 'R', ' ', 'O', 'N', '!', 500 dup (0)



;..................................................................................
; Time_Date_Stamp_Converteor PROCEDURE DATA
;..................................................................................



	time_date				DB					256 dup (?)
	leap_year_array			DD					1972, 1976, 1980, 1984, 1988, 1992, 1996, 2000, 2004, 2008, 2012, 2016, 2020, 2024, 2028, 2032, 2036, 2040, 2044, 2048, 2052, 2056, 2060, 2064
	month_array				DD					31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31



;..................................................................................
; Write_Data_To_File PROCEDURE DATA
;..................................................................................



	hFile					DWORD					?
	iostatus				IO_STATUS_BLOCK			<>
	file_O_A_S				OBJECT_ATTRIBUTES_STRUCT	<>
	FileNameUnicode			UNICODE_STRING			<>
	file_name				DW					'\', '?', '?', '\', 'C', ':', '\', 'R', 'O', 'A', 'K', '.', 'T', 'X', 'T', 0
;	file_name				DW					'\', '?', '?', '\', 'N', ':', '\', 't', 'e', 'm', 'p', '\', 'm', 'e', 'm', 'o', 'r', 'y', '\', 's', 'y', 's', '\', 'R', 'O', 'A', 'K', '.', 'T', 'X', 'T', 0
;	file_name				DW					'\', '?', '?', '\', 'M', ':', '\', 't', 'e', 'm', 'p', '\', 't', '\', 's', 'y', 's', '\', 'R', 'O', 'A', 'K', '.', 'T', 'X', 'T', 0



;..................................................................................
; Write_PIMAGE_EXPORT_DIRECTORY_To_File PROCEDURE DATA
;..................................................................................



	iedName				DD					?
	iedNumberOfFunctions		DWORD					?
	ied_buffy				DB					1024 dup(?)
	ied_string_0			DB				      13, 10, 13, 10, 'IMAGE_EXPORT_DIRECTORY STRUCTURE CONTENTS FOR '
	ied_string_1			DB					13, 10, 13, 10, 'Characteristics                             = '
	ied_string_2			DB					   '.', 13, 10, 'TimeDateStamp                               = '
	ied_string_3			DB					   '.', 13, 10, 'In My World That Translates To              = '
	ied_string_4			DB					   '.', 13, 10, 'MajorVersion                                = '
	ied_string_5			DB					   '.', 13, 10, 'MinorVersion                                = '
	ied_string_6			DB					   '.', 13, 10, 'Name                                        = '
	ied_string_7			DB					   '.', 13, 10, 'Base                                        = '
	ied_string_8			DB					   '.', 13, 10, 'NumberOfFunctions                           = '
	ied_string_9			DB					   '.', 13, 10, 'NumberOfNames                               = '
	ied_string_10			DB					   '.', 13, 10, 'AddressOfFunctions                          = '
	ied_string_11			DB					   '.', 13, 10, 'AddressOfNames                              = '
	ied_string_12			DB					   '.', 13, 10, 'AddressOfNameOrdinals                       = '
	ied_string_13			DB					   '.', 13, 10



;..................................................................................
; Write_PIMAGE_NT_HEADER_To_File PROCEDURE DATA
;..................................................................................



	a_dll_string			DB 					50 dup(?)
	a_dll_string_ext			DB					50 dup(?)
	hal_string				DB					'hal', 0
	hal_dll_string			DB					'hal.dll', 0
	ntdll_string			DB					'ntdll', 0
	ntdll_dll_string			DB					'ntdll.dll', 0
	ntoskrnl_string			DB					'ntoskrnl', 0
	ntoskrnl_exe_string		DB					'ntoskrnl.exe', 0
	bootvid_string			DB					'bootvid', 0
	bootvid_dll_string		DB					'bootvid.dll', 0
	win32k_string			DB					'win32k', 0
	win32k_sys_string			DB					'win32k.sys', 0
	inh_string_1			DB					13, 10, 13, 10, 'IMAGE NT HEADER STRUCTURE CONTENTS FOR '
	inh_string_2			DB					'.', 13, 10, 13, 10, 'Signature                                   = '
	inh_string_3			DB					        '.', 13, 10, 'FileHeader.Machine                          = '
	inh_string_4			DB					        '.', 13, 10, 'FileHeader.NumberOfSections                 = '
	inh_string_5			DB					        '.', 13, 10, 'FileHeader.TimeDateStamp                    = '
	inh_string_6			DB					        '.', 13, 10, 'In My World That Translates To              = '
	inh_string_7			DB					        '.', 13, 10, 'FileHeader.PointerToSymbolTable             = '
	inh_string_8			DB					        '.', 13, 10, 'FileHeader.NumberOfSymbols                  = '
	inh_string_9			DB					        '.', 13, 10, 'FileHeader.SizeOfOptionHeader               = '
	inh_string_10			DB					        '.', 13, 10, 'FileHeader.Characteristics                  = '
	inh_string_11			DB					        '.', 13, 10, 'OptionalHeader.Magic                        = '
	inh_string_12			DB					        '.', 13, 10, 'OptionalHeader.MajorLinkerVersion           = '
	inh_string_13			DB					        '.', 13, 10, 'OptionalHeader.MinorLinkerVersion           = '
	inh_string_14			DB					        '.', 13, 10, 'OptionalHeader.SizeOfCode                   = '
	inh_string_15			DB					        '.', 13, 10, 'OptionalHeader.SizeOfInitializedData        = '
	inh_string_16			DB					        '.', 13, 10, 'OptionalHeader.SizeOfUninitializedData      = '
	inh_string_17			DB					        '.', 13, 10, 'OptionalHeader.AddressOfEntryPoint          = '
	inh_string_18			DB					        '.', 13, 10, 'OptionalHeader.BaseOfCode                   = '
	inh_string_19			DB					        '.', 13, 10, 'OptionalHeader.BaseOfData                   = '
	inh_string_20			DB					        '.', 13, 10, 'OptionalHeader.ImageBase                    = '
	inh_string_21			DB					        '.', 13, 10, 'OptionalHeader.SectionalAlignment           = '
	inh_string_22			DB					        '.', 13, 10, 'OptionalHeader.FileAlignment                = '
	inh_string_23			DB					        '.', 13, 10, 'OptionalHeader.MajorOperatingSystemVersion  = '
	inh_string_24			DB					        '.', 13, 10, 'OptionalHeader.MinorOperatingSystemVersion  = '
	inh_string_25			DB                  		        '.', 13, 10, 'OptionalHeader.MajorImageVersion            = '
	inh_string_26			DB					        '.', 13, 10, 'OptionalHeader.MinorImageVersion            = '
	inh_string_27			DB					        '.', 13, 10, 'OptionalHeader.MajorSubsystemVersion        = '
	inh_string_28			DB					        '.', 13, 10, 'OptionalHeader.MinorSubsystemVersion        = '
	inh_string_29			DB					        '.', 13, 10, 'OptionalHeader.Win32VersionValue            = '
	inh_string_30			DB					        '.', 13, 10, 'OptionalHeader.SizeOfImage                  = '
	inh_string_31			DB					        '.', 13, 10, 'OptionalHeader.SizeOfHeaders                = '
	inh_string_32			DB					        '.', 13, 10, 'OptionalHeader.CheckSum                     = '
	inh_string_33			DB					        '.', 13, 10, 'OptionalHeader.Subsystem                    = '
	inh_string_34			DB					        '.', 13, 10, 'OptionalHeader.DllCharacteristics           = '
	inh_string_35			DB					        '.', 13, 10, 'OptionalHeader.SizeOfStackReserve           = '
	inh_string_36			DB					        '.', 13, 10, 'OptionalHeader.SizeOfStackCommit            = '
	inh_string_37			DB					        '.', 13, 10, 'OptionalHeader.SizeOfHeapReserve            = '
	inh_string_38			DB					        '.', 13, 10, 'OptionalHeader.SizeOfHeapCommit             = '
	inh_string_39			DB					        '.', 13, 10, 'OptionalHeader.LoaderFlags                  = '
	inh_string_40			DB					        '.', 13, 10, 'OptionalHeader.NumberOfRvaAndSizes          = '
	inh_string_41			DB					        '.', 13, 10, 'OptionalHeader.DataDirectory.VirtualAddress = '
	inh_string_42			DB					        '.', 13, 10, 'OptionalHeader.DataDirectory.Size           = '
	inh_string_43			DB					        '.', 13, 10



;..................................................................................
; Write_Table_Of_Functions_To_File PROCEDURE DATA
;..................................................................................



	function_table_name_1		DB					13, 10, 13, 10, 'FUNCTIONS IN '
	function_table_name_2		DB					'                                  ORDINAL     DATA             ADDRESS', 13, 10
	RVA_NAME				DD					?
	tab_string				DB					'      ', 0
	hmb_function_address		DD					?
	ntdll_function_address		DD					?
	gtc_function_address		DD					?
	hal_make_beep			DB					'HalMakeBeep', 0
	ntdll__atoi64_function		DB					'_atoi64', 0
	number_string			DB					'987654321', 0
	crap_string				DB					'crap', 0
	atoi64_error_msg			DB					'ERROR WITH CALL TO _atoi64!  You used the string: ', 0
	atoi64_success_msg		DB					'Successful call to _atoi64!  You used the string: ', 0
	ntdll_zw_create_process		DB					'ZwCreateProcess', 0
	ntdll_zw_get_tick_count		DB					'ZwGetTickCount', 0
	ntdll_zw_read_virtual_memory	DB					'ZwReadVirtualMemory', 0
	address_plus_base			DD					?
	process_handle			DD					?



;..................................................................................
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< END >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;..................................................................................








